<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>include/FLAC/file_encoder.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.2.14 -->
<center>
<a class="qindex" href="index.html">Main Page</a> &nbsp; <a class="qindex" href="modules.html">Modules</a> &nbsp; <a class="qindex" href="hierarchy.html">Class Hierarchy</a> &nbsp; <a class="qindex" href="classes.html">Alphabetical List</a> &nbsp; <a class="qindex" href="annotated.html">Compound List</a> &nbsp; <a class="qindex" href="files.html">File List</a> &nbsp; <a class="qindex" href="functions.html">Compound Members</a> &nbsp; <a class="qindex" href="globals.html">File Members</a> &nbsp; </center>
<hr><h1>include/FLAC/file_encoder.h</h1><a href="FLAC_2file__encoder_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre>00001 <font class="comment">/* libFLAC - Free Lossless Audio Codec library</font>
00002 <font class="comment"> * Copyright (C) 2002,2003,2004,2005  Josh Coalson</font>
00003 <font class="comment"> *</font>
00004 <font class="comment"> * Redistribution and use in source and binary forms, with or without</font>
00005 <font class="comment"> * modification, are permitted provided that the following conditions</font>
00006 <font class="comment"> * are met:</font>
00007 <font class="comment"> *</font>
00008 <font class="comment"> * - Redistributions of source code must retain the above copyright</font>
00009 <font class="comment"> * notice, this list of conditions and the following disclaimer.</font>
00010 <font class="comment"> *</font>
00011 <font class="comment"> * - Redistributions in binary form must reproduce the above copyright</font>
00012 <font class="comment"> * notice, this list of conditions and the following disclaimer in the</font>
00013 <font class="comment"> * documentation and/or other materials provided with the distribution.</font>
00014 <font class="comment"> *</font>
00015 <font class="comment"> * - Neither the name of the Xiph.org Foundation nor the names of its</font>
00016 <font class="comment"> * contributors may be used to endorse or promote products derived from</font>
00017 <font class="comment"> * this software without specific prior written permission.</font>
00018 <font class="comment"> *</font>
00019 <font class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</font>
00020 <font class="comment"> * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</font>
00021 <font class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</font>
00022 <font class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR</font>
00023 <font class="comment"> * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,</font>
00024 <font class="comment"> * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,</font>
00025 <font class="comment"> * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR</font>
00026 <font class="comment"> * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF</font>
00027 <font class="comment"> * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING</font>
00028 <font class="comment"> * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS</font>
00029 <font class="comment"> * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</font>
00030 <font class="comment"> */</font>
00031 
00032 <font class="preprocessor">#ifndef FLAC__FILE_ENCODER_H</font>
00033 <font class="preprocessor"></font><font class="preprocessor">#define FLAC__FILE_ENCODER_H</font>
00034 <font class="preprocessor"></font>
00035 <font class="preprocessor">#include "export.h"</font>
00036 <font class="preprocessor">#include "<a class="code" href="OggFLAC_2seekable__stream__encoder_8h.html">seekable_stream_encoder.h</a>"</font>
00037 
00038 <font class="preprocessor">#ifdef __cplusplus</font>
00039 <font class="preprocessor"></font><font class="keyword">extern</font> <font class="stringliteral">"C"</font> {
00040 <font class="preprocessor">#endif</font>
00041 <font class="preprocessor"></font>
00042 
<a name="l00105"></a><a class="code" href="group__flac__file__encoder.html#a52">00105</a> <font class="keyword">typedef</font> <font class="keyword">enum</font> {
00106 
00107     <a class="code" href="FLAC_2file__encoder_8h.html#a52a2">FLAC__FILE_ENCODER_OK</a> = 0,
00110     <a class="code" href="FLAC_2file__encoder_8h.html#a52a3">FLAC__FILE_ENCODER_NO_FILENAME</a>,
00115     <a class="code" href="FLAC_2file__encoder_8h.html#a52a4">FLAC__FILE_ENCODER_SEEKABLE_STREAM_ENCODER_ERROR</a>,
00120     <a class="code" href="FLAC_2file__encoder_8h.html#a52a5">FLAC__FILE_ENCODER_FATAL_ERROR_WHILE_WRITING</a>,
00123     <a class="code" href="FLAC_2file__encoder_8h.html#a52a6">FLAC__FILE_ENCODER_ERROR_OPENING_FILE</a>,
00126     <a class="code" href="FLAC_2file__encoder_8h.html#a52a7">FLAC__FILE_ENCODER_MEMORY_ALLOCATION_ERROR</a>,
00129     <a class="code" href="FLAC_2file__encoder_8h.html#a52a8">FLAC__FILE_ENCODER_ALREADY_INITIALIZED</a>,
00135     <a class="code" href="FLAC_2file__encoder_8h.html#a52a9">FLAC__FILE_ENCODER_UNINITIALIZED</a>
00138 } <a class="code" href="FLAC_2file__encoder_8h.html#a52">FLAC__FileEncoderState</a>;
00139 
<a name="l00145"></a><a class="code" href="group__flac__file__encoder.html#a0">00145</a> <font class="keyword">extern</font> FLAC_API <font class="keyword">const</font> <font class="keywordtype">char</font> * <font class="keyword">const</font> <a class="code" href="FLAC_2file__encoder_8h.html#a0">FLAC__FileEncoderStateString</a>[];
00146 
00147 
00148 <font class="comment">/***********************************************************************</font>
00149 <font class="comment"> *</font>
00150 <font class="comment"> * class FLAC__FileEncoder</font>
00151 <font class="comment"> *</font>
00152 <font class="comment"> ***********************************************************************/</font>
00153 
00154 <font class="keyword">struct </font>FLAC__FileEncoderProtected;
00155 <font class="keyword">struct </font>FLAC__FileEncoderPrivate;
<a name="l00160"></a><a class="code" href="structFLAC____FileEncoder.html">00160</a> <font class="keyword">typedef</font> <font class="keyword">struct </font>{
00161     <font class="keyword">struct </font>FLAC__FileEncoderProtected *protected_; <font class="comment">/* avoid the C++ keyword 'protected' */</font>
00162     <font class="keyword">struct </font>FLAC__FileEncoderPrivate *private_; <font class="comment">/* avoid the C++ keyword 'private' */</font>
00163 } <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a>;
00164 
<a name="l00177"></a><a class="code" href="group__flac__file__encoder.html#a1">00177</a> <font class="keyword">typedef</font> void (*<a class="code" href="FLAC_2file__encoder_8h.html#a1">FLAC__FileEncoderProgressCallback</a>)(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__uint64 bytes_written, FLAC__uint64 samples_written, <font class="keywordtype">unsigned</font> frames_written, <font class="keywordtype">unsigned</font> total_frames_estimate, <font class="keywordtype">void</font> *client_data);
00178 
00179 
00180 <font class="comment">/***********************************************************************</font>
00181 <font class="comment"> *</font>
00182 <font class="comment"> * Class constructor/destructor</font>
00183 <font class="comment"> *</font>
00184 <font class="comment"> ***********************************************************************/</font>
00185 
00193 FLAC_API <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *<a class="code" href="FLAC_2file__encoder_8h.html#a2">FLAC__file_encoder_new</a>();
00194 
00201 FLAC_API <font class="keywordtype">void</font> <a class="code" href="FLAC_2file__encoder_8h.html#a3">FLAC__file_encoder_delete</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00202 
00203 <font class="comment">/***********************************************************************</font>
00204 <font class="comment"> *</font>
00205 <font class="comment"> * Public class method prototypes</font>
00206 <font class="comment"> *</font>
00207 <font class="comment"> ***********************************************************************/</font>
00208 
00220 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a4">FLAC__file_encoder_set_verify</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__bool value);
00221 
00233 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a5">FLAC__file_encoder_set_streamable_subset</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__bool value);
00234 
00246 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a6">FLAC__file_encoder_set_do_mid_side_stereo</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__bool value);
00247 
00259 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a7">FLAC__file_encoder_set_loose_mid_side_stereo</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__bool value);
00260 
00272 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a8">FLAC__file_encoder_set_channels</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00273 
00289 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a9">FLAC__file_encoder_set_bits_per_sample</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00290 
00302 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a10">FLAC__file_encoder_set_sample_rate</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00303 
00315 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a11">FLAC__file_encoder_set_blocksize</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00316 
00328 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a12">FLAC__file_encoder_set_max_lpc_order</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00329 
00345 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a13">FLAC__file_encoder_set_qlp_coeff_precision</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00346 
00358 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a14">FLAC__file_encoder_set_do_qlp_coeff_prec_search</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__bool value);
00359 
00371 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a15">FLAC__file_encoder_set_do_escape_coding</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__bool value);
00372 
00384 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a16">FLAC__file_encoder_set_do_exhaustive_model_search</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__bool value);
00385 
00397 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a17">FLAC__file_encoder_set_min_residual_partition_order</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00398 
00410 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a18">FLAC__file_encoder_set_max_residual_partition_order</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00411 
00423 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a19">FLAC__file_encoder_set_rice_parameter_search_dist</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">unsigned</font> value);
00424 
00436 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a20">FLAC__file_encoder_set_total_samples_estimate</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__uint64 value);
00437 
00450 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a21">FLAC__file_encoder_set_metadata</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <a class="code" href="structFLAC____StreamMetadata.html">FLAC__StreamMetadata</a> **metadata, <font class="keywordtype">unsigned</font> num_blocks);
00451 
00471 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a22">FLAC__file_encoder_set_filename</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keyword">const</font> <font class="keywordtype">char</font> *value);
00472 
00492 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a23">FLAC__file_encoder_set_progress_callback</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <a class="code" href="FLAC_2file__encoder_8h.html#a1">FLAC__FileEncoderProgressCallback</a> value);
00493 
00506 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a24">FLAC__file_encoder_set_client_data</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keywordtype">void</font> *value);
00507 
00516 FLAC_API <a class="code" href="FLAC_2file__encoder_8h.html#a52">FLAC__FileEncoderState</a> <a class="code" href="FLAC_2file__encoder_8h.html#a25">FLAC__file_encoder_get_state</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00517 
00528 FLAC_API <a class="code" href="FLAC_2seekable__stream__encoder_8h.html#a56">FLAC__SeekableStreamEncoderState</a> <a class="code" href="FLAC_2file__encoder_8h.html#a26">FLAC__file_encoder_get_seekable_stream_encoder_state</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00529 
00541 FLAC_API <a class="code" href="FLAC_2stream__encoder_8h.html#a52">FLAC__StreamEncoderState</a> <a class="code" href="FLAC_2file__encoder_8h.html#a27">FLAC__file_encoder_get_stream_encoder_state</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00542 
00555 FLAC_API <a class="code" href="FLAC_2stream__decoder_8h.html#a36">FLAC__StreamDecoderState</a> <a class="code" href="FLAC_2file__encoder_8h.html#a28">FLAC__file_encoder_get_verify_decoder_state</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00556 
00568 FLAC_API <font class="keyword">const</font> <font class="keywordtype">char</font> *<a class="code" href="FLAC_2file__encoder_8h.html#a29">FLAC__file_encoder_get_resolved_state_string</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00569 
00590 FLAC_API <font class="keywordtype">void</font> <a class="code" href="FLAC_2file__encoder_8h.html#a30">FLAC__file_encoder_get_verify_decoder_error_stats</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, FLAC__uint64 *absolute_sample, <font class="keywordtype">unsigned</font> *frame_number, <font class="keywordtype">unsigned</font> *channel, <font class="keywordtype">unsigned</font> *sample, FLAC__int32 *expected, FLAC__int32 *got);
00591 
00602 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a31">FLAC__file_encoder_get_verify</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00603 
00614 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a32">FLAC__file_encoder_get_streamable_subset</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00615 
00626 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a33">FLAC__file_encoder_get_do_mid_side_stereo</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00627 
00638 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a34">FLAC__file_encoder_get_loose_mid_side_stereo</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00639 
00650 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a35">FLAC__file_encoder_get_channels</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00651 
00662 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a36">FLAC__file_encoder_get_bits_per_sample</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00663 
00674 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a37">FLAC__file_encoder_get_sample_rate</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00675 
00686 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a38">FLAC__file_encoder_get_blocksize</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00687 
00698 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a39">FLAC__file_encoder_get_max_lpc_order</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00699 
00710 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a40">FLAC__file_encoder_get_qlp_coeff_precision</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00711 
00722 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a41">FLAC__file_encoder_get_do_qlp_coeff_prec_search</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00723 
00734 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a42">FLAC__file_encoder_get_do_escape_coding</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00735 
00746 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a43">FLAC__file_encoder_get_do_exhaustive_model_search</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00747 
00758 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a44">FLAC__file_encoder_get_min_residual_partition_order</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00759 
00770 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a45">FLAC__file_encoder_get_max_residual_partition_order</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00771 
00782 FLAC_API <font class="keywordtype">unsigned</font> <a class="code" href="FLAC_2file__encoder_8h.html#a46">FLAC__file_encoder_get_rice_parameter_search_dist</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00783 
00794 FLAC_API FLAC__uint64 <a class="code" href="FLAC_2file__encoder_8h.html#a47">FLAC__file_encoder_get_total_samples_estimate</a>(<font class="keyword">const</font> <a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00795 
00810 FLAC_API <a class="code" href="FLAC_2file__encoder_8h.html#a52">FLAC__FileEncoderState</a> <a class="code" href="FLAC_2file__encoder_8h.html#a48">FLAC__file_encoder_init</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00811 
00826 FLAC_API <font class="keywordtype">void</font> <a class="code" href="FLAC_2file__encoder_8h.html#a49">FLAC__file_encoder_finish</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder);
00827 
00843 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a50">FLAC__file_encoder_process</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keyword">const</font> FLAC__int32 * <font class="keyword">const</font> buffer[], <font class="keywordtype">unsigned</font> samples);
00844 
00863 FLAC_API FLAC__bool <a class="code" href="FLAC_2file__encoder_8h.html#a51">FLAC__file_encoder_process_interleaved</a>(<a class="code" href="structFLAC____FileEncoder.html">FLAC__FileEncoder</a> *encoder, <font class="keyword">const</font> FLAC__int32 buffer[], <font class="keywordtype">unsigned</font> samples);
00864 
00865 <font class="comment">/* \} */</font>
00866 
00867 <font class="preprocessor">#ifdef __cplusplus</font>
00868 <font class="preprocessor"></font>}
00869 <font class="preprocessor">#endif</font>
00870 <font class="preprocessor"></font>
00871 <font class="preprocessor">#endif</font>
</pre></div><hr><address><small>Generated on Fri Feb 4 18:39:10 2005 for FLAC by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.gif" alt="doxygen" align="middle" border=0 
width=110 height=53></a>1.2.14 written by <a href="mailto:dimitri@stack.nl">Dimitri van Heesch</a>,
 &copy;&nbsp;1997-2002</small></address>
</body>
</html>
