/*
 * libmad - MPEG audio decoder library
 * Copyright (C) 2000-2004 Underbit Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: huffman.h,v 1.11 2004/01/23 09:41:32 rob Exp $
 */

/********************************************************************************
* huffman.h MODIFIED for compiling with MetroWerks CodeWarrior 5 and 6.3 on MacOS
*
* Copyright (C) 2004-2008 moreforge
*
* This program is free software. you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation@ either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY, without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program@ if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
**************************************************************************/

/* CodeWarrior modifications, also see the modified layer3.c */

# ifndef LIBMAD_HUFFMAN_H
# define LIBMAD_HUFFMAN_H

#ifdef WORDS_BIGENDIAN
 #error WORDS_BIGENDIAN needs to be undefined for Metrowerks CW
#endif

union huffquad {
  struct {
    unsigned short final  :  1;
    unsigned short bits   :  3;
    unsigned short offset : 12;
  } ptr;
  struct {
    unsigned short final :  1;
    unsigned short hlen  :  3;
    unsigned short v     :  1;
    unsigned short w     :  1;
    unsigned short x     :  1;
    unsigned short y     :  1;
    unsigned short b8    :  1;
    unsigned short b9    :  1;
    unsigned short ba    :  1;
    unsigned short bb    :  1;
    unsigned short bc    :  1;
    unsigned short bd    :  1;
    unsigned short be    :  1;
    unsigned short bf    :  1;
  } value;
  unsigned short final   :  1;
  struct {
    unsigned short b0    :  1;
    unsigned short b1    :  1;
    unsigned short b2    :  1;
    unsigned short b3    :  1;
    unsigned short b4    :  1;
    unsigned short b5    :  1;
    unsigned short b6    :  1;
    unsigned short b7    :  1;
    unsigned short b8    :  1;
    unsigned short b9    :  1;
    unsigned short ba    :  1;
    unsigned short bb    :  1;
    unsigned short bc    :  1;
    unsigned short bd    :  1;
    unsigned short be    :  1;
    unsigned short bf    :  1;
  } all;
};

union huffpair {
  struct {
    unsigned short final  :  1;
    unsigned short bits   :  3;
    unsigned short offset : 12;
  } ptr;
  struct {
    unsigned short final :  1;
    unsigned short hlen  :  3;
    unsigned short x     :  4;
    unsigned short y     :  4;
    unsigned short bc    :  1;
    unsigned short bd    :  1;
    unsigned short be    :  1;
    unsigned short bf    :  1;
  } value;
  unsigned short final   :  1;
  struct {
    unsigned short b0    :  1;
    unsigned short b1    :  1;
    unsigned short b2    :  1;
    unsigned short b3    :  1;
    unsigned short b4    :  1;
    unsigned short b5    :  1;
    unsigned short b6    :  1;
    unsigned short b7    :  1;
    unsigned short b8    :  1;
    unsigned short b9    :  1;
    unsigned short ba    :  1;
    unsigned short bb    :  1;
    unsigned short bc    :  1;
    unsigned short bd    :  1;
    unsigned short be    :  1;
    unsigned short bf    :  1;
  } all;
};

struct hufftable {
  union huffpair const *table;
  unsigned short linbits;
  unsigned short startbits;
};

extern union huffquad const *const mad_huff_quad_table[2];
extern struct hufftable const mad_huff_pair_table[32];

# endif
