#!/bin/sh

# script mamklibsunix.sh
# rebuilds the libs in the libs dir for unix
#--------------------------------------------------------------------------

# run from the MoreAmp/libs dir

if [ "libs" != `pwd | rev | cut -c 1-4 | rev` ] ; then
 echo "mamklibsunix.sh : not in libs"
 echo >&2 "mamklibsunix.sh : not in libs"
 exit 1
fi

#--------------------------------------------------------------------------

# cdparanoia

echo
date
echo "cdparanoia"
echo >&2
date >&2
echo >&2 "cdparanoia"

cd cdparanoia
make clean; make distclean
./configure --disable-shared
make lib
cp -p paranoia/libcdda_paranoia.a .
cp -p interface/libcdda_interface.a .
cd ..
#--------------------------------------------------------------------------

# faac

echo
date
echo "faac"
echo >&2
date >&2
echo >&2 "faac"

./mamkfaacunix.sh
#--------------------------------------------------------------------------

# faad2

echo
date
echo "faad2"
echo >&2
date >&2
echo >&2 "faad2"

./mamkfaad2unix.sh
#--------------------------------------------------------------------------

# lame

echo
date
echo "lame"
echo >&2
date >&2
echo >&2 "lame"

cd lame
make clean; make distclean
./configure --disable-shared --disable-decoder --disable-decode-layer2 --disable-frontend --disable-gtktest
# --disable-brhist
make
cp -p libmp3lame/.libs/libmp3lame.a .
cd ..
#--------------------------------------------------------------------------

# libid3tag

echo
date
echo "libid3tag"
echo >&2
date >&2
echo >&2 "libid3tag"

cd libid3tag
make clean; make distclean
./configure --disable-shared
make
cp -p ./.libs/libid3tag.a .
cd ..
#--------------------------------------------------------------------------

# libmad

echo
date
echo "libmad"
echo >&2
date >&2
echo >&2 "libmad"

cd libmad
make clean; make distclean
./configure --disable-shared
make
cp -p ./.libs/libmad.a .
cd ..
#--------------------------------------------------------------------------

# libogg

echo
date
echo "libogg"
echo >&2
date >&2
echo >&2 "libogg"

cd libogg
make clean; make distclean
./configure --disable-shared --prefix=`pwd`/inst
make
cp -p src/.libs/libogg.a .
make install
cd ..
#--------------------------------------------------------------------------

# libvorbis

echo
date
echo "libvorbis"
echo >&2
date >&2
echo >&2 "libvorbis"

cd libvorbis
make clean; make distclean
./configure --disable-shared --with-ogg=`pwd`/../libogg/inst
make
cp -p lib/.libs/libvorbis.a .
cp -p lib/.libs/libvorbisenc.a .
cp -p lib/.libs/libvorbisfile.a .
cd ..
#--------------------------------------------------------------------------

# libjack

echo
date
echo "jack"
echo >&2
date >&2
echo >&2 "jack"

cd jack
make clean; # make distclean

./configure --enable-static --disable-shared --disable-portaudio

cd libjack
make
cd ..

mkdir -p ./$osxdir
cp -p libjack/.libs/libjack.a .
cd ..
#--------------------------------------------------------------------------

# portaudio

echo
date
echo "portaudio"
echo >&2
date >&2
echo >&2 "portaudio"

./mamkpaunix.sh
#--------------------------------------------------------------------------

# libFLAC

echo
date
echo "flac"
echo >&2
date >&2
echo >&2 "flac"

cd flac
make clean; make distclean

# 1.1.2
# ./configure --disable-shared \
#             --disable-dependency-tracking \
#             --disable-libtool-lock \
#             --disable-oggtest

# 1.2.1
# ./configure --disable-shared --disable-dependency-tracking --disable-libtool-lock --disable-oggtest --disable-ogg --disable-xmms-plugin --disable-flac --disable-doxygen-docs --disable-cpplibs

./configure --disable-shared \
            --disable-dependency-tracking \
            --disable-libtool-lock \
            --disable-oggtest \
            --disable-ogg --disable-xmms-plugin --disable-flac --disable-doxygen-docs --disable-cpplibs

cd src/libFLAC
make
cd ../..
cp -p src/libFLAC/.libs/libFLAC.a .
cd ..

#--------------------------------------------------------------------------

echo
date
echo >&2
date >&2
