// maAudioWin.c

/*
 * MoreAmp Win32 audio 
 * Copyright (C) 2004-2008 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "maConfig.h" // included by all moreamp files

#ifdef __MAWIN__
 #ifdef MAUNUSEDWIN
  #pragma warning( disable : 4100 ) // unreferenced formal parameter
 #endif
 #pragma warning( disable : 4115 ) // named type definition in parentheses
 #pragma warning( disable : 4206 ) // nonstandard extension used : translation unit is empty
#endif

#ifdef AUDIO_WIN_WAVE


#ifdef __cplusplus
extern "C"
{
#endif

#include <wtypes.h>
#include <stdio.h>

#include "maPlayer.h"
#include "maUtils.h"
#include "maEqualizer.h"
#include "maAudioWin.h"

#define MMNODRV
#define MMNOMIDI
#define MMNOAUX
#define MMNOJOY
#define MMNOMCI
#define MMNOMMIO
#include <mmsystem.h>

WAVEFORMATEX l_format;

int win32PauseSound();
int win32ResumeSound();

void CALLBACK psSndCallBackProc(HWAVEOUT handle, UINT message,
						DWORD data, DWORD param1, DWORD param2);

int waveWrite(HWAVEOUT handle, WAVEHDR *header, char *pcm_data,
									DWORD pcm_length, DWORD user);

int g_semwaiting;

 // locals :
// int l_win32mixid = 0;
// HMIXER l_win32mixhandle = NULL;
HWAVEOUT l_pSoundChannel = NULL;
WAVEHDR l_header[NSNDBUFS] = {0};

int maPause(int pause)
{
	int previous = g_pause;
		
	if(pause && previous == 0)
	{
		if(!win32PauseSound())
			g_pause = 1;
	}
	else if(previous == 1)
	{
		if(!win32ResumeSound())
			g_pause = 0;
	}

	return previous;
		
} // maPause


int l_winvolumer;
int l_winvolumel;
void maOutputSetVolume(int volumeL, int volumeR)
{
	// this sets up integer multipliers used in waveWrite() to reduce the volume
	l_winvolumer = volumeR;
	l_winvolumel = volumeL;
	
	/*
	// this sets the volume system-wide
	MIXERLINECONTROLS mixlinectrl;
	MIXERCONTROL mixctrl;
	MIXERCONTROLDETAILS_UNSIGNED vol[2];
	MIXERCONTROLDETAILS details;
	unsigned int idmixer;

	if(!l_pSoundChannel)
		return;

	if(!l_win32mixhandle)
	{
		mixerGetID(0L, &idmixer, MIXER_OBJECTF_WAVEOUT);

		if(mixerOpen(&l_win32mixhandle, idmixer, 0, 0, 0) == MMSYSERR_NOERROR)
		{
			memset(&mixlinectrl, 0, sizeof(mixlinectrl));
			mixlinectrl.cbStruct = sizeof(mixlinectrl);
			mixlinectrl.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME;
			mixlinectrl.cControls = 1;
			mixlinectrl.cbmxctrl = sizeof(MIXERCONTROL);
			mixlinectrl.pamxctrl = &mixctrl;
			memset(&mixctrl, 0, sizeof(mixctrl));
			mixctrl.cbStruct = sizeof(mixctrl);

			mixerGetLineControls((HMIXEROBJ)l_win32mixhandle, 
									&mixlinectrl, 
									MIXER_OBJECTF_HMIXER | MIXER_GETLINECONTROLSF_ONEBYTYPE);
			l_win32mixid = mixctrl.dwControlID;
		}
		else
		{
			maLog("maOutputSetVolume mixerOpen failed");
			l_win32mixhandle = NULL;
			return;
		}

	}

	details.cbStruct = sizeof(MIXERCONTROLDETAILS);
	details.dwControlID = l_win32mixid;
	details.cChannels = 2;
	details.hwndOwner = NULL;
	details.cMultipleItems = 0;
	details.cbDetails = sizeof(MIXERCONTROLDETAILS_UNSIGNED);
	details.paDetails = &vol;

	//vol[0].dwValue = ((( volume        & 0xff) * 100)/kVOLMAX) * 0x28F; (0x28f == 655)
	//vol[1].dwValue = ((((volume >> 16) & 0xff) * 100)/kVOLMAX) * 0x28F;

	//old vol[0].dwValue = (volume & 0x000000ff) << kVOLEXP; // left
	//old vol[1].dwValue = (volume & 0x00ff0000) >> kVOLEXP;
	vol[0].dwValue = volumeL; // new untested
	vol[1].dwValue = volumeR;

	mixerSetControlDetails((HMIXEROBJ)l_win32mixhandle, &details, MIXER_OBJECTF_HMIXER);
	*/
	
} // maOutputSetVolume


int win32PauseSound()
{
	MMRESULT err;
	char cstr[256];

	if(!l_pSoundChannel)
		return 1;

	if((err = waveOutPause(l_pSoundChannel)) != MMSYSERR_NOERROR)
	{
		sprintf(cstr, "win32PauseSound waveOutPause err=%d", err);
		maLog(cstr);
		return 1;
	}
		  
	return 0;

} // win32PauseSound


int win32ResumeSound()
{
	MMRESULT err;

	if(!l_pSoundChannel)
		return 1;

	if(g_stopB) // silence
		waveOutReset(l_pSoundChannel);

	if((err = waveOutRestart(l_pSoundChannel)) != MMSYSERR_NOERROR)
	{
		char cstr[256];
		sprintf(cstr, "win32ResumeSound waveOutRestart err=%d", err);
		maLog(cstr);
		return 1;
	}

	return 0;
		
} // win32ResumeSound


#ifndef OSErr
 #define OSErr signed long
#endif
#ifndef noErr
 #define noErr 0
#endif


int waveWrite(HWAVEOUT handle, WAVEHDR *pheader, char *pcm_data, DWORD pcm_length, DWORD user)
{
	// we do the volume control here
	short *p, *q;
	DWORD i;

	if(g_stopB) // silence
		return 0;

	if(l_winvolumer == kVOLMAX && l_winvolumel == kVOLMAX) // no change in volume
	{
	}
	else if(l_winvolumer == kVOLMAX) // reduce left volume only
	{
		p = (short *)pcm_data;
		for(i = 0; i < pcm_length >> 2; i++)
		{
			*p++ = (short)((l_winvolumel * *p) >> kVOLEXP);
			p++;
		}
	}
	else if(l_winvolumel == kVOLMAX) // reduce right volume only
	{
		q = (short *)(pcm_data + 2);
		for(i = 0; i < pcm_length >> 2; i++)
		{
			*q++ = (short)((l_winvolumer * *q) >> kVOLEXP);
			q++;
		}
	}
	else // reduce both left and right volumes
	{
		p = (short *)pcm_data;
		q = p + 1;
		for(i = 0; i < pcm_length >> 2; i++)
		{
			*p++ = (short)((l_winvolumel * *p) >> kVOLEXP);
			p++;
			*q++ = (short)((l_winvolumer * *q) >> kVOLEXP);
			q++;
		}
	}

	if(pheader->dwFlags & WHDR_PREPARED)
		waveOutUnprepareHeader(handle, pheader, sizeof(WAVEHDR));

	pheader->lpData         = pcm_data;
	pheader->dwBufferLength = pcm_length;
	pheader->dwUser         = user;
	pheader->dwFlags        = 0;
	pheader->dwLoops        = 0;

	if(waveOutPrepareHeader(handle, pheader, sizeof(WAVEHDR)) != MMSYSERR_NOERROR)
	{
		maLog("waveWrite waveOutPrepareHeader failed");
		return -1;
	}

	if(waveOutWrite(handle, pheader, sizeof(WAVEHDR)) != MMSYSERR_NOERROR)
	{
		maLog("waveWrite waveOutWrite failed");
		return -1;
	}
 
	return 0;

} // waveWrite


int maOutputToSound(void* pcmblock, unsigned long frames, unsigned long len, int whichbuf)
{
	if(waveWrite(l_pSoundChannel, &l_header[whichbuf],
						g_sndbuf[whichbuf], len, whichbuf) == -1)
		return 1;
	
	return 0;

} // maOutputToSound


int maOpenSndChannel()
{
	if(l_pSoundChannel)
	{
		if(!g_sets.fileout[kOUTSOUND].mode) // don't close and re-open the sound channel, unless required
		{
			if(l_format.nSamplesPerSec == (unsigned)g_state.insamplerate)
			{
				g_semwaiting = -1;
				return 0;
			}
			g_sets.fileout[kOUTSOUND].mode = 1;
			maCloseSndChannel(0);
			g_sets.fileout[kOUTSOUND].mode = 0;
		}
		else
			maCloseSndChannel(0);
	}

	// create a sync object
	if(maSemaphoreNew(&g_semaudiowin))
	{
		g_semaudiowin = NULL;
		maLog("maOpenSndChannel maSemaphoreNew failed");
		return 1;
	}
	
	g_semwaiting = -1;

	// open a sound channel

	// set_format(&l_format, channels, speed, depth);
	l_format.wFormatTag      = WAVE_FORMAT_PCM;
	l_format.nChannels       = MAOUTCHANNELS;
	l_format.nSamplesPerSec  = g_state.insamplerate;
	l_format.wBitsPerSample  = MAOUTBITS;
	l_format.nBlockAlign     = MAOUTBYTES; //channels * bits / 8  4;
	l_format.nAvgBytesPerSec = g_state.insamplerate * l_format.nBlockAlign; //speed * (channels * bits / 8) 176400;
	l_format.cbSize          = 0;

	if(waveOutOpen(&l_pSoundChannel, WAVE_MAPPER, &l_format, (DWORD)psSndCallBackProc,
									0, CALLBACK_FUNCTION) != MMSYSERR_NOERROR)
	{
		l_pSoundChannel = NULL;
		maLog("maOpenSndChannel failed to open a sound channel");
		g_state.stop |= STOP_SNDCHANNEL;
		return 1;
	}
		
	return 0;
	
} // maOpenSndChannel


void maCloseSndChannel(int wait)
{	
	int i;

	if(!l_pSoundChannel)
	{
		; //maLog("maLog maCloseSndChannel error null l_pSoundChannel");
	}
	else
	{
		// wait 'til not busy
		if(wait)
		{
			g_stopB = 0;
			while(!g_stopB)
			{
				for(i = 0; i < NSNDBUFS; i++)
					if(g_bufready[i]) // has not played yet
						break;
				if(i >= NSNDBUFS)
					break;
				ThreadYield();
			}
			while(!g_stopB)
			{
				for(i = 0; i < NSNDBUFS; i++)
					if(l_header[i].dwFlags & WHDR_PREPARED) // has not played yet
						if(waveOutUnprepareHeader(l_pSoundChannel, &l_header[i],
											sizeof(WAVEHDR)) == WAVERR_STILLPLAYING)
							break;
				if(i >= NSNDBUFS)
					break;
				ThreadYield();
			}
		}

		// g_waitaudiodone = 0;
		
		waveOutPause(l_pSoundChannel);
		waveOutReset(l_pSoundChannel);

		for(i = 0; i < NSNDBUFS; i++)
			if(l_header[i].dwFlags & WHDR_PREPARED)
				waveOutUnprepareHeader(l_pSoundChannel, &l_header[i], sizeof(WAVEHDR));

		if(!g_sets.fileout[kOUTSOUND].mode) // don't close and re-open the sound channel
		{
			// g_waitaudiodone = 0;
			return;
		}
		if(waveOutClose(l_pSoundChannel) != MMSYSERR_NOERROR)
			maLog("maCloseSndChannel waveOutClose failed");

		l_pSoundChannel = NULL;
		// g_waitaudiodone = 0;
	}

	/* if(l_win32mixhandle)
	{
		mixerClose(l_win32mixhandle);
		l_win32mixhandle = NULL;
		l_win32mixid = 0;
	}
	*/
	
	if(g_semaudiowin)
	{
		maSemaphoreDelete(g_semaudiowin);
		g_semaudiowin = NULL;
	}

} // maCloseSndChannel


// this is the sound callback
void CALLBACK psSndCallBackProc(HWAVEOUT handle, UINT message, DWORD data,
		       DWORD param1, DWORD param2)
{
	switch (message)
	{
		case WOM_DONE:
			g_bufready[((WAVEHDR *)param1)->dwUser] = 0;
			if(g_semwaiting == (int)((WAVEHDR *)param1)->dwUser)
				maSemaphorePost(g_semaudiowin);
			return;
		break;

		case WOM_OPEN:
		case WOM_CLOSE:
		default:
			return;
		break;
	}

} // psSndCallBackProc

#ifdef __cplusplus
}
#endif

#endif // AUDIO_WIN_WAVE

// eof
