// maCda.h

/*
 * MoreAmp
 * Copyright (C) 2004-2008 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __MACDA_H__
#define __MACDA_H__

#ifdef __cplusplus
extern "C"
{
#endif

#define CDAFRAMESPERSEC 75
#define CDAFRAMESPERSECL 75L
#define CDABLOCKSIZE 2352

typedef struct
{
	int driverRefNum;			// access to cd reader
#ifndef __MAUNIX__
	int fsvolrefnum;			// cd reader volume on mac, drive letter on pc, not used on unix
#endif
	int exists;					// drive exists in system
	int isactive;				// drive is selected for audio use
	int isready;				// drive is ready for audio use, has audio media
	int track;					// 1-based this track
	int tracklast;				// 1-based last track of cd
	unsigned int lbasintrack;	// total blocks in this track
	unsigned int lbafirst;		// first block of this track
	unsigned int lbalast;		// last block of this track
	unsigned int lba;			// first of numblocks to read
	int durationsecs;			// duration of this track
	char name[256];				// e.g. "CD Audio 7"
} cdadrive;

// __MAOSX__
typedef struct
{
	int track;					// 1-based track index
	unsigned int lbasintrack;	// total blocks in this track
	unsigned int lbafirst;		// first block of this track
	unsigned int lbalast;		// last block of this track
	int durationsecs;			// duration of this track
} cdatrack;

typedef struct
{
	int driverRefNum;			// access to cd reader
	int fsvolrefnum;			// FSVolumeRefNum fsvolrefnum;	// cd reader volume on mac, drive letter on pc
	short forkRefNum;			// SInt16 forkRefNum;			// of file opened for reading, e.g. "1 Audio Track.aiff"
	int exists;					// drive exists in system
	int isactive;				// drive is selected for audio use
	int isready;				// drive is ready for audio use, has audio media
	int track;					// 1-based this track
	int tracklast;				// 1-based last track of cd
	unsigned int lba;			// first of numblocks to read
	char name[256];				// e.g. "CD Audio 7"
	cdatrack *cdtrack;			// pointers to track data
} cdadisk;

extern char *g_cdabuf;
extern int g_cdabufblocks;

#if defined(__MAOS9__)
 #pragma import on
#endif

int CdaGetTrackStartEnd(int drive);
int CdaReadTrack(int drive, long *pbytesread);
int CdaGetCdInfo(int drive, char *StrtTrk, char *EndTrk);
int CdaGetCdFeatures(int drive, unsigned int *features);
int CdaGetBlockSize(int drive, int* blocksize);
int CdaSetBlockSize(int drive, int blocksize);
int CdaSetSpindleSpeed(int drive, int speed);
int CdaGetEndOfDisk(int drive, unsigned char *datablk);
int CdaCleanup(int drive);
int CdaEject(int drive);
int CdaInitCDRom();
void CdaDeInitCDRom();

#ifndef __MAWIN__
 extern int g_cdaactive;
#endif

extern int g_cdanumdrives;

#if defined(__MAOS9__)
 #pragma import off
#endif

#if defined(__MAOSX__) || defined(__MAOS9__)
 int CdaGetCDDrives();
#endif

#if defined(__MAOSX__)
 int CdaPBOpenFile(int drive);
 int CdaPBCloseFile(int drive);
#endif

extern cdadrive g_cdadrive[];

#ifdef __cplusplus
}
#endif

#endif // __MACDA_H__

// eof

