// maGUI.h

/*
 * MoreAmp
 * Copyright (C) 2004-2008 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __MAGUI_H__
#define __MAGUI_H__

#include "maDefs.h"

#ifdef __cplusplus
extern "C"
{
#endif

// factory window positions and sizes
///////////////////////////////////////////////////////////////////////

#if defined(MAGUIOSX) && !defined(MAGUIWX)
 #define XADD 8 // fudge
 #define YADD 26
 
 #define ABOUTXPOSDEF 1
 #define ABOUTYPOSDEF 45
 #define ABOUTXSIZEDEF 680
 #define ABOUTYSIZEDEF 500
 
 #define VIEWERXPOSDEF 300
 #define VIEWERYPOSDEF 45
 #define VIEWERXSIZEDEF 680
 #define VIEWERYSIZEDEF 500
 
 #define KEYBINDINGSXPOSDEF 200
 #define KEYBINDINGSYPOSDEF 45
 #define KEYBINDINGSXSIZEDEF 400
 #define KEYBINDINGSYSIZEDEF 500
 
 #define SCROLLERWIDTH 16

 #define XPOSDEF 1
 #define YPOSDEF 45
 #define XSIZEDEF 300
 #define YSIZEDEF 272

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + XADD)
 #define LISTYPOSDEF YPOSDEF
 #define LISTXSIZEDEF 293
 #define LISTYSIZEDEF YSIZEDEF
 #define LISTCOLXSIZEDEF (LISTXSIZEDEF - SCROLLERWIDTH)

 #define EQXPOSDEF XPOSDEF
 #define EQYPOSDEF (YPOSDEF + YSIZEDEF + YADD)
 #define EQXSIZEDEF 601
 #define EQYSIZEDEF 252
 
 #define EQ2POSDELTA 10
 #define EQ2XPOSDEF (EQXPOSDEF + EQ2POSDELTA)
 #define EQ2YPOSDEF (EQYPOSDEF + EQ2POSDELTA)
 #define EQ2XSIZEDEF EQXSIZEDEF
 #define EQ2YSIZEDEF EQYSIZEDEF

 #define EFFECTSXPOSDEF (LISTXPOSDEF + LISTXSIZEDEF + XADD)
 #define EFFECTSYPOSDEF YPOSDEF
 #define EFFECTSXSIZEDEF 252
 #define EFFECTSYSIZEDEF YSIZEDEF
 
 #define FILEOUTXPOSDEF XPOSDEF
 #define FILEOUTYPOSDEF (EQYPOSDEF + 100)
 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 250

 #define XPOSDEF2 XPOSDEF // alt values
 #define YPOSDEF2 YPOSDEF
 #define XSIZEDEF2 XSIZEDEF
 #define YSIZEDEF2 50
 
 #define LISTXPOSDEF2 XPOSDEF2
 #define LISTYPOSDEF2 (YPOSDEF2 + YSIZEDEF2 + YADD)
 #define LISTXSIZEDEF2 XSIZEDEF2
 #define LISTYSIZEDEF2 (EQYSIZEDEF2 + EFFECTSYSIZEDEF2 - YSIZEDEF2)
 
 #define EQXPOSDEF2 LISTXPOSDEF
 #define EQYPOSDEF2 LISTYPOSDEF
 #define EQXSIZEDEF2 EQXSIZEDEF
 #define EQYSIZEDEF2 EQYSIZEDEF

 #define EQ2XPOSDEF2 (EQXPOSDEF2 + EQ2POSDELTA)
 #define EQ2YPOSDEF2 (EQYPOSDEF2 + EQ2POSDELTA)
 #define EQ2XSIZEDEF2 EQXSIZEDEF2
 #define EQ2YSIZEDEF2 EQYSIZEDEF2

 #define EFFECTSXPOSDEF2 EQXPOSDEF2
 #define EFFECTSYPOSDEF2 (EQYPOSDEF2 + EQYSIZEDEF2 + YADD)
 #define EFFECTSXSIZEDEF2 EFFECTSXSIZEDEF
 #define EFFECTSYSIZEDEF2 EQYSIZEDEF
 
 #define FILEOUTXPOSDEF2 FILEOUTXPOSDEF
 #define FILEOUTYPOSDEF2 FILEOUTYPOSDEF
 #define FILEOUTXSIZEDEF2 FILEOUTXSIZEDEF
 #define FILEOUTYSIZEDEF2 FILEOUTYSIZEDEF 
 
 #define LISTCOLXSIZEDEF2 LISTCOLXSIZEDEF

 #define ADVANCEDXPOSDEF LISTXPOSDEF
 #define ADVANCEDYPOSDEF LISTYPOSDEF
 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF 300
#endif // MAGUIOSX

///////////////////////////////////////////////////////////////////////

#if defined(__MAOSX__) && !defined(MAGUIOSX)
 #define ABOUTXPOSDEF 1
 #if defined(__WXMAC__)
  #define ABOUTYPOSDEF 30
 #else
  #define ABOUTYPOSDEF 1
 #endif
 #define ABOUTXSIZEDEF 680
 #define ABOUTYSIZEDEF 500

 #define VIEWERXPOSDEF 300
 #if defined(__WXMAC__)
  #define VIEWERYPOSDEF 30
 #else
  #define VIEWERYPOSDEF 1
 #endif
 #define VIEWERXSIZEDEF 680
 #define VIEWERYSIZEDEF 500

 #define KEYBINDINGSXPOSDEF 200
 #if defined(__WXMAC__)
  #define KEYBINDINGSYPOSDEF 30
 #else
  #define KEYBINDINGSYPOSDEF 1
 #endif
 #define KEYBINDINGSXSIZEDEF 400
 #define KEYBINDINGSYSIZEDEF 500

 #define YSIZEADJUST 0
 
 #define SCROLLERWIDTH 20

 #define XPOSDEF 1
 #define YPOSDEF 44
 #define XSIZEDEF 302
 #define YSIZEDEF (308 + YSIZEADJUST)

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 12)
 #define LISTYPOSDEF YPOSDEF
 #define LISTXSIZEDEF 450
 #define LISTYSIZEDEF YSIZEDEF
 #define LISTCOLXSIZEDEF (LISTXSIZEDEF - SCROLLERWIDTH)

 #define EQXPOSDEF XPOSDEF
 #define EQYPOSDEF 364
 #define EQXSIZEDEF 762
 #define EQYSIZEDEF (280 + YSIZEADJUST)

 #define EQ2POSDELTA 10
 #define EQ2XPOSDEF (EQXPOSDEF + EQ2POSDELTA)
 #define EQ2YPOSDEF (EQYPOSDEF + EQ2POSDELTA)
 #define EQ2XSIZEDEF EQXSIZEDEF
 #define EQ2YSIZEDEF EQYSIZEDEF

 #define EFFECTSXPOSDEF LISTXPOSDEF
 #define EFFECTSYPOSDEF EQYPOSDEF
 #define EFFECTSXSIZEDEF 300
 #define EFFECTSYSIZEDEF EQYSIZEDEF
 
 #define FILEOUTXPOSDEF 40
 #define FILEOUTYPOSDEF 400
 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF (220 + YSIZEADJUST)

 #define XPOSDEF2 XPOSDEF // alt values
 #define YPOSDEF2 YPOSDEF
 #define XSIZEDEF2 XSIZEDEF
 #define YSIZEDEF2 (86 + YSIZEADJUST)

 #define EQXPOSDEF2 EQXPOSDEF
 #define EQYPOSDEF2 EQYPOSDEF
 #define EFFECTSXPOSDEF2 EFFECTSXPOSDEF
 #define EFFECTSYPOSDEF2 EFFECTSYPOSDEF
 #define LISTXPOSDEF2 LISTXPOSDEF
 #define LISTYPOSDEF2 LISTYPOSDEF
 #define FILEOUTXPOSDEF2 FILEOUTXPOSDEF
 #define FILEOUTYPOSDEF2 FILEOUTYPOSDEF
 #define EQXSIZEDEF2 EQXSIZEDEF
 #define EQYSIZEDEF2 EQYSIZEDEF
 #define EFFECTSXSIZEDEF2 EFFECTSXSIZEDEF
 #define EFFECTSYSIZEDEF2 EFFECTSYSIZEDEF
 #define LISTXSIZEDEF2 LISTXSIZEDEF
 #define LISTYSIZEDEF2 LISTYSIZEDEF
 #define FILEOUTXSIZEDEF2 FILEOUTXSIZEDEF
 #define FILEOUTYSIZEDEF2 FILEOUTYSIZEDEF 
 #define LISTCOLXSIZEDEF2 LISTCOLXSIZEDEF

 #define EQ2XPOSDEF2 (EQXPOSDEF2 + EQ2POSDELTA)
 #define EQ2YPOSDEF2 (EQYPOSDEF2 + EQ2POSDELTA)
 #define EQ2XSIZEDEF2 EQXSIZEDEF2
 #define EQ2YSIZEDEF2 EQYSIZEDEF2

 #define ADVANCEDXPOSDEF LISTXPOSDEF
 #define ADVANCEDYPOSDEF LISTYPOSDEF
 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF 300
#endif // __MAOSX__

///////////////////////////////////////////////////////////////////////

#if defined(__MAOS9__)
 #define ABOUTXPOSDEF 1
 #define ABOUTYPOSDEF 1
 #define ABOUTXSIZEDEF 680
 #define ABOUTYSIZEDEF 500
 #define VIEWERXPOSDEF 300
 #define VIEWERYPOSDEF 1
 #define VIEWERXSIZEDEF 680
 #define VIEWERYSIZEDEF 500
 #define KEYBINDINGSXPOSDEF 200
 #define KEYBINDINGSYPOSDEF 1
 #define KEYBINDINGSXSIZEDEF 400
 #define KEYBINDINGSYSIZEDEF 500

 #define YSIZEADJUST 0
 
 #define SCROLLERWIDTH 20

 #define XPOSDEF 1
 #define YPOSDEF 44
 #define XSIZEDEF 302
 #define YSIZEDEF (288 + YSIZEADJUST)

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 12)
 #define LISTYPOSDEF YPOSDEF
 #define LISTXSIZEDEF 450
 #define LISTYSIZEDEF YSIZEDEF
 #define LISTCOLXSIZEDEF (LISTXSIZEDEF - SCROLLERWIDTH)

 #define EQXPOSDEF XPOSDEF
 #define EQYPOSDEF 364
 #define EQXSIZEDEF 762
 #define EQYSIZEDEF (260 + YSIZEADJUST)
 
 #define EQ2POSDELTA 10
 #define EQ2XPOSDEF (EQXPOSDEF + EQ2POSDELTA)
 #define EQ2YPOSDEF (EQYPOSDEF + EQ2POSDELTA)
 #define EQ2XSIZEDEF EQXSIZEDEF
 #define EQ2YSIZEDEF EQYSIZEDEF

 #define EFFECTSXPOSDEF LISTXPOSDEF
 #define EFFECTSYPOSDEF EQYPOSDEF
 #define EFFECTSXSIZEDEF 300
 #define EFFECTSYSIZEDEF EQYSIZEDEF
 
 #define FILEOUTXPOSDEF 40
 #define FILEOUTYPOSDEF 400
 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF (200 + YSIZEADJUST) 

 #define XPOSDEF2 XPOSDEF // alt values
 #define YPOSDEF2 YPOSDEF
 #define XSIZEDEF2 XSIZEDEF
 #define YSIZEDEF2 (76 + YSIZEADJUST)

 #define EQXPOSDEF2 EQXPOSDEF
 #define EQYPOSDEF2 EQYPOSDEF
 #define EFFECTSXPOSDEF2 EFFECTSXPOSDEF
 #define EFFECTSYPOSDEF2 EFFECTSYPOSDEF
 #define LISTXPOSDEF2 LISTXPOSDEF
 #define LISTYPOSDEF2 LISTYPOSDEF
 #define FILEOUTXPOSDEF2 FILEOUTXPOSDEF
 #define FILEOUTYPOSDEF2 FILEOUTYPOSDEF
 #define EQXSIZEDEF2 EQXSIZEDEF
 #define EQYSIZEDEF2 EQYSIZEDEF
 #define EFFECTSXSIZEDEF2 EFFECTSXSIZEDEF
 #define EFFECTSYSIZEDEF2 EFFECTSYSIZEDEF
 #define LISTXSIZEDEF2 LISTXSIZEDEF
 #define LISTYSIZEDEF2 LISTYSIZEDEF
 #define FILEOUTXSIZEDEF2 FILEOUTXSIZEDEF
 #define FILEOUTYSIZEDEF2 FILEOUTYSIZEDEF 
 #define LISTCOLXSIZEDEF2 LISTCOLXSIZEDEF

 #define EQ2XPOSDEF2 (EQXPOSDEF2 + EQ2POSDELTA)
 #define EQ2YPOSDEF2 (EQYPOSDEF2 + EQ2POSDELTA)
 #define EQ2XSIZEDEF2 EQXSIZEDEF2
 #define EQ2YSIZEDEF2 EQYSIZEDEF2

 #define ADVANCEDXPOSDEF LISTXPOSDEF
 #define ADVANCEDYPOSDEF LISTYPOSDEF
 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF 300
#endif // __MAOS9__

///////////////////////////////////////////////////////////////////////

#if defined(__MAWIN__)
 #define ABOUTXPOSDEF 1
 #define ABOUTYPOSDEF 1
 #define ABOUTXSIZEDEF 680
 #define ABOUTYSIZEDEF 500
 #define VIEWERXPOSDEF 300
 #define VIEWERYPOSDEF 1
 #define VIEWERXSIZEDEF 680
 #define VIEWERYSIZEDEF 500
 #define KEYBINDINGSXPOSDEF 200
 #define KEYBINDINGSYPOSDEF 1
 #define KEYBINDINGSXSIZEDEF 400
 #define KEYBINDINGSYSIZEDEF 500

 #define YSIZEADJUST 0
 
 #define SCROLLERWIDTH 20

 #define XPOSDEF 1
 #define YPOSDEF 42
 #define XSIZEDEF 312
 #define YSIZEDEF 336

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF)
 #define LISTYPOSDEF YPOSDEF
 #define LISTXSIZEDEF 450
 #define LISTYSIZEDEF YSIZEDEF
 #define LISTCOLXSIZEDEF (LISTXSIZEDEF - SCROLLERWIDTH)

 #define EQXPOSDEF XPOSDEF
 #define EQYPOSDEF 378
 #define EQXSIZEDEF 762
 #define EQYSIZEDEF 308

 #define EQ2POSDELTA 10
 #define EQ2XPOSDEF (EQXPOSDEF + EQ2POSDELTA)
 #define EQ2YPOSDEF (EQYPOSDEF + EQ2POSDELTA)
 #define EQ2XSIZEDEF EQXSIZEDEF
 #define EQ2YSIZEDEF EQYSIZEDEF

 #define EFFECTSXPOSDEF LISTXPOSDEF
 #define EFFECTSYPOSDEF EQYPOSDEF
 #define EFFECTSXSIZEDEF 300
 #define EFFECTSYSIZEDEF EQYSIZEDEF

 #define FILEOUTXPOSDEF 40
 #define FILEOUTYPOSDEF 400
 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 200

 #define XPOSDEF2 XPOSDEF
 #define YPOSDEF2 YPOSDEF
 #define XSIZEDEF2 XSIZEDEF
 #define YSIZEDEF2 124

 #define EQXPOSDEF2 EQXPOSDEF
 #define EQYPOSDEF2 EQYPOSDEF
 #define EFFECTSXPOSDEF2 EFFECTSXPOSDEF
 #define EFFECTSYPOSDEF2 EFFECTSYPOSDEF
 #define LISTXPOSDEF2 LISTXPOSDEF
 #define LISTYPOSDEF2 LISTYPOSDEF
 #define FILEOUTXPOSDEF2 FILEOUTXPOSDEF
 #define FILEOUTYPOSDEF2 FILEOUTYPOSDEF
 #define EQXSIZEDEF2 EQXSIZEDEF
 #define EQYSIZEDEF2 EQYSIZEDEF
 #define EFFECTSXSIZEDEF2 EFFECTSXSIZEDEF
 #define EFFECTSYSIZEDEF2 EFFECTSYSIZEDEF
 #define LISTXSIZEDEF2 LISTXSIZEDEF
 #define LISTYSIZEDEF2 LISTYSIZEDEF
 #define FILEOUTXSIZEDEF2 FILEOUTXSIZEDEF
 #define FILEOUTYSIZEDEF2 FILEOUTYSIZEDEF 
 #define LISTCOLXSIZEDEF2 LISTCOLXSIZEDEF

 #define EQ2XPOSDEF2 (EQXPOSDEF2 + EQ2POSDELTA)
 #define EQ2YPOSDEF2 (EQYPOSDEF2 + EQ2POSDELTA)
 #define EQ2XSIZEDEF2 EQXSIZEDEF2
 #define EQ2YSIZEDEF2 EQYSIZEDEF2

 #define ADVANCEDXPOSDEF LISTXPOSDEF
 #define ADVANCEDYPOSDEF LISTYPOSDEF
 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF 300
#endif // __MAWIN__

///////////////////////////////////////////////////////////////////////

#if defined( __MAUNIX__) && !defined(MAGUIGTK)
 #define ABOUTXPOSDEF 1
 #define ABOUTYPOSDEF 1
 #define ABOUTXSIZEDEF 680
 #define ABOUTYSIZEDEF 500
 #define VIEWERXPOSDEF 300
 #define VIEWERYPOSDEF 1
 #define VIEWERXSIZEDEF 680
 #define VIEWERYSIZEDEF 500
 #define KEYBINDINGSXPOSDEF 200
 #define KEYBINDINGSYPOSDEF 1
 #define KEYBINDINGSXSIZEDEF 400
 #define KEYBINDINGSYSIZEDEF 500

 #if defined(__WXX11__)
  #define YSIZEADJUST 0 // wxx11
  #define MENUBARYSIZE 24
 #else
  #define YSIZEADJUST 0 // wxgtk
  #define MENUBARYSIZE 24
 #endif
 
 #define SCROLLERWIDTH 20
 
 #define XPOSDEF 1
 #define YPOSDEF 42
 #define XSIZEDEF 312
 #define YSIZEDEF 314

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 9)
 #define LISTYPOSDEF YPOSDEF
 #define LISTXSIZEDEF 422
 #define LISTYSIZEDEF (YSIZEDEF + YSIZEADJUST)
 #define LISTCOLXSIZEDEF (LISTXSIZEDEF - SCROLLERWIDTH)

 #define EQXPOSDEF XPOSDEF
 #define EQYPOSDEF 383
 #define EQXSIZEDEF 743
 #define EQYSIZEDEF (305 - MENUBARYSIZE)

 #define EQ2POSDELTA 10
 #define EQ2XPOSDEF (EQXPOSDEF + EQ2POSDELTA)
 #define EQ2YPOSDEF (EQYPOSDEF + EQ2POSDELTA)
 #define EQ2XSIZEDEF EQXSIZEDEF
 #define EQ2YSIZEDEF EQYSIZEDEF

 #define EFFECTSXPOSDEF LISTXPOSDEF
 #define EFFECTSYPOSDEF EQYPOSDEF
 #define EFFECTSXSIZEDEF 300
 #define EFFECTSYSIZEDEF EQYSIZEDEF

 #define FILEOUTXPOSDEF 40
 #define FILEOUTYPOSDEF 400
 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 200

 #define XPOSDEF2 XPOSDEF
 #define YPOSDEF2 YPOSDEF
 #define XSIZEDEF2 XSIZEDEF
 #define YSIZEDEF2 90

 #define EQXPOSDEF2 EQXPOSDEF
 #define EQYPOSDEF2 EQYPOSDEF
 #define EFFECTSXPOSDEF2 EFFECTSXPOSDEF
 #define EFFECTSYPOSDEF2 EFFECTSYPOSDEF
 #define LISTXPOSDEF2 LISTXPOSDEF
 #define LISTYPOSDEF2 LISTYPOSDEF
 #define FILEOUTXPOSDEF2 FILEOUTXPOSDEF
 #define FILEOUTYPOSDEF2 FILEOUTYPOSDEF
 #define EQXSIZEDEF2 EQXSIZEDEF
 #define EQYSIZEDEF2 EQYSIZEDEF
 #define EFFECTSXSIZEDEF2 EFFECTSXSIZEDEF
 #define EFFECTSYSIZEDEF2 EFFECTSYSIZEDEF
 #define LISTXSIZEDEF2 LISTXSIZEDEF
 #define LISTYSIZEDEF2 LISTYSIZEDEF
 #define FILEOUTXSIZEDEF2 FILEOUTXSIZEDEF
 #define FILEOUTYSIZEDEF2 FILEOUTYSIZEDEF 
 #define LISTCOLXSIZEDEF2 LISTCOLXSIZEDEF

 #define EQ2XPOSDEF2 (EQXPOSDEF2 + EQ2POSDELTA)
 #define EQ2YPOSDEF2 (EQYPOSDEF2 + EQ2POSDELTA)
 #define EQ2XSIZEDEF2 EQXSIZEDEF2
 #define EQ2YSIZEDEF2 EQYSIZEDEF2

 #define AUDIOCDXPOSDEF 40
 #define AUDIOCDYPOSDEF 400
 #define AUDIOCDXSIZEDEF 300
 #define AUDIOCDYSIZEDEF 200
 #define AUDIOCDXPOSDEF2 AUDIOCDXPOSDEF
 #define AUDIOCDYPOSDEF2 AUDIOCDYPOSDEF
 #define AUDIOCDXSIZEDEF2 AUDIOCDXSIZEDEF
 #define AUDIOCDYSIZEDEF2 AUDIOCDYSIZEDEF
 
 #define ADVANCEDXPOSDEF LISTXPOSDEF
 #define ADVANCEDYPOSDEF LISTYPOSDEF
 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF 300
#endif // __MAUNIX__ && !MAGUIGTK

///////////////////////////////////////////////////////////////////////

#if defined( __MAUNIX__) && defined(MAGUIGTK) // gtk1 or gtk2
 #define ABOUTXPOSDEF 1
 #define ABOUTYPOSDEF 1
 #define ABOUTXSIZEDEF 680
 #define ABOUTYSIZEDEF 500
 #define VIEWERXPOSDEF 300
 #define VIEWERYPOSDEF 1
 #define VIEWERXSIZEDEF 680
 #define VIEWERYSIZEDEF 500
 #define KEYBINDINGSXPOSDEF 200
 #define KEYBINDINGSYPOSDEF 1
 #define KEYBINDINGSXSIZEDEF 400
 #define KEYBINDINGSYSIZEDEF 500

#if defined(MAGUIGTK2)
 #define YSIZEADJUST 0
#else
 #define YSIZEADJUST 0
#endif

 #define MENUBARYSIZE 24
 
 #define SCROLLERWIDTH 30 // for sizing column0
 
 #define XPOSDEF 1
 #define YPOSDEF 1
 #define XSIZEDEF 312
 #define YSIZEDEF 312

 #define LISTXPOSDEF (XPOSDEF + XSIZEDEF + 9)
 #define LISTYPOSDEF YPOSDEF
 #define LISTXSIZEDEF 304
 #define LISTYSIZEDEF (YSIZEDEF + YSIZEADJUST)
 #define LISTCOLXSIZEDEF (LISTXSIZEDEF - SCROLLERWIDTH)

 #define EQXPOSDEF XPOSDEF
 #define EQYPOSDEF (YSIZEDEF + MENUBARYSIZE + MENUBARYSIZE + 4)
 #define EQXSIZEDEF 625
 #define EQYSIZEDEF (262 - MENUBARYSIZE)

 #define EQ2POSDELTA 10
 #define EQ2XPOSDEF (EQXPOSDEF + EQ2POSDELTA)
 #define EQ2YPOSDEF (EQYPOSDEF + EQ2POSDELTA)
 #define EQ2XSIZEDEF EQXSIZEDEF
 #define EQ2YSIZEDEF EQYSIZEDEF

 #define EFFECTSXPOSDEF LISTXPOSDEF
 #define EFFECTSYPOSDEF (EQYPOSDEF - MENUBARYSIZE)
 #define EFFECTSXSIZEDEF 280
 #define EFFECTSYSIZEDEF EQYSIZEDEF

 #define FILEOUTXPOSDEF EQXPOSDEF
 #define FILEOUTYPOSDEF (EQYPOSDEF - MENUBARYSIZE)
 #define FILEOUTXSIZEDEF 300
 #define FILEOUTYSIZEDEF 204

 #define XPOSDEF2 XPOSDEF
 #define YPOSDEF2 YPOSDEF
 #define XSIZEDEF2 XSIZEDEF
 #define YSIZEDEF2 100

 #define EQXPOSDEF2 EQXPOSDEF
 #define EQYPOSDEF2 EQYPOSDEF
 #define EFFECTSXPOSDEF2 EFFECTSXPOSDEF
 #define EFFECTSYPOSDEF2 EFFECTSYPOSDEF
 #define LISTXPOSDEF2 LISTXPOSDEF
 #define LISTYPOSDEF2 LISTYPOSDEF
 #define FILEOUTXPOSDEF2 FILEOUTXPOSDEF
 #define FILEOUTYPOSDEF2 FILEOUTYPOSDEF
 #define EQXSIZEDEF2 EQXSIZEDEF
 #define EQYSIZEDEF2 EQYSIZEDEF
 #define EFFECTSXSIZEDEF2 EFFECTSXSIZEDEF
 #define EFFECTSYSIZEDEF2 EFFECTSYSIZEDEF
 #define LISTXSIZEDEF2 LISTXSIZEDEF
 #define LISTYSIZEDEF2 LISTYSIZEDEF
 #define FILEOUTXSIZEDEF2 FILEOUTXSIZEDEF
 #define FILEOUTYSIZEDEF2 FILEOUTYSIZEDEF 
 #define LISTCOLXSIZEDEF2 LISTCOLXSIZEDEF

 #define EQ2XPOSDEF2 (EQXPOSDEF2 + EQ2POSDELTA)
 #define EQ2YPOSDEF2 (EQYPOSDEF2 + EQ2POSDELTA)
 #define EQ2XSIZEDEF2 EQXSIZEDEF2
 #define EQ2YSIZEDEF2 EQYSIZEDEF2

 #define AUDIOCDXPOSDEF EQXPOSDEF
 #define AUDIOCDYPOSDEF (EQYPOSDEF - MENUBARYSIZE)
 #define AUDIOCDXSIZEDEF 300
 #define AUDIOCDYSIZEDEF 200
 #define AUDIOCDXPOSDEF2 AUDIOCDXPOSDEF
 #define AUDIOCDYPOSDEF2 AUDIOCDYPOSDEF
 #define AUDIOCDXSIZEDEF2 AUDIOCDXSIZEDEF
 #define AUDIOCDYSIZEDEF2 AUDIOCDYSIZEDEF
 
 #define ADVANCEDXPOSDEF LISTXPOSDEF
 #define ADVANCEDYPOSDEF LISTYPOSDEF
 #define ADVANCEDXSIZEDEF 400
 #define ADVANCEDYSIZEDEF 300
#endif // __MAUNIX__ && MAGUIGTK

///////////////////////////////////////////////////////////////////////

// for maFileDialogM
typedef struct {
	int nitems;
	char **pitems;
	void *items; // null separated items
} maArray;

// api
void SpinButtonEnable(int window, int button);
void SpinButtonDisable(int window, int button);

void PushButtonPaintUp(int window, int button);
void PushButtonPaintDown(int window, int button);
void PushButtonPopup(int window, int button);

void PushButtonEnable(int window, int button);
void PushButtonDisable(int window, int button);
void PushButtonSimulateClick(int window, int button);
void PushButtonSetDescriptor(int window, int button, char *desc);

void PopupButtonEnable(int window, int popup);
void PopupButtonDisable(int window, int popup);
void PopupButtonClear(int window, int popup);
void PopupButtonAppend(int window, int popup, char *text);
void PopupButtonSetValue(int window, int popup, int value);
void PopupButtonSetText(int window, int popup, int item, char *text);
void PopupButtonGetSelection(int window, int popup, int *item);
void PopupButtonSetSelection(int window, int popup, int item);
//void PopupButtonGetText(int window, int edittext, int item, char *outBuffer, int inBufferLength, long *outTextLength);

void LittleArrowEnable(int window, int arrow);
void LittleArrowDisable(int window, int arrow);

void StaticTextEnable(int window, int statictext);
void StaticTextDisable(int window, int statictext);
void StaticTextSetText(int window, int statictext, char *text);
void StaticTextSetValue(int window, int statictext, int value);
void StaticTextRefresh(int window, int statictext);
void StaticTextGetText(int window, int statictext, char *text);

void EditTextSetText(int window, int edittext, char *text);
void EditTextGetText(int window, int edittext, char *outBuffer, int inBufferLength, long *outTextLength);

void ListAppend(int window, int list, char *text);
void ListClear(int window, int list);
int ListGetRowSelected(int window, int list);
void ListEnsureVisible(int window, int list, int row);
void ListSelect(int window, int list, int row);
void ListGetText(int window, int list, int row, char *text);
// not used void ListSetText(int window, int list, int row, char *text);
void ListSetHeader(int window, int list, int col, char *header);
void ListSetColumnWidth();

void MenuSetChecked(int menu, int item, int value);
int MenuIsChecked(int menu, int item);
void MenuEnable(int menu, int item);
void MenuDisable(int menu, int item);
void MenuSetLabel(int menu, char *label);
void MenuGetLabel(int menu, char *label);
void UpdateSubMenusRecent();

void CheckBoxSetValue(int window, int checkbox, int value);
int CheckBoxGetValue(int window, int checkbox);
void CheckBoxToggle(int window, int checkbox);
void CheckBoxSetDescriptor(int window, int checkbox, char *desc);
void CheckBoxHide(int window, int checkbox);
void CheckBoxShow(int window, int checkbox);
void CheckBoxEnable(int window, int checkbox);
void CheckBoxDisable(int window, int checkbox);

void maLogAPI(const char *whence, int window, int item);

void DisplayGetSize(int *x, int *y);

void WindowDoClose(int window);
void WindowDoDestroy(int window);
int WindowIsShown(int window);
void WindowSetSize(int window, int xsize, int ysize);
void WindowMove(int window, int xpos, int ypos);
void WindowShow(int window);
void WindowSetTitle(int window, char *title);
void WindowGetCoordinates(int window, int *xpos, int *ypos, int *xsize, int *ysize);
void WindowItemHide(int window, int item);
void WindowItemShow(int window, int item);

int	AppWindowMake();
void ListWindowMake();
void EqualizerWindowMake();
void Equalizer2WindowMake();
void EffectsWindowMake();
#if !defined(MANOCDA) && defined(__MAUNIX__)
 void AudioCDWindowMake();
#endif
void AdvancedWindowMake();
void FileOutWindowMake();
void PromptNumWindowMake();

int SliderGetValue(int window, int slider);
void SliderSetValue(int window, int slider, int value);
int HSliderGetValue(int window, int slider);
void HSliderSetValue(int window, int slider, int value);
void SliderEnable(int window, int slider);
void SliderDisable(int window, int slider);

int maFileDialog(char *selectedpath, int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags);
int maFileDialogM(maArray *parray,   int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags);
void maFileDialogMFree(maArray *parray);
int maDirSelector(char *pdirpath, char *prompt);

void guiAppYield();

int maMessageBox(char *s1, char *s2, int flags);

void DoTimerPlaySonglist(int delay);
void DoTimerRunLoop(int delay);
void DoTimerPlay(int delay);
void DoTimerStop(int delay);

void maViewCatalog();
void maViewLog();
void maViewReadme();
void maViewAbout();
#if defined(MAKEYBOARD)
 void maEditKeyBindings();
#endif

void maGUIfree();
void maGUIQuit();

int maModKeyDown();

#ifdef __cplusplus
}
#endif

#endif // __MAGUI_H__

// eof
