// maGUIosx.cpp

/*
 * MoreAmp
 * Copyright (C) 2005-2008 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "maConfig.h" // included by all moreamp files

// on os x 10.4 avoid compilation warnings such as:
// 'InitCursor' is deprecated (declared at /System/Library/Frameworks/ApplicationServices.framework/Frameworks/QD.framework/Headers/Quickdraw.h:2059)
#ifndef MAC_OS_X_VERSION_MIN_REQUIRED
    #define MAC_OS_X_VERSION_MIN_REQUIRED MAC_OS_X_VERSION_10_2
#endif
 
// This file contains the code to run with the native osx carbon (Interface Builder) gui.

#if defined(MAGUIOSX)

// #define MATRACEGUIOSX

#include <stdio.h>
#include <string.h>

#include <Events.h>

#include "maGUI.h"
#include "maUtils.h"
#include "maPlayer.h"
#include "maSongList.h"

#ifdef __cplusplus
extern "C"
{
#endif

EventLoopTimerRef l_timerrunloop;

UInt32 l_commandid[ID_MENU_LAST + 1] = {NULL};
int menuchecked[ID_MENU_LAST + 1] = {0}; // keep track of checked menu items here because don't know how to query for checked state 
int l_txnbusy = 0;
int l_linenum = 0;
int l_llinemax = 0;
char *l_lline;

OSStatus CommandEventHandler(HICommandExtended *command, int windowid, Rect *r);
OSStatus AppWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus ListWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus FileOutWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus EffectsWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus EqualizerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus Equalizer2WindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus ViewerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus AboutViewerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus PromptNumWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);
OSStatus AdvancedWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData);

void SliderCallback(ControlHandle control, SInt16 part);
ControlActionUPP SliderCallbackProc = NewControlActionUPP(SliderCallback);

OSStatus CheckBoxColorCallback(ControlRef inControl, SInt16 inMessage, SInt16 inDrawDepth, Boolean inDrawInColor);
ControlColorUPP CheckBoxColorCallbackProc = NewControlColorUPP(CheckBoxColorCallback);

void SetCommandId();
int MenuToggleChecked(UInt32 commandid);
void WindowGetOrigin(int window, int *xpos, int *ypos);
void WindowGetSize(int window, int *xsize, int *ysize);
int ViewerWindowMake(int windowid, char *wintitle);
int AboutViewerWindowMake(int windowid, char *wintitle);
void OnButtonFind(int windowid);
void OnButtonEditSave(int windowid);
void GetColumn0Width();
void EditTextRestoreSelection(int windowid);
OSStatus TextViewCustomScroll(WindowRef window, OSType signature, TXNScrollUnit scrollUnit,
								SInt32 textViewDelta, SInt32 cacheValue);
int MakeMenus(IBNibRef nibRef);
void MenuDeleteItem(int item);

#define CMD_MENU_ABOUT 'MMAB' // ID_MENU_FIRST
#define CMD_MENU_QUIT 'MFQU'
#define CMD_MENU_OPENLIST 'MFOP'
#define CMD_MENU_MAKELIST 'MFMA'
#define CMD_MENU_SAVELISTAS 'MFSA'
#define CMD_MENU_DELETELIST 'MFDE'
#define CMD_MENU_PLAYFILE 'MFPL'
#define CMD_MENU_OPENRECENT 'MFOE'
#define CMD_MENU_STOP 'MCST'
#define CMD_MENU_PAUSE 'MCPA'
#define CMD_MENU_PREVIOUS 'MCPR'
#define CMD_MENU_PLAY 'MCPL'
#define CMD_MENU_NEXT 'MCNE'
#define CMD_MENU_SETVDISK 'MSSE'
#if defined(MAINSTANCES)
 #define CMD_MENU_MULTIPLEINST 'MSMU'
#endif
#if defined(MAKEYBOARD)
 #define CMD_MENU_KEYBOARD 'MSUS'
#endif
#if defined(MAMOUSEWHEEL)
 #define CMD_MENU_MOUSEWHEEL 'MSUM'
#endif
#define CMD_MENU_ADVANCED 'MSAD'
#if(!defined(MANOCDA) && defined(__MAUNIX__))
 #define CMD_MENU_SETAUDIOCD 'NULL'
#endif
#define CMD_MENU_SETFACTORY 'MSFA'
#define CMD_MENU_SETDEFAULT 'MSDE'
#define CMD_MENU_SETSAVED 'MSSD'
#define CMD_MENU_SAVEMASETS 'MSSA'
#define CMD_MENU_SAVEMASETSDEFAULT 'MSSF'
#define CMD_MENU_TITLEINFO 'MSTI'
#define CMD_SUBMENU_TITLEINFO1 'MSTL'
#define CMD_SUBMENU_TITLEINFO2 'MSTS'
#define CMD_SUBMENU_TITLEINFO3 'MSTN'
#define CMD_MENU_SPINDOWN 'NULL'
#define CMD_MENU_RANDOM 'MSRA'
#define CMD_MENU_REPTPLAYED 'MSRE'
#define CMD_MENU_LOOPLOADED 'MSLO'
#define CMD_MENU_LOOPLIST 'MSLL'
#define CMD_MENU_AUTOSTART 'MSAU'
#define CMD_MENU_ERRLOGGING 'MSER'
#define CMD_MENU_SINGLEPLAY 'MSSI'
#define CMD_MENU_HIPRIORITY 'MSHI'
#define CMD_MENU_EQUALIZER 'MSEQ'
#define CMD_MENU_EFFECTS 'MSEF'
#define CMD_MENU_EQEXTRA 'MSEX'
#define CMD_MENU_MONO 'MSMO'
#define CMD_MENU_INVERTRIGHT 'MSIN'
#define CMD_MENU_EQ31BANDS 'MS31'
#define CMD_MENU_ZEROLIST 'MTZE'
#define CMD_MENU_SPINDOWNNOW 'MTSP'
#define CMD_MENU_PLAYCD 'MCPC'
#define CMD_MENU_EJECTCD 'MCEC'
#define CMD_MENU_AUDIOIN 'MCAU'
#define CMD_MENU_MAKECATALOG 'MTMA'
#define CMD_MENU_VIEWCATALOG 'MTVI'
#define CMD_MENU_VIEWLOG 'MTVW'
#define CMD_MENU_CLEARLOG 'MTCL'
#if defined(MAKEYBOARD)
 #define CMD_MENU_EDITKEYBINDINGS 'MTED'
 #define CMD_MENU_BLANKKEYBINDINGS 'MTBL'
#endif
#define CMD_MENU_SHOWLIST 'MHLI'
#define CMD_MENU_SHOWEQ 'MHEQ'
#define CMD_MENU_SHOWEFFECTS 'MHEF'
#define CMD_MENU_SHOWFILEOUT 'MHFI'
#define CMD_MENU_ALTSIZE 'MHAL'
#define CMD_MENU_FACTORYSIZE 'MHFA'
#define CMD_MENU_SAVEDSIZE 'MHSA'
#define CMD_MENU_DEFAULTSIZE 'MHDA'
#define CMD_MENU_README 'MHRE' // ID_MENU_LAST
#define CMD_SUBMENU_OPENRECENT1 'MFO0'
#define CMD_SUBMENU_OPENRECENT2 'MFO1'
#define CMD_SUBMENU_OPENRECENT3 'MFO2'
#define CMD_SUBMENU_OPENRECENT4 'MFO3'
#define CMD_SUBMENU_OPENRECENT5 'MFO4'
#define CMD_SUBMENU_OPENRECENT6 'MFO5'
#define CMD_SUBMENU_OPENRECENT7 'MFO6'
#define CMD_SUBMENU_OPENRECENT8 'MFO7'
#define CMD_SUBMENU_OPENRECENT9 'MFO8'
#define CMD_SUBMENU_OPENRECENT10 'MFO9'

void SetCommandId()
{
	l_commandid[ID_MENU_ABOUT] = CMD_MENU_ABOUT; // ID_MENU_FIRST
	l_commandid[ID_MENU_QUIT] = CMD_MENU_QUIT;
	l_commandid[ID_MENU_OPENLIST] = CMD_MENU_OPENLIST;
	l_commandid[ID_MENU_MAKELIST] = CMD_MENU_MAKELIST;
	l_commandid[ID_MENU_SAVELISTAS] = CMD_MENU_SAVELISTAS;
	l_commandid[ID_MENU_DELETELIST] = CMD_MENU_DELETELIST;
	l_commandid[ID_MENU_PLAYFILE] = CMD_MENU_PLAYFILE;
	l_commandid[ID_MENU_OPENRECENT] = CMD_MENU_OPENRECENT;
	l_commandid[ID_SUBMENU_OPENRECENT1] = CMD_SUBMENU_OPENRECENT1;
	l_commandid[ID_SUBMENU_OPENRECENT2] = CMD_SUBMENU_OPENRECENT2;
	l_commandid[ID_SUBMENU_OPENRECENT3] = CMD_SUBMENU_OPENRECENT3;
	l_commandid[ID_SUBMENU_OPENRECENT4] = CMD_SUBMENU_OPENRECENT4;
	l_commandid[ID_SUBMENU_OPENRECENT5] = CMD_SUBMENU_OPENRECENT5;
	l_commandid[ID_SUBMENU_OPENRECENT6] = CMD_SUBMENU_OPENRECENT6;
	l_commandid[ID_SUBMENU_OPENRECENT7] = CMD_SUBMENU_OPENRECENT7;
	l_commandid[ID_SUBMENU_OPENRECENT8] = CMD_SUBMENU_OPENRECENT8;
	l_commandid[ID_SUBMENU_OPENRECENT9] = CMD_SUBMENU_OPENRECENT9;
	l_commandid[ID_SUBMENU_OPENRECENT10] = CMD_SUBMENU_OPENRECENT10;	
	l_commandid[ID_MENU_STOP] = CMD_MENU_STOP;
	l_commandid[ID_MENU_PAUSE] = CMD_MENU_PAUSE;
	l_commandid[ID_MENU_PREVIOUS] = CMD_MENU_PREVIOUS;
	l_commandid[ID_MENU_PLAY] = CMD_MENU_PLAY;
	l_commandid[ID_MENU_NEXT] = CMD_MENU_NEXT;
	l_commandid[ID_MENU_SETVDISK] = CMD_MENU_SETVDISK;
#if defined(MAINSTANCES)
	l_commandid[ID_MENU_MULTIPLEINST] = CMD_MENU_MULTIPLEINST;
#endif
#if defined(MAKEYBOARD)
	l_commandid[ID_MENU_KEYBOARD] = CMD_MENU_KEYBOARD;
#endif
#if defined(MAMOUSEWHEEL)
	l_commandid[ID_MENU_MOUSEWHEEL] = CMD_MENU_MOUSEWHEEL;
#endif
	l_commandid[ID_MENU_ADVANCED] = CMD_MENU_ADVANCED;
#if(!defined(MANOCDA) && defined(__MAUNIX__))
	l_commandid[ID_MENU_SETAUDIOCD] = CMD_MENU_SETAUDIOCD;
#endif
	l_commandid[ID_MENU_SETFACTORY] = CMD_MENU_SETFACTORY;
	l_commandid[ID_MENU_SETDEFAULT] = CMD_MENU_SETDEFAULT;
	l_commandid[ID_MENU_SETSAVED] = CMD_MENU_SETSAVED;
	l_commandid[ID_MENU_SAVEMASETS] = CMD_MENU_SAVEMASETS;
	l_commandid[ID_MENU_SAVEMASETSDEFAULT] = CMD_MENU_SAVEMASETSDEFAULT;
	l_commandid[ID_MENU_TITLEINFO] = CMD_MENU_TITLEINFO;
	l_commandid[ID_SUBMENU_TITLEINFO1] = CMD_SUBMENU_TITLEINFO1;
	l_commandid[ID_SUBMENU_TITLEINFO2] = CMD_SUBMENU_TITLEINFO2;
	l_commandid[ID_SUBMENU_TITLEINFO3] = CMD_SUBMENU_TITLEINFO3;
	l_commandid[ID_MENU_SPINDOWN] = CMD_MENU_SPINDOWN;
	l_commandid[ID_MENU_RANDOM] = CMD_MENU_RANDOM;
	l_commandid[ID_MENU_REPTPLAYED] = CMD_MENU_REPTPLAYED;
	l_commandid[ID_MENU_LOOPLOADED] = CMD_MENU_LOOPLOADED;
	l_commandid[ID_MENU_LOOPLIST] = CMD_MENU_LOOPLIST;
	l_commandid[ID_MENU_AUTOSTART] = CMD_MENU_AUTOSTART;
	l_commandid[ID_MENU_ERRLOGGING] = CMD_MENU_ERRLOGGING;
	l_commandid[ID_MENU_SINGLEPLAY] = CMD_MENU_SINGLEPLAY;
	l_commandid[ID_MENU_HIPRIORITY] = CMD_MENU_HIPRIORITY;
	l_commandid[ID_MENU_EQUALIZER] = CMD_MENU_EQUALIZER;
	l_commandid[ID_MENU_EFFECTS] = CMD_MENU_EFFECTS;
	l_commandid[ID_MENU_EQEXTRA] = CMD_MENU_EQEXTRA;
	l_commandid[ID_MENU_MONO] = CMD_MENU_MONO;
	l_commandid[ID_MENU_INVERTRIGHT] = CMD_MENU_INVERTRIGHT;
	l_commandid[ID_MENU_EQ31BANDS] = CMD_MENU_EQ31BANDS;
	l_commandid[ID_MENU_ZEROLIST] = CMD_MENU_ZEROLIST;
	l_commandid[ID_MENU_SPINDOWNNOW] = CMD_MENU_SPINDOWNNOW;
	l_commandid[ID_MENU_PLAYCD] = CMD_MENU_PLAYCD;
	l_commandid[ID_MENU_EJECTCD] = CMD_MENU_EJECTCD;
	l_commandid[ID_MENU_AUDIOIN] = CMD_MENU_AUDIOIN;
	l_commandid[ID_MENU_MAKECATALOG] = CMD_MENU_MAKECATALOG;
	l_commandid[ID_MENU_VIEWCATALOG] = CMD_MENU_VIEWCATALOG;
	l_commandid[ID_MENU_VIEWLOG] = CMD_MENU_VIEWLOG;
	l_commandid[ID_MENU_CLEARLOG] = CMD_MENU_CLEARLOG;
#if defined(MAKEYBOARD)
	l_commandid[ID_MENU_EDITKEYBINDINGS] = CMD_MENU_EDITKEYBINDINGS;
	l_commandid[ID_MENU_BLANKKEYBINDINGS] = CMD_MENU_BLANKKEYBINDINGS;
#endif
	l_commandid[ID_MENU_SHOWLIST] = CMD_MENU_SHOWLIST;
	l_commandid[ID_MENU_SHOWEQ] = CMD_MENU_SHOWEQ;
	l_commandid[ID_MENU_SHOWEFFECTS] = CMD_MENU_SHOWEFFECTS;
	l_commandid[ID_MENU_SHOWFILEOUT] = CMD_MENU_SHOWFILEOUT;
	l_commandid[ID_MENU_ALTSIZE] = CMD_MENU_ALTSIZE;
	l_commandid[ID_MENU_SAVEDSIZE] = CMD_MENU_SAVEDSIZE;
	l_commandid[ID_MENU_DEFAULTSIZE] = CMD_MENU_DEFAULTSIZE;
	l_commandid[ID_MENU_FACTORYSIZE] = CMD_MENU_FACTORYSIZE;
	l_commandid[ID_MENU_README] = CMD_MENU_README; // ID_MENU_LAST
}

enum
{
	ViewerInstanceDataProperty = 'TXNd',
	ViewerInstanceDataCreator = 'MAMP'
};

struct ViewerInstanceData
{
	int windowid;
	TXNObject TXNobj;
	ControlRef scrollbar;
	SInt32 scrollCache;
	SInt32 scrollCacheS;
	int hits;
	int atbottom;
	int OffsetsValid;
	TXNOffset StartOffset;
	TXNOffset EndOffset;
	char *findtext;	
	char fpath[MAX_PATH];
};

ViewerInstanceData l_vreadme;
ViewerInstanceData l_log;
ViewerInstanceData l_catalog;
ViewerInstanceData l_keybindings;

void maTrace(char *str);
void maTrace(char *str)
{
	maLog(str);
}

TXNObject WindowGetTXNObj(WindowRef window);
ViewerInstanceData *GetViewerInstanceData(WindowRef window);

void OnTimerRunLoop(EventLoopTimerRef theTimer, void *userData); 
void OnTimerRunLoop(EventLoopTimerRef theTimer, void *userData) 
{
#ifdef MATRACEGUIOSX
	maTrace("OnTimerRunLoop");
#endif

	RunLoop(NULL);
}


void maGuiLog(char *str);
void maGuiLog(char *str)
{
	printf(str);
	printf("\n");
}


int main(int argc, char *argv[]) // MAGUIOSX
{
	g_argc = argc;
	g_argv = argv;

	// minimum osx version
	long response;
	OSErr err = Gestalt(gestaltSystemVersion, &response);
	Boolean ok = ((err == noErr) && (response >= 0x00001030));
	if(!ok)
	{
		StandardAlert(kAlertStopAlert, "\pMac OS X 10.3 (minimum) is recommended for MoreAmp OSX", "\p", NULL, NULL);
		// ExitToShell();
	}

	SetCommandId();

	// runLoop timer
	EventLoopRef mainLoop;
	EventLoopTimerUPP timerUPP;
	mainLoop = GetMainEventLoop();
	timerUPP = NewEventLoopTimerUPP(OnTimerRunLoop);
	InstallEventLoopTimer(mainLoop, kEventDurationForever, 0, timerUPP, NULL, &l_timerrunloop);

	// for drop and quit
	InitAppleEvents(NULL);
	
	//strcpy(&g_AboutText[strlen(g_AboutText) - 64], " Native (Carbon) GUI"); 
	g_AboutText[strlen(g_AboutText) - 64] = 0;
	
	if(!OnInit_())		
		return 1; // failed

	// main loop
	RunApplicationEventLoop();
	
	return 0;
	
} // main 


EventTypeSpec TextInputEvents[] = { { kEventClassTextInput, kEventTextInputUnicodeForKeyEvent } };

int MakeMenus(IBNibRef nibRef)
{
	int i;
	IBNibRef lnibRef;
	OSStatus status;
	char items[MAXOPENRECENT][OPENRECENTLENGTH];
	char fname[OPENRECENTLENGTH];
	char cstr[256];
	
#ifdef MATRACEGUIOSX
	maTrace("MakeMenus");
#endif
	
	lnibRef = nibRef;
	if(!nibRef)
	{
		status = CreateNibReference(CFSTR("maosx"), &lnibRef);
		if(status != noErr)
		{
			sprintf(cstr, "MakeMenus CreateNibReference status %d 'maosx.nib'", (int)status);
			maLog(cstr);
			return 1;
		}
	}

	status = SetMenuBarFromNib(lnibRef, CFSTR("MenuBar"));
	if(status != noErr)
	{
		sprintf(cstr, "MakeMenus SetMenuBarFromNib err %d", (int)status);
		maLog(cstr);
		return 1;
	}

	if(!GetRecent(items))
	{
		for (i = 0; i < MAXOPENRECENT; i++)
		{
			if(!items[i][0])
				break;
			FilenameFromPathname(items[i], fname);
			MenuSetLabel(ID_SUBMENU_OPENRECENT1 + i, fname);
		}
		for (; i < MAXOPENRECENT; i++)
			MenuDeleteItem(ID_SUBMENU_OPENRECENT1 + i);
	}
	
	if(!nibRef)
		DisposeNibReference(lnibRef);

		return 0;
		
} // MakeMenus


void UpdateSubMenusRecent()
{
#ifdef MATRACEGUIOSX
	maTrace("UpdateSubMenusRecent");
#endif
	if(g_w[WINDOWAPP])
		MakeMenus(NULL);
}


int	AppWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("AppWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess },
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef window;
	char cstr[256];
	
	InitCursor();

	// Search the bundle for a .nib file named 'maosx.nib'
	status = CreateNibReference(CFSTR("maosx"), &nibRef);
	if(status != noErr)
	{
		sprintf(cstr, "AppWindowMake CreateNibReference status %d 'maosx.nib'", (int)status);
		maLog(cstr);
		return 1;
	}

	// MakeMenu(nibRef);
	if(MakeMenus(nibRef))
		return 1;

#if !defined(MAKEYBOARD)
	DisableMenuCommand(NULL, 'MSUS');
#endif
#if !defined(MAMOUSEWHEEL)
	DisableMenuCommand(NULL, 'MSUM');
#endif

	status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
	DisposeNibReference(nibRef);
	if(status != noErr)
	{
		sprintf(cstr, "AppWindowMake CreateWindowFromNib err %d", (int)status);
		maLog(cstr);
		return 1;
	}

	status = InstallWindowEventHandler(window, NewEventHandlerUPP(AppWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWAPP, NULL);
	if(status != noErr)
	{
		sprintf(cstr, "AppWindowMake InstallWindowEventHandler err %d", (int)status);
		maLog(cstr);
		return 1;
	}

	id.signature = 'MAMP';
							
	// red checkboxes
	id.id = ID_CHK_REPTSONG;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_BEG;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_END;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_EFFECTS;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_MONOLEFT;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_MONORIGHT;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_MONODIFF;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_INVERTRIGHT;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
	id.id = ID_CHK_SINGLEPLAY;
	GetControlByID(window, &id, &cb);	
	status = SetControlColorProc(cb, CheckBoxColorCallbackProc);
		
	// slider (scrollbar) callback proc
	id.id = ID_SLIDER_VOLUMEL;
	GetControlByID(window, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_VOLUMER;
	GetControlByID(window, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_VOLUMESEP;
	GetControlByID(window, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_PREAMP;
	GetControlByID(window, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	id.id = ID_SLIDER_POSITION;
	GetControlByID(window, &id, &cb);
	SetControlAction(cb, SliderCallbackProc);
	
	g_w[WINDOWAPP] = window;

	// output selector, nib already has one item
	PopupButtonSetText(WINDOWAPP, ID_POPUP_OUTPUT, 0, g_extstrout[kOUTSOUND]);
 	char label[64];
	for(int i = kOUTFIRST; i <= kOUTLAST; i++)
	{
		sprintf(label, "%s file", &g_extstrout[i][1]);
		PopupButtonAppend(WINDOWAPP, ID_POPUP_OUTPUT, label);
 	}
	
	HISize min, max;
	GetWindowResizeLimits(window, &min, &max);
	min.width = 20;
	min.height = 20;
	SetWindowResizeLimits(window, &min, &max);

	MacMoveWindow(window, g_sets.xpos[g_sets.winconf], g_sets.ypos[g_sets.winconf], false); // front
	SizeWindow(window, g_sets.xsize[g_sets.winconf], g_sets.ysize[g_sets.winconf], false); // !update
	ShowWindow(window);
	
	UpdateDisplay();
	
#if defined(MAKEYBOARD)
	UpdateMenuKbLabels();
	UpdateButtonLabels();
#endif
  
	return 0;	

} // AppWindowMake


// util
#define C1(x) ((char)((x >> 24) & 0xff))
#define C2(x) ((char)((x >> 16) & 0xff))
#define C3(x) ((char)((x >>  8) & 0xff))
#define C4(x) ((char)(x & 0xff))
char g_4str[16];
char *C4str(UInt32 x)
{
	sprintf(g_4str, "%c%c%c%c", C1(x), C2(x), C3(x), C4(x));
	return g_4str;
}


OSStatus CommandEventHandler(HICommandExtended *command, int windowid, Rect *r)
{
	void *window;
	short value;
	DataBrowserItemID first;
	DataBrowserItemID last;
	ControlKind outControlKind;

	GetControlKind(command->source.control, &outControlKind);
	if(outControlKind.kind == kControlKindLittleArrows)
	{
		Point pt;
		GetMouse(&pt);
		LocalToGlobal(&pt);
		pt.v -= r->top;
		Rect bounds;
		GetControlBounds(command->source.control, &bounds);
		if(pt.v >= bounds.top + ((bounds.bottom - bounds.top) / 2)) // LittleArrow down
			value = -1;
		else
			value = 1; // LittleArrow up
	}
	else if(outControlKind.kind == kControlKindDataBrowser)
	{
		GetDataBrowserSelectionAnchor(command->source.control, &first, &last);
		value = first;
	}
	else
		value = GetControlValue(command->source.control);
		
	// 'BXXX' are buttons, 'MXXX' are menus (MFiles MControls MSettings ...), 'CXXX' are checkboxs, etc
	switch(command->commandID)
	{
		// app window and menus
		case kHICommandSelectWindow:
		return eventNotHandledErr;
		
		case CMD_MENU_ABOUT:
			maViewAbout();
		break;
		case 'BQUI':
		case CMD_MENU_QUIT:
			OnButtonQuit();
		break;
		case 'BPRE':
		case CMD_MENU_PREVIOUS:
			OnButtonPrevious();
		break;
		case 'BPLA':
		case CMD_MENU_PLAY:
			OnButtonPlay();
		break;
		case 'BPAU':
		case CMD_MENU_PAUSE:
			OnButtonPause();
		break;
		case 'BSTO':
		case CMD_MENU_STOP:
			OnButtonStop();
		break;
		case 'BNEX':
		case CMD_MENU_NEXT:
			OnButtonNext();
		break;

		case CMD_MENU_OPENLIST:
			OnMenuOpenList();
		break;
		case CMD_MENU_MAKELIST:
			OnMenuMakeList();
		break;
		case CMD_MENU_SAVELISTAS:
			OnMenuSaveListAs();
		break;
		case CMD_MENU_DELETELIST:
			OnMenuDeleteList();
		break;
		
		case CMD_MENU_PLAYFILE:
			OnMenuPlayFile();
		break;
		case CMD_SUBMENU_OPENRECENT1:
			OnMenuOpenRecent(0);
		break;
		case CMD_SUBMENU_OPENRECENT2:
			OnMenuOpenRecent(1);
		break;
		case CMD_SUBMENU_OPENRECENT3:
			OnMenuOpenRecent(2);
		break;
		case CMD_SUBMENU_OPENRECENT4:
			OnMenuOpenRecent(3);
		break;
		case CMD_SUBMENU_OPENRECENT5:
			OnMenuOpenRecent(4);
		break;
		case CMD_SUBMENU_OPENRECENT6:
			OnMenuOpenRecent(5);
		break;
		case CMD_SUBMENU_OPENRECENT7:
			OnMenuOpenRecent(6);
		break;
		case CMD_SUBMENU_OPENRECENT8:
			OnMenuOpenRecent(7);
		break;
		case CMD_SUBMENU_OPENRECENT9:
			OnMenuOpenRecent(8);
		break;
		case CMD_SUBMENU_OPENRECENT10:
			OnMenuOpenRecent(9);
		break;
		case CMD_MENU_PLAYCD:
			OnMenuPlayCD();
		break;
		case CMD_MENU_EJECTCD:
			OnMenuEjectCD();
		break;
		case CMD_MENU_AUDIOIN:
			OnMenuAudioIn();
		break;
		case CMD_MENU_SAVEMASETS:
			OnMenuSave();
		break;
		case CMD_MENU_SETSAVED:
			OnMenuSetSaved();
		break;
		case CMD_MENU_SETDEFAULT:
			OnMenuSetDefault();
		break;
		case CMD_MENU_SETFACTORY:
			OnMenuSetFactory();
		break;
		case CMD_MENU_SAVEMASETSDEFAULT:
			OnMenuAsDefaults();
		break;
		case CMD_MENU_EQUALIZER:
			MenuToggleChecked(command->commandID);
			OnMenuEqualizer((g_sets.eqflags & MAEQACTIVE) ? 0 : 1);
		break;
		case CMD_MENU_EQ31BANDS:
			MenuToggleChecked(command->commandID);
			OnMenuEq31Bands((g_sets.eqflags & MAEQ31BANDS) ? 0 : 1);
		break;
		case CMD_MENU_EQEXTRA:
			MenuToggleChecked(command->commandID);
			OnMenuEqExtra((g_sets.eqflags & MAEQEXTRA) ? 0 : 1);
		break;
		case CMD_MENU_EFFECTS:
			MenuToggleChecked(command->commandID);
			OnMenuEffects((g_sets.effects & EFFECTSON) ? 0 : 1);
		break;
		case CMD_MENU_RANDOM:
			MenuToggleChecked(command->commandID);
			OnMenuRandom(g_sets.random ? 0 : 1);
		break;
		case CMD_MENU_REPTPLAYED:
			MenuToggleChecked(command->commandID);
			OnMenuReptPlayed(g_sets.reptplayed ? 0 : 1);
		break;
		case CMD_MENU_LOOPLOADED:
			MenuToggleChecked(command->commandID);
			OnMenuLoopLoaded(g_sets.looploaded ? 0 : 1);
		break;
		case CMD_MENU_LOOPLIST:
			MenuToggleChecked(command->commandID);
			OnMenuLoopList(g_sets.looplist ? 0 : 1);
		break;
		case CMD_MENU_MONO:
			MenuToggleChecked(command->commandID);
			OnMenuMono(g_sets.monodiff ? 0 : 1);
		break;
		case CMD_MENU_INVERTRIGHT:
			MenuToggleChecked(command->commandID);
			OnMenuInvertRight(g_sets.invertright ? 0 : 1);
		break;
		case CMD_MENU_SINGLEPLAY:
			MenuToggleChecked(command->commandID);
			OnMenuSinglePlay(g_sets.singleplay ? 0 : 1);
		break;
		case CMD_MENU_HIPRIORITY:
			MenuToggleChecked(command->commandID);
			OnMenuHiPriority(g_sets.highpriority ? 0 : 1);
		break;
		case 'MSSP': // only for os9
			MenuToggleChecked(command->commandID);
			OnMenuSpindown(g_sets.spindown ? 0 : 1);
		break;
		case CMD_SUBMENU_TITLEINFO1:
			MenuToggleChecked(command->commandID);
			OnCheckTitleInfo(1);
		break;
		case CMD_SUBMENU_TITLEINFO2:
			MenuToggleChecked(command->commandID);
			OnCheckTitleInfo(2);
		break;
		case CMD_SUBMENU_TITLEINFO3:
			MenuToggleChecked(command->commandID);
			OnCheckTitleInfo(3);
		break;
		case CMD_MENU_AUTOSTART:
			MenuToggleChecked(command->commandID);
			OnMenuAutoStart(g_sets.autostart ? 0 : 1);
		break;
		case CMD_MENU_ERRLOGGING:
			MenuToggleChecked(command->commandID);
			OnMenuErrLogging((g_sets.logflags & kMALOGOFF) ? 1 : 0);
		break;
		case CMD_MENU_SETVDISK:
			OnMenuSetVDisk();
		break;
#if defined(MAINSTANCES)
		case CMD_MENU_MULTIPLEINST:
			MenuToggleChecked(command->commandID);
			OnMenuMultipleInst(g_sets.multipleinst ? 0 : 1);
		break;
#endif
#if defined(MAKEYBOARD)
		case CMD_MENU_KEYBOARD:
			MenuToggleChecked(command->commandID);
			OnMenuKeyboard(g_sets.keyboard ? 0 : 1);
		break;
#endif
#if defined(MAMOUSEWHEEL)
		case CMD_MENU_MOUSEWHEEL:
			MenuToggleChecked(command->commandID);
			OnMenuMouseWheel(g_sets.mousewheel ? 0 : 1);
		break;
#endif
		case CMD_MENU_ADVANCED:
			DoWindowAdvanced(1);
		break;
		case CMD_MENU_SHOWLIST:
			if(!MenuToggleChecked(command->commandID))
			{
				if((window = g_w[WINDOWLIST]))
				{
					OnWindowClosedList();
					l_linenum = 0;
					g_w[WINDOWLIST] = window;
				}
			}
			OnMenuList();
		break;
		case CMD_MENU_SHOWEQ:
			if(!MenuToggleChecked(command->commandID))
			{
				if((window = g_w[WINDOWEQ]))
				{
					 OnWindowClosedEq();
					 g_w[WINDOWEQ] = window;
				}
			}
			OnMenuEqWindow();
		break;
		case CMD_MENU_ZEROLIST:
			 OnMenuZero();
		break;
		case CMD_MENU_MAKECATALOG:
			 OnMenuMakeCatalog();
		break;
		case CMD_MENU_VIEWCATALOG:
			 OnMenuViewCatalog();
		break;
		case CMD_MENU_VIEWLOG:
			 OnMenuViewLog();
		break;
		case CMD_MENU_CLEARLOG:
			 OnMenuClearLog();
		break;
#if defined(MAKEYBOARD)
		case CMD_MENU_EDITKEYBINDINGS:
			 OnMenuEditKeyBindings();
		break;
		case CMD_MENU_BLANKKEYBINDINGS:
			 OnMenuBlankKeyBindings();
		break;
#endif
		case CMD_MENU_SHOWEFFECTS:
			MenuToggleChecked(command->commandID);
			OnMenuEffectsWindow();
		break;
		case CMD_MENU_SHOWFILEOUT:
			MenuToggleChecked(command->commandID);
			OnMenuFileOut();
		break;
		case CMD_MENU_ALTSIZE:
			MenuToggleChecked(command->commandID);
			OnMenuAltSize(g_sets.winconf ? 0 : 1, 0);
		break;
		case CMD_MENU_SAVEDSIZE:
			OnMenuSavedSize(0);
		break;
		case CMD_MENU_DEFAULTSIZE:
			OnMenuDefaultSize(0);
		break;
		case CMD_MENU_FACTORYSIZE:
			OnMenuFactorySize(0);
		break;
		case CMD_MENU_README:
			OnMenuReadme();
		break;
		case 'SBEG':
			OnLittleArrowBegin(value); // 1 up, -1 down
		break;
		case 'SEND':
			OnLittleArrowEnd(value);
		break;
		case 'SBUF':
			OnLittleArrowBuffer(value);
		break;
		case 'CALT':
			OnCheckAltSize(value, 0);
		break;
		case 'CRES':
			OnCheckReptSong(value);
		break;
		case 'CBEG':
			OnCheckBoxBeg(value);
		break;
		case 'CEND':
			OnCheckBoxEnd(value);
		break;
		case 'CBAL':
			OnCheckBalance(value);
		break;
		case 'CPRE':
			OnCheckLimiter(value);
		break;
		case 'CEQW':
			if(!value)
			{
				if((window = g_w[WINDOWEQ]))
				{
					 OnWindowClosedEq();
					 g_w[WINDOWEQ] = window;
				}
			}
			OnCheckEqWindow(value);
		break;
		case 'CEQU':
			OnCheckEqualizer(value);
		break;
		case 'CE31':
			OnCheckEq31Bands(value);
		break;
		case 'CEQE':
			OnCheckEqExtra(value);
		break;
		case 'CEFF':
			OnCheckEffects(value);
		break;
		case 'CMOL':
			OnCheckMonoLeft(value);
		break;
		case 'CMOR':
			OnCheckMonoRight(value);
		break;
		case 'CMOD':
			OnCheckMonoDiff(value);
		break;
		case 'CLIS':
			if(!value)
			{
				if((window = g_w[WINDOWLIST]))
				{
					OnWindowClosedList();
					l_linenum = 0;
					g_w[WINDOWLIST] = window;
				}
			}
			OnCheckListWindow(value);
		break;
		case 'CRAN':
			OnCheckRandom(value);
		break;
		case 'CREP':
			OnCheckReptPlayed(value);
		break;
		case 'CLOO':
			OnCheckLoopLoaded(value);
		break;
		case 'CLOL':
			OnCheckLoopList(value);
		break;
		case 'CINV':
			OnCheckInvertRight(value);
		break;
		case 'CSIN':
			OnCheckSinglePlay(value);
		break;
		case 'CUMT':
			OnCheckUseM3u(value);
		break;
		case 'CSPI':
#ifdef __MAOS9__
			OnCheckSpindown(value);
#else
			CheckBoxSetValue(WINDOWAPP, ID_CHK_SPINDOWN, 0);
#endif
		break;
		case 'CTIT':
			OnCheckTitleInfo(0);
		break;
		case 'PSOU':
			OnPopupOutput(value - 1);
		break;
		case 'PMEM':
			OnPopupBuffer(value - 1);
		break;

		// list window
		case 'BINF':
			OnButtonInfo();
		break;
		case 'BLIS':
			OnButtonList();
		break;
		case 'BLOA':
			OnButtonLoaded();
		break;
		case 'BSON':
			OnButtonSong();
		break;
		case 'CSHI':
			OnCheckShowIndex(value);
		break;
		case 'CSHD':
			OnCheckShowDir(value);
		break;
		case 'CSHP':
			OnCheckShowPath(value);
		break;
		case 'CADD':
			OnCheckAddMode(value);
		break;
		/* for browser in nib
		case 'LIST':
			OnListWindowSingleClick(0);
		break;
		*/
		// equalizer window
		case 'BMIN':
			OnButtonEqMinus();
		break;
		case 'BPLU':
			OnButtonEqPlus();
		break;
		case 'BMID':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Mid();
			else
				OnButtonEqMid();
		break;
		case 'BCOP':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Copy();
			else
				OnButtonEqCopy();
		break;
		case 'BPAS':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Paste();
			else
				OnButtonEqPaste();
		break;
		case 'BRES':
			if(windowid == WINDOWEQ2)
				OnButtonEq2Restore();
			else
				OnButtonEqRestore();
		break;
		case 'BSHL':
			OnButtonEqShiftL();
		break;
		case 'BSHR':
			OnButtonEqShiftR();
		break;
		case 'BINV':
			OnButtonEqInvert();
		break;
		case 'SOFF':
			OnLittleArrowEqOffset(value);
		break;
		case 'PPRE':
			OnPopupEqPreset(value - 1);
		break;
		case 'CEQB':
			OnCheckEqualizerB(value);
		break;
		case 'C31B':
			OnCheckEq31BandsB(value);
		break;
		case 'CEXB':
			OnCheckEqExtraB(value);
		break;
		case 'CSEP':
			OnCheckSeparateLR(value);
		break;
		case 'CZOO':
			OnCheckEqZoom(value);
		break;
		case 'CLIN':
			OnCheckEqLink(value);
		break;

		// effects window
		case 'CEFB':
			OnCheckEffectsB(value);
		break;
		case 'CPIT':
			OnCheckPitch(value);
		break;
		case 'CTEM':
			OnCheckTempo(value);
		break;
		case 'CSPE':
			OnCheckSpeed(value);
		break;
		case 'CNOA':
			OnCheckQualFilter(value);
		break;
		case 'CLOQ':
			OnCheckQualSpeed(value);
		break;

		// fileout window
		case 'BCHA':
			OnButtonFileOutDir();
		break;
		case 'CADT':
			OnCheckBoxADTS(value);
		break;
		case 'CM4A':
			OnCheckBoxM4A(value);
		break;
		case 'PBIT':
			OnPopupBitRate(value - 1);
		break;
		case 'PQUA':
			OnPopupQuality(value - 1);
		break;
		case 'PMOD':
			OnPopupMode(value - 1);
		break;
		case 'PSAM':
			OnPopupSampleRate(value - 1);
		break;
		
		// viewer window(s)
		case 'BFIN':
			OnButtonFind(windowid);
		return eventNotHandledErr;
		case 'BEDI':
			OnButtonEditSave(windowid);
		return eventNotHandledErr;

		// prompt number popup
		case 'BPRO':
			OnButtonPromptNum(1); // Ok
		break;
		case 'BPRC':
			OnButtonPromptNum(0); // Cancel
		break;

		// advanced settings window
		case 'CCRE':
			OnCheckCloseReopen(value);
		break;
		case 'CHIP':
			OnCheckHighPriority(value);
		break;

		default:
		/*
			{
			char cstr[256];
			sprintf(cstr, "CommandEventHandler '%s' 0x%x", C4str(command->commandID), (int)command->attributes);
			maGuiLog(cstr);
			}
		*/
		return eventNotHandledErr;
	}
	
	return noErr;
	
} // CommandEventHandler


OSStatus AppWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
#if defined(MAKEYBOARD)
		EventRef rawEvent;
		unsigned char charCode;
		int retcode;
#endif
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClose:
					OnButtonQuit();				
				break;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
					{
						int x = g_sets.xpos[g_sets.winconf];
						int y = g_sets.ypos[g_sets.winconf];
						WindowGetOrigin((int)userData, &g_sets.xpos[g_sets.winconf], &g_sets.ypos[g_sets.winconf]);
						OnWindowMoved(WINDOWAPP, g_sets.xpos[g_sets.winconf] - x, g_sets.ypos[g_sets.winconf] - y);
					}
					if(attributes & kWindowBoundsChangeUserResize)
						WindowGetSize((int)userData, &g_sets.xsize[g_sets.winconf], &g_sets.ysize[g_sets.winconf]);
				return eventNotHandledErr;
								
				default:
				return eventNotHandledErr;
			}
		break;

#if defined(MAMOUSEWHEEL)
		case kEventClassMouse:
			if(g_sets.mousewheel && g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
					GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);
					if(charCode == kDownArrowCharCode)
						retcode = MAWXK_DOWN;
					else if(charCode == kUpArrowCharCode) 
						retcode = MAWXK_UP;
					else if(charCode == kEnterCharCode) 
						retcode = MAWXK_RETURN;
					else retcode = charCode; 
					maOnKey(0, retcode);
					return noErr;
				break;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}

	return noErr;
	
} // AppWindowEventHandler


void guiAppYield() 
{
#ifdef MATRACEGUIOSX
	maTrace("guiAppYield");
#endif

	EventMask eventMask = highLevelEventMask;
	EventRecord event; 
	UInt32 ticks = 3; // 60 == 1 second
 	WaitNextEvent(eventMask, &event, ticks, NULL);

} // guiAppYield


OSStatus CheckBoxColorCallback(ControlRef inControl, SInt16 inMessage, SInt16 inDrawDepth, Boolean inDrawInColor)
{
	//WindowRef window = GetControlOwner(inControl);

	if(!GetControlValue(inControl)) // || !window || !IsWindowActive(window)))
		return eventNotHandledErr;

	RGBColor color = {0xffff, 0, 0};
	RGBForeColor(&color);
	
	return noErr;
	
} // CheckBoxColorCallback


void CheckBoxDisable(int window, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI("CheckBoxEnable nocb", window, checkbox);		
}


void CheckBoxEnable(int window, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI("CheckBoxEnable nocb", window, checkbox);		
}


int CheckBoxGetValue(int window, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxGetValue");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return 0;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		return GetControlValue(cb) ? 1 : 0;
	maLogAPI("CheckBoxGetValue nocb", window, checkbox);		
	return 0;
}


void CheckBoxHide(int window, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxHide");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		HideControl(cb);
	else
		maLogAPI("CheckBoxHide nocb", window, checkbox);		
}


void CheckBoxSetDescriptor(int window, int checkbox, char *desc)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxSetDescriptor");
#endif
	int l;
	ControlRef cb;
	ControlID id;
	unsigned char pstr[256];

	if(!g_w[window] || !desc)
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		strncpy((char *)&pstr[1], (const char *)desc, 255);
		if((l = strlen(desc)) > 255)
			l = 255;
		pstr[0] = l;
		SetControlTitle(cb, pstr);
	}
	else
		maLogAPI("CheckBoxSetDescriptor nocb", window, checkbox);
}


void MenuSetLabel(int item, char *label)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuSetLabel");
#endif
	int l;
	MenuRef pmenu;
	MenuItemIndex index;
	OSStatus status;
	unsigned char pstr[256];
	if(label == NULL)
	{
		maLog("MenuSetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		char cstr[256];
		sprintf(cstr, "MenuSetLabel GetIndMenuItemWithCommandID l_commandid[%d]='%c%c%c%c' err=%d", item,
		(char)((l_commandid[item] >> 24) & 0xff), (char)((l_commandid[item] >> 16) & 0xff),
		(char)((l_commandid[item] >>  8) & 0xff), (char)(l_commandid[item] & 0xff), (int)status);
		maLog(cstr);
		return;
	}
	strncpy((char *)&pstr[1], (const char *)label, 255);
	if((l = strlen(label)) > 255)
		l = 255;
	pstr[0] = l;
	SetMenuItemText(pmenu, index, pstr);

} // MenuSetLabel


void MenuGetLabel(int item, char *label)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuGetLabel");
#endif
	MenuRef pmenu;
	MenuItemIndex index;
	OSStatus status;
	unsigned char pstr[256];
	if(label == NULL)
	{
		maLog("MenuGetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		char cstr[256];
		sprintf(cstr, "MenuGetLabel GetIndMenuItemWithCommandID l_commandid[%d]='%c%c%c%c' err=%d", item,
		(char)((l_commandid[item] >> 24) & 0xff), (char)((l_commandid[item] >> 16) & 0xff),
		(char)((l_commandid[item] >>  8) & 0xff), (char)(l_commandid[item] & 0xff), (int)status);
		maLog(cstr);
		return;
	}
	GetMenuItemText(pmenu, index, pstr);
	pstr[pstr[0] + 1] = 0;
  	strcpy(label, (char *)&pstr[1]);

} // MenuGetLabel


void MenuDeleteItem(int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuDeleteItem");
#endif
	MenuRef pmenu;
	MenuItemIndex index;
	OSStatus status;
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		char cstr[256];
		sprintf(cstr, "MenuDeleteItem GetIndMenuItemWithCommandID l_commandid[%d]='%c%c%c%c' err=%d", item,
		(char)((l_commandid[item] >> 24) & 0xff), (char)((l_commandid[item] >> 16) & 0xff),
		(char)((l_commandid[item] >>  8) & 0xff), (char)(l_commandid[item] & 0xff), (int)status);
		maLog(cstr);
		return;
	}
	DeleteMenuItem(pmenu, index);

} // MenuDeleteItem


void CheckBoxSetValue(int window, int checkbox, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxSetValue");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		SetControlValue(cb, value ? 1 : 0);
	else
		maLogAPI("CheckBoxSetValue nocb", window, checkbox);		
}


void CheckBoxShow(int window, int checkbox)
{
#ifdef MATRACEGUIOSX
	maTrace("CheckBoxShow");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = checkbox;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		ShowControl(cb);
	else
		maLogAPI("CheckBoxShow nocb", window, checkbox);		
}


void maLogAPI(const char *errtxt, int window, int item)
{
	char cstr[256];
	sprintf(cstr, "%s window=%d item=%d", errtxt, window, item);
	maLog(cstr);
}


void DisplayGetSize(int *x, int *y)
{
#ifdef MATRACEGUIOSX
	maTrace("DisplayGetSize");
#endif
	
	BitMap screenBits;
	GetQDGlobalsScreenBits(&screenBits);

	if(x != NULL)
		*x = screenBits.bounds.right - screenBits.bounds.left;
	else
		maLog("DisplayGetSize null x parameter");

	if(y != NULL)
		*y = screenBits.bounds.bottom - screenBits.bounds.top;
	else
		maLog("DisplayGetSize null y parameter");
}


void DoTimerRunLoop(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerRunLoop");
#endif

	SetEventLoopTimerNextFireTime(l_timerrunloop, delay * kEventDurationMillisecond);
}


void DoTimerPlay(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerPlay");
#endif
	maSleep(delay);
	OnButtonPlay();
}


void DoTimerStop(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerStop");
#endif
	maSleep(delay);
	OnButtonStop();
}


void DoTimerPlaySonglist(int delay)
{
#ifdef MATRACEGUIOSX
	maTrace("DoTimerPlaySonglist");
#endif
	maSleep(delay);
	PlaySonglistB(g_newsonglist);
}


void EditTextSaveSelection(int windowid)
{
#ifdef MATRACEGUIOSX
	maTrace("EditTextSaveSelection");
#endif
	ViewerInstanceData *v;
	TXNObject txnObj;

	if(!g_w[windowid])
		return;
		
	if((v = GetViewerInstanceData((WindowRef)g_w[windowid])) == NULL)
	{
		maLog("EditTextSaveSelection GetViewerInstanceData failed");
		return;
	}

	v->OffsetsValid = 0;

	if((txnObj = WindowGetTXNObj((WindowRef)g_w[windowid])) == NULL)
	{
		maLog("EditTextSaveSelection WindowGetTXNObj failed");
		return;
	}
	
	TXNGetSelection(txnObj, &v->StartOffset, &v->EndOffset);
	v->scrollCacheS = v->scrollCache;
	v->OffsetsValid = 1;
		
} // EditTextSaveSelection


void EditTextRestoreSelection(int windowid)
{
#ifdef MATRACEGUIOSX
	maTrace("EditTextRestoreSelection");
#endif
	ViewerInstanceData *v;
	TXNObject txnObj;
	ControlRef cb = NULL;
	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	ControlID id2 = {'MAMP', ID_EDITTEXT_VIEWER};

	if(!g_w[windowid])
		return;
		
	if((v = GetViewerInstanceData((WindowRef)g_w[windowid])) == NULL)
	{
		maLog("EditTextRestoreSelection GetViewerInstanceData failed");
		return;
	}

	if (v->OffsetsValid == 0)
		return;
		
	v->OffsetsValid = 0;
	
	if((txnObj = WindowGetTXNObj((WindowRef)g_w[windowid])) == NULL)
	{
		maLog("EditTextRestoreSelection WindowGetTXNObj failed");
		return;
	}
	
	TextViewCustomScroll((WindowRef)g_w[windowid], 'MAMP', 0, v->scrollCacheS - v->scrollCache, v->scrollCacheS);

	// adjust scrollbar thumb position
	if(GetControlByID((WindowRef)g_w[(int)windowid], &id, &cb) == noErr)
		SetControl32BitValue(cb, v->scrollCacheS);
	
	// kludge to refresh, for big files 
	cb = NULL;
	if(GetControlByID((WindowRef)g_w[(int)windowid], &id2, &cb) == noErr)
	{
		HideControl(cb);
		ShowControl(cb);
	}
	
} // EditTextRestoreSelection


void EditTextSetText(int windowid, int edittext, char *text)
{
#ifdef MATRACEGUIOSX
	maTrace("EditTextSetText");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef str;

	if(!g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = edittext;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		str = CFStringCreateWithCString(NULL, (const char *)text, CFStringGetSystemEncoding());
		if(str)
			SetControlData(cb, 0, kControlStaticTextCFStringTag, sizeof(CFStringRef), &str);
		else
			maLogAPI("EditTextSetText CFStringCreateWithCString failed", windowid, edittext);		
	}
	else
		maLogAPI("EditTextSetText nocb", windowid, edittext);		

} // EditTextSetText


void EditTextGetText(int windowid, int edittext, char *outBuffer, int inBufferLength, long *outTextLength)
{
#ifdef MATRACEGUIOSX
	maTrace("EditTextGetText");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef str;

	if(!g_w[windowid])
		return;

	id.signature = 'MAMP';
	id.id = edittext;
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);
	if(cb)
	{
		GetControlData(cb, 0, kControlStaticTextCFStringTag, sizeof(CFStringRef), &str, NULL);
		if(!CFStringGetCString(str, outBuffer, inBufferLength, CFStringGetSystemEncoding()))
		{
			maLogAPI("EditTextGetText CFStringCreateWithCString failed", windowid, edittext);
			outBuffer[0] = 0;
		}
		if(outTextLength)
			*outTextLength = strlen(outBuffer);
	}
	else
		maLogAPI("EditTextGetText nocb", windowid, edittext);		

} // EditTextGetText


OSStatus EqPresetKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus EqPresetKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	EventRef rawEvent;
	unsigned char charCode;

	GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
	GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);

	if(charCode != '\r')
		return eventNotHandledErr;

	OnEditTextEq();
	
	return noErr;
}

void EqualizerWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("EqualizerWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClosed },
									{ kEventClassWindow,	kEventWindowBoundsChanged },
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassMouse,		kEventMouseUp },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef window;
	int i;
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("EqualizerWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEQ])
	{		
		// Search the bundle for a .nib file named 'maosxEq.nib'
		status = CreateNibReference(CFSTR("maosxEq"), &nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "EqualizerWindowMake CreateNibReference err %d 'maosxEq.nib'", (int)status);
			maLog(cstr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "EqualizerWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(cstr);
			return;
		}

		status = InstallWindowEventHandler(window, NewEventHandlerUPP(EqualizerWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWEQ, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "EqualizerWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(cstr);
			return;
		}
		
		id.signature = 'MAMP';
		
		// kb event handler
		id.id = ID_EDITTEXT_EQ;

		GetControlByID(window, &id, &cb);	
		InstallEventHandler(GetControlEventTarget(cb), NewEventHandlerUPP(EqPresetKbHandler),
							GetEventTypeCount(TextInputEvents), TextInputEvents, (void *)WINDOWEQ, NULL);

		// slider (scrollbar) callback proc
		for(id.id = ID_SLIDER_EQ_FIRST; id.id <= ID_SLIDER_EQ_LAST; id.id++)
		{
			GetControlByID(window, &id, &cb);
			SetControlAction(cb, SliderCallbackProc);
		}
		
		g_w[WINDOWEQ] = window;
		
		if(g_sets.eqflags & MASEPARATELR)
			sprintf(cstr, "%s Equalizer Left Channel", g_prognametitle);
		else
			sprintf(cstr, "%s Equalizer", g_prognametitle);
		WindowSetTitle(WINDOWEQ, cstr);
		
		// settings values
		CheckBoxSetValue(WINDOWEQ, ID_CHK_EQUALIZERB, g_sets.eqflags & MAEQACTIVE ? 1 : 0);
		CheckBoxSetValue(WINDOWEQ, ID_CHK_EQ31BANDSB, g_sets.eqflags & MAEQ31BANDS ? 1 : 0);
		CheckBoxSetValue(WINDOWEQ, ID_CHK_EQEXTRAB, g_sets.eqflags & MAEQEXTRA ? 1 : 0);
		CheckBoxSetValue(WINDOWEQ, ID_CHK_EQZOOM, g_sets.eqflags & MAEQZOOM ? 1 : 0);
		CheckBoxSetValue(WINDOWEQ, ID_CHK_EQLINK, g_sets.eqflags & MAEQLINK ? 1 : 0);
		for(i = 0; i < EQNUMPRESETS; i++)
		{
			if(strlen(g_sets.eqpresets[i].eqname) == 0 || g_sets.eqpresets[i].eqname[0] == ' ')
				sprintf(g_sets.eqpresets[i].eqname, "Preset%d", i + 1);
			PopupButtonSetText(WINDOWEQ, ID_POPUP_EQPRESET, i, g_sets.eqpresets[i].eqname);
		}

		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(window);
	}
	else
		maLog("EqualizerWindowMake already made");

} // EqualizerWindowMake


OSStatus EqualizerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
#if defined(MAKEYBOARD)
		EventRef rawEvent;
		unsigned char charCode;
#endif
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClosed:
					OnWindowClosedEq();
				return eventNotHandledErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						WindowGetOrigin((int)userData, &g_sets.eqxpos[g_sets.winconf], &g_sets.eqypos[g_sets.winconf]);
					if(attributes & kWindowBoundsChangeUserResize)
						WindowGetSize((int)userData, &g_sets.eqxsize[g_sets.winconf], &g_sets.eqysize[g_sets.winconf]);
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
 		break;
		
#if defined(MAMOUSEWHEEL) || defined(MAKEYBOARD)
		case kEventClassMouse:
 #if defined(MAMOUSEWHEEL)
 			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
 #endif
 #if defined(MAKEYBOARD)
			// give up kb focus on click in eq window outside Preset Name editor
 			if(g_sets.keyboard && GetEventKind(event) == kEventMouseUp)
				ClearKeyboardFocus((WindowRef)g_w[WINDOWEQ]);
			else
 #endif
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
					GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);
					maOnKey(0, charCode);
					return noErr;
				break;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // EqualizerWindowEventHandler


void Equalizer2WindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("Equalizer2WindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClosed },
									{ kEventClassWindow,	kEventWindowBoundsChanged },
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassMouse,		kEventMouseUp },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef window;
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("Equalizer2WindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEQ2])
	{		
		// Search the bundle for a .nib file named 'maosxEq2.nib'
		status = CreateNibReference(CFSTR("maosxEq2"), &nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "Equalizer2WindowMake CreateNibReference err %d 'maosxEq2.nib'", (int)status);
			maLog(cstr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "Equalizer2WindowMake CreateWindowFromNib err %d", (int)status);
			maLog(cstr);
			return;
		}

		status = InstallWindowEventHandler(window, NewEventHandlerUPP(Equalizer2WindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWEQ2, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "Equalizer2WindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(cstr);
			return;
		}
		
		id.signature = 'MAMP';
		
		// slider (scrollbar) callback proc
		for(id.id = ID_SLIDER_EQ_FIRST; id.id <= ID_SLIDER_EQ_LAST; id.id++)
		{
			GetControlByID(window, &id, &cb);
			SetControlAction(cb, SliderCallbackProc);
		}
		
		g_w[WINDOWEQ2] = window;
		
		if(g_sets.eqflags & MASEPARATELR) 
			sprintf(cstr, "%s Equalizer Right Channel", g_prognametitle);
		else
			sprintf(cstr, "%s Equalizer Right Channel (Off)", g_prognametitle); // never happens
		WindowSetTitle(WINDOWEQ2, cstr);
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(window);
	}
	else
		maLog("Equalizer2WindowMake already made");

} // Equalizer2WindowMake


OSStatus Equalizer2WindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
#if defined(MAKEYBOARD)
		EventRef rawEvent;
		unsigned char charCode;
#endif

	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClosed:
					OnWindowClosedEq2();
				return eventNotHandledErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						WindowGetOrigin((int)userData, &g_sets.eq2xpos[g_sets.winconf], &g_sets.eq2ypos[g_sets.winconf]);
					if(attributes & kWindowBoundsChangeUserResize)
						WindowGetSize((int)userData, &g_sets.eq2xsize[g_sets.winconf], &g_sets.eq2ysize[g_sets.winconf]);
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
 		break;
		
#if defined(MAMOUSEWHEEL) || defined(MAKEYBOARD)
		case kEventClassMouse:
 #if defined(MAMOUSEWHEEL)
 			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
 #endif
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
					GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);
					maOnKey(0, charCode);
					return noErr;
				break;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // Equalizer2WindowEventHandler


void EffectsWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("EffectsWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClosed },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};  					
	IBNibRef nibRef;
	OSStatus status;
	WindowRef window;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("EffectsWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWEFFECTS])
	{		
		// Search the bundle for a .nib file named 'maosxEffects.nib' 
		status = CreateNibReference(CFSTR("maosxEffects"), &nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "EffectsWindowMake CreateNibReference err %d 'maosxEffects.nib'", (int)status);
			maLog(cstr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "EffectsWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(cstr);
			return;
		}
	
		status = InstallWindowEventHandler(window, NewEventHandlerUPP(EffectsWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWEFFECTS, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "EffectsWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(cstr);
			return;
		}
		
		// slider (scrollbar) callback proc
		ControlID id;
		ControlRef cb;
		id.signature = 'MAMP';
		id.id = ID_SLIDER_PITCH;
		GetControlByID(window, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		id.id = ID_SLIDER_PITCH2;
		GetControlByID(window, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		id.id = ID_SLIDER_TEMPO;
		GetControlByID(window, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		id.id = ID_SLIDER_SPEED;
		GetControlByID(window, &id, &cb);
		SetControlAction(cb, SliderCallbackProc);
		
		// red checkboxes
		id.id = ID_CHK_EFFECTSB;
		GetControlByID(window, &id, &cb);	
		status = SetControlColorProc(cb, CheckBoxColorCallbackProc);

		g_w[WINDOWEFFECTS] = window;
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(window);
	}
	else
		maLog("EffectsWindowMake already made");

} // EffectsWindowMake


OSStatus EffectsWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
#if defined(MAKEYBOARD)
		EventRef rawEvent;
		unsigned char charCode;
#endif
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClosed:
					OnWindowClosedEffects();
				return eventNotHandledErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						WindowGetOrigin((int)userData, &g_sets.effectsxpos[g_sets.winconf], &g_sets.effectsypos[g_sets.winconf]);
					if(attributes & kWindowBoundsChangeUserResize)
						WindowGetSize((int)userData, &g_sets.effectsxsize[g_sets.winconf], &g_sets.effectsysize[g_sets.winconf]);
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

#if defined(MAMOUSEWHEEL)
		case kEventClassMouse:
			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
					GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);
					maOnKey(0, charCode);
					return noErr;
				break;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
 	}

	return noErr;
	
} // EffectsWindowEventHandler


void FileOutWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("FileOutWindowMake");
#endif
	IBNibRef nibRef;
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClosed },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
								};  					
	OSStatus status;
	WindowRef window;
	char *pnibfile;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("FileOutWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWOUTCUR])
	{		
		// Search the bundle for a .nib file
		switch( g_sets.output)
		{
#ifdef ENCODEMP3
			case kOUTMP3 :
				pnibfile = "maosxFileOutMp3";
			break;
#endif
		
#ifdef ENCODEOGG
			case kOUTOGG :
				pnibfile = "maosxFileOutOgg";
			break;
#endif
		
#ifdef ENCODEAIF
			case kOUTAIF :
				pnibfile = "maosxFileOutAif";
			break;
#endif
		
#ifdef ENCODEWAV
			case kOUTWAV :
				pnibfile = "maosxFileOutWav";
			break;
#endif
		
#ifdef ENCODEAAC
			case kOUTAAC :
				pnibfile = "maosxFileOutAac";
			break;
#endif
		
#ifdef ENCODEMP4
			case kOUTMP4 :
				pnibfile = "maosxFileOutMp4";
			break;
#endif
		
#ifdef ENCODEWMA
			case kOUTWMA :
				pnibfile = "maosxFileOutWma";
			break;
#endif
		
#ifdef ENCODEFLAC
			case kOUTFLAC :
				pnibfile = "maosxFileOutFlac";
			break;
#endif
			default:
				maLog("FileOutWindowMake unknown window");
			return;
		}
		
		CFStringRef str;
		str = CFStringCreateWithCString(NULL, (const char *)pnibfile, CFStringGetSystemEncoding());
		status = CreateNibReference(str, &nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "FileOutWindowMake CreateNibReference err %d '%s.nib'", (int)status, pnibfile);
			maLog(cstr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "FileOutWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(cstr);
			return;
		}
	
		status = InstallWindowEventHandler(window, NewEventHandlerUPP(FileOutWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWOUTCUR, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "FileOutWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(cstr);
			return;
		}
		
		g_w[WINDOWOUTCUR] = window;
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(window);
	}
	else
		maLog("FileOutWindowMake already made");

} // FileOutWindowMake


OSStatus FileOutWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClosed:
					OnWindowClosedFileOut();
				return eventNotHandledErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						WindowGetOrigin((int)userData, &g_sets.fileoutxpos[g_sets.winconf],
													  &g_sets.fileoutypos[g_sets.winconf]);
					if(attributes & kWindowBoundsChangeUserResize)
						WindowGetSize((int)userData, &g_sets.fileoutxsize[g_sets.winconf],
													&g_sets.fileoutysize[g_sets.winconf]);
					return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // FileOutWindowEventHandler


OSStatus PromptNumKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus PromptNumKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	EventRef rawEvent;
	unsigned char charCode;

	GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
	GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);

	if(charCode != MAWXK_RETURN && charCode != MAWXK_RETURN_NUMPAD) // '\r' or 0x03
		return eventNotHandledErr;

	OnEditTextPromptNum();
	
	return noErr;
	
} // PromptNumKbHandler


void PromptNumWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("PromptNumWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
									{ kEventClassWindow,	kEventWindowClosed },
								};
	IBNibRef nibRef;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	WindowRef window;
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("PromptNumWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWPROMPTNUM])
	{		
		// Search the bundle for a .nib file named 'maosxPromptNum.nib'
		status = CreateNibReference(CFSTR("maosxPromptNum"), &nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "PromptNumWindowMake CreateNibReference err %d 'maosxPromptNum.nib'", (int)status);
			maLog(cstr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "PromptNumWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(cstr);
			return;
		}

		status = InstallWindowEventHandler(window, NewEventHandlerUPP(PromptNumWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWPROMPTNUM, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "PromptNumWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(cstr);
			return;
		}
		
		id.signature = 'MAMP';
		
		// kb event handler
		id.id = ID_EDITTEXT_PROMPTNUM;

		GetControlByID(window, &id, &cb);	
		InstallEventHandler(GetControlEventTarget(cb), NewEventHandlerUPP(PromptNumKbHandler),
							GetEventTypeCount(TextInputEvents), TextInputEvents, (void *)WINDOWPROMPTNUM, NULL);

		g_w[WINDOWPROMPTNUM] = window;
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(window);
			
		// set focus to edit text
		SetKeyboardFocus (GetControlOwner(cb), cb, kControlFocusNoPart);
		SetKeyboardFocus (GetControlOwner(cb), cb, kControlFocusNextPart);
	}
	else
		maLog("PromptNumWindowMake already made");

} // PromptNumWindowMake


OSStatus PromptNumWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClosed:
					OnWindowClosedPromptNum();
					g_w[(int)userData] = NULL;
				return eventNotHandledErr;				

				default:
				break;
			}
		break;

		default:
		break;
	}

	return eventNotHandledErr;
	
} // PromptNumWindowEventHandler


void AdvancedWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("AdvancedWindowMake");
#endif
	IBNibRef nibRef;
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClosed },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
								};  					
	OSStatus status;
	WindowRef window;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("AdvancedWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWADVANCED])
	{		
		// Search the bundle for a .nib file named 'maosxAdvanced.nib'
		status = CreateNibReference(CFSTR("maosxAdvanced"), &nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "AdvancedWindowMake CreateNibReference err %d 'maosxAdvanced.nib'", (int)status);
			maLog(cstr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "AdvancedWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(cstr);
			return;
		}
	
		status = InstallWindowEventHandler(window, NewEventHandlerUPP(AdvancedWindowEventHandler),
											sizeof(eventspec), eventspec, (void *)WINDOWADVANCED, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "AdvancedWindowMake InstallWindowEventHandler err %d", (int)status);
			maLog(cstr);
			return;
		}
		
		g_w[WINDOWADVANCED] = window;
		
		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(window);
	}
	else
		maLog("AdvancedWindowMake already made");

} // AdvancedWindowMake


OSStatus AdvancedWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowClosed:
					OnWindowClosedAdvanced();
				return eventNotHandledErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						WindowGetOrigin((int)userData, &g_sets.advancedxpos, &g_sets.advancedypos);
					if(attributes & kWindowBoundsChangeUserResize)
						WindowGetSize((int)userData, &g_sets.advancedxsize, &g_sets.advancedysize);
					return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

		default:
		return eventNotHandledErr;
	}
	
	return noErr;

} // AdvancedWindowEventHandler


void ListAppend(int window, int list, char *text)
{
#ifdef MATRACEGUIOSX
	maTrace("ListAppend");
#endif
	int llinemax;
	int islist = 0;
	ControlID id;
	ControlRef cb;
	DataBrowserItemID item;
	OSStatus status;
	
	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(!cb)
	{
		maLogAPI("ListAppend nocb", window, list);
		return;		
	}

	switch (g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
	{
		case LBOXLIST :
			if(!(llinemax = g_songsnum))
				llinemax = 1;
			islist = 1;
		break;
		case LBOXLOADED :	
			if(!(llinemax = g_loadednum))
				llinemax = 1;
		break;
		case LBOXINFO :
		case LBOXID3 :
		default :
			llinemax = 128;
		break;
	}

	if(llinemax && l_linenum >= llinemax)
	{
		maLog("ListAppend reached max list size");
		return;
	}
	
	if(l_lline)
	{
		if(llinemax != l_llinemax)
		{
			MAFREE(l_lline);
			l_lline = NULL;
		}
	}
	
	if(!(l_llinemax = llinemax))
		return;
	
	if(!l_lline && (l_lline = (char *)MAMALLOC(l_llinemax * LISTLINELEN)) == NULL)
	{
		maLog("ListAppend MAMALLOC failed");
		return;
	}

	strcpy(l_lline + l_linenum * LISTLINELEN, text);
	
	if(islist)
	{
		if(l_linenum < llinemax - 1)
			status = AddDataBrowserItems(cb, kDataBrowserNoItem, 1, NULL, kDataBrowserItemNoProperty);
		else // last of list
			status = AddDataBrowserItems(cb, kDataBrowserNoItem, l_linenum + 1, NULL, kDataBrowserItemNoProperty);
	}
	else
	{
		item = l_linenum + 1;
		status = AddDataBrowserItems(cb, kDataBrowserNoItem, 1, &item, kDataBrowserItemNoProperty);
	}
				
	if(status != noErr)
	{
		maLog("ListAppend AddDataBrowserItems failed");
		return;
	}
	
	l_linenum++;
	
} // ListAppend

 
void ListClear(int window, int list)
{
#ifdef MATRACEGUIOSX
	maTrace("ListClear");
#endif
	ControlID id;
	ControlRef cb;
	OSStatus status;
	
	if(!g_w[window])
		return;

	if(l_linenum)
	{
		id.signature = 'MAMP';
		id.id = list;
		status = GetControlByID((WindowRef)g_w[window], &id, &cb);	
		if(status != noErr)
		{
			char cstr[256];
			sprintf(cstr, "ListClear GetControlByID error=%d window=%d list=%d", (int)status, window, list);
			maLog(cstr);
		}
		else
		{
			if(cb)
			{
  				status = RemoveDataBrowserItems(cb, kDataBrowserNoItem, 0, NULL, kDataBrowserItemNoProperty);
				if(status != noErr)
				{
					char cstr[256];
					sprintf(cstr, "ListClear RemoveDataBrowserItems error=%d window=%d list=%d",
																	(int)status, window, list);
					maLog(cstr);
				}
			}
			else
				maLogAPI("ListClear nocb", window, list);
		}
		
		l_linenum = 0;
	}
	
	if(l_lline)
	{
		MAFREE(l_lline);
		l_lline = NULL;
	}

} // ListClear


int ListGetRowSelected(int window, int list)
{
#ifdef MATRACEGUIOSX
	maTrace("ListGetRowSelected");
#endif
	DataBrowserItemID first;
	DataBrowserItemID last;
	ControlID id;
	ControlRef cb;
	
	if(!g_w[window])
		return -1;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		GetDataBrowserSelectionAnchor(cb, &first, &last);
	else
		maLogAPI("ListGetRowSelected nocb", window, list);

	return first - 1;
}


void ListEnsureVisible(int window, int list, int row)
{
#ifdef MATRACEGUIOSX
	maTrace("ListEnsureVisible");
#endif
	ControlID id;
	ControlRef cb;
	
	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
	{
		RevealDataBrowserItem(cb, row + 1, kDataBrowserItemNoProperty,
		kDataBrowserRevealAndCenterInView + kDataBrowserRevealWithoutSelecting);
	}
	else
		maLogAPI("ListEnsureVisible nocb", window, list);
}


void ListSelect(int window, int list, int row)
{
#ifdef MATRACEGUIOSX
	maTrace("ListSelect");
#endif
	ControlID id;
	ControlRef cb;
	DataBrowserItemID item = row + 1;
	
	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
  	{
		g_listselect++;
		SetDataBrowserSelectedItems(cb, 1, &item, kDataBrowserItemsAssign);
	}
	else
		maLogAPI("ListSelect nocb", window, list);
}


void ListGetText(int window, int list, int row, char *text)
{
#ifdef MATRACEGUIOSX
	maTrace("ListGetText");
#endif
	
	if(!g_w[window])
		return;

	if(l_lline)
		strcpy(text, l_lline + row * LISTLINELEN);
	else
		maLogAPI("ListGetText no l_lline", window, list);

	/* if we could get a text item out of the browser we could get rid of l_lline...
	Handle items;
	ControlID id;
	ControlRef cb;
		
	id.signature = 'MAMP';
	id.id = list;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
  	{
		OSStatus status;
		items = NewHandle(0);
		status = GetDataBrowserItems(cb, (DataBrowserItemID)(row + 1), false, kDataBrowserItemNoState, items);
		if(status != noErr)
		{
			maLog("ListGetText GetDataBrowserItems failed");
			DisposeHandle(items);
			return;
		}
		DisposeHandle(items);
	}
	else
		maLogAPI("ListGetText nocb", window, list);
	*/
	
} // ListGetText


/* not used void ListSetText(int window, int list, int row, char *text)
{
#ifdef MATRACEGUIOSX
	maTrace("ListSetText");
#endif
}
*/


enum {ListCol1Property = 'COL1'}; // this is set in the .nib column settings, if we have a browser in nib
void ListSetHeader(int window, int list, int col, char *header)
{
#ifdef MATRACEGUIOSX
	maTrace("ListSetHeader");
#endif

	ControlRef cb;
	ControlID id;
	CFStringRef str;
	OSStatus status;
	DataBrowserListViewHeaderDesc desc = {0};
	
	if(!g_w[WINDOWLIST])
		return;

	id.signature = 'MAMP';
	id.id = ID_LIST_CTRL;
	status = GetControlByID((WindowRef)g_w[WINDOWLIST], &id, &cb);
	if(status != noErr)
	{
		maLog("ListSetHeader GetControlByID failed");
		return;
	}

	str = CFStringCreateWithCString(NULL, (const char *)header, CFStringGetSystemEncoding());
	if(!str)
	{
		maLog("ListSetHeader CFStringCreateWithCString failed");
		return;
	}

	status = GetDataBrowserListViewHeaderDesc(cb, ListCol1Property, &desc);
	if(status != noErr)
	{
		maLog("ListSetHeader GetDataBrowserListViewHeaderDesc failed");
		// return;
		// try to keep going :
		desc.version = kDataBrowserListViewLatestHeaderDesc;
		desc.minimumWidth = 20; // same as in .nib column info
		desc.maximumWidth = 1024;
		desc.initialOrder = kDataBrowserOrderIncreasing;
		desc.btnFontStyle.flags = kControlUseFontMask + kControlUseJustMask;
		desc.btnFontStyle.font = kControlFontSmallSystemFont;
		desc.btnFontStyle.style = kControlUseThemeFontIDMask;
		// desc.titleOffset = 0;
		// desc.btnFontStyle.just = 0; // left justification
		// desc.btnFontStyle.size;
		// desc.btnFontStyle.mode;
		// desc.btnFontStyle.foreColor;
		// desc.btnFontStyle.backColor;
		// desc.btnContentInfo; 
	}
	
	desc.titleString = str;
	status = SetDataBrowserListViewHeaderDesc(cb, ListCol1Property, &desc);
	if(status != noErr)
		maLog("ListSetHeader SetDataBrowserListViewHeaderDesc failed");

} // ListSetHeader


void SetColumn0Width(int width)
{
	UInt16 w;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	
	if(!g_w[WINDOWLIST])
		return;

	if(width <= 0)
	{
		switch(g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
		{
			case LBOXINFO:
				w = g_sets.listcolxsize[g_sets.winconf][0];
			break;
			case LBOXLIST:
				w = g_sets.listcolxsize[g_sets.winconf][1];
			break;
			case LBOXLOADED:
				w = g_sets.listcolxsize[g_sets.winconf][2];
			break;
			case LBOXID3:
				w = g_sets.listcolxsize[g_sets.winconf][3];
			break;
			default:
			return;
		}
	}
	else
		w = width;
	
	id.signature = 'MAMP';
	id.id = ID_LIST_CTRL;
	status = GetControlByID((WindowRef)g_w[WINDOWLIST], &id, &cb);
	if(status != noErr)
	{
		maLog("SetColumn0Width GetControlByID failed");
		return;
	}
	
	status = SetDataBrowserTableViewColumnWidth(cb, w);
	if(status != noErr)
	{
		maLog("SetColumn0Width SetDataBrowserTableViewColumnWidth failed");
		return;
	}

	if(width > 0)
		GetColumn0Width();

} // SetColumn0Width

		
void GetColumn0Width()
{
	UInt16 width;
	ControlRef cb;
	ControlID id;
	OSStatus status;
	
	if(!g_w[WINDOWLIST])
		return;

	id.signature = 'MAMP';
	id.id = ID_LIST_CTRL;
	status = GetControlByID((WindowRef)g_w[WINDOWLIST], &id, &cb);
	if(status != noErr)
	{
		maLog("GetColumn0Width GetControlByID failed");
		return;
	}
	
	status = GetDataBrowserTableViewColumnWidth(cb, &width)										;
	if(status != noErr)
	{
		maLog("GetColumn0Width GetDataBrowserTableViewColumnWidth failed");
		return;
	}

	if(width < (g_sets.listxsize[g_sets.winconf] - SCROLLERWIDTH))
		width = g_sets.listxsize[g_sets.winconf] - SCROLLERWIDTH;

	switch(g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
	{
		case LBOXINFO:
			g_sets.listcolxsize[g_sets.winconf][0] = width;
		break;
		case LBOXLIST:
			g_sets.listcolxsize[g_sets.winconf][1] = width;
		break;
		case LBOXLOADED:
			g_sets.listcolxsize[g_sets.winconf][2] = width;
		break;
		case LBOXID3:
			g_sets.listcolxsize[g_sets.winconf][3] = width;
		break;
		default:
		break;
	}

	return;
	
} // GetColumn0Width

		
void ListSetColumnWidth()
{
#ifdef MATRACEGUIOSX
	maTrace("ListSetColumnWidth");
#endif
	SetColumn0Width(0);
}


OSStatus ListDBItemDataCallback(ControlRef browser, DataBrowserItemID itemID, DataBrowserPropertyID property,
								DataBrowserItemDataRef itemData, Boolean changeValue)
{
	OSStatus status = noErr; 
	CFStringRef str;
	
	if(!changeValue)
	{
		switch(property)
		{
			case ListCol1Property:
				if(itemID < 1 || itemID > (DataBrowserItemID)l_llinemax)
				{
					maLog("ListDBItemDataCallback bad itemID");
					status = errDataBrowserItemNotAdded;
					break;
				}
				str = CFStringCreateWithCString(NULL, (const char *)(l_lline + (itemID - 1) * LISTLINELEN), CFStringGetSystemEncoding());
				if(str)
					status = SetDataBrowserItemDataText(itemData, str);
				else
				{
					maLog("ListDBItemDataCallback CFStringCreateWithCString failed");
					status = errDataBrowserItemNotAdded;
				}
				//if(itemID && itemID == l_llinemax) // on last item
			break;
			default:
				status = errDataBrowserPropertyNotSupported;
			break;
		}
	}
	else
		status = errDataBrowserPropertyNotSupported;

	return status;

} // ListDBItemDataCallback


void ListDBNotificationCallback(ControlRef browser, DataBrowserItemID itemID,
						DataBrowserItemNotification message, DataBrowserItemDataRef itemData)
{
	switch(message)
	{
		case kDataBrowserUserStateChanged:
			GetColumn0Width();
		break;
		case kDataBrowserItemDoubleClicked:
			OnListWindowDoubleClick();
		break;
		case kDataBrowserItemSelected:
			OnListWindowSingleClick((int)itemID); // will do nothing if g_listselect is > 0
		break;
		default:
		break;
	}
	return;
}


#define kListSpacer1 54 // room for buttons and keybindings text
OSStatus ListWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	Rect r;
	UInt32 attributes;
	HIViewRef contentView;
	HIRect boundsRect;
#if defined(MAKEYBOARD)
		EventRef rawEvent;
		unsigned char charCode;
#endif
	
	switch(GetEventClass(event))
	{
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			WindowRef window;
			GetEventParameter(event, kEventParamDirectObject, typeWindowRef, NULL, sizeof(window), NULL, &window);
			switch(GetEventKind(event))
		 	{
				case kEventWindowClosed:
					OnWindowClosedList();
					l_linenum = 0;
				return eventNotHandledErr;

				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						WindowGetOrigin((int)userData, &g_sets.listxpos[g_sets.winconf], &g_sets.listypos[g_sets.winconf]);
					if(attributes & kWindowBoundsChangeUserResize) // OnSize
					{
						WindowGetSize((int)userData, &g_sets.listxsize[g_sets.winconf], &g_sets.listysize[g_sets.winconf]);
						HIViewFindByID(HIViewGetRoot(window), kHIViewWindowContentID, &contentView);
						HIViewGetBounds(contentView, &boundsRect);
						boundsRect.origin.y += kListSpacer1;
						boundsRect.size.height -= kListSpacer1;
						HIViewSetFrame(HIViewGetFirstSubview(contentView), &boundsRect);
						SetColumn0Width((int)(boundsRect.size.width - SCROLLERWIDTH));
					}
				return eventNotHandledErr;

				default:
				return eventNotHandledErr;
			}
		break;

#if defined(MAMOUSEWHEEL) || defined(MAKEYBOARD)
		case kEventClassMouse:
 #if defined(MAMOUSEWHEEL)
 			if(g_sets.mousewheel && GetEventKind(event) == kEventMouseWheelMoved)
			{
				SInt32 wheeldelta;
				HIPoint point;
				GetEventParameter(event, kEventParamWindowMouseLocation, typeHIPoint, NULL, sizeof(point), NULL, &point);
				if(point.y > kListSpacer1 + 23) // mouse pointer is inside the list
					return eventNotHandledErr;
				GetEventParameter(event, kEventParamMouseWheelDelta, typeSInt32, nil, sizeof(wheeldelta), nil, &wheeldelta);
				if(wheeldelta > 0)
					ChangeVolume(MAWHEELVOLUMEDELTA);
				else if(wheeldelta < 0)
					ChangeVolume(-MAWHEELVOLUMEDELTA);
			}
			else
 #endif
 #if defined(MAKEYBOARD)
			// give up kb focus on click in list window outside list
 			if(g_sets.keyboard && GetEventKind(event) == kEventMouseUp)
			{
				HIPoint point;
				GetEventParameter(event, kEventParamWindowMouseLocation, typeHIPoint, NULL, sizeof(point), NULL, &point);
				if(point.y > kListSpacer1 + 23) // mouse pointer is inside the list
					return eventNotHandledErr;
				ClearKeyboardFocus((WindowRef)g_w[WINDOWLIST]);
			}
			else
 #endif
				return eventNotHandledErr;
		break;
#endif

#if defined(MAKEYBOARD)
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
					GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);
					maOnKey(0, charCode);
					return noErr;
				break;
				default:
				break;
			}
		break;
#endif

		default:
		return eventNotHandledErr;
	}

	return noErr;
	
} // ListWindowEventHandler


OSStatus ListKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus ListKbHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	EventRef rawEvent;
	unsigned char charCode;
	
	GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
	GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);

	if(charCode != '\r')
		return eventNotHandledErr;

	OnListWindowDoubleClick();
	
	return noErr;
}


void ListWindowMake()
{
#ifdef MATRACEGUIOSX
	maTrace("ListWindowMake");
#endif
	EventTypeSpec eventspec[] = {
									{ kEventClassCommand,   kEventCommandProcess }, 
									{ kEventClassWindow,	kEventWindowClosed },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
#if defined(MAMOUSEWHEEL)
									{ kEventClassMouse,		kEventMouseWheelMoved },
#endif
#if defined(MAKEYBOARD)
									{ kEventClassMouse,		kEventMouseUp },
									{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
#endif
								};  					
	IBNibRef nibRef;
	WindowRef window;
	ControlRef browser;
	ControlID id = {'MAMP', ID_LIST_CTRL};
	OSStatus status;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("ListWindowMake no App window");
		return;
	}
	
	if(!g_w[WINDOWLIST])
	{		
		// Search the bundle for a .nib file named 'maosxList.nib'
		status = CreateNibReference(CFSTR("maosxList"), &nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "ListWindowMake CreateNibReference err %d 'maosxList.nib'", (int)status);
			maLog(cstr);
			return;
		}

		status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
		DisposeNibReference(nibRef);
		if(status != noErr)
		{
			sprintf(cstr, "ListWindowMake CreateWindowFromNib err %d", (int)status);
			maLog(cstr);
			return;
		}

		status = InstallWindowEventHandler(window, NewEventHandlerUPP(ListWindowEventHandler), 
											sizeof(eventspec), eventspec, (void *)WINDOWLIST, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "ListWindowMake InstallWindowEventHandler (window) err %d", (int)status);
			maLog(cstr);
			return;
		}
		
		HISize min, max;
		GetWindowResizeLimits(window, &min, &max);
		min.width = 20;
		min.height = 20;
		SetWindowResizeLimits(window, &min, &max);

		g_w[WINDOWLIST] = window;
		
		// listbox
		// GetControlByID(window, &id, &browser);
		// a DataBrowser created from a nib file seems to have problems detecting mouse doubleclicks
		// with large (1500+) song lists, so we don't put one in the nib file and create it here instead
		
		// for browser not in nib : 	
		Rect bounds;
		bounds.top = kListSpacer1;
		bounds.left = 0;
		bounds.bottom = g_sets.listysize[g_sets.winconf];
		bounds.right = g_sets.listxsize[g_sets.winconf];
		CreateDataBrowserControl(window, &bounds, kDataBrowserListView, &browser);		
		SetControlID(browser, &id);
		SetDataBrowserSelectionFlags(browser, kDataBrowserSelectOnlyOne);

		// browser callbacks
		DataBrowserCallbacks dbCallbacks;
		dbCallbacks.version = kDataBrowserLatestCallbacks;
		InitDataBrowserCallbacks(&dbCallbacks);
		dbCallbacks.u.v1.itemDataCallback =
			NewDataBrowserItemDataUPP((DataBrowserItemDataProcPtr)ListDBItemDataCallback);
		dbCallbacks.u.v1.itemNotificationCallback =
			(DataBrowserItemNotificationUPP)NewDataBrowserItemNotificationWithItemUPP(ListDBNotificationCallback);
		SetDataBrowserCallbacks(browser, &dbCallbacks);
		
		// more stuff for browser not in nib :
		DataBrowserListViewColumnDesc columnDesc;
		columnDesc.headerBtnDesc.titleOffset = 0;
		columnDesc.headerBtnDesc.version = kDataBrowserListViewLatestHeaderDesc;
		columnDesc.headerBtnDesc.btnFontStyle.flags	= kControlUseFontMask | kControlUseJustMask;
		columnDesc.headerBtnDesc.btnContentInfo.contentType = kControlNoContent;
		columnDesc.headerBtnDesc.btnFontStyle.just = teFlushDefault;
		columnDesc.headerBtnDesc.minimumWidth = 20;
		columnDesc.headerBtnDesc.maximumWidth = 1024;
		columnDesc.headerBtnDesc.btnFontStyle.font = kControlFontSmallSystemFont;
		columnDesc.headerBtnDesc.btnFontStyle.style = kControlUseThemeFontIDMask;
		CFStringRef str = CFStringCreateWithCString(NULL, "", CFStringGetSystemEncoding());
		columnDesc.headerBtnDesc.titleString = str;
		columnDesc.propertyDesc.propertyID = ListCol1Property;
		columnDesc.propertyDesc.propertyType = kDataBrowserTextType;
		columnDesc.propertyDesc.propertyFlags = kDataBrowserListViewTypeSelectColumn | kDataBrowserListViewSelectionColumn;
		status = AddDataBrowserListViewColumn(browser, &columnDesc, kDataBrowserListViewAppendColumn);
		AutoSizeDataBrowserListViewColumns(browser);
		SetDataBrowserHasScrollBars(browser, true, true);
		SetDataBrowserTableViewHiliteStyle(browser, kDataBrowserTableViewFillHilite);
		SetDataBrowserListViewHeaderBtnHeight(browser, 17);

		// kb event handler
		status = InstallEventHandler(GetControlEventTarget(browser), NewEventHandlerUPP(ListKbHandler),
							GetEventTypeCount(TextInputEvents), TextInputEvents, (void *)WINDOWLIST, NULL);
		if(status != noErr)
		{
			sprintf(cstr, "ListWindowMake InstallEventHandler (kb) err %d", (int)status);
			maLog(cstr);
		}

		if(g_w[WINDOWAPP] && WindowIsShown(WINDOWAPP))
			ShowWindow(window);
	}
	else
		maLog("ListWindowMake already made");

} // ListWindowMake


void MenuEnable(int menu, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuEnable");
#endif
	EnableMenuCommand(NULL, l_commandid[item]);
}


void MenuDisable(int menu, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuDisable");
#endif
	DisableMenuCommand(NULL, l_commandid[item]);
}


int MenuIsChecked(int menu, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("MenuIsChecked");
#endif
	return menuchecked[item];
}


void MenuSetChecked(int menu, int item, int value)
{
	OSStatus status;
#ifdef MATRACEGUIOSX
	maTrace("MenuSetChecked");
#endif
	MenuRef pmenu;
	MenuItemIndex index;
	if(l_commandid[item] == 'NULL')
		return;
	if((status = GetIndMenuItemWithCommandID(NULL, l_commandid[item], 1, &pmenu, &index)))
	{
		char cstr[256];
		sprintf(cstr, "MenuSetChecked GetIndMenuItemWithCommandID menu=%d l_commandid[%d]='%c%c%c%c' err=%d",
		menu, item,
		(char)((l_commandid[item] >> 24) & 0xff), (char)((l_commandid[item] >> 16) & 0xff),
		(char)((l_commandid[item] >>  8) & 0xff), (char)(l_commandid[item] & 0xff), (int)status);
		maLog(cstr);
		return;
	}
	MacCheckMenuItem(pmenu, index, value ? 1 : 0);
	menuchecked[item] = value ? 1 : 0;
}


int MenuToggleChecked(UInt32 commandid)
{
	int item;
	for(item = ID_MENU_FIRST; item <= ID_MENU_LAST; item++)
		if(commandid == l_commandid[item])
		{
			MenuSetChecked(0, item, menuchecked[item] ? 0 : 1);
			return menuchecked[item]; // new value
		}
	return -1;
}


void PopupButtonEnable(int window, int popup)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI("PopupButtonEnable nocb", window, popup);		
}


void PopupButtonDisable(int window, int popup)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI("PopupButtonDisable nocb", window, popup);		
}


/* not used
void PopupButtonClear(int window, int popup)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonClear");
#endif
	ControlRef cb;
	ControlID id;
	MenuRef menu;
	short item;
	
	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
  	if(cb)
	{
		GetControlData(cb, 0, kControlPopupButtonMenuRefTag, sizeof(MenuRef), &menu, NULL);
		for(item = 1; item <= CountMenuItems(menu); item++)
			DeleteMenuItem(menu, item);
	}
	else
		maLogAPI("PopupButtonClear nocb", window, popup);		
}
*/


void PopupButtonAppend(int window, int popup, char *text)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonAppend");
#endif
	int l;
	ControlRef cb;
	ControlID id;
	MenuRef menu;
	unsigned char pstr[256];

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
  	if(cb)
	{
		strncpy((char *)&pstr[1], (const char *)text, 255);
		if((l = strlen(text)) > 255)
			l = 255;
		pstr[0] = l;
		GetControlData(cb, 0, kControlPopupButtonMenuRefTag, sizeof(MenuRef), &menu, NULL);
		AppendMenuItemText(menu, pstr);
		if(CountMenuItems(menu) >= 1)
		{
			SetControlMaximum(cb, CountMenuItems(menu));
			SetControlMinimum(cb, 1);
		}
		else
		{
			SetControlMinimum(cb, 0);
			SetControlMaximum(cb, 0);
		}
	}
	else
		maLogAPI("PopupButtonAppend nocb", window, popup);		
}


void PopupButtonSetValue(int window, int popup, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonSetValue");
#endif
	ControlRef cb;
	ControlID id;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
		SetControlValue(cb, value + 1);
	else
		maLogAPI("PopupButtonSetValue nocb", window, popup);		
	return;
}


void PopupButtonSetText(int window, int popup, int item, char *text)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonSetText");
#endif
	int l;
	ControlRef cb;
	ControlID id;
	MenuRef menu;
	unsigned char pstr[256];

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = popup;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		strncpy((char *)&pstr[1], (const char *)text, 255);
		if((l = strlen(text)) > 255)
			l = 255;
		pstr[0] = l;
		GetControlData(cb, 0, kControlPopupButtonMenuRefTag, sizeof(MenuRef), &menu, NULL);
		SetMenuItemText(menu, item + 1, pstr);
	}
	else
		maLogAPI("PopupButtonSetText nocb", window, popup);		

} // PopupButtonSetText


/* not used void PopupButtonSetSelection(int window, int popup, int item)
{
#ifdef MATRACEGUIOSX
	maTrace("PopupButtonSetSelection");
#endif
}
*/


/* not used void SpinButtonEnable(int window, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonEnable");
#endif
	PushButtonEnable(window, button);
}


void SpinButtonDisable(int window, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("SpinButtonDisable");
#endif
	PushButtonDisable(window, button);
}
*/


void PushButtonPaintUp(int window, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonPaintUp");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		SetControlValue(cb, 0);
	else
		maLogAPI("PushButtonPaintUp nocb", window, button);		
}


void PushButtonPaintDown(int window, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonPaintDown");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		SetControlValue(cb, 1);
	else
		maLogAPI("PushButtonPaintDown nocb", window, button);		
}


void PushButtonEnable(int window, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI("PushButtonEnable nocb", window, button);		
}


void PushButtonDisable(int window, int button)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI("PushButtonDisable nocb", window, button);		
}


void PushButtonSetDescriptor(int window, int button, char *desc)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonSetDescriptor");
#endif
	int l;
	ControlRef cb;
	ControlID id;
	unsigned char pstr[256];

	if(!g_w[window] || !desc)
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		strncpy((char *)&pstr[1], (const char *)desc, 255);
		if((l = strlen(desc)) > 255)
			l = 255;
		pstr[0] = l;
		SetControlTitle(cb, pstr);
	}
	else
		maLogAPI("PushButtonSetDescriptor nocb", window, button);
}


void PushButtonGetDescriptor(int window, int button, char *desc)
{
#ifdef MATRACEGUIOSX
	maTrace("PushButtonGetDescriptor");
#endif
	ControlRef cb;
	ControlID id;
	unsigned char pstr[258];

	if(!g_w[window] || !desc)
		return;

	id.signature = 'MAMP';
	id.id = button;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		GetControlTitle(cb, pstr);
		pstr[pstr[0] + 1] = 0;
		strcpy(desc, (const char *)&pstr[1]);
	}
	else
		maLogAPI("PushButtonGetDescriptor nocb", window, button);
}

void SliderCallback(ControlHandle control, SInt16 part)
{
	SInt16 startValue;
	SInt16 delta;
	ControlID id;
	
	startValue = GetControlValue(control);
	
	delta = 0;
	
	switch(part)
	{
		case kControlUpButtonPart:
			if(startValue > GetControlMinimum(control))
				delta = -1;
			break;
		
		case kControlDownButtonPart:
			if(startValue < GetControlMaximum(control))
				delta = 1;
			break;
		
		case kControlPageUpPart:
			if(startValue > GetControlMinimum(control))
				delta = -10;
			break;
		
		case kControlPageDownPart:
			if(startValue < GetControlMaximum(control))
				delta = 10;
			break;
	}
	
	if(delta)
		SetControlValue(control, startValue + delta);

	if(part != kControlIndicatorPart && delta == 0)
		return;
	
	if(GetControlID(control, &id))
	{
		maLogAPI("SliderCallback GetControlID failed", WINDOWAPP, id.id);
		return;
	}

	if(id.id >= ID_SLIDER_EQ_FIRST && id.id <= ID_SLIDER_EQ_LAST)
	{
		OnSliderEq(id.id - ID_SLIDER_EQ_FIRST, SliderGetValue(WINDOWEQ, id.id), 0);
		return;
	}
	
	switch(id.id)
	{
		case ID_SLIDER_VOLUMEL :
			OnSliderVolumeL(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMEL));
		break;
		case ID_SLIDER_VOLUMER :
			OnSliderVolumeR(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMER));
		break;
		case ID_SLIDER_VOLUMESEP :
			OnSliderSeparation(SliderGetValue(WINDOWAPP, ID_SLIDER_VOLUMESEP));
		break;
		case ID_SLIDER_PREAMP :
			OnSliderPreamp(SliderGetValue(WINDOWAPP, ID_SLIDER_PREAMP));
		break;
		case ID_SLIDER_POSITION :
			OnSliderPosition(SliderGetValue(WINDOWAPP, ID_SLIDER_POSITION));
		break;

		case ID_SLIDER_PITCH :
			OnSliderPitch(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_PITCH));
		break;
		case ID_SLIDER_PITCH2 :
			OnSliderPitch2(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_PITCH2));
		break;
		case ID_SLIDER_TEMPO :
			OnSliderTempo(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_TEMPO));
		break;
		case ID_SLIDER_SPEED :
			OnSliderSpeed(SliderGetValue(WINDOWEFFECTS, ID_SLIDER_SPEED));
		break;

		default:
			maLogAPI("SliderCallback unexpected id", WINDOWAPP, id.id);
		break;
	}

} // SliderCallback


int SliderGetValue(int window, int slider) // also ScrollBarGetValue
{
#ifdef MATRACEGUIOSX
	maTrace("SliderGetValue");
#endif
	ControlRef cb;
	ControlID id;
	ControlKind kind;

	if(!g_w[window])
		return 0;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		GetControlKind(cb, &kind);
		if(kind.kind == kControlKindScrollBar) // some are really scrollbars and work differently
			return GetControlMaximum(cb) - GetControlValue(cb);
		return GetControlValue(cb);
	}
	else
		maLogAPI("SliderGetValue nocb", window, slider);		
	return 0;
}


void HSliderSetValue(int window, int slider, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("HSliderSetValue");
#endif
	SliderSetValue(window, slider, value);
}


void SliderSetValue(int window, int slider, int value) // also ScrollBarSetValue
{
#ifdef MATRACEGUIOSX
	maTrace("SliderSetValue");
#endif
	ControlRef cb;
	ControlID id;
	ControlKind kind;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		GetControlKind(cb, &kind);
		if(kind.kind == kControlKindScrollBar) // some are really scrollbars and work differently
			SetControlValue(cb, GetControlMaximum(cb) - value); // 'Maximum' is bottom, min is 0
		else
			SetControlValue(cb, value);
	}
	else
		maLogAPI("SliderSetValue nocb", window, slider);		
	return;
}


void SliderEnable(int window, int slider)
{
#ifdef MATRACEGUIOSX
	maTrace("SliderEnable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		EnableControl(cb);
	else
		maLogAPI("SliderEnable nocb", window, slider);		
}


void SliderDisable(int window, int slider)
{
#ifdef MATRACEGUIOSX
	maTrace("SliderDisable");
#endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = slider;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		DisableControl(cb);
	else
		maLogAPI("SliderDisable nocb", window, slider);		
}


/*
void StaticTextSetColor(int window, int statictext, short red, short green, short blue)
{
#ifdef MATRACEGUIOSX
	maTrace("StaticTextSetColor");
#endif
	ControlRef cb;
	ControlID id;
	ControlFontStyleRec rec;
	
	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = statictext;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		GetControlData(cb, 0, kControlStaticTextStyleTag, sizeof(ControlFontStyleRec), &rec, NULL);
		rec.foreColor.red = red;
		rec.foreColor.green = green;
		rec.foreColor.blue = blue;
		rec.flags = kControlUseAllMask;
		SetControlData(cb, 0, kControlStaticTextStyleTag, sizeof(ControlFontStyleRec), &rec);
	}
	else
		maLogAPI("StaticTextSetColor nocb", window, statictext);		

} // StaticTextSetColor
*/


void StaticTextSetText(int window, int statictext, char *text)
{
#ifdef MATRACEGUIOSX
	maTrace("StaticTextSetText");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef str;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = statictext;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		str = CFStringCreateWithCString(NULL, (const char *)text, CFStringGetSystemEncoding());
		if(str)
			SetControlData(cb, 0, kControlStaticTextCFStringTag, sizeof(CFStringRef), &str);
		else
			maLogAPI("StaticTextSetText CFStringCreateWithCString failed", window, statictext);		
	}
	else
		maLogAPI("StaticTextSetText nocb", window, statictext);

} // StaticTextSetText


void StaticTextSetValue(int window, int statictext, int value)
{
#ifdef MATRACEGUIOSX
	maTrace("StaticTextSetValue");
#endif
	ControlRef cb;
	ControlID id;
	CFStringRef str;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = statictext;
	GetControlByID((WindowRef)g_w[window], &id, &cb);
	if(cb)
	{
		char text[64];
		sprintf(text, "%d", value);
		str = CFStringCreateWithCString(NULL, (const char *)text, CFStringGetSystemEncoding());
		if(str)
			SetControlData(cb, 0, kControlStaticTextCFStringTag, sizeof(CFStringRef), &str);
		else
			maLogAPI("StaticTextSetValue CFStringCreateWithCString failed", window, statictext);		
	}
	else
		maLogAPI("StaticTextSetValue nocb", window, statictext);		

} // StaticTextSetValue


void WindowDoClose(int window)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowDoClose");
#endif
	if(!g_w[window])
	{
		maLog("WindowDoClose no window");
		return;
	}
	DisposeWindow((WindowRef)g_w[window]);
	ReleaseWindow((WindowRef)g_w[window]);
	// OnWindowClosedPromptNum() // if not called by callback

} // WindowDoClose


void WindowDoDestroy(int window)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowDoDestroy");
#endif
	if(!g_w[window])
	{
		maLog("WindowDoDestroy no window");
		return;
	}
	ReleaseWindow((WindowRef)g_w[window]);
}


void WindowGetOrigin(int window, int *xpos, int *ypos)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowGetOrigin");
#endif
	Rect r;
	if(!g_w[window])
	{
		maLog("WindowGetOrigin no window");
		return;
	}
	if(!xpos || !ypos)
	{
		maLog("WindowGetOrigin bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[window], kWindowGlobalPortRgn, &r))
	{
		maLog("WindowGetOrigin GetWindowBounds failed");
		return;
	}
	*xpos = r.left;
	*ypos = r.top;
	
} // WindowGetOrigin


void WindowGetSize(int window, int *xsize, int *ysize)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowGetSize");
#endif
	Rect r;
	if(!g_w[window])
	{
		maLog("WindowGetSize no window");
		return;
	}
	if(!xsize || !ysize)
	{
		maLog("WindowGetSize bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[window], kWindowGlobalPortRgn, &r))
	{
		maLog("WindowGetSize GetWindowBounds failed");
		return;
	}
	*xsize = r.right - r.left;
	*ysize = r.bottom - r.top;
	
} // WindowGetSize


void WindowGetCoordinates(int window, int *xpos, int *ypos, int *xsize, int *ysize)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowGetCoordinates");
#endif

	WindowGetSize(window, xsize, ysize);
	WindowGetOrigin(window, xpos, ypos);
		
} // WindowGetCoordinates


/*
void WindowItemHide(int window, int item)
{
 #ifdef MATRACEGUIOSX
	maTrace("WindowItemHide");
 #endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = item;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		HideControl(cb);
	else
		maLogAPI("WindowItemHide nocb", window, item);		
} // WindowItemHide


void WindowItemShow(int window, int item)
{
 #ifdef MATRACEGUIOSX
	maTrace("WindowItemShow");
 #endif
	ControlID id;
	ControlRef cb;

	if(!g_w[window])
		return;

	id.signature = 'MAMP';
	id.id = item;
	GetControlByID((WindowRef)g_w[window], &id, &cb);	
	if(cb)
		ShowControl(cb);
	else
		maLogAPI("WindowItemShow nocb", window, item);		
} // WindowItemShow
*/

int WindowIsShown(int window)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowIsShown");
#endif
	if(!g_w[window])
	{
		maLog("WindowIsShown no window");
		return 0;
	}
	return MacIsWindowVisible((WindowRef)g_w[window]) ? 1 : 0;
}


void WindowSetSize(int window, int xsize, int ysize)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowSetSize");
#endif
	if(!g_w[window])
	{
		maLog("WindowSetSize no window");
		return;
	}
	SizeWindow((WindowRef)g_w[window], xsize, ysize, true); // update
}


void WindowMove(int window, int xpos, int ypos)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowMove");
#endif
	if(!g_w[window])
	{
		maLog("WindowMove no window");
		return;
	}
	MacMoveWindow((WindowRef)g_w[window], xpos, ypos, false); // front
}


void WindowShow(int window)
{
#ifdef MATRACEGUIOSX
	maTrace("WindowShow");
#endif
	if(!g_w[window])
	{
		maLog("WindowShow no window");
		return;
	}
	ShowWindow((WindowRef)g_w[window]);
}


void WindowSetTitle(int window, char *title)
{
	int l;
	unsigned char pstr[256];
#ifdef MATRACEGUIOSX
	maTrace("WindowSetTitle");
#endif
	if(!g_w[window])
	{
		sprintf((char *)pstr, "WindowSetTitle failed on window %d", window);
		maLog((char *)pstr);
		return;
	}
	strncpy((char *)&pstr[1], (const char *)title, 255);
	if((l = strlen(title)) > 255)
		l = 255;
	pstr[0] = l;
	SetWTitle((WindowRef)g_w[window], pstr);
}


int maDirSelector(char *selectedpath, char *prompt)
{
	NavReplyRecord reply;
	NavDialogOptions dialogOptions;
	FSRef dirAsFSRef;
	AEDesc specDesc;
	OSErr status;
	char dirpath[MAX_PATH];
	
	if(!selectedpath)
	{
		maLog("maDirSelector null selectedpath parameter");
		return 1;
	}

	status = NavGetDefaultDialogOptions(&dialogOptions);
	if(status != noErr)
	{
		maLog("maDirSelector NavGetDefaultDialogOptions failed");
		return 1;
	}

	status = NavChooseFolder(NULL, &reply, &dialogOptions, NULL, NULL, NULL);
	if(status != noErr && status != userCanceledErr)
	{
		maLog("maDirSelector NavChooseFolder failed");
		return 1;
	}

	if(status == userCanceledErr)
		return 1;

	if(!reply.validRecord)
	{
		maLog("maDirSelector not validRecord");
		return 1;
	}	

	status = AECoerceDesc(&reply.selection, typeFSRef, &specDesc);
	if(status != noErr)
	{
		maLog("maDirSelector AECoerceDesc failed");
		return 1;
	}

	dirAsFSRef = **(FSRef**)specDesc.dataHandle;
	if(specDesc.dataHandle != nil)
		AEDisposeDesc(&specDesc);

	status = FSRefMakePath(&dirAsFSRef, (UInt8 *)dirpath, sizeof(dirpath));
	if(status != noErr)
	{
		maLog("maDirSelector FSRefMakePath failed");
		return 1;
	}

	strcpy(selectedpath, dirpath);
	
	return 0;
	
} // maDirSelector


char l_defaultLocation[MAX_PATH] = "";
void NavEventCallback(NavEventCallbackMessage inSelector, NavCBRecPtr ioParams, NavCallBackUserData ioUserData);
NavEventUPP NavEventCallbackUPP = NewNavEventUPP(NavEventCallback);
void NavEventCallback(NavEventCallbackMessage inSelector, NavCBRecPtr ioParams, NavCallBackUserData ioUserData)
{
	FSRef theFSRef;
	AEDesc theLocation = {typeNull, NULL};

	if(inSelector == kNavCBStart)
	{
		if(l_defaultLocation[0])
		{
			if(FSPathMakeRef((const UInt8 *)l_defaultLocation, &theFSRef, NULL) == noErr)
			 if(AECreateDesc(typeFSRef, &theFSRef, sizeof(theFSRef), &theLocation) == noErr)
				 NavCustomControl(ioParams->context, kNavCtlSetLocation, (void *)&theLocation);
		}
	}

} // NavEventCallback


int maFileDialog(char *selectedpath, int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags)
{
	NavDialogCreationOptions dialogOptions;
	NavDialogRef dialog = NULL;
	NavReplyRecord replyRecord;
	FSRef fileAsFSRef;
	CFMutableArrayRef popup;
	int ret = 0;
	char *pfilter;
	OSStatus status;
	char cstr[256];
	char fpath[MAX_PATH];
	char fname[MAX_PATH];
#ifdef MATRACEGUIOSX
	maTrace("maFileDialog");
#endif

	if(!selectedpath)
	{
		maLog("maFileDialog null selectedpath parameter");
		return 1;
	}
	
	if(defdir && defdir[0])
		strcpy(l_defaultLocation, defdir);
	else
		l_defaultLocation[0] = 0;
		
	status = NavGetDefaultDialogCreationOptions(&dialogOptions);
	if(status != noErr)
	{
		maLog("maFileDialog NavGetDefaultDialogCreationOptions failed");
		goto maFileDialogErr;
	}

	dialogOptions.windowTitle = CFStringCreateWithCString(NULL, (const char *)prompt, CFStringGetSystemEncoding());

	sprintf(cstr, "%s%c%s", defdir, FILESEP, deffile); 
	if(strlen(cstr) > 1)
		dialogOptions.message = CFStringCreateWithCString(NULL, (const char *)cstr, CFStringGetSystemEncoding());

	if(flags & maSAVE)
	{
		dialogOptions.saveFileName = CFStringCreateWithCString(NULL, (const char *)deffile, CFStringGetSystemEncoding());
		status = NavCreatePutFileDialog(&dialogOptions, kNavGenericSignature, kNavGenericSignature,
																	NavEventCallbackUPP, NULL, &dialog);
		if(status != noErr)
		{
			maLog("maFileDialog NavCreatePutFileDialog failed");
			goto maFileDialogErr;
		}
	}
	else
	{
		// "(*.maf)|*.maf|Any file (*)|*"
		if(strstr(wildcard, EXTMAF))
			pfilter = "*.maf";
		else
			pfilter = "*.*";
		popup = CFArrayCreateMutable(kCFAllocatorDefault, 1, &kCFTypeArrayCallBacks);
		CFArrayAppendValue(popup, CFStringCreateWithCString(NULL, (const char *)pfilter, CFStringGetSystemEncoding()));
		dialogOptions.popupExtension = popup;

		status = NavCreateGetFileDialog(&dialogOptions, NULL, NavEventCallbackUPP, NULL, NULL, NULL, &dialog);
		if(status != noErr)
		{
			maLog("maFileDialog NavCreateGetFileDialog failed");
			goto maFileDialogErr;
		}
	}

	status = NavDialogRun(dialog);
	if(status != noErr)
	{
		maLog("maFileDialog NavDialogRun failed");
		goto maFileDialogErr;
	}

	status = NavDialogGetReply(dialog, &replyRecord);
	if(status != noErr && status != userCanceledErr)
	{
		maLog("maFileDialog NavDialogGetReply failed");
		goto maFileDialogErr;
	}
	if(status == userCanceledErr)
		goto maFileDialogErr;

	status = AEGetNthPtr(&(replyRecord.selection), 1, typeFSRef, NULL, NULL, &fileAsFSRef, sizeof(FSRef), NULL);
	if(status != noErr)
	{
		maLog("maFileDialog AEGetNthPtr failed");
		goto maFileDialogErr;
	}
		
	memset(fpath, 0, sizeof(fpath));
	status = FSRefMakePath(&fileAsFSRef, (UInt8 *)fpath, sizeof(fpath));
	if(status != noErr)
	{
		maLog("maFileDialog FSRefMakePath failed");
		goto maFileDialogErr;
	}

	if(flags & maSAVE)
	{
		if(!CFStringGetCString(replyRecord.saveFileName, fname, MAX_PATH - 1, CFStringGetSystemEncoding()))
		{
			maLog("maFileDialog CFStringGetCString failed");
			goto maFileDialogErr;
		}

		if((strlen(selectedpath) + strlen(fname)) > (MAX_PATH - 2))
		{
			maLog("maFileDialog failed, file paths/names too long");
			goto maFileDialogErr;
		}
		
		sprintf(selectedpath, "%s%c%s", fpath, FILESEP, fname); 
	}
	else
	{
		if(fpath[MAX_PATH - 1] || strlen(fpath) > (MAX_PATH - 1))
		{
			maLog("maFileDialog failed, file paths/names too long");
			goto maFileDialogErr;
		}
		strcpy(selectedpath, fpath);
	}
		
	goto maFileDialogNoErr;

maFileDialogErr:
	ret = 1;
	
maFileDialogNoErr:
	if(dialog)
		NavDialogDispose(dialog);

	return ret;
	
} // maFileDialog


void maFileDialogMFree(maArray *parray)
{
#ifdef MATRACEGUIOSX
	maTrace("maFileDialogMFree");
#endif
	int i;
	
	if(!parray)
		return;
	if(parray->pitems)
	{
		for(i = 0; i < parray->nitems; i++)
			if(parray->pitems[i])
				MAFREE(parray->pitems[i]);
		MAFREE(parray->pitems);
	}
	parray->pitems = NULL;
	parray->nitems = 0;
}


// for multiple selections (from 'Play Song Files')
int maFileDialogM(maArray *parray, int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags)
{
	NavDialogCreationOptions dialogOptions;
	NavDialogRef dialog;
	NavReplyRecord replyRecord;
	FSRef fileAsFSRef;
	char fpath[MAX_PATH - 1];
	long i, theCount;
	int ret = 0;
	OSStatus status;
	char cstr[256];
#ifdef MATRACEGUIOSX
	maTrace("maFileDialogM");
#endif
	
	if(!parray)
	{
		maLog("maFileDialogM null parray parameter");
		return 1;
	}
	
	parray->nitems = 0;
	parray->pitems = NULL;
	parray->items = NULL; // not used in guiosx

	if(defdir && defdir[0])
		strcpy(l_defaultLocation, defdir);
	else
		l_defaultLocation[0] = 0;

	status = NavGetDefaultDialogCreationOptions(&dialogOptions);
	if(status != noErr)
	{
		maLog("maFileDialogM NavGetDefaultDialogCreationOptions failed");
		goto maFileDialogMErr;
	}
	
	dialogOptions.optionFlags |= (kNavAllowMultipleFiles /*+ kNavAllFilesInPopup*/);
	dialogOptions.windowTitle = CFStringCreateWithCString(NULL, (const char *)prompt, CFStringGetSystemEncoding());
	sprintf(cstr, "%s%c%s", defdir, FILESEP, deffile); 
	if(strlen(cstr) > 1)
		dialogOptions.message = CFStringCreateWithCString(NULL, (const char *)cstr, CFStringGetSystemEncoding());
	/*
	//"Any file|*|mp3|*.mp3|ogg|*.ogg|wma|*.wma|wav|*.wav|aif|*.aif|aiff|*.aiff|cda|*.cda|aac|*.aac|mp4|*.mp4|m2a|*.m2a|m4a|*.m4a"
	size_t numFilters;
	numFilters = 0;
	if(numFilters)
	{
		CFMutableArrayRef popup;
		popup = CFArrayCreateMutable(kCFAllocatorDefault, numFilters, &kCFTypeArrayCallBacks);
		for ( size_t i = 0 ; i < numFilters ; ++i )
		{
			CFArrayAppendValue(popup, CFStringCreateWithCString(NULL, (const char *)"*.*", CFStringGetSystemEncoding()));
		}
	}
	dialogOptions.popupExtension = popup;
	*/
	status = NavCreateGetFileDialog(&dialogOptions, NULL, NavEventCallbackUPP, NULL, NULL, NULL, &dialog);
	if(status != noErr)
	{
		maLog("maFileDialogM NavCreateGetFileDialog failed");
		goto maFileDialogMErr;
	}
	
	status = NavDialogRun(dialog);
	if(status != noErr)
	{
		maLog("maFileDialogM NavDialogRun failed");
		goto maFileDialogMErr;
	}
	
	status = NavDialogGetReply(dialog, &replyRecord);
	if(status != noErr && status != userCanceledErr)
	{
		maLog("maFileDialogM NavDialogGetReply failed");
		goto maFileDialogMErr;
	}
	if(status == userCanceledErr)
		goto maFileDialogMErr;

	status = AECountItems(&replyRecord.selection, &theCount);
	if(status != noErr)
	{
		maLog("maFileDialogM AECountItems failed");
		goto maFileDialogMErr;
	}
	if(!theCount)
		goto maFileDialogMErr;
		
	parray->nitems = theCount;
	
	if((parray->pitems = (char **)MAMALLOC(theCount * sizeof(char *))) == NULL)
	{
		maFileDialogMFree(parray);
		maLog("maFileDialogM MAMALLOC failed");
		goto maFileDialogMErr;
	}
	
	for(i = 1; i <= theCount; i++)
	{
		status = AEGetNthPtr(&(replyRecord.selection), i, typeFSRef, NULL, NULL, &fileAsFSRef, sizeof(FSRef), NULL);
		if(status != noErr)
		{
			maFileDialogMFree(parray);
			maLog("maFileDialogM AEGetNthPtr failed");
			goto maFileDialogMErr;
		}
		
		status = FSRefMakePath(&fileAsFSRef, (UInt8 *)fpath, sizeof(fpath));
		if(status != noErr)
		{
			maFileDialogMFree(parray);
			maLog("maFileDialogM FSRefMakePath failed");
			goto maFileDialogMErr;
		}

		if((parray->pitems[i - 1] = (char *)MAMALLOC(strlen(fpath) + 1)) == NULL)
		{
			maFileDialogMFree(parray);
			maLog("maFileDialogM MAMALLOC failed");
			goto maFileDialogMErr;
		}

		strcpy(parray->pitems[i - 1], fpath);
	}
	
	goto maFileDialogMNoErr;
		
maFileDialogMErr:
	ret = 1;
	
maFileDialogMNoErr:
	if(dialog)
		NavDialogDispose(dialog);

	return ret;

} //maFileDialogM


int maMessageBox(char *s1, char *s2, int flags)
{
#ifdef MATRACEGUIOSX
	maTrace("maMessageBox");
#endif
	SInt16 choice;
	char cstr[512];
	
	if((flags & maYES_NO) == maYES_NO)
	{
		AlertStdAlertParamRec alertparam = {true, false, nil, "\pYes", "\pNo", nil, 1, 0, kWindowDefaultPosition};
		sprintf(&cstr[1], "%s :\n\n%s\n\n%s", g_prognametitle, s2, s1);
		cstr[0] = strlen(&cstr[1]);
		StandardAlert(kAlertCautionAlert, (const unsigned char *)cstr, "\p", &alertparam, &choice);
		return (choice == 1) ? maYES : maNO;
	}
	if((flags & maOK) == maOK)
	{
		AlertStdAlertParamRec alertparam = {true, false, nil, "\pOk", nil, nil, 1, 0, kWindowDefaultPosition};
		sprintf(&cstr[1], "%s :\n\n%s\n\n%s", g_prognametitle, s2, s1);
		cstr[0] = strlen(&cstr[1]);
		StandardAlert(kAlertCautionAlert, (const unsigned char *)cstr, "\p", &alertparam, &choice);
		return maYES;
	}

	return maNO;
	
} // maMessageBox


void maViewReadme()
{
#ifdef MATRACEGUIOSX
	maTrace("maViewReadme");
#endif
	ViewerWindowMake(WINDOWREADME, "MoreAmp README");
	
} // maViewReadme


void maViewCatalog()
{
#ifdef MATRACEGUIOSX
	maTrace("maViewCatalog");
#endif
	ViewerWindowMake(WINDOWCATALOG, "MoreAmp CATALOG");

} // maViewCatalog


void maViewLog()
{
#ifdef MATRACEGUIOSX
	maTrace("maViewLog");
#endif
	ViewerWindowMake(WINDOWLOG, "MoreAmp LOG");

} // maViewLog


#if defined(MAKEYBOARD)
 void maEditKeyBindings()
 {
#ifdef MATRACEGUIOSX
	maTrace("maEditKeyBindings");
#endif
	ViewerWindowMake(WINDOWKEYBINDINGS, "MoreAmp Key Bindings");

 } // maEditKeyBindings
#endif


#define MAFINDSTRMAX 64 // arbitrary
OSStatus ViewerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	HICommandExtended command;
	UInt32 attributes;
	UInt32 kind;
	Rect r;
	Handle handle;
	TXNObject txnObj;
	ControlRef cb;
	ControlRef outControl;
	ControlID id;
	TXNOffset oStartOffset;
	TXNOffset oEndOffset;
	ByteCount nbytes;
	OSStatus status;
	EventMouseButton whichbutton;
	char findstr[MAFINDSTRMAX + 2];
	
	switch(GetEventClass(event))
	{
		case kEventClassMouse:
			if((kind = GetEventKind(event)) == kEventMouseWheelMoved)
				return eventNotHandledErr;

			if(kind == kEventMouseUp)   // right-clicking in the viewer edittext when it has focus copies
			{							// highlighted text to the find edittext and starts (continues) a search
				status = GetEventParameter(event, kEventParamMouseButton, typeMouseButton, NULL,
													sizeof(EventMouseButton), NULL, &whichbutton);	
				if(status != noErr || whichbutton == kEventMouseButtonPrimary)
					return eventNotHandledErr; // user clicked the left mouse button

				id.signature = 'MAMP';
				id.id = ID_EDITTEXT_VIEWER;
				status = GetControlByID((WindowRef)g_w[(int)userData], &id, &cb);
				if(status != noErr)
					return eventNotHandledErr;
				status = GetKeyboardFocus((WindowRef)g_w[(int)userData], &outControl);
				if(status != noErr || !outControl || outControl != cb)
					return eventNotHandledErr; // the viewer edittext control does not have focus
					
				if(l_txnbusy)
					return eventNotHandledErr;

				txnObj = WindowGetTXNObj((WindowRef)g_w[(int)userData]);
				TXNGetSelection(txnObj, &oStartOffset, &oEndOffset);
				status = TXNGetDataEncoded(txnObj, oStartOffset, oEndOffset, &handle, kTXNTextData);
				if(status != noErr)
				{
					maLog("ViewerWindowEventHandler TXNGetDataEncoded failed");
					return eventNotHandledErr;
				}
				nbytes = oEndOffset - oStartOffset;
				if(nbytes > 0)
				{
					if(nbytes > MAFINDSTRMAX)
						nbytes = MAFINDSTRMAX;
					memcpy(findstr, *handle, nbytes);
					DisposeHandle(handle);
					findstr[nbytes] = 0;
					EditTextSetText((int)userData, ID_EDITTEXT_VIEWERFIND, findstr);
					OnButtonFind((int)userData);
				}
				else
				{
					DisposeHandle(handle);
					EditTextSetText((int)userData, ID_EDITTEXT_VIEWERFIND, (char *)"");
					StaticTextSetText((int)userData, ID_TEXT_VIEWERFOUND, (char *)"");
				}
				
				return eventNotHandledErr;
			}			
		break;
		
		case kEventClassCommand:
			GetEventParameter(event, kEventParamDirectObject, typeHICommand, NULL,
															sizeof(HICommandExtended), NULL, &command);
			GetWindowBounds((WindowRef)g_w[(int)userData], kWindowGlobalPortRgn, &r);
			return CommandEventHandler(&command, (int)userData, &r);
		break;
		
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, NULL, sizeof(attributes), NULL, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
					{
#if defined(MAKEYBOARD)
						if((int)userData == WINDOWKEYBINDINGS)
							WindowGetOrigin((int)userData, &g_sets.keybindingsxpos, &g_sets.keybindingsypos);
						else
#endif
							WindowGetOrigin((int)userData, &g_sets.viewerxpos, &g_sets.viewerypos);
					}
					if(attributes & kWindowBoundsChangeUserResize)
					{
#if defined(MAKEYBOARD)
						if((int)userData == WINDOWKEYBINDINGS)
							WindowGetSize((int)userData, &g_sets.keybindingsxsize, &g_sets.keybindingsysize);
						else
#endif
							WindowGetSize((int)userData, &g_sets.viewerxsize, &g_sets.viewerysize);
					}
				return eventNotHandledErr;

				case kEventWindowClose:
					g_w[(int)userData] = NULL;
				return eventNotHandledErr;				

				default:
				break;
			}
		break;

		default:
		break;
	}

	return eventNotHandledErr;
	
} // ViewerWindowEventHandler


#define MASTRSAVE "Save"
#define MASTREDIT "Edit"
OSStatus ViewerEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus ViewerEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	char cstr[32];
	
	switch(GetEventClass(event))
	{
		case kEventClassTextInput:
			switch(GetEventKind(event))
		 	{
				case kEventTextInputUnicodeForKeyEvent:
					PushButtonGetDescriptor((int)userData, ID_BTN_EDITSAVE, cstr);
					if(!strcmp(cstr, MASTRSAVE)) // in edit mode
						return eventNotHandledErr;
					else
						return noErr;
				default:
				break;
			}
		break;
		
		case kEventClassControl: // workaround for main EditText behavior with focus changes
			switch(GetEventKind(event))
		 	{
				case kEventControlSetFocusPart: // main EditText or find EditText about to lose or gain focus
					EditTextSaveSelection((int)userData);
				break;
				
				case kEventControlHit: // main EditText or find EditText has been clicked (and gotten focus)
					EditTextRestoreSelection((int)userData);
				break;

				default:
				break;
			}
		break;
		
		default:
		break;
	}

	return eventNotHandledErr;

} // ViewerEditTextHandler


OSStatus ViewerFindEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus ViewerFindEditTextHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	EventRef rawEvent;
	unsigned char charCode;
	
	switch(GetEventClass(event))
	{
		case kEventClassTextInput: // kEventTextInputUnicodeForKeyEvent:
			GetEventParameter(event, kEventParamTextInputSendKeyboardEvent, typeEventRef, NULL, sizeof(rawEvent), NULL, &rawEvent);
			GetEventParameter(rawEvent, kEventParamKeyMacCharCodes, typeChar, NULL, sizeof(char), NULL, &charCode);
			if(charCode == '\r')
			{
				OnButtonFind((int)userData);
				return noErr;
			}
		break;
		
		case kEventClassControl:
			switch(GetEventKind(event))
		 	{
				case kEventControlHit:
					EditTextRestoreSelection((int)userData);
				break;

				default:
				break;
			}
		break;
		
		default:
		break;
	}

	return eventNotHandledErr;
	
} // ViewerFindEditTextHandler


void ViewerScrollerActionProc(ControlRef controlRef, ControlPartCode partCode);
OSStatus ViewerMouseWheelHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData);
OSStatus ViewerMouseWheelHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	OSStatus result = eventNotHandledErr;
	EventMouseWheelAxis axis;
	ControlRef cb;
	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	SInt32 delta;

	GetEventParameter(event, kEventParamMouseWheelAxis, typeMouseWheelAxis,
												NULL, sizeof(EventMouseWheelAxis), NULL, &axis);	
	GetEventParameter(event, kEventParamMouseWheelDelta, typeLongInteger,
															NULL, sizeof(SInt32), NULL, &delta);	

	if(axis == kEventMouseWheelAxisY)
	{
		GetControlByID((WindowRef)g_w[(int)userData], &id, &cb);
		ViewerScrollerActionProc(cb, delta > 0 ? kControlUpButtonPart : kControlDownButtonPart);
		result = noErr;
	}
	
	return result;
}


OSStatus ViewerScrollerMouseWheelHandler(EventHandlerCallRef inCallRef, EventRef event, void *userData)
{
	OSStatus result = eventNotHandledErr;
	EventMouseWheelAxis axis;
	SInt32 delta;
	ControlRef cb;
	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	GetControlByID((WindowRef)g_w[(int)userData], &id, &cb);

	GetEventParameter(event, kEventParamMouseWheelAxis, typeMouseWheelAxis,
												NULL, sizeof(EventMouseWheelAxis), NULL, &axis);	
	GetEventParameter(event, kEventParamMouseWheelDelta, typeLongInteger,
															NULL, sizeof(SInt32), NULL, &delta);
	if(axis == kEventMouseWheelAxisY)
	{
		ViewerScrollerActionProc(cb, delta > 0 ? kControlUpButtonPart : kControlDownButtonPart);
		result = noErr;
	}
	
	return result;
}


/////////////////////////////// TXN

const SInt32 maINT32_MAX = 2147483647; // INT32_MAX
ControlActionUPP l_ViewerScrollerControlActionUPP = NULL;
TXNScrollInfoUPP l_ViewerTXNScrollInfoUPP = NULL;


TXNObject WindowGetTXNObj(WindowRef window)
{
	ViewerInstanceData *v;
	if((v = GetViewerInstanceData(window)) == NULL)
		return NULL;
	return v->TXNobj;
}


ViewerInstanceData *GetViewerInstanceData(WindowRef window)
{
	OSStatus status;
	ViewerInstanceData *v;
	status = GetWindowProperty(window, ViewerInstanceDataCreator, ViewerInstanceDataProperty,
								sizeof(ViewerInstanceData *), NULL, &v);
	if(status != noErr)
	{
		maLog("GetViewerInstanceData GetWindowProperty failed");
		return NULL;
	}
	return v;
}


void TextViewSetVertScrollCache(WindowRef window, SInt32 value)
{
	ViewerInstanceData *v;
	if((v = GetViewerInstanceData(window)) == NULL)
		return;
	v->scrollCache = value;
}


// Tell a control to update its value & maximum.
OSStatus ControlUpdateValues(ControlRef scrollBar, SInt32 value, SInt32 max)
{
	require(IsValidControlHandle(scrollBar), BadControl);
	SetControl32BitValue(scrollBar, value);
	SetControl32BitMaximum(scrollBar, max);
	return noErr;
	BadControl:
	return paramErr;
}


void ViewerTXNScrollInfoCallback(SInt32 value, SInt32 max,
					TXNScrollBarOrientation orientation, SInt32 userData)
{
	OSStatus status;
	ControlRef cb = NULL;
	if(userData)
	{
		if(g_w[(int)userData] == NULL)
			return;
		ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
		status = GetControlByID((WindowRef)g_w[(int)userData], &id, &cb);
	}
	else
		maLog("ViewerTXNScrollInfoCallback null userData");
	if(cb != NULL)
	{
		status = ControlUpdateValues(cb, value, max);
		TextViewSetVertScrollCache((WindowRef)g_w[(int)userData], value);
	}
	else
		maLog("ViewerTXNScrollInfoCallback null cb");
}


UInt32 TextViewGetTextWindowHeight(WindowRef window)
{
	OSStatus status = paramErr;
	TXNLongRect textRect;
	require(window != NULL, CantGetRect);
	status = TXNGetRectBounds(WindowGetTXNObj(window), NULL, NULL, &textRect);
	require_noerr(status, CantGetRect);
	return textRect.right - textRect.left;
	CantGetRect:
	return 0;
}


OSStatus TextViewCustomScroll(WindowRef window, OSType signature, TXNScrollUnit scrollUnit,
								SInt32 textViewDelta, SInt32 cacheValue)
{
	OSStatus status = paramErr;
	SInt32 vDelta, hDelta;
	ViewerInstanceData *v;
	if((v = GetViewerInstanceData(window)) == NULL)
		return paramErr;
	vDelta = textViewDelta;
	hDelta = 0;
	v->scrollCache = cacheValue;
	if(v->TXNobj)
		status = TXNScroll(v->TXNobj, scrollUnit, scrollUnit, &vDelta, &hDelta);
	return status;
}


SInt32 TextViewGetVertScrollCache(WindowRef window)
{
	ViewerInstanceData *v;
	if((v = GetViewerInstanceData(window)) == NULL)
		return 0;
	return v->scrollCache;
}


UInt32 TextViewGetHeight(WindowRef window)
{
	Rect viewRect = { 0,0,0,0 };
	TXNGetViewRect(WindowGetTXNObj(window), &viewRect);
	return viewRect.bottom-viewRect.top;
}


void ViewerScrollerActionProc(ControlRef controlRef, ControlPartCode partCode)
{
	SInt32 value;
	SInt32 textViewDelta, controlDelta, controlMin, controlMax;
	SInt32 cacheValue;
	TXNScrollUnit scrollUnits;
	ControlID id = {'MAMP', ID_SCROLLBAR_VIEWERV};
	WindowRef window = NULL;
	SInt32 viewHeight = 0;
	scrollUnits = kTXNScrollUnitsInPixels;
	textViewDelta = controlDelta = 0;
	window = GetControlOwner(controlRef);
	if(window == NULL)
	{
		maLog("ViewerScrollerActionProc GetControlOwner");
		return;
	}
	value = GetControl32BitValue(controlRef);
	controlMin = GetControl32BitMinimum(controlRef);
	controlMax = GetControl32BitMaximum(controlRef);
	viewHeight = TextViewGetHeight(window);
	switch (partCode)
	{
		case kControlDownButtonPart:
			textViewDelta = controlDelta = 12; // s.b. line height in pixels
			scrollUnits = kTXNScrollUnitsInPixels;
		break;
		case kControlUpButtonPart:
			textViewDelta = controlDelta = -12;
			scrollUnits = kTXNScrollUnitsInPixels;
		break;
		case kControlPageUpPart:
			textViewDelta = -1;
			controlDelta = (viewHeight <= maINT32_MAX ? viewHeight : maINT32_MAX);
			scrollUnits = kTXNScrollUnitsInViewRects;
			controlDelta = -controlDelta;
		break;
		case kControlPageDownPart:
			textViewDelta = 1;
			controlDelta = (viewHeight <= maINT32_MAX ? viewHeight : maINT32_MAX);
			scrollUnits = kTXNScrollUnitsInViewRects;
		break;
		case kControlIndicatorPart:
			cacheValue = 0;
			scrollUnits = kTXNScrollUnitsInPixels;
			cacheValue = TextViewGetVertScrollCache(window);
			textViewDelta = value - (cacheValue <= maINT32_MAX ? cacheValue : maINT32_MAX);
		break;
		default:
		break;
	}
	if(partCode != kControlIndicatorPart)
	{
		value += controlDelta;
		if(value < controlMin)
			value = controlMin;
		if(value > controlMax)
			value = controlMax;
		SetControl32BitValue(controlRef, value);
	}
	
	TextViewCustomScroll(window, id.signature, scrollUnits, textViewDelta, value);

	return;
	
} // ViewerScrollerActionProc


int maGetFileSize(FILE *file, int what, int nomem); // in maMemFile.h
int ViewerWindowMake(int windowid, char *wintitle)
{
	char *pmem = NULL;
	size_t fsize;
	FILE *fp = NULL;
	int islog = 0;
	SInt32 max;
	SInt32 height;
	char *p;
	char *tptr = NULL;
	size_t tsize;
	ControlRef edit;
	ControlRef findedit;
	ControlID id;
	HIViewRef textView;
	TXNObject txnObj;
	IBNibRef nibRef;
	WindowRef window;
	ControlRef scrollbar;
	ViewerInstanceData *v;
	OSStatus status;
	EventTypeSpec eventspec[] =	{
									{ kEventClassCommand,   kEventCommandProcess },
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged },
								};
								
	EventTypeSpec mouseWheelEvent = { kEventClassMouse, kEventMouseWheelMoved };

	EventTypeSpec ViewerEditTextEvents[] =	{
												{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },											
												{ kEventClassMouse,		kEventMouseUp }, // for right mouse click
												{ kEventClassControl,	kEventControlSetFocusPart },
												{ kEventClassControl,	kEventControlHit },
											};
	
	EventTypeSpec ViewerFindEditTextEvents[] =	{
												{ kEventClassTextInput,	kEventTextInputUnicodeForKeyEvent },
												{ kEventClassControl,	kEventControlHit },
											};
	char cstr[MAX_PATH + 256];

	islog = 0;

	switch(windowid)
	{
		case WINDOWREADME:
			v = &l_vreadme;
		break;
		case WINDOWCATALOG:
			v = &l_catalog;
		break;
		case WINDOWLOG:
			v = &l_log;
		break;
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			v = &l_keybindings;
		break;
#endif
		default:
			sprintf(cstr, "ViewerWindowMake bad windowid %d ", windowid);
			maLog(cstr);
			return 1;
		break;
	}

	status = CreateNibReference(CFSTR("maosxViewer"), &nibRef);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake CreateNibReference err %d 'maosxViewer.nib'", (int)status);
		maLog(cstr);
		return 1;
	}
	
	status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
	DisposeNibReference(nibRef);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake CreateWindowFromNib err %d 'maosxViewer.nib'", (int)status);
		maLog(cstr);
		return 1;
	}
	
	g_w[windowid] = (void *)window;
	id.signature = 'MAMP';
	
	id.id = ID_EDITTEXT_VIEWER;
	GetControlByID(window, &id, &edit);
	
	status = HIViewFindByID(HIViewGetRoot(window), id, &textView);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake HIViewFindByID err %d", (int)status);
		maLog(cstr);
	}
	
	// viewer window event handler - all handlers have userData = widowid
	status = InstallWindowEventHandler(window, NewEventHandlerUPP(ViewerWindowEventHandler),
										sizeof(eventspec), eventspec, (void *)windowid, NULL);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake InstallWindowEventHandler err %d", (int)status);
		maLog(cstr);
	}

	// kb event handler
	status = InstallEventHandler(GetControlEventTarget(edit), NewEventHandlerUPP(ViewerEditTextHandler),
				GetEventTypeCount(ViewerEditTextEvents), ViewerEditTextEvents, (void *)windowid, NULL);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake InstallEventHandler err %d", (int)status);
		maLog(cstr);
	}

	status = HIViewFindByID(HIViewGetRoot(window), id, &textView);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake HIViewFindByID err %d", (int)status);
		maLog(cstr);
	}
	txnObj = HITextViewGetTXNObject(textView);
	if(!txnObj)
		maLog("ViewerWindowMake HITextViewGetTXNObject failed");

	// set viewer instance-specific data in the window's property
	v->windowid = windowid;
	v->TXNobj = txnObj;
	v->scrollbar = 0;
	v->scrollCache = 0;
	v->scrollCacheS = 0;
	v->hits = 0;
	v->atbottom = 0;
	v->OffsetsValid = 0;
	v->StartOffset = 0;
	v->EndOffset = 0;
	
	switch(windowid)
	{
		case WINDOWREADME:
			strcpy(v->fpath, g_readmepath);
			v->findtext = g_readmefind;
		break;
		
		case WINDOWCATALOG:
			if(FilenameFromPathname(g_songlist, cstr))
			{
				sprintf(cstr, "ViewerWindowMake FilenameFromPathname failed on '%s'", g_songlist);
				maLog(cstr);
				return 1;
			}
			if((p = strstr(cstr, g_extstr[kMAMAF])))
				*p = 0;
			sprintf(v->fpath, "%s%c%s.txt", g_madir, FILESEP, cstr);
			v->findtext = g_catalogfind;
		break;
		
		case WINDOWLOG:
			islog = 1;
			strcpy(v->fpath, g_logpath);
			v->findtext = g_logfind;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			strcpy(v->fpath, g_keybindingspath);
			v->findtext = g_keybindingsfind;
		break;
#endif

		default:
		break;
	}

	if(!maFileExists(v->fpath))
	{
		if(islog)
			sprintf(cstr, "NO ERRORS = no log file '%s'", v->fpath);
		else
			sprintf(cstr, "File '%s' not found", v->fpath);
		tptr = cstr;
		tsize = strlen(cstr);
	}
	else
	{
		if((fp = mafopen(v->fpath, "rb")) == NULL)
		{
			sprintf(cstr, "ViewerWindowMake mafopen failed on '%s'", v->fpath);
			maLog(cstr);
			tptr = cstr;
			tsize = strlen(cstr);
		}
		else
		{
			fsize = maGetFileSize(fp, 0, 1);

			if((pmem = (char *)MAMALLOC(fsize + 2)) == NULL)
			{
				sprintf(cstr, "ViewerWindowMake MAMALLOC failed fsize=%d", (int)fsize);
				maLog(cstr);
				tptr = cstr;
				tsize = strlen(cstr);
			}
			else
			{
				if(fread(pmem, 1, fsize, fp) != fsize)
				{
					fclose(fp);
					fp = NULL;
					MAFREE(pmem);
					pmem = NULL;
					sprintf(cstr, "ViewerWindowMake fread failed '%s'", v->fpath);
					maLog(cstr);
					tptr = cstr;
					tsize = strlen(cstr);
				}
				else
				{
					tptr = pmem;
					tsize = fsize;
				}
			}		
		}
	}
	
	if(fp)
		fclose(fp);

	status = SetWindowProperty(window, ViewerInstanceDataCreator, ViewerInstanceDataProperty,
																sizeof(ViewerInstanceData *), &v);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake SetWindowProperty err %d", (int)status);
		maLog(cstr);
	}
		
	// mouse wheel handler
	status = InstallEventHandler(GetControlEventTarget(edit), NewEventHandlerUPP(ViewerMouseWheelHandler),
										1, &mouseWheelEvent, (void *)windowid, NULL);

	// find-edittext input handler
	id.id = ID_EDITTEXT_VIEWERFIND;
	GetControlByID(window, &id, &findedit);	
	status = InstallEventHandler(GetControlEventTarget(findedit), NewEventHandlerUPP(ViewerFindEditTextHandler),
			GetEventTypeCount(ViewerFindEditTextEvents), ViewerFindEditTextEvents, (void *)windowid, NULL);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake InstallEventHandler err %d", (int)status);
		maLog(cstr);
	}

 	// scroll bar handler
	id.id = ID_SCROLLBAR_VIEWERV;
	status = GetControlByID(window, &id, &scrollbar);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake GetControlByID err %d ", (int)status);
		maLog(cstr);
	}
	else
	{
		if(l_ViewerScrollerControlActionUPP != NULL)
			DisposeControlActionUPP(l_ViewerScrollerControlActionUPP);
		l_ViewerScrollerControlActionUPP = NewControlActionUPP(ViewerScrollerActionProc);
		SetControlAction(scrollbar, l_ViewerScrollerControlActionUPP);
		status = InstallEventHandler(GetControlEventTarget(scrollbar),
									NewEventHandlerUPP(ViewerScrollerMouseWheelHandler),
									1, &mouseWheelEvent, (void *)windowid, NULL);
		height = (SInt32)TextViewGetTextWindowHeight(window);
		max = height <= maINT32_MAX ? height : maINT32_MAX;
		SetControl32BitMaximum(scrollbar, max);
	}
	if(l_ViewerTXNScrollInfoUPP != NULL)
		DisposeTXNScrollInfoUPP(l_ViewerTXNScrollInfoUPP);
	if((l_ViewerTXNScrollInfoUPP = NewTXNScrollInfoUPP(ViewerTXNScrollInfoCallback)) == NULL)
	{
		sprintf(cstr, "ViewerWindowMake NewTXNScrollInfoUPP failed");
		maLog(cstr);
	}
	else
		TXNRegisterScrollInfoProc(txnObj, l_ViewerTXNScrollInfoUPP, (SInt32)windowid);
	
	// put text in the viewer edittext control
	status = TXNSetData(txnObj, kTXNTextData, tptr, tsize, kTXNStartOffset, kTXNEndOffset);
	if(status != noErr)
	{
		sprintf(cstr, "ViewerWindowMake TXNSetData err %d 'maosxViewer.nib'", (int)status);
		maLog(cstr);
	}

	if(pmem)
	{
		MAFREE(pmem);
		pmem = NULL;
	}

	TXNSetSelection(txnObj, 0, 0); // scroll to top
	TXNShowSelection(txnObj, false);
	TXNClear(txnObj);
	
#if defined(MAKEYBOARD)
	if(windowid == WINDOWKEYBINDINGS)
	{
		MacMoveWindow(window, g_sets.keybindingsxpos, g_sets.keybindingsypos, false); // front
		SizeWindow(window, g_sets.keybindingsxsize, g_sets.keybindingsysize, true); // update
	}
	else // readme, log, catalog
#endif
	{
		MacMoveWindow(window, g_sets.viewerxpos, g_sets.viewerypos, false);
		SizeWindow(window, g_sets.viewerxsize, g_sets.viewerysize, true);
	}
	
	WindowSetTitle(windowid, wintitle);
	
	EditTextSetText(windowid, ID_EDITTEXT_VIEWERFIND, v->findtext);

	ShowWindow(window);

	return 0;
	
} // ViewerWindowMake


OSStatus AboutViewerWindowEventHandler(EventHandlerCallRef handler, EventRef event, void *userData)
{
	UInt32 attributes;
	
	switch(GetEventClass(event))
	{
		case kEventClassWindow:
			switch(GetEventKind(event))
		 	{
				case kEventWindowBoundsChanged:
					GetEventParameter(event, kEventParamAttributes, typeUInt32, nil, sizeof(attributes), nil, &attributes);
					if(attributes & kWindowBoundsChangeOriginChanged)
						WindowGetOrigin((int)userData, &g_sets.aboutxpos, &g_sets.aboutypos);
					if(attributes & kWindowBoundsChangeUserResize)
						WindowGetSize((int)userData, &g_sets.aboutxsize, &g_sets.aboutysize);
				break;

				case kEventWindowClose:
					g_w[(int)userData] = NULL;
				break;

				default:
				break;
			}
		break;

		default:
		break;
	}

	return eventNotHandledErr;
	
} // AboutViewerWindowEventHandler


int AboutViewerWindowMake(int windowid, char *wintitle)
{
	IBNibRef nibRef;
	WindowRef window;
	OSStatus status;
	ControlRef cb;
	ControlID id = {'MAMP', ID_TEXTVIEW_ABOUTVIEWER};
	HIViewRef textView;
	EventTypeSpec eventspec[] = {
									{ kEventClassWindow,	kEventWindowClose },
									{ kEventClassWindow,	kEventWindowBoundsChanged }, 
								};
	char cstr[MAX_PATH + 256];

	if(windowid != WINDOWABOUT)
		return 1;
		
	status = CreateNibReference(CFSTR("maosxViewerAbout"), &nibRef);
	if(status != noErr)
	{
		sprintf(cstr, "AboutViewerWindowMake CreateNibReference err %d 'maosxViewerAbout.nib'", (int)status);
		maLog(cstr);
		return 1;
	}
	
	status = CreateWindowFromNib(nibRef, CFSTR("MainWindow"), &window);
	DisposeNibReference(nibRef);
	if(status != noErr)
	{
		sprintf(cstr, "AboutViewerWindowMake CreateWindowFromNib err %d 'maosxViewerAbout.nib'", (int)status);
		maLog(cstr);
		return 1;
	}
	
	status = InstallWindowEventHandler(window, NewEventHandlerUPP(AboutViewerWindowEventHandler),
										sizeof(eventspec), eventspec, (void *)windowid, NULL);
	if(status != noErr)
	{
		sprintf(cstr, "AboutViewerWindowMake InstallWindowEventHandler err %d", (int)status);
		maLog(cstr);
	}

	g_w[windowid] = (void *)window;
	
	HIViewFindByID(HIViewGetRoot(window), id, &textView);
	
	status = TXNSetData(HITextViewGetTXNObject(textView), kTXNTextData, g_AboutText, strlen(g_AboutText),
																kTXNStartOffset, kTXNEndOffset);
	if(status != noErr)
	{
		sprintf(cstr, "AboutViewerWindowMake TXNSetData err %d 'maosxViewerAbout.nib'", (int)status);
		maLog(cstr);
	}
	
	TXNSetSelection(HITextViewGetTXNObject(textView), 0, 0);
	TXNShowSelection(HITextViewGetTXNObject(textView), false);
	TXNClear(HITextViewGetTXNObject(textView));
  
	MacMoveWindow(window, g_sets.aboutxpos, g_sets.aboutypos, false); // front
	SizeWindow(window, g_sets.aboutxsize, g_sets.aboutysize, true); // update

	WindowSetTitle(windowid, wintitle);
	
	GetControlByID((WindowRef)g_w[WINDOWABOUT], &id, &cb);
	DeactivateControl(cb);
	
	ShowWindow(window);

	return 0;
	
} // AboutViewerWindowMake


void maViewAbout()
{
#ifdef MATRACEGUIOSX
	maTrace("maViewAbout");
#endif
	AboutViewerWindowMake(WINDOWABOUT, "About MoreAmp");

} // maViewAbout


/* void SetFindText(char *text)
{
	EditTextSetText(m_id_window, ID_EDITTEXT_VIEWERFIND, text);
}
*/

// code from SimpleText for our TXNFind replacement :
Boolean IsThisTheString(
			Ptr p,						// pointer to check
			Str255 searchString,		// string to check for
			Boolean isCaseSensitive)	// case sensitive check or not
//	Returns true if the supplied string is at the specified offset.
//	Otherwise returns false.
{
	Handle 	itl2Table;
	long	offset, length;
	short	script;
	Boolean result = false;

	script = FontToScript(GetSysFont());
	GetIntlResourceTable(script, smWordSelectTable, &itl2Table, &offset, &length);

	if(itl2Table != NULL)
	{
		if(isCaseSensitive)
			result = (CompareText(p, &searchString[1], searchString[0], searchString[0], itl2Table) == 0);
		else
			result = (IdenticalText(p, &searchString[1], searchString[0], searchString[0], itl2Table) == 0);
	}

	return result;
} // IsThisTheString


Boolean PerformSearch(  Handle	h,					// handle to search
						long start,					// offset to begin with
						Str255 searchString,		// string to search for
						Boolean isCaseSensitive,	// case sensitive search
						Boolean isBackwards,		// search backwards from starting point
						Boolean isWraparound,		// wrap search around from end->begining
						long * pNewStart,			// returned new selection start
						long * pNewEnd)				// returned new selection end
//	Performs a search on the supplied handle, starting at the provided
//	offset.  Returns the new selection start and end values, and true
//	if the search is successful.  Otherwise it returns false.
{
	char	flags;
	Ptr		startPtr;
	Ptr		endPtr;
	Ptr		searchPtr;
	Boolean	foundIt = false;
	
	flags = HGetState(h);
	HLock(h);
			
	// back up one when searching backwards, or we'll hit every time on the current
	// character
	if(isBackwards)
	{
		if(start != 0)
		{
			--start;
		}
		else
		{
			if(isWraparound)
				start = GetHandleSize(h);
			else
				return(false);
		}
	}
		
	// determine the bounds of the searching
	startPtr = (*h) + start;
	if(isWraparound )
	{
		if(isBackwards)
		{
			// go backwards until just after the start, or begining of
			// document is start is the end
			if(start == GetHandleSize(h))
				endPtr = *h;
			else
				endPtr = startPtr + 1;
		}
		else
		{
			// go forwards until just before the start, or to the end
			// of the document is the start is already the begining
			if(start == 0)
				endPtr = *h + GetHandleSize(h);
			else
				endPtr = startPtr - 1;
		}
	}
	else
	{
		if(isBackwards)
		{
			// go back until hit begining of document
			endPtr = *h-1;	
		}
		else
		{
			// go forward until hit end of document
			endPtr = *h + GetHandleSize(h);
		}
	}
		
	searchPtr = startPtr;
	while(searchPtr != endPtr)
	{
		short	byteType;
		
		byteType = CharacterByteType(startPtr, searchPtr - startPtr, smCurrentScript);
		
		if(((byteType == smSingleByte) || (byteType == smFirstByte)) &&
			IsThisTheString(searchPtr, searchString, isCaseSensitive)
			)
		{
			foundIt = true;
			*pNewStart = searchPtr - *h;
			*pNewEnd = *pNewStart + searchString[0];
			break;
		}
			
		if(isBackwards)
			--searchPtr;
		else
			++searchPtr;
			
		if(isWraparound)
		{
			if(searchPtr < *h)
				searchPtr = *h + GetHandleSize(h);
			if(searchPtr > *h + GetHandleSize(h))
				searchPtr = *h;
		}
	}
		
	HSetState(h, flags);
	
	return(foundIt);
	
} // PerformSearch


OSStatus maTXNFind( TXNObject					iTXNObject,
					const TXNMatchTextRecord*	iMatchTextDataPtr, /* can be NULL */
					TXNDataType					iDataType,
					TXNMatchOptions				iMatchOptions,
					TXNOffset					iStartSearchOffset,
					TXNOffset					iEndSearchOffset,
					TXNFindUPP					iFindProc,
					SInt32						iRefCon,
					TXNOffset*					oStartMatchOffset,
					TXNOffset*					oEndMatchOffset)
{
	Handle handle;
	long pNewStart;
	long pNewEnd;
	Str255 searchString;
	ByteCount nbytes = TXNDataSize(iTXNObject);

	OSStatus status = TXNGetDataEncoded(iTXNObject, 0, nbytes, &handle, kTXNTextData);
	if(status != noErr)
	{
		maLog("maTXNFind TXNGetDataEncoded failed");
		return status;
	}
	
	memcpy(&searchString[1], iMatchTextDataPtr->iTextPtr, iMatchTextDataPtr->iTextToMatchLength);
	searchString[0] = iMatchTextDataPtr->iTextToMatchLength;
	
	if(PerformSearch(   handle,				// handle to search
						iStartSearchOffset, // offset to begin with
						searchString,		// string to search for
						false,				// case sensitive search
						false,				// search backwards from starting point
						false,				// wrap search around from end->begining
						&pNewStart,			// returned new selection start
						&pNewEnd))			// returned new selection end		
	{
		*oStartMatchOffset = pNewStart;
		*oEndMatchOffset = pNewEnd;
	}
	else	
	{
		*oStartMatchOffset = 0xFFFFFFFF; // not found
		*oEndMatchOffset = 0xFFFFFFFF;
	}
	
	DisposeHandle(handle);
	
	return noErr;

} // maTXNFind


OSStatus maTXNCount( TXNObject					iTXNObject,
					const TXNMatchTextRecord*	iMatchTextDataPtr,
					TXNDataType					iDataType,
					TXNMatchOptions				iMatchOptions,
					TXNOffset					iStartSearchOffset,
					TXNOffset					iEndSearchOffset,
					TXNFindUPP					iFindProc,
					SInt32						iRefCon,
					int*						oHits)
{
	Handle handle;
	long pNewStart;
	long pNewEnd;
	Str255 searchString;
	TXNOffset StartSearchOffset = iStartSearchOffset; 
	ByteCount nbytes = TXNDataSize(iTXNObject);

	OSStatus status = TXNGetDataEncoded(iTXNObject, 0, nbytes, &handle, kTXNTextData);
	if(status != noErr)
	{
		maLog("maTXNCount TXNGetDataEncoded failed");
		return status;
	}
	
	memcpy(&searchString[1], iMatchTextDataPtr->iTextPtr, iMatchTextDataPtr->iTextToMatchLength);
	searchString[0] = iMatchTextDataPtr->iTextToMatchLength;
	
	while(PerformSearch(	handle,				// handle to search
							StartSearchOffset,  // offset to begin with
							searchString,		// string to search for
							false,				// case sensitive search
							false,				// search backwards from starting point
							false,				// wrap search around from end->begining
							&pNewStart,			// returned new selection start
							&pNewEnd))			// returned new selection end		
	{
		(*oHits)++;
		StartSearchOffset = pNewEnd + 1;
	}
		
	DisposeHandle(handle);
	
	return noErr;

} // maTXNCount


void OnButtonFind(int windowid)
{
	long findfrom;
	long findlen;
	char findstr[256];
	TXNOffset oStartOffset;
	TXNOffset oEndOffset;
	TXNMatchTextRecord iMatchTextData;
	TXNOffset iStartSearchOffset;
	TXNOffset iEndSearchOffset;
	TXNOffset oStartMatchOffset;
	TXNOffset oEndMatchOffset;
	ViewerInstanceData *v;
	ControlID id = {'MAMP', ID_EDITTEXT_VIEWER};
	ControlRef cb;
	ControlRef outControl;
	OSStatus status;
	
	if(l_txnbusy)
		return;
	l_txnbusy = 1;
	
	PushButtonDisable(windowid, ID_BTN_VIEWERFIND);
	TXNObject txnObj = WindowGetTXNObj((WindowRef)g_w[windowid]);
	
	// the text in the find edit box is the target text
	EditTextGetText(windowid, ID_EDITTEXT_VIEWERFIND, findstr, 255, &findlen);
	if(findlen < 1)
	{
		StaticTextSetText(windowid, ID_TEXT_VIEWERFOUND, (char *)"Nothing to find.");
		PushButtonEnable(windowid, ID_BTN_VIEWERFIND);
		l_txnbusy = 0;
		return;
	}
	if(findlen > MAFINDSTRMAX)
	{
		findstr[MAFINDSTRMAX] = 0;
		findlen = MAFINDSTRMAX;
		EditTextSetText(windowid, ID_EDITTEXT_VIEWERFIND, findstr);
	}

	// if target string has changed, recount targets
	if((v = GetViewerInstanceData((WindowRef)g_w[windowid])) == NULL)
	{
		l_txnbusy = 0;
		return;
	}
	if(v->hits <= 0 || mastrcasecmp(findstr, v->findtext))
	{
		v->hits = 0;
		memcpy(v->findtext, findstr, findlen);
		v->findtext[findlen] = 0;
		iMatchTextData.iTextPtr = v->findtext;
		iMatchTextData.iTextToMatchLength = findlen;
		iMatchTextData.iTextEncoding = kTextEncodingDefaultFormat; // GetApplicationTextEncoding(); // ?
		iStartSearchOffset = kTXNStartOffset;
		iEndSearchOffset = kTXNEndOffset;
		oStartMatchOffset = 0;
		status = maTXNCount(txnObj, &iMatchTextData, kTXNTextData, kTXNIgnoreCaseMask,
								iStartSearchOffset, iEndSearchOffset, NULL, 0, &v->hits);		
		if(status != noErr)
		{
			maLog("OnButtonFind maTXNCount failed");
			PushButtonEnable(windowid, ID_BTN_VIEWERFIND);
			l_txnbusy = 0;
			return;
		}
	}
	if(v->hits <= 0)
	{
		StaticTextSetText(windowid, ID_TEXT_VIEWERFOUND, (char *)"Not found");
		PushButtonEnable(windowid, ID_BTN_VIEWERFIND);
		l_txnbusy = 0;
		return;
	}

	if(v->atbottom)
	{
		v->atbottom = 0;
		findfrom = kTXNStartOffset;
	}
	else
	{
		TXNGetSelection(txnObj, &oStartOffset, &oEndOffset);
		findfrom = oEndOffset;
	}

	// look for target string from findfrom
	iMatchTextData.iTextPtr = v->findtext;
	iMatchTextData.iTextToMatchLength = strlen(v->findtext);
	iMatchTextData.iTextEncoding = kTextEncodingDefaultFormat; // GetApplicationTextEncoding(); // ?
	iStartSearchOffset = findfrom;
	iEndSearchOffset = kTXNEndOffset;
	status = maTXNFind(txnObj, &iMatchTextData, kTXNTextData, kTXNIgnoreCaseMask,
								iStartSearchOffset, iEndSearchOffset, NULL, 0,
								&oStartMatchOffset, &oEndMatchOffset);
	if(status != noErr)
	{
		maLog("OnButtonFind TXNFind failed");
		PushButtonEnable(windowid, ID_BTN_VIEWERFIND);
		l_txnbusy = 0;
		return;
	}
	
	if(oStartMatchOffset != 0xFFFFFFFF) // found
	{
		status = TXNSetSelection(txnObj, oStartMatchOffset, oEndMatchOffset);
		TXNShowSelection(txnObj, false);
		sprintf(findstr, "%d", v->hits); // sprintf(findstr, "%d (L%d)", v->hits, line);
		StaticTextSetText(windowid, ID_TEXT_VIEWERFOUND, findstr);
		 // kludge to refresh edittext when focus is elsewhere:
		GetControlByID((WindowRef)g_w[windowid], &id, &cb);
		if(cb)
		{
			GetKeyboardFocus((WindowRef)g_w[windowid], &outControl);
			if(cb != outControl)
			{   
				DisableControl(cb);
				EnableControl(cb);
			}
		}
	}
	else
	{
		StaticTextSetText(windowid, ID_TEXT_VIEWERFOUND, (char *)"At bottom.");
		v->atbottom = 1;
	}

	PushButtonEnable(windowid, ID_BTN_VIEWERFIND);
	l_txnbusy = 0;
	
} // OnButtonFind


void OnButtonEditSave(int windowid)
{
	FILE *fp;	
	ControlRef cb;
	ControlID id = {'MAMP', ID_EDITTEXT_VIEWER};
	ViewerInstanceData *v;
	UInt8 *pbytes;
	CFIndex cfindex;
	TXNObject txnObj;
	ByteCount nbytes;
	CFDataRef oDataRef;
	OSStatus status;
	char cstr[MAX_PATH + 256];
	
	if(l_txnbusy)
		return;
	l_txnbusy = 1;
	
	GetControlByID((WindowRef)g_w[windowid], &id, &cb);

	PushButtonGetDescriptor(windowid, ID_BTN_EDITSAVE, cstr);
	if(!strcmp(cstr, MASTRSAVE))
	{
		if((v = GetViewerInstanceData((WindowRef)g_w[windowid])) == NULL)
		{
			l_txnbusy = 0;
			return;
		}
		txnObj = WindowGetTXNObj((WindowRef)g_w[windowid]);
		nbytes = TXNDataSize(txnObj);
		status = TXNFlattenObjectToCFDataRef(txnObj, kTXNTextData, &oDataRef);
		if(status != noErr)
			maLog("OnButtonEditSave TXNFlattenObjectToCFDataRef failed");
		else
		{
			if(nbytes < 1) // CFDataGetLength() crashes if 0
			{
				nbytes = 0;
				pbytes = (UInt8 *)cstr;
			}
			else
			{
				cfindex = CFDataGetLength(oDataRef);
				pbytes = (UInt8 *)CFDataGetBytePtr(oDataRef);
				nbytes = cfindex;
			}
			// rewrite file
			if((fp = mafopen(v->fpath, "wb")) == NULL)
			{
				sprintf(cstr, "MyFrameViewer OnButtonEditSave mafopen failed on '%s'", v->fpath);
				maLog(cstr);
			}
			else
			{
				if(fwrite(pbytes, 1, nbytes, fp) != nbytes)
				{
					sprintf(cstr, "MyFrameViewer OnButtonEditSave fwrite errno=%d '%s'", errno, v->fpath);
					maLog(cstr);
				}
				if(fclose(fp) != 0)
				{
					sprintf(cstr, "MyFrameViewer OnButtonEditSave fclose errno=%d '%s'", errno, v->fpath);
					maLog(cstr);
				}
			
#if defined(MAKEYBOARD)
				// reload
				if(windowid == WINDOWKEYBINDINGS) //(!strcmp(g_keybindingspath, v->fpath))
				{
					// int ret;
					if((/* ret = */ LoadKeyBindings(1)) == 1)
						maLog("MyFrameViewer OnButtonEditSave LoadKeyBindings failed");
					// else if(ret == 2) // fopen failed
					// else if(ret == 3) // no valid entries
					// else if(ret == 4) // duplicate entries
				}
#endif
			}
		}
		PushButtonSetDescriptor(windowid, ID_BTN_EDITSAVE, MASTREDIT);
	}
	else
		PushButtonSetDescriptor(windowid, ID_BTN_EDITSAVE, MASTRSAVE);
	
	l_txnbusy = 0;
	
} // OnButtonEditSave


void maGUIfree()
{
	if(l_lline)
	{
		MAFREE(l_lline);
		l_lline = NULL;
	}
}

void maGUIQuit()
{
	QuitApplicationEventLoop();

} // maGUIQuit


int maModKeyDown()
{
	UInt32 bstate;

	if((bstate = GetCurrentEventButtonState()) & (1 << 1)) // secondary
		return 1;

	if(bstate & (1 << 0)) // primary)
		if(GetCurrentEventKeyModifiers() & shiftKey)
			return 1;

	KeyMap Keys; 
	unsigned char *BytePtr = (unsigned char*)Keys; 
	GetKeys(Keys);
	if(BytePtr[7] & 1) // Shift 0x38 == 56 = (7 * 8) + 0
		return 1;

	return 0; 

} // maModKeyDown

#ifdef __cplusplus
}
#endif

#endif // MAGUIOSX

// eof

