#!/bin/sh

echo $0

# mamksrcgz.sh

mygroup="pm"
myuser="pm"

# make a MoreAmp-x-x-xx-src.tar.gz release file from 'MoreAmpDev' dir

if [ root != `whoami` ] ; then
 echo must run as root - su, not sudo
 exit 1 
fi

if [ $myuser != $LOGNAME ] ; then
 echo must have logged in as $myuser
 exit 1 
fi

chgrp -R $mygroup .
chown -R $myuser .

mahome="/Users/$myuser" # `echo ~`
madir="MoreAmpDev"

if [ ! -d $mahome/$madir ] ; then
 echo "$mahome/$madir not found"
 exit 1
fi

# if [ $mahome/$madir != `pwd` ] ; then
#  echo `pwd` "not in $mahome/$madir"
#  exit 1
# fi

maconfig="$mahome/$madir/src/maConfig.h"
if [ ! -f $maconfig ] ; then
 echo "$mahome/$madir/$maconfig not found"
 exit 1
fi

maversion=`fgrep MOREAMP_VERSION_STRING $maconfig | cut -f2 -d\"`
masrc=MoreAmp-$maversion
matar=$masrc-src.tar 
magz=$matar.gz

if [ -d $mahome/$masrc ] ; then
 echo "$mahome/$masrc already exists"
 exit 1
fi

if [ -f $mahome/$matar ] ; then
 echo "$mahome/$matar already exists"
 exit 1
fi

if [ -f $mahome/$magz ] ; then
 echo "$mahome/$magz already exists"
 exit 1
fi

find . -type d -exec chmod 777 {} \;
find . -type f -exec chmod 777 {} \; 
 
make clean

find "$mahome/$madir" -name ".DS_Store" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.ncb" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.ilk" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.idb" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.pdb" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.plg" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.sbr" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "BuildLog.htm" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.vcproj.*.user" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.opt" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.o" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.lo" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "*.obj" -exec rm {} \; 2>/dev/null
find "$mahome/$madir" -name "config.cache" -exec rm -fr {} \; 2>/dev/null
find "$mahome/$madir" -name "autom4te.cache" -exec rm -fr {} \; 2>/dev/null
find "$mahome/$madir" -type d -name ".libs" -exec rm -fr {} \; 2>/dev/null
find "$mahome/$madir/libs/msvc" -type d -name "obj" -exec rm -fr {} \; 2>/dev/null
find "$mahome/$madir/libs/msvc" -type d -name "Debug" -exec rm -fr {} \; 2>/dev/null
# find "$mahome/$madir/libs/msvc" -type d -name "Release" -exec rm -fr {} \; 2>/dev/null
rm -f "$mahome/$madir/libs/"*/*.a
rm -f "$mahome/$madir/libs/libmad/config.h"
rm -f "$mahome/$madir/libs/libid3tag/config.h"
rm -f "$mahome/$madir/libs/lame/config.h"
rm -fr "$mahome/$madir/libs/libogg/inst"
rm -fr "$mahome/$madir/mac/build/MoreAmp.build"
rm -fr "$mahome/$madir/mac/build/MoreAmpN.build"
rm -fr "$mahome/$madir/mac/build/MoreAmpNGTK.build"
rm -fr "$mahome/$madir/mac/build/MoreAmpNOGUI.build"
rm -fr "$mahome/$madir/mac/build/MoreAmpIntel26.build"
rm -fr "$mahome/$madir/mac/build/MoreAmpIntel28.build"
rm -fr "$mahome/$madir/mac/build/MoreAmpIntelN.build"
rm -fr "$mahome/$madir/mac/build/Default"
rm -fr "$mahome/$madir/mac/build/Deployment"
rm -fr "$mahome/$madir/mac/build/Development"
rm -fr "$mahome/$madir/msvc++/obj"
rm -fr "$mahome/$madir/msvc++/Release"
rm -fr "$mahome/$madir/msvc++/Debug"
rm -fr "$mahome/$madir/msvc++/Output"
find "$mahome/$madir" -type f -name "*.sh" -exec chmod -f a+x {} \;
find "$mahome/$madir/libs" -type f -name "configure" -exec chmod -f a+x {} \;
find "$mahome/$madir/libs" -type f -name "bootstrap" -exec chmod -f a+x {} \;

cd $mahome
mv "$mahome/$madir" "$mahome/$masrc"
echo archiving $mahome/$masrc to $mahome/$magz...
tar cf $matar $masrc
gzip $mahome/$matar
mv "$mahome/$masrc" "$mahome/$madir"

# chgrp -R $mygroup .
# chown -R $myuser .

chgrp $mygroup $mahome/$magz
chown $myuser $mahome/$magz

ls -l $mahome/$magz
find "$mahome/$madir" -type f | wc -l

