#!/bin/sh

# mamkwxTunicode.sh
# use one of multiple wx installations
# wxMac-2.6.3
# wxMac-2.8.6
# wxX11-2.8.6
# wxGTK-2.6.3
# wxGTK-2.8.6

err0=1 # 0 (true) = ok
err1=1
err2=1
err3=1

platform=$1
version=$2
release=$3

if [ "$platform" = "mac" ]; then
 err1=0
fi
if [ "$platform" = "gtk" ]; then
 err1=0
fi
if [ "$platform" = "gtk2" ]; then
 err1=0
fi
if [ "$platform" = "x11" ]; then
 err1=0
fi
if [ "$version" = "4" ]; then
 err2=0
fi
if [ "$version" = "6" ]; then
 err2=0
fi
if [ "$version" = "8" ]; then
 err2=0
fi
if [ "$release" = "1" ]; then
 err3=0
fi
if [ "$release" = "2" ]; then
 err3=0
fi
if [ "$release" = "3" ]; then
 err3=0
fi
if [ "$release" = "6" ]; then
 err3=0
fi
if [ "$release" = "7" ]; then
 err3=0
fi
if [ "$err1" != "0" ]; then
  echo "$0 : platform arg1 not mac or gtk or gtk2 or x11"
  exit 1
fi
if [ "$err2" != "0" ]; then
  echo "$0 : version arg2 not 4 or 6 or 8"
  exit 1
fi
if [ "$err3" != "0" ]; then
  echo "$0 : release arg3 not 1 or 2 or 3 or 4"
  exit 1
fi

if [ "$platform" = "mac" ]; then
 if [ "$version" = "6" ]; then
  # if [ "$release" = "3" ]; then # wxMac-2.6.3 
  #  ln -sfv /usr/local/include/wx-2.6/wxMac-2.6.3 /usr/local/include/wx-2.6/wx
  #  err0=$?
  #  if [ "$err0" = "0" ]; then
      ln -sfv /usr/local/lib/wx/config/mac-unicode-release-static-2.6 /usr/local/bin/wx-config
      err0=$?
  #  fi
  # fi
 fi
 if [ "$version" = "8" ]; then
  # if [ "$release" = "6" ]; then # wxMac-2.8.6 
  #  ln -sfv /usr/local/include/wx-2.8/wxMac-2.8.6 /usr/local/include/wx-2.8/wx
  #  err0=$?
  #  if [ "$err0" = "0" ]; then
      ln -sfv /usr/local/lib/wx/config/mac-unicode-release-static-2.8 /usr/local/bin/wx-config
      err0=$?
  #  fi
  # fi
 fi
fi

if [ "$platform" = "x11" ]; then
 if [ "$version" = "6" ]; then
  if [ "$release" = "3" ]; then # wxX11-2.6.3
   ln -sfv /usr/local/lib/wx/config/x11univ-unicode-release-static-2.6 /usr/local/bin/wx-config
   err0=$?
  fi
 fi
fi

if [ "$platform" = "gtk" ]; then
 if [ "$version" = "6" ]; then
  if [ "$release" = "3" ]; then # wxGTK-2.6.3
   ln -sfv /usr/local/include/wx-2.6/wx/wxGTK-2.6.3 /usr/local/include/wx-2.6/wx
   err0=$?
   if [ "$err0" = "0" ]; then
    ln -sfv /usr/local/lib/wx/config/gtk-unicode-release-static-2.6 /usr/local/bin/wx-config
    err0=$?
   fi
  fi
 fi
 if [ "$version" = "8" ]; then
  if [ "$release" = "6" ]; then # wxGTK-2.8.6
   ln -sfv /usr/local/include/wx-2.8/wx/wxGTK-2.8.6 /usr/local/include/wx-2.8/wx
   err0=$?
   if [ "$err0" = "0" ]; then
    ln -sfv /usr/local/lib/wx/config/gtk-unicode-release-static-2.8 /usr/local/bin/wx-config
    err0=$?
   fi
  fi
  if [ "$release" = "7" ]; then # wxGTK-2.8.7
   ln -sfv /usr/local/include/wx-2.8/wx/wxGTK-2.8.7 /usr/local/include/wx-2.8/wx
   err0=$?
   if [ "$err0" = "0" ]; then
    ln -sfv /usr/local/lib/wx/config/gtk-unicode-release-static-2.8 /usr/local/bin/wx-config
    err0=$?
   fi
  fi
 fi
fi

if [ "$platform" = "gtk2" ]; then
 if [ "$version" = "6" ]; then
  if [ "$release" = "3" ]; then # wxGTK-2.6.3
   ln -sfv /usr/local/include/wx-2.6/wx/wxGTK-2.6.3 /usr/local/include/wx-2.6/wx
   err0=$?
   if [ "$err0" = "0" ]; then
    ln -sfv /usr/local/lib/wx/config/gtk2-unicode-release-static-2.6 /usr/local/bin/wx-config
    err0=$?
   fi
  fi
 fi
 if [ "$version" = "8" ]; then
  if [ "$release" = "6" ]; then # wxGTK-2.8.6
   ln -sfv /usr/local/include/wx-2.8/wx/wxGTK-2.8.6 /usr/local/include/wx-2.8/wx
   err0=$?
   if [ "$err0" = "0" ]; then
    ln -sfv /usr/local/lib/wx/config/gtk2-unicode-release-static-2.8 /usr/local/bin/wx-config
    err0=$?
   fi
  fi
  if [ "$release" = "7" ]; then # wxGTK-2.8.7
   ln -sfv /usr/local/include/wx-2.8/wx/wxGTK-2.8.7 /usr/local/include/wx-2.8/wx
   err0=$?
   if [ "$err0" = "0" ]; then
    ln -sfv /usr/local/lib/wx/config/gtk2-unicode-release-static-2.8 /usr/local/bin/wx-config
    err0=$?
   fi
  fi
 fi
fi

if [ "$err0" != "0" ]; then
  echo "$0 failed"
  exit 1
fi

echo "$0 done :" `wx-config --basename` `wx-config --version`

exit 0

