// maGUIgtk.c

/*
 * MoreAmp
 * Copyright (C) 2005-2008 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "maConfig.h" // included by all moreamp files

// This file contains the code to run with the GTK+-1.2.10 gui.

#if defined(MAGUIGTK)

// #define MATRACEGUIGTK

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>

#if defined(MAGUIGTK2)
 #define GTK_ENABLE_BROKEN // for GTK_TEXT in GTK2
#endif

#include <gtk/gtk.h>

#if GTK_MAJOR_VERSION == 1
 #warning building with GTK+1
 #if defined(MAGUIGTK2)
  #warning MAGUIGTK2 should not be defined with GTK1
 #endif
#endif

#if GTK_MAJOR_VERSION == 2
 #warning building with GTK+2 
 #if !defined(MAGUIGTK2)
  #warning MAGUIGTK2 should be defined with GTK2
 #endif
#endif

#include "gdk/gdkkeysyms.h"

#include "maGUI.h"
#include "maUtils.h"
#include "maPlayer.h"
#include "maSongList.h"

/*
// Player controls
#include "maButtonsPlayer/BMFFwdMask.xpm"
#include "maButtonsPlayer/BMFFwdDisabled.xpm"
#include "maButtonsPlayer/BMFFwd.xpm"

#include "maButtonsPlayer/BMPlayMask.xpm"
#include "maButtonsPlayer/BMPlayDisabled.xpm"
#include "maButtonsPlayer/BMPlay.xpm"

#include "maButtonsPlayer/BMQuitMask.xpm"
#include "maButtonsPlayer/BMQuitDisabled.xpm"
#include "maButtonsPlayer/BMQuit.xpm"

#include "maButtonsPlayer/BMRewindMask.xpm"
#include "maButtonsPlayer/BMRewindDisabled.xpm"
#include "maButtonsPlayer/BMRewind.xpm"

#include "maButtonsPlayer/BMStopMask.xpm"
#include "maButtonsPlayer/BMStopDisabled.xpm"
#include "maButtonsPlayer/BMStop.xpm"

#include "maButtonsPlayer/BMPause.xpm"
#include "maButtonsPlayer/BMPauseDisabled.xpm"
#include "maButtonsPlayer/BMPauseMask.xpm"
*/

#define MABUTTONWDEF 70
#define MABUTTONHDEF 26
#define MAEOL 0x0a // 0x0d


enum
{
	maGDK_DELETE = 1,
	maGDK_CONFIGURE,
	maBUTTONFIND,
	maBUTTONEDIT,
	maBUTTONCLOSE,
	maENTRYCHANGED,
	maENTRYKEYPRESS,
	maMOUSEBUTTON,
	maGAINFOCUS,
	maBUTTONOK,
	maBUTTONCANCEL
};

#ifdef __cplusplus
extern "C"
{
#endif

// these mawidget structs are filled in when making a widget and
// passed to the widget's callback function
typedef struct
{
	int id;
	void *adj;
	int skip;
	void *slider;
} maslider;
#define NUMSLIDERS (ID_SLIDER_LAST - ID_SLIDER_FIRST + 1)
maslider l_slider[NUMSLIDERS];

typedef struct
{
	int id;
	void *adj;
	int skip;
} maspinbutton;
#define NUMSPINBUTTON (ID_SPIN_LAST - ID_SPIN_FIRST + 1)
maspinbutton l_spinbutton[NUMSPINBUTTON];
#if GTK_MAJOR_VERSION == 1
 #define SPSIZx 8
 #define SPSIZy 16
#else
 #define SPSIZx 16
 #define SPSIZy 20
#endif

typedef struct
{
	int id;
	void *btn;
	int skip;
} mabutton;
#define NUMBUTTONS (ID_BUTTON_LAST - ID_BUTTON_FIRST + 1)
mabutton l_button[NUMBUTTONS];

typedef struct
{
	int id;
	int value; // 0-based index
	int nitems;
	void *optionmenu;
} mapopupbutton;
#define NUMPOPUPBUTTONS (ID_POPUP_LAST - ID_POPUP_FIRST + 1)
mapopupbutton l_popupbutton[NUMPOPUPBUTTONS];

typedef struct
{
	int id;
	void *text;
} matext;
#define NUMTEXTS 96 // (ID_TEXT_LAST - ID_TEXT_FIRST + 1)
matext l_text[NUMTEXTS];
#define ID_TEXT_NOID 0
#define ID_TEXT_MONODIFF ID_TEXT_LAST + 1

typedef struct
{
	int id;
	void *cb;
	int skip;
	int color;
	void *text;
} macheckbox;
#define NUMCHECKBOXES (ID_CHECKBOX_LAST - ID_CHECKBOX_FIRST + 1)
macheckbox l_checkbox[NUMCHECKBOXES];
GdkColor rgbred = { 0, 0xffff, 0x0000, 0x0000 };
GdkColor rgbblack = { 0, 0x0000, 0x0000, 0x0000 };
GtkStyle *pcheckboxred = NULL;
GtkStyle *pcheckboxblack = NULL;

guint l_timerrunloop = -1;
GtkItemFactory *l_item_factory = NULL;
GtkItemFactory *l_subitem_factory1 = NULL;
GtkItemFactory *l_subitem_factory2 = NULL;
GtkWidget *l_menubar = NULL;
GtkWidget *l_main_vbox = NULL;
GtkWidget *l_list_vbox = NULL;
GtkWidget *l_eq_vbox = NULL;
GtkWidget *l_audiocd_vbox = NULL;
GtkWidget *l_advanced_vbox = NULL;
GtkWidget *l_effects_vbox = NULL;
GtkWidget *l_fileout_vbox = NULL;
GtkWidget *l_promptnum_vbox = NULL;
GtkWidget *l_fixed = NULL;
GtkWidget *l_eqentry = NULL;
GtkWidget *l_promptnumentry = NULL;
GtkWidget *l_clist = NULL;
GtkWidget *l_scale = NULL;
maslider l_hslider;

int l_txnbusy = 0;
int l_linenum = 0;

// the coordinates in window_get_position, window_move and event->configure are not the same,
// depending on the window manager. We compute the differences in AppWindowMake()
int l_wmdiffx = 0;
int l_wmdiffy = 0;

int MenuEventHandler(gpointer callback_data, guint callback_action, GtkWidget *widget);
int CommandEventHandler(gpointer callback_data, guint callback_action, GtkWidget *widget);
#if defined(MAKEYBOARD)
  gint KeyboardEventHandler(GtkWidget *widget, GdkEventKey *event, gpointer data);
#endif
#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
  gint MouseWheelEventHandler(GtkWidget *widget, GdkEventScroll *event, gpointer data);
 #else
  gint MouseWheelEventHandler(GtkWidget *widget, GdkEventButton *event, gpointer data);
 #endif
#endif
gint AppWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint ListWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint EqualizerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint Equalizer2WindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint AudioCDWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint EffectsWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint FileOutWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint AboutViewerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint PromptNumWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
gint AdvancedWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data);
int ViewerWindowMake(int windowid, char *wintitle);
int AboutViewerWindowMake(int windowid, char *wintitle);
void OnButtonFind(int windowid);
void OnButtonEditSave(void *widget, int windowid);
void GetColumn0Width();
void MakeMenus();
void hslidercallback(GtkWidget *widget, maslider *lslider);
void slidercallback(GtkWidget *widget, maslider *lslider);
int CheckboxIndexFromId(int id);
int TextIndexFromId(int id);
int ButtonIndexFromId(int id);
int PopupButtonIndexFromId(int id);
int SliderIndexFromId(int id);
int SpinButtonIndexFromId(int id);
void OnViewerLeftClick(int windowid);
void OnViewerRightClick(int windowid);
void OnViewerKeyPressed(int windowid, void *widget, int keyval);
void maTrace(char *str);
gint OnTimerRunLoop(gpointer data); 
void maGuiLog(char *str);
int SetupMenuRecentLabels();
void RebuildMenus();
void BuildMenus();
void DeleteMenus();


void maTrace(char *str)
{
	//maLog(str);
	printf(str);
	printf("\n");
}


gint OnTimerRunLoop(gpointer data) 
{
#ifdef MATRACEGUIGTK
	maTrace("OnTimerRunLoop");
#endif

	RunLoop(NULL);
	
	return 0;
}


void maGuiLog(char *str)
{
	printf(str);
	printf("\n");
}


int main(int argc, char *argv[]) // MAGUIGTK
{
	g_argc = argc;
	g_argv = argv;

#if defined(MAINSTANCES)
	if(argc == 2 && !strcmp(argv[1], "maclearlocks")) // run this in case we have a stuck lock
	{
		InstanceClearAll();
		printf("cleared locks\n");
		exit(0);
	}

	if(argc == 2 && !strcmp(argv[1], "malistlocks")) // run this to see locks
	{
		sprintf(g_logpath, "malistlocks.txt");
		InstanceListAll();
		printf("listed locks\n");
		exit(0);
	}
#endif

	sprintf(&g_AboutText[strlen(g_AboutText) - 64],	" Native (GTK+%d.%d.%d) GUI",
						GTK_MAJOR_VERSION, GTK_MINOR_VERSION, GTK_MICRO_VERSION); 
	
	if(!OnInit_())		
		return 1; // failed

	// main loop
	gtk_main();

	return(0);
	
} // main 


void StaticTextSetText(int window, int statictext, char *text)
{
#ifdef MATRACEGUIGTK
	maTrace("StaticTextSetText");
#endif
	int idx;

	if(!g_w[window])
		return;

	if((idx = TextIndexFromId(statictext)) < 0)
	{
		char cstr[256];
		sprintf(cstr, "StaticTextSetText TextIndexFromId %d failed", statictext);
		maLog(cstr);
		return; 
	}
	
	gtk_label_set_text(GTK_LABEL(l_text[idx].text), text);

} // StaticTextSetText


GtkItemFactoryCallback1 menucallback(gpointer callback_data, guint callback_action, GtkWidget *widget)
{
	char cstr[256];
	if(callback_action < 0 || callback_action > ID_MENU_LAST)
	{
		sprintf(cstr, "menucallback callback_action=%d", callback_action);
		maLog(cstr);
		return (GtkItemFactoryCallback1)FALSE;
	}
	if(MenuEventHandler(callback_data, callback_action, widget))
		return (GtkItemFactoryCallback1)FALSE; // not handled
	return (GtkItemFactoryCallback1)TRUE;
}


gchar l_menulabel[87][64] = // all have 4 trailing spaces for key bindings
{
	{0},
	// MoreAmp menu
	"/Help/About moreamp    ", // ID_MENU_FIRST
	// File menu
	"/File/Open Song List...    ",
	"/File/Make Song List...    ",
	"/File/Save Song List As...    ",
	"/File/Delete Song List...    ",
	"/File/Play Song Files...    ",
	"/File/Open Recent...    ",
	"/Item 1    ", // ID_SUBMENU_OPENRECENT1
	"/Item 2    ",
	"/Item 3    ",
	"/Item 4    ",
	"/Item 5    ",
	"/Item 6    ",
	"/Item 7    ",
	"/Item 8    ",
	"/Item 9    ",
	"/Item 10    ", // exactly MAXOPENRECENT submenus
	"/File/Quit    ",
	// Controls menu
	"/Controls/Stop    ",
	"/Controls/Pause    ",
	"/Controls/Previous    ",
	"/Controls/Play    ",
	"/Controls/Next    ",
	"/Controls/Play CD    ",
	"/Controls/Eject CD    ",
	"/Controls/Audio In    ",
	// Settings menu
	"/Settings/Save Settings    ",
	"/Settings/Saved Settings    ",
	"/Settings/Default Settings    ",
	"/Settings/Factory Settings    ",
	"/Settings/Save Settings As Default    ",
#if !defined(MANOCDA) && defined(__MAUNIX__)
	"/Settings/Set Audio CD Drives...    ", // ID_MENU_SETAUDIOCD,
#endif
	"/Settings/Effects    ",
	"/Settings/Random    ",
	"/Settings/Repeat Played    ",
	"/Settings/Loop Loaded    ",
	"/Settings/Loop List    ",
	"/Settings/Equalizer    ",
	"/Settings/Eq 31 Bands    ",
	"/Settings/EqExtra    ",
	
	"/Settings/Mono    ",
	"/Settings/Invert Right    ",
	"/Settings/Single Play    ",
	"/Settings/High Priority    ",
	"/Settings/Spindown    ",	
	"/Settings/Title Info...    ",
	"/List Name    ",
	"/Song Name    ",
	"/Numbers    ",
	"/Settings/Auto Start    ",
	"/Settings/Error Logging    ",
	"/Settings/Set Virtual Disk...    ",
#if defined(MAINSTANCES)
	"/Settings/Multiple Instances    ",
#endif
#if defined(MAKEYBOARD)
	"/Settings/Use Keyboard    ",	
#endif
#if defined(MAMOUSEWHEEL)
	"/Settings/Use MouseWheel    ",	
#endif
	"/Settings/Advanced Settings...    ",
	// Tools menu
	"/Tools/Zero List    ",
	"/Tools/Spindown Now    ",
	"/Tools/Make Catalog    ",
	"/Tools/View Catalog    ",
	"/Tools/View Log    ",
	"/Tools/Clear Log    ",
#if defined(MAKEYBOARD)
	"/Tools/Edit Key Bindings    ",
	"/Tools/Blank Key Bindings    ",
#endif
	// Show menu
	"/Show/Lists    ",
	"/Show/Equalizer    ",
	"/Show/Effects    ",
	"/Show/File Output    ",
	"/Show/Alt Sizes    ",
	"/Show/Saved Sizes    ",
	"/Show/Default Sizes    ",
	"/Show/Factory Sizes    ",
	// Help menu
	"/Help/README    ", // ID_MENU_LAST
}; // l_menulabel


GtkItemFactoryEntry l_menu_items[] =
{
	// File menu
	{ "/File", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_OPENLIST, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MAKELIST, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVELISTAS, NULL },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_DELETELIST, NULL },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PLAYFILE, NULL },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, NULL, ID_MENU_OPENRECENT, "<Item>" },
	{ "/File/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_QUIT, NULL },

	// Controls menu
	{ "/Controls", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_STOP, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PAUSE, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PREVIOUS, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PLAY, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_NEXT, NULL },
	{ "/Controls/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_PLAYCD, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EJECTCD, NULL },
	{ "/Controls/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_AUDIOIN, NULL },

	// Settings menu
	{ "/Settings", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVEMASETS, NULL },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETSAVED, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETDEFAULT, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETFACTORY, NULL },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVEMASETSDEFAULT, NULL },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EQUALIZER, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EQ31BANDS, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EQEXTRA, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EFFECTS, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_RANDOM, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_REPTPLAYED, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_LOOPLOADED, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_LOOPLIST, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MONO, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_INVERTRIGHT, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SINGLEPLAY, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_HIPRIORITY, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SPINDOWN, "<CheckItem>" },
	{ NULL, NULL, NULL, ID_MENU_TITLEINFO, "<Item>" },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_AUTOSTART, "<CheckItem>" },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ERRLOGGING, "<CheckItem>" },
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETVDISK, NULL },
#if !defined(MANOCDA) && defined(__MAUNIX__)
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SETAUDIOCD, NULL },
#endif
#if defined(MAINSTANCES)
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MULTIPLEINST, "<CheckItem>" },
#endif
#if defined(MAKEYBOARD)
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_KEYBOARD, "<CheckItem>" },	
#endif
#if defined(MAMOUSEWHEEL)
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MOUSEWHEEL, "<CheckItem>" },	
#endif
	{ "/Settings/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ADVANCED, NULL },	

	// Tools menu
	{ "/Tools", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ZEROLIST, NULL },
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SPINDOWNNOW, NULL },
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_MAKECATALOG, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_VIEWCATALOG, NULL },
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_VIEWLOG, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_CLEARLOG, NULL },
#if defined(MAKEYBOARD)
	{ "/Tools/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_EDITKEYBINDINGS, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_BLANKKEYBINDINGS, NULL },
#endif

	// Show menu
	{ "/Show", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWLIST, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWEQ, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWEFFECTS, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SHOWFILEOUT, "<CheckItem>" },
	{ "/Show/sep", NULL, NULL, 0, "<Separator>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ALTSIZE, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_SAVEDSIZE, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_DEFAULTSIZE, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_FACTORYSIZE, NULL },

	// Help menu
	{ "/Help", NULL, NULL, 0, "<Branch>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_README, NULL }, // MAREADME	
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_MENU_ABOUT,  NULL }, // sprintf(cstr, "About %s", MOREAMP_NAME);
}; // l_menu_items


GtkItemFactoryEntry l_submenu1_items[] =
{
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT1, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT2, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT3, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT4, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT5, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT6, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT7, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT8, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT9, NULL },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_OPENRECENT10, NULL },
};


GtkItemFactoryEntry l_submenu2_items[] =
{
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_TITLEINFO1, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_TITLEINFO2, "<CheckItem>" },
	{ NULL, NULL, (GtkItemFactoryCallback)menucallback, ID_SUBMENU_TITLEINFO3, "<CheckItem>" },
};


#if defined(MAKEYBOARD)
void SetupMenuKbLabels()
{
#ifdef MATRACEGUIGTK
	maTrace("SetupMenuKbLabels");
#endif
	int i;
	int l;
	int menuid;
	char nulabel[256];
	
	if(!g_w[WINDOWAPP])
		return;

	for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
	{
		if(!l_menulabel[menuid] ||
			(menuid >= ID_SUBMENU_OPENRECENT1 && menuid < (ID_SUBMENU_OPENRECENT1 + MAXOPENRECENT)))
			continue;
		strcpy(nulabel, l_menulabel[menuid]);

		if((l = strlen(nulabel) - 3) < 3)
		{
			maLog("SetupMenuKbLabels l_menulabel too short");
			continue;
		}
		strcpy(&nulabel[l], "   "); // 3 spaces
		for(i = 0; i < MANUMKEYS; i++)
		{
			if(g_sets.keyboard && g_keybindings[i].key && menuid == g_keybindings[i].menuid)
			{
				sprintf(&nulabel[l], "'%c'", (char)g_keybindings[i].key);
				break;
			}
		}

		strcpy(l_menulabel[menuid], nulabel);
	}

} // SetupMenuKbLabels
#endif


void DeleteMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("DeleteMenus");
#endif
	if(!g_w[WINDOWAPP])
		return;
	if(l_subitem_factory2)
	{
		gtk_object_destroy((GtkObject *)l_subitem_factory2);
		l_subitem_factory2 = NULL;
	}
	if(l_subitem_factory1)
	{
		gtk_object_destroy((GtkObject *)l_subitem_factory1);
		l_subitem_factory1 = NULL;
	}
	if(l_item_factory)
	{
		gtk_object_destroy((GtkObject *)l_item_factory);
		l_item_factory = NULL;
	}

} // DeleteMenus


void BuildMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("BuildMenus");
#endif
	int j;
	int sub1 = 0;
	int sub2 = 0;
	int menuid;
	char cstr[256];
	
	// menu
	gpointer callback_data = (char *)0;
	gint nmenu_items = sizeof(l_menu_items) / sizeof(l_menu_items[0]);
	for(j = 1; j < nmenu_items; j++)
	{
		if(l_menu_items[j].callback_action == ID_MENU_OPENRECENT)
			sub1 = j;
		else if(l_menu_items[j].callback_action == ID_MENU_TITLEINFO)
			sub2 = j;
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_menu_items[j].callback_action == menuid)
			{
				l_menu_items[j].path = l_menulabel[menuid];
				break;
			}
		}
		if(l_menu_items[j].callback_action && !l_menu_items[j].path)
		{
			sprintf(cstr, "BuildMenus null l_menu_items[%d].path", j);
			maLog(cstr);
		}
	}
	l_item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", NULL);
	gtk_item_factory_create_items(l_item_factory, nmenu_items, l_menu_items, callback_data);

	// submenu 1
	callback_data = (char *)1;
	nmenu_items = sizeof(l_submenu1_items) / sizeof(l_submenu1_items[0]);
	for(j = 0; j < nmenu_items && j < MAXOPENRECENT; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu1_items[j].callback_action == menuid)
			{
				l_submenu1_items[j].path = l_menulabel[menuid];
				break;
			}
		}
		if(!l_menulabel[ID_SUBMENU_OPENRECENT1 + j][0]) // no blank submenus
			break;
	}
	l_subitem_factory1 = gtk_item_factory_new(GTK_TYPE_MENU, "<main>", NULL);
	gtk_item_factory_create_items(l_subitem_factory1, j, l_submenu1_items, callback_data);
	if(sub1)
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(gtk_item_factory_get_widget(l_item_factory, l_menu_items[sub1].path)),
								 GTK_WIDGET(gtk_item_factory_get_widget(l_subitem_factory1, "")));

	// submenu 2
	callback_data = (char *)1;
	nmenu_items = sizeof(l_submenu2_items) / sizeof(l_submenu2_items[0]);
	for(j = 0; j < nmenu_items; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu2_items[j].callback_action == menuid)
			{
				l_submenu2_items[j].path = l_menulabel[menuid];
				break;
			}
		}
	}
	l_subitem_factory2 = gtk_item_factory_new(GTK_TYPE_MENU, "<main>", NULL);
	gtk_item_factory_create_items(l_subitem_factory2, nmenu_items, l_submenu2_items, callback_data);
	if(sub2)
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(gtk_item_factory_get_widget(l_item_factory, l_menu_items[sub2].path)),
								 GTK_WIDGET(gtk_item_factory_get_widget(l_subitem_factory2, "")));

	l_menubar = gtk_item_factory_get_widget(l_item_factory, "<main>");
	gtk_widget_set_name(l_menubar, "mamenu");
	
	// assign name for gtkrc
	nmenu_items = sizeof(l_menu_items) / sizeof(l_menu_items[0]);
	for(j = 1; j < nmenu_items; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_menu_items[j].callback_action == menuid)
			{
				gtk_widget_set_name(gtk_item_factory_get_widget(l_item_factory, l_menu_items[j].path), "mamenu");
				break;
			}
		}
	}
	nmenu_items = sizeof(l_submenu1_items) / sizeof(l_submenu1_items[0]);
	for(j = 0; j < nmenu_items && j < MAXOPENRECENT; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu1_items[j].callback_action == menuid && l_submenu1_items[j].path != NULL)
			{
				gtk_widget_set_name(gtk_item_factory_get_widget(l_subitem_factory1, l_submenu1_items[j].path), "mamenu");
				break;
			}
		}
	}
	nmenu_items = sizeof(l_submenu2_items) / sizeof(l_submenu2_items[0]);
	for(j = 0; j < nmenu_items; j++)
	{
		for(menuid = ID_MENU_FIRST; menuid <= ID_MENU_LAST; menuid++)
		{
			if(l_submenu2_items[j].callback_action == menuid && l_submenu2_items[j].path != NULL)
			{
				gtk_widget_set_name(gtk_item_factory_get_widget(l_subitem_factory2, l_submenu2_items[j].path), "mamenu");
				break;
			}
		}
	}
	
} // BuildMenus


#if defined(MAKEYBOARD)
void UpdateMenuKbLabels()
{
#ifdef MATRACEGUIGTK
	maTrace("UpdateMenuKbLabels");
#endif
	RebuildMenus();
}
#endif


void RebuildMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("RebuildMenus");
#endif
	if(!g_w[WINDOWAPP])
		return;
	DeleteMenus();
	MakeMenus();
	UpdateMenus();
	gtk_box_pack_start(GTK_BOX(l_main_vbox), l_menubar, FALSE, FALSE, 0);
	gtk_widget_show(l_menubar);
	
} // RebuildMenus


void MakeMenus()
{
#ifdef MATRACEGUIGTK
	maTrace("MakeMenus");
#endif
#if defined(MAKEYBOARD)
	SetupMenuKbLabels();
#endif
	SetupMenuRecentLabels();
	BuildMenus();
}


void buttoncallback(GtkWidget *widget,  gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("buttoncallback");
#endif

	if(((mabutton *)callback_data)->skip)
	{
		((mabutton *)callback_data)->skip = 0;
		return;
	}
	
	CommandEventHandler(callback_data, ((mabutton *)callback_data)->id, widget);
}


void gtktextsetred(GtkWidget *text, int red)
{
	if(text)
	{
		if(!pcheckboxred)
		{
			pcheckboxred = gtk_style_copy(gtk_widget_get_style(text));
			pcheckboxred->fg[GTK_STATE_NORMAL] = rgbred;
		}
		
		if(!pcheckboxblack)
		{
			pcheckboxblack = gtk_style_copy(gtk_widget_get_style(text));
			pcheckboxblack->fg[GTK_STATE_NORMAL] = rgbblack;
		}
		
		if(red)
			gtk_widget_set_style(text, pcheckboxred);
		else	
			gtk_widget_set_style(text, pcheckboxblack);
	}

} // gtktextsetred


void checkboxcallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("checkboxcallback");
#endif

	if(((macheckbox *)callback_data)->skip)
	{
		((macheckbox *)callback_data)->skip = 0;
		return;
	}

	if(((macheckbox *)callback_data)->text)
#if GTK_MAJOR_VERSION == 1
		gtktextsetred(((macheckbox *)callback_data)->text, GTK_TOGGLE_BUTTON(widget)->active ? 1 : 0);
#else
	{
		if(((macheckbox *)callback_data)->color)
			gtktextsetred(((macheckbox *)callback_data)->text, GTK_TOGGLE_BUTTON(widget)->active ? 1 : 0);
		else
			gtktextsetred(((macheckbox *)callback_data)->text, 0);
	}
#endif
	
	CommandEventHandler(callback_data, ((macheckbox *)callback_data)->id, widget);
}


// popups are menus, the widget here is a menuitem
// ID_POPUP_XXX is in the 24 lsb's, the 0-based menuitem index is in the 25th+ msb's.
void popupcallback(GtkWidget *widget, int id)
{
#ifdef MATRACEGUIGTK
	maTrace("popupcallback");
#endif
	int value = id >> 24;
	int lid = id & 0xffffff;
	int idx = PopupButtonIndexFromId(lid);
	l_popupbutton[idx].value = value;
	CommandEventHandler((gpointer)value, lid, widget);

} // checkboxcallback


void spinbuttoncallback(GtkWidget *widget, maspinbutton *lspinbutton)
{
#ifdef MATRACEGUIGTK
	maTrace("spinbuttoncallback");
#endif
	int value;

	if(lspinbutton->skip)
	{
		lspinbutton->skip = 0;
		return;
	}

	value = (GTK_ADJUSTMENT(widget)->value > 0.0) ? 1 : -1;

	lspinbutton->skip = 1;
	gtk_adjustment_set_value(GTK_ADJUSTMENT(widget), 0.0);	

	switch(lspinbutton->id)
	{
		case ID_SPIN_BEG :
			OnLittleArrowBegin(value); // 1 up, -1 down
		break;
		case ID_SPIN_END:
			OnLittleArrowEnd(value);
		break;
		case ID_SPIN_BUFFER:
			OnLittleArrowBuffer(value);
		break;
		case ID_SPIN_EQOFFSET:
			OnLittleArrowEqOffset(value);
		break;
		default:
			maLogAPI("spinbuttoncallback unexpected id", WINDOWAPP, lspinbutton->id);
		break;
	}

} // spinbuttoncallback


#define XBASE 2
#define YBASE 2
#define POSX (XBASE)
#define POSY (YBASE)
#define BEGX (POSX +  98)
#define ENDX (POSX + 200)
#define MENUBARH 24
#define MABUTTONW 44
#define MABUTTONH 34
#define MABUTTONSPACING 6
#define BUTTONTEXTY (YBASE + MABUTTONH)
#define HSLIDERPOSX (POSX)
#define HSLIDERWIDTH (XSIZEDEF - 19)
#define HSLIDERPOSY (POSY + 54)
#define HSLIDERHEIGHT 20

void *MakeText(int dynamic, int id, char *label, int xpos, int ypos, int style)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeText");
#endif
	int idx = 0;
	GtkWidget *text;

	if(dynamic)
	{
		if((idx = TextIndexFromId(id)) < 0)
		{
			for(idx = 0; idx < NUMTEXTS; idx++)
				if(l_text[idx].id == 0)
					break;
			if(idx == NUMTEXTS)
			{
				char cstr[256];
				sprintf(cstr, "MakeText id=%d already have max %d texts", id, NUMTEXTS);
				maLog(cstr);
				return NULL; 
			}
		}
	}
	
	text = gtk_label_new(label);
	gtk_fixed_put(GTK_FIXED(l_fixed), text, xpos, ypos);
	
	if(style)
		gtk_widget_set_name(text, "matextB");
	else
		gtk_widget_set_name(text, "matext");

	if(dynamic)
	{
		l_text[idx].id = id;
		l_text[idx].text = (void *)text;
	}

	return text;
	
} // MakeText 


void MakeButtonA(int id, char *label, int xpos, int ypos, int width, int height)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeButton");
#endif
	int idx;
	GtkWidget *button;
	char name[64];
	
	if((idx = ButtonIndexFromId(id)) < 0)
	{
		char cstr[256];
		sprintf(cstr, "MakeButton ButtonIndexFromId %d failed", id);
		maLog(cstr);
		return; 
	}

	if(id == ID_BTN_PAUSE)
		button = gtk_toggle_button_new_with_label(label);	
	else
		button = gtk_button_new_with_label(label);
	
	l_button[idx].id = id;
	l_button[idx].btn = button;
	l_button[idx].skip = 0;
	
	sprintf(name, "mabutton%s", label);
	gtk_widget_set_name(button, name);
	
#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
 #else
	gtk_signal_connect(GTK_OBJECT(button), "button_press_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(buttoncallback), (gpointer)&l_button[idx]);
	gtk_fixed_put(GTK_FIXED(l_fixed), button, xpos, ypos);
	gtk_widget_set_usize(button, width, height);

} // MakeButtonA


int l_ButtonPos, l_buttonTop;
void MakeButton(int id, char *label)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeButton");
#endif

	MakeButtonA(id, label, l_ButtonPos, l_buttonTop, MABUTTONW , MABUTTONH);
	l_ButtonPos += (MABUTTONW + MABUTTONSPACING);

} // MakeButton


#define CBYSIZ 14 // checkboxes
#define CBXSIZ 80 // 140 for checkboxes with large font
#define CBXSIZ2 (CBXSIZ + 20)
#define CBXSIZ3 50
#define CBXSIZ0 (CBYSIZ + 2) // no label
#define CBXSIZ4 (CBYSIZ + CBYSIZ + 2)
#define CBXSIZ5 (40)
#define CBXSIZ6 (CBXSIZ + 40)
#define CBXSIZ7 (340) // for advanced settings checkboxes

void *MakeCheckbox(int labelid, int id, char *label, int xpos, int ypos, int width, int red)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeCheckbox");
#endif
	int idx;
	GtkWidget *checkbox;
	
	if((idx = CheckboxIndexFromId(id)) < 0)
	{
		char cstr[256];
		sprintf(cstr, "MakeCheckbox CheckboxIndexFromId %d failed", id);
		maLog(cstr);
		return NULL; 
	}
	
#if GTK_MAJOR_VERSION == 1
	if(red)
		checkbox = gtk_check_button_new();
	else
		checkbox = gtk_check_button_new_with_label(label);
#else
		checkbox = gtk_check_button_new();
#endif
	
	gtk_widget_set_usize(GTK_WIDGET(checkbox), width, CBYSIZ);
	
#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
 #else
	gtk_signal_connect(GTK_OBJECT(checkbox), "button_press_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
		GTK_SIGNAL_FUNC(checkboxcallback), (gpointer)&l_checkbox[idx]);
	gtk_fixed_put(GTK_FIXED(l_fixed), checkbox, xpos - 3, ypos);

	l_checkbox[idx].id = id;
	l_checkbox[idx].cb = checkbox;
	l_checkbox[idx].color = red;
	l_checkbox[idx].skip = 0;
	
#if GTK_MAJOR_VERSION == 1
	if(red)
		l_checkbox[idx].text = MakeText(labelid == ID_TEXT_NOID ? 0 : labelid, id, label, xpos + 14, ypos - 1, 0);
	else
		l_checkbox[idx].text = NULL;
#else
		l_checkbox[idx].text = MakeText(labelid == ID_TEXT_NOID ? 0 : labelid, id, label, xpos + 14, ypos - 1, 0);
#endif

	gtk_widget_set_name(checkbox, "macheckbox");

	return checkbox;

} // MakeCheckbox


#define SLIDERISSCROLLBAR
#if defined(SLIDERISSCROLLBAR)
 #define SLIDERDELTAY 21
#else
 #define SLIDERDELTAY 0
#endif
#define VSLIDERW 20  // vslider width
#define VSLIDERH 102 // vslider height


void *MakeSlider(int id, int minval, int maxval, int xpos, int ypos, int width, int height, int style)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeSlider");
#endif
	int idx;
	GtkObject *adj;
	GtkWidget *slider;
	char name[64];
	
	if((idx = SliderIndexFromId(id)) < 0)
	{
		char cstr[256];
		sprintf(cstr, "MakeSlider SliderIndexFromId %d failed", id);
		maLog(cstr);
		return NULL; 
	}
	
	adj = gtk_adjustment_new(0.0, (gfloat)minval, (gfloat)(maxval + 1), 1.0, 1.0, 1.0);

#if defined(SLIDERISSCROLLBAR)
	slider = gtk_vscrollbar_new(GTK_ADJUSTMENT(adj));
#else
	slider = gtk_vscale_new(GTK_ADJUSTMENT(adj));
	gtk_scale_set_draw_value(GTK_SCALE(slider), FALSE);
#endif

	if(style)
		strcpy(name, "masliderB");
	else
		strcpy(name, "maslider");
	gtk_widget_set_name(slider, name);

	gtk_widget_set_usize(GTK_WIDGET(slider), width, height + SLIDERDELTAY);	
	gtk_range_set_update_policy(GTK_RANGE(slider), GTK_UPDATE_CONTINUOUS);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
		GTK_SIGNAL_FUNC(slidercallback), (gpointer)&l_slider[idx]);
	gtk_fixed_put(GTK_FIXED(l_fixed), slider, xpos, ypos + 2);

	l_slider[idx].id = id;
	l_slider[idx].adj = adj;
	l_slider[idx].skip = 0;
	l_slider[idx].slider = slider;
	
	gtk_widget_set_name(slider, "maslider");

	return adj;

} // MakeSlider


void *MakeSpinButton(int id, int xpos, int ypos)
{
#ifdef MATRACEGUIGTK
	maTrace("MakeSpinButton");
#endif
	int idx;
	GtkObject *adj;
	GtkWidget *spinbutton;
	 
	if((idx = SpinButtonIndexFromId(id)) < 0)
	{
		char cstr[256];
		sprintf(cstr, "MakeSpinButton SpinButtonIndexFromId %d failed", id);
		maLog(cstr);
		return NULL; 
	}

	adj = gtk_adjustment_new(0.0, (gfloat)INT_MIN, (gfloat)INT_MAX, 16.0, 16.0, 1.0);
	spinbutton = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 0.0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinbutton), TRUE);
#if GTK_MAJOR_VERSION == 1
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(spinbutton), GTK_SHADOW_NONE); //GTK_SHADOW_OUT);
#endif
	gtk_widget_set_usize(spinbutton, SPSIZx, SPSIZy);
#if GTK_MAJOR_VERSION == 1
	gtk_fixed_put(GTK_FIXED(l_fixed), spinbutton, xpos + 8, ypos + 2);
#else
	gtk_fixed_put(GTK_FIXED(l_fixed), spinbutton, xpos /* + 8 */, ypos /* + 2 */);
#endif
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
		GTK_SIGNAL_FUNC(spinbuttoncallback), (gpointer)&l_spinbutton[idx]);
	l_spinbutton[idx].id = id;
	l_spinbutton[idx].adj = adj;
	l_spinbutton[idx].skip = 0;

	gtk_widget_set_name(spinbutton, "maspinbutton");

	return adj;

} // MakeSpinButton


void *MakePopup(int id, int nitems, char **items, int xpos,int ypos, int width, int height)
{
	int i;
	int idx;
	GtkWidget *optionmenu;
	GtkWidget *menu;
	GtkWidget *menuitem;

	if((idx = PopupButtonIndexFromId(id)) < 0)
	{
		char cstr[256];
		sprintf(cstr, "MakePopup PopupButtonIndexFromId %d failed", id);
		maLog(cstr);
		return NULL;
	}
	menu = gtk_menu_new();
	gtk_widget_set_name(menu, "mapopup");
	for(i = 0; i < nitems; i++)
	{
		menuitem = gtk_menu_item_new_with_label(items[i]);
		gtk_widget_set_name(menuitem, "mapopup");
		gtk_menu_append(GTK_MENU(menu), menuitem);
		gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
			GTK_SIGNAL_FUNC(popupcallback), (gpointer)((i << 24) + id));
	}  
	optionmenu = gtk_option_menu_new();
	l_popupbutton[idx].optionmenu = optionmenu;
	l_popupbutton[idx].nitems = nitems;
	gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu), menu);
	gtk_widget_set_usize(optionmenu, width, height);
	gtk_fixed_put(GTK_FIXED(l_fixed), optionmenu, xpos, ypos);

	gtk_widget_set_name(optionmenu, "mapopup");

#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2) // don't scroll popups
	if(id != ID_POPUP_EQPRESET) // this one is fun to scroll
		gtk_signal_connect(GTK_OBJECT(optionmenu), "scroll_event",
			GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #else
 #endif
#endif

	return optionmenu;
	
} // MakePopup


#define GTKRCFILE "magtkrc"
int l_gtkinited = 0;
int l_gtkiniting = 0;
void magtkinit()
{
#ifdef MATRACEGUIGTK
	maTrace("magtkinit");
#endif
	char gtkrcfile[MAX_PATH];

	if(l_gtkiniting) // don't reenter
		return;
	l_gtkiniting = 1;
	
	sprintf(gtkrcfile, "%s%c%s%c%s", g_madir, FILESEP, MASETTINGSDIR, FILESEP, GTKRCFILE);
	if(maFileExists(gtkrcfile))
	{
		char *p[2];
		p[0] = gtkrcfile;
		p[1] = NULL;
		gtk_rc_set_default_files(p);
	}
	if(!gtk_init_check(&g_argc, &g_argv))
	{
#if defined(MAINSTANCES)
		InstanceClearThis();
 #if defined(MAUSESHM)
		if(g_pmashm)
		{
			MAFREE(g_pmashm); // only creator should free this
			g_pmashm = NULL;
		}
 #endif
		ClearInitLock();
#endif
		gtk_init(&g_argc, &g_argv); // let gtk display error msg and quit the app
	}
	gdk_rgb_init();
	
	l_gtkinited = 1;
	l_gtkiniting = 0;
	
} // magtkinit


int SetupMenuRecentLabels()
{
#ifdef MATRACEGUIOSX
	maTrace("SetupMenuRecentLabels");
#endif
	int i;
	char items[MAXOPENRECENT][OPENRECENTLENGTH];

	if(GetRecent(items))
		return 1;
		
	for (i = 0; i < MAXOPENRECENT; i++)
	{
		if(!items[i][0])
			break;
		 FilenameFromPathname(items[i], &l_menulabel[ID_SUBMENU_OPENRECENT1 + i][1]);
		 l_menulabel[ID_SUBMENU_OPENRECENT1 + i][0] = '/';
	}
	
	for (; i < MAXOPENRECENT; i++)
		l_menulabel[ID_SUBMENU_OPENRECENT1 + i][0] = 0;
	
	return 0;
	
} // SetupMenuRecentLabels


void UpdateSubMenusRecent()
{
#ifdef MATRACEGUIOSX
	maTrace("UpdateSubMenusRecent");
#endif
	if(g_w[WINDOWAPP])
		RebuildMenus();
}


int	AppWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("AppWindowMake");
#endif
	GtkWidget *window;
	char label[32];
	int x1, x2, y1, y2;
	
	if(!l_gtkinited)
		magtkinit();
	
	l_fixed = gtk_fixed_new();

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
 	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(AppWindowEventHandler), (gpointer)maGDK_CONFIGURE);

#if defined(MAGUIGTK2) && (defined(MAKEYBOARD) || defined(MAMOUSEWHEEL))
	int mask = 0;
#endif

#if defined(MAKEYBOARD)
 #if defined(MAGUIGTK2)
	mask = GDK_KEY_PRESS_MASK;
	gtk_widget_set_events(window, mask);
 #endif
	gtk_signal_connect(GTK_OBJECT(window), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
#endif

#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
	mask |= GDK_SCROLL_MASK;
	gtk_widget_set_events(window, GDK_SCROLL_MASK);
	gtk_signal_connect(GTK_OBJECT(window), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #else
	gtk_signal_connect(GTK_OBJECT(window), "button_press_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

	g_w[WINDOWAPP] = window;

	l_main_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_main_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_main_vbox);

	// menus
	MakeMenus();
	gtk_box_pack_start_defaults(GTK_BOX(l_main_vbox), l_menubar);
	gtk_widget_show(l_menubar);

	// buttons and shortcut labels
	l_ButtonPos = XBASE;
	l_buttonTop = YBASE; // + MENUBARH;

#if defined(MAKEYBOARD)
	MakeText(1, ID_TEXT_BUTTON_QUIT, label, l_ButtonPos + 14, BUTTONTEXTY, 0);
#endif
	MakeButton(ID_BTN_QUIT, LABEL_B_QUIT);

	strcpy(label, LABEL_PREV);
#if defined(MAKEYBOARD)
	MakeText(1, ID_TEXT_BUTTON_PREVIOUS, label, l_ButtonPos + 6, BUTTONTEXTY, 0);
#endif
	MakeButton(ID_BTN_PREVIOUS, LABEL_B_PREV);

	strcpy(label, LABEL_PLAY);
#if defined(MAKEYBOARD)
	MakeText(1, ID_TEXT_BUTTON_PLAY, label,	l_ButtonPos + 4, BUTTONTEXTY, 0);
#endif
	MakeButton(ID_BTN_PLAY, LABEL_B_PLAY);

	strcpy(label, LABEL_PAUSE);
#if defined(MAKEYBOARD)
	MakeText(1, ID_TEXT_BUTTON_PAUSE, label,l_ButtonPos, BUTTONTEXTY, 0);
#endif
	MakeButton(ID_BTN_PAUSE, LABEL_B_PAUSE);
	
	strcpy(label, LABEL_STOP);
#if defined(MAKEYBOARD)
	MakeText(1, ID_TEXT_BUTTON_STOP, label,	l_ButtonPos + 4, BUTTONTEXTY, 0);
#endif
	MakeButton(ID_BTN_STOP, LABEL_B_STOP);

	strcpy(label, LABEL_NEXT);
#if defined(MAKEYBOARD)
	MakeText(1, ID_TEXT_BUTTON_NEXT, label,	l_ButtonPos + 4, BUTTONTEXTY, 0);
#endif
	MakeButton(ID_BTN_NEXT, LABEL_B_NEXT);
	gtk_box_pack_end_defaults(GTK_BOX(l_main_vbox), l_fixed);
	
	// position slider
	l_hslider.adj = gtk_adjustment_new(0.0, (gfloat)POSMIN, (gfloat)(POSMAX + 1), 1.0, 1.0, 1.0);
	l_hslider.id = ID_SLIDER_POSITION;
	l_scale = gtk_hscale_new(GTK_ADJUSTMENT(l_hslider.adj));
	gtk_widget_set_usize(GTK_WIDGET(l_scale), HSLIDERWIDTH, HSLIDERHEIGHT);
	gtk_range_set_update_policy(GTK_RANGE(l_scale), GTK_UPDATE_DELAYED); // GTK_UPDATE_CONTINUOUS GTK_UPDATE_DISCONTINUOUS
	gtk_signal_connect(GTK_OBJECT(l_hslider.adj), "value_changed",
		GTK_SIGNAL_FUNC(hslidercallback), (gpointer)&l_hslider);
	gtk_scale_set_draw_value(GTK_SCALE(l_scale), FALSE);
	gtk_fixed_put(GTK_FIXED(l_fixed), l_scale, HSLIDERPOSX, HSLIDERPOSY);

	// Alt size checkbox
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_ALTSIZE, "", XBASE, YBASE + MABUTTONH + 2, CBXSIZ0, 0); // in front "Quit"

	// repeat controls
	#define POSY2 (POSY + 90)

	MakeText(1, ID_TEXT_TIMEPOS, NOTIMESTR, POSX + 6, POSY2 - 5, 0);	
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_REPTSONG, "Repeat",	POSX + 6, POSY2 + 9, CBXSIZ, 1); // red
	MakeSpinButton(ID_SPIN_BEG, BEGX + 2, POSY2 - 4);
	MakeText(1, ID_TEXT_TIMEBEG, NOTIMESTR, BEGX + 20, POSY2 - 5, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_BEG, "Begin", BEGX + 20, POSY2 + 9, CBXSIZ, 1); // red
	MakeSpinButton(ID_SPIN_END, ENDX + 2, POSY2 - 4);
	MakeText(1, ID_TEXT_TIMEEND, NOTIMESTR, ENDX + 20, POSY2 - 5, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_END, "End", ENDX + 20, POSY2 + 9, CBXSIZ, 1); // red

	// Volume, Separation, Preamp controls
	#define POSHEIGHT 120
	#define VOLY  (YBASE +  POSHEIGHT + 2)
	#define VOLX  (XBASE +  2)
	#define VOLLX (VOLX  +  0)
	#define VOLRX (VOLX  + 31)
	#define SEPX  (VOLX  + 63)
	#define PREAX (VOLX  + 93)

#if defined(MAGUIGTK2)
	#define GTK2FIXY 4
	#define GTK2FIXY2 2
#else
	#define GTK2FIXY 0
	#define GTK2FIXY2 0
#endif

	MakeText(0, ID_TEXT_VOLUME, "Volume dB", VOLLX + 4, VOLY - 6, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_BALANCE, "Balance", VOLLX + 4,	VOLY + 10, CBXSIZ, 0);
	MakeSlider(ID_SLIDER_VOLUMEL, VOLUMEMIN, VOLUMEMAX, VOLLX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_100VOLL, "100", VOLLX, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);
	MakeSlider(ID_SLIDER_VOLUMER, VOLUMEMIN, VOLUMEMAX, VOLRX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_100VOLR, "100", VOLRX, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);
	
	MakeText(1, ID_TEXT_SEP, "Sep", SEPX, VOLY - 6, 0);
	MakeText(1, ID_TEXT_S, "s", SEPX - 7, VOLY + 21 + GTK2FIXY, 0);
	MakeSlider(ID_SLIDER_VOLUMESEP, SEPARATIONMIN, SEPARATIONMAX, SEPX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_M, "m", SEPX - 7, VOLY + 109 + SLIDERDELTAY + GTK2FIXY, 0);
	MakeText(1, ID_TEXT_100SEP, "100", SEPX + 3, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);
	
	MakeText(1, ID_TEXT_PREAMP, "Preamp", PREAX - 2, VOLY - 6, 0);
	MakeSlider(ID_SLIDER_PREAMP, PREAMPMIN, PREAMPMAX, PREAX, VOLY + 21 + GTK2FIXY, VSLIDERW, VSLIDERH, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_LIMITER, "Limit", PREAX - 2, VOLY + 10, CBXSIZ3, 0); 
	MakeText(1, ID_TEXT_0, "-00.0", PREAX, VOLY + 124 + SLIDERDELTAY + GTK2FIXY, 0);

	// checkboxes
	#define CBWX (XBASE + 144)
	#define CBWY (YBASE + POSHEIGHT - 4)
	#define CBYDEL 17
	
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQWINDOW,		"EqWindow",		CBWX, CBWY, CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQUALIZER,	"Equalizer",	CBWX, CBWY + (1 * CBYDEL), CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQ31BANDS,	"Eq31Bands",	CBWX, CBWY + (2 * CBYDEL), CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQEXTRA,		"EqExtra",		CBWX, CBWY + (3 * CBYDEL), CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EFFECTS,		"Effects",		CBWX, CBWY + (4 * CBYDEL), CBXSIZ, 1); // red

	#define CBXPOS (XBASE + 220)
	#define CBYPOS (cbypos += CBYDEL)
	
	int cbypos = CBWY - CBYDEL;
	
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_LISTWINDOW,	"ListWindow",	CBXPOS, CBYPOS, CBXSIZ2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_RANDOM,		"Random",		CBXPOS, CBYPOS, CBXSIZ2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_REPTPLAYED,	"ReptPlayed",	CBXPOS, CBYPOS, CBXSIZ2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_LOOPLOADED,	"LoopLoaded",	CBXPOS, CBYPOS, CBXSIZ2, 1); // red
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_LOOPLIST,		"LoopList",		CBXPOS, CBYPOS, CBXSIZ2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_INVERTRIGHT,  "InvertRight",	CBXPOS, CBYPOS, CBXSIZ2, 1); // red
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_SINGLEPLAY,   "SinglePlay",	CBXPOS, CBYPOS, CBXSIZ2, 1); // red
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_USEM3U,		"Use m3u",		CBXPOS, CBYPOS, CBXSIZ2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_SPINDOWN,		"Spindown",		CBXPOS, CBYPOS, CBXSIZ2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_TITLEINFO,	"TitleInfo",	CBXPOS, CBYPOS, CBXSIZ2, 0);

	// mono/stereo
	#define MSTX (XBASE + 129)
	#define MSTY (YBASE + POSHEIGHT + 91 + GTK2FIXY2)
	
	MakeText(1, ID_TEXT_OUTPUT, "Output Stereo", MSTX + 0, MSTY - 14, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_MONOLEFT, "L", MSTX +  0, MSTY, CBXSIZ4, 1); // red
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_MONORIGHT, "R", MSTX + 26, MSTY, CBXSIZ4, 1); // red
	MakeCheckbox(ID_TEXT_MONODIFF, ID_CHK_MONODIFF, "rev", MSTX + 52, MSTY, CBXSIZ5, 1); // red and dynamic
	
	// Output popup button (combo box)
	#define POPX (XBASE + 125)
	#define POPY (YBASE + POSHEIGHT + 105 + GTK2FIXY2)
	#define POPY2 (POPY + 35)
	int i;
	char *outitems[kOUTMAX];
	char items[kOUTMAX][64];
	outitems[0] = g_extstrout[kOUTSOUND];
	for(i = kOUTFIRST; i <= kOUTLAST; i++)
	{
		sprintf(items[i - kOUTFIRST], "%s file", &g_extstrout[i][1]);
		outitems[i - kOUTFIRST + 1] = items[i - kOUTFIRST];
	}
	MakePopup(ID_POPUP_OUTPUT, kOUTLAST - kOUTFIRST + 2, outitems, POPX, POPY, 85, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_OUTPUT, kOUTLAST);
	
	// Mem Buffer spin control
	MakeSpinButton(ID_SPIN_BUFFER, POPX, POPY2 - 2 + GTK2FIXY2);

	// Mem Buffer popup button
	char *outitems2[] =
	{
		"Mem",
		"Vdisk",
		"Direct",
	};
	MakePopup(ID_POPUP_BUFFER, 3, outitems2, POPX + 16, POPY2 + GTK2FIXY2, 69, 20);
	PopupButtonSetValue(WINDOWAPP, ID_POPUP_BUFFER, 1);
	
	MakeText(1, ID_TEXT_BUFFER, "Buffer 2047 Mb", POPX,	POPY2 - 14 + GTK2FIXY2, 0);

	gtk_widget_set_uposition(window, (gint)g_sets.xpos[g_sets.winconf], (gint)g_sets.ypos[g_sets.winconf]);

	gtk_widget_show_all(window);
		
	UpdateDisplay();
	
#ifdef MANOCDA
	MenuDisable(MENUMACONTROLS, ID_MENU_PLAYCD);
	MenuDisable(MENUMACONTROLS, ID_MENU_EJECTCD);
#endif

#if !defined(NODECODEAUDIOIN)
#else
	MenuDisable(MENUMACONTROLS, ID_MENU_AUDIOIN);
#endif

	MenuDisable(MENUMASETS, ID_MENU_SPINDOWN);
	MenuDisable(MENUTOOLS, ID_MENU_SPINDOWNNOW);

	while(gtk_events_pending())
		gtk_main_iteration();
	
	gdk_window_get_root_origin((GTK_WIDGET(g_w[WINDOWAPP]))->window, &x1, &y1);
	gdk_window_get_origin((GTK_WIDGET(g_w[WINDOWAPP]))->window, &x2, &y2);
	l_wmdiffx = x2 - x1;
	l_wmdiffy = y2 - y1;
	OnMenuSavedSize(1);
	
	return 0;	

} // AppWindowMake


int MenuEventHandler(gpointer callback_data, guint callback_action, GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "MenuEventHandler callback_data=0x%x callback_action=%d widget=0x%x",
						(int)callback_data, callback_action, (int)widget);
maGuiLog(cstr);
}
#endif

	// always_show_toggle is used as flag set in MenuSetChecked()
	// to tell us to ignore this event
	if(GTK_IS_CHECK_MENU_ITEM(widget) && (GTK_CHECK_MENU_ITEM(widget))->always_show_toggle == 0)
	{
		(GTK_CHECK_MENU_ITEM(widget))->always_show_toggle = 1; // normal value
		return 0;
	}
	
	switch(callback_action)
	{
		case ID_MENU_ABOUT:
			maViewAbout();
		break;
		case ID_MENU_QUIT:
			OnButtonQuit();
		break;
		case ID_MENU_PREVIOUS:
			OnButtonPrevious();
		break;
		case ID_MENU_PLAY:
			OnButtonPlay();
		break;
		case ID_MENU_PAUSE:
			OnButtonPause();
		break;
		case ID_MENU_STOP:
			OnButtonStop();
		break;
		case ID_MENU_NEXT:
			OnButtonNext();
		break;

		case ID_MENU_OPENLIST:
			OnMenuOpenList();
		break;
		case ID_MENU_MAKELIST:
			OnMenuMakeList();
		break;
		case ID_MENU_SAVELISTAS:
			OnMenuSaveListAs();
		break;
		case ID_MENU_DELETELIST:
			OnMenuDeleteList();
		break;
		
		case ID_MENU_PLAYFILE:
			OnMenuPlayFile();
		break;
		case ID_SUBMENU_OPENRECENT1:
			OnMenuOpenRecent(0);
		break;
		case ID_SUBMENU_OPENRECENT2:
			OnMenuOpenRecent(1);
		break;
		case ID_SUBMENU_OPENRECENT3:
			OnMenuOpenRecent(2);
		break;
		case ID_SUBMENU_OPENRECENT4:
			OnMenuOpenRecent(3);
		break;
		case ID_SUBMENU_OPENRECENT5:
			OnMenuOpenRecent(4);
		break;
		case ID_SUBMENU_OPENRECENT6:
			OnMenuOpenRecent(5);
		break;
		case ID_SUBMENU_OPENRECENT7:
			OnMenuOpenRecent(6);
		break;
		case ID_SUBMENU_OPENRECENT8:
			OnMenuOpenRecent(7);
		break;
		case ID_SUBMENU_OPENRECENT9:
			OnMenuOpenRecent(8);
		break;
		case ID_SUBMENU_OPENRECENT10:
			OnMenuOpenRecent(9);
		break;
		case ID_MENU_PLAYCD:
			OnMenuPlayCD();
		break;
		case ID_MENU_EJECTCD:
			OnMenuEjectCD();
		break;
		case ID_MENU_AUDIOIN:
			OnMenuAudioIn();
		break;
		case ID_MENU_SAVEMASETS:
			OnMenuSave();
		break;
		case ID_MENU_SETSAVED:
			OnMenuSetSaved();
		break;
		case ID_MENU_SETDEFAULT:
			OnMenuSetDefault();
		break;
		case ID_MENU_SETFACTORY:
			OnMenuSetFactory();
		break;
		case ID_MENU_SAVEMASETSDEFAULT:
			OnMenuAsDefaults();
		break;
		case ID_MENU_EQUALIZER:
			OnMenuEqualizer((g_sets.eqflags & MAEQACTIVE) ? 0 : 1);
		break;
		case ID_MENU_EQ31BANDS:
			OnMenuEq31Bands((g_sets.eqflags & MAEQ31BANDS) ? 0 : 1);
		break;
		case ID_MENU_EQEXTRA:
			OnMenuEqExtra((g_sets.eqflags & MAEQEXTRA) ? 0 : 1);
		break;
		case ID_MENU_EFFECTS:
			OnMenuEffects((g_sets.effects & EFFECTSON) ? 0 : 1);
		break;
		case ID_MENU_RANDOM:
			OnMenuRandom(g_sets.random ? 0 : 1);
		break;
		case ID_MENU_REPTPLAYED:
			OnMenuReptPlayed(g_sets.reptplayed ? 0 : 1);
		break;
		case ID_MENU_LOOPLOADED:
			OnMenuLoopLoaded(g_sets.looploaded ? 0 : 1);
		break;
		case ID_MENU_LOOPLIST:
			OnMenuLoopList(g_sets.looplist ? 0 : 1);
		break;
		case ID_MENU_MONO:
			OnMenuMono(g_sets.monodiff ? 0 : 1);
		break;
		case ID_MENU_INVERTRIGHT:
			OnMenuInvertRight(g_sets.invertright ? 0 : 1);
		break;
		case ID_MENU_SINGLEPLAY:
			OnMenuSinglePlay(g_sets.singleplay ? 0 : 1);
		break;
		case ID_MENU_HIPRIORITY:
			OnMenuHiPriority(g_sets.highpriority ? 0 : 1);
		break;
		case ID_SUBMENU_TITLEINFO1:
			OnCheckTitleInfo(1);
		break;
		case ID_SUBMENU_TITLEINFO2:
			OnCheckTitleInfo(2);
		break;
		case ID_SUBMENU_TITLEINFO3:
			OnCheckTitleInfo(3);
		break;
		case ID_MENU_AUTOSTART:
			OnMenuAutoStart(g_sets.autostart ? 0 : 1);
		break;
		case ID_MENU_ERRLOGGING:
			OnMenuErrLogging((g_sets.logflags & kMALOGOFF) ? 1 : 0);
		break;
		case ID_MENU_SETVDISK:
			OnMenuSetVDisk();
		break;
#if !defined(MANOCDA) && defined(__MAUNIX__)
		case ID_MENU_SETAUDIOCD:
			DoWindowAudioCD(1);
		break;
#endif
#if defined(MAINSTANCES)
		case ID_MENU_MULTIPLEINST:
			OnMenuMultipleInst(g_sets.multipleinst ? 0 : 1);
		break;
#endif
#if defined(MAKEYBOARD)
		case ID_MENU_KEYBOARD:
			OnMenuKeyboard(g_sets.keyboard ? 0 : 1);
		break;
#endif
#if defined(MAMOUSEWHEEL)
		case ID_MENU_MOUSEWHEEL:
			OnMenuMouseWheel(g_sets.mousewheel ? 0 : 1);
		break;
#endif
		case ID_MENU_ADVANCED:
			DoWindowAdvanced(1);
		break;
		case ID_MENU_SHOWLIST:
			OnMenuList();
			if(!MenuIsChecked(0, callback_action))
			{
				OnWindowClosedList();
				l_linenum = 0;
			}
		break;
		case ID_MENU_SHOWEQ:
			OnMenuEqWindow();
			if(!MenuIsChecked(0, callback_action))
				OnWindowClosedEq();
		break;
		case ID_MENU_ZEROLIST:
			 OnMenuZero();
		break;
		case ID_MENU_MAKECATALOG:
			 OnMenuMakeCatalog();
		break;
		case ID_MENU_VIEWCATALOG:
			 OnMenuViewCatalog();
		break;
		case ID_MENU_VIEWLOG:
			 OnMenuViewLog();
		break;
		case ID_MENU_CLEARLOG:
			 OnMenuClearLog();
		break;
#if defined(MAKEYBOARD)
		case ID_MENU_EDITKEYBINDINGS:
			 OnMenuEditKeyBindings();
		break;
		case ID_MENU_BLANKKEYBINDINGS:
			 OnMenuBlankKeyBindings();
		break;
#endif
		case ID_MENU_SHOWEFFECTS:
			OnMenuEffectsWindow();
		break;
		case ID_MENU_SHOWFILEOUT:
			OnMenuFileOut();
		break;
		case ID_MENU_ALTSIZE:
			OnMenuAltSize(g_sets.winconf ? 0 : 1, 0);
		break;
		case ID_MENU_SAVEDSIZE:
			OnMenuSavedSize(0);
		break;
		case ID_MENU_DEFAULTSIZE:
			OnMenuFactorySize(0);
		break;
		case ID_MENU_FACTORYSIZE:
			OnMenuFactorySize(0);
		break;
		case ID_MENU_README:
			OnMenuReadme();
		break;
		default:
#ifdef MATRACEGUIGTK
			{
			char cstr[256];
			sprintf(cstr, "MenuEventHandler callback_data=0x%x callback_action=%d widget=0x%x",
							(int)callback_data, callback_action, (int)widget);
			maGuiLog(cstr);
			}
#endif
		return 1;
	}
	
	return 0;
	
} // MenuEventHandler


int CommandEventHandler(gpointer callback_data, guint id, GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
maTrace("CommandEventHandler");
#endif
	switch(id)
	{
		case ID_BTN_QUIT:
			OnButtonQuit();
		break;
		case ID_BTN_PREVIOUS:
			OnButtonPrevious();
		break;
		case ID_BTN_PLAY:
			OnButtonPlay();
		break;
		case ID_BTN_PAUSE:
			if(g_running)
				OnButtonPause();
			else
				PushButtonPaintUp(WINDOWAPP, ID_BTN_PAUSE);
		break;
		case ID_BTN_STOP:
			OnButtonStop();
		break;
		case ID_BTN_NEXT:
			OnButtonNext();
		break;

		case ID_CHK_ALTSIZE:
			OnCheckAltSize(GTK_TOGGLE_BUTTON(widget)->active, 0);
		break;
		case ID_CHK_REPTSONG:
			OnCheckReptSong(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_BEG:
			OnCheckBoxBeg(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_END:
			OnCheckBoxEnd(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_BALANCE:
			OnCheckBalance(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LIMITER:
			OnCheckLimiter(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQWINDOW:
			OnCheckEqWindow(GTK_TOGGLE_BUTTON(widget)->active);
			// when closing we do not get a window closed event
			if(!(GTK_TOGGLE_BUTTON(widget)->active))
				OnWindowClosedEq();
		break;
		case ID_CHK_EQUALIZER:
			OnCheckEqualizer(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQ31BANDS:
			OnCheckEq31Bands(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQEXTRA:
			OnCheckEqExtra(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EFFECTS:
			OnCheckEffects(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_MONOLEFT:
			OnCheckMonoLeft(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_MONORIGHT:
			OnCheckMonoRight(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_MONODIFF:
			OnCheckMonoDiff(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LISTWINDOW:
			OnCheckListWindow(GTK_TOGGLE_BUTTON(widget)->active);
			// when closing we do not get a window closed event
			if(!(GTK_TOGGLE_BUTTON(widget)->active))
			{
				OnWindowClosedList();
				l_linenum = 0;
			}
		break;
		case ID_CHK_RANDOM:
			OnCheckRandom(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_REPTPLAYED:
			OnCheckReptPlayed(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LOOPLOADED:
			OnCheckLoopLoaded(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_LOOPLIST:
			OnCheckLoopList(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_INVERTRIGHT:
			OnCheckInvertRight(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SINGLEPLAY:
			OnCheckSinglePlay(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_USEM3U:
			OnCheckUseM3u(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SPINDOWN:
			CheckBoxSetValue(WINDOWAPP, ID_CHK_SPINDOWN, 0);
		break;
		case ID_CHK_TITLEINFO:
			OnCheckTitleInfo(0);
		break;

		case ID_POPUP_OUTPUT:
			OnPopupOutput((int)callback_data);
		break;
		case ID_POPUP_BUFFER:
			OnPopupBuffer((int)callback_data);
		break;
		
		// list window
		case ID_BTN_INFO:
			OnButtonInfo();
		break;
		case ID_BTN_SONGLIST:
			OnButtonList();
		break;
		case ID_BTN_LOADED:
			OnButtonLoaded();
		break;
		case ID_BTN_SONGINFO:
			OnButtonSong();
		break;
		case ID_CHK_SHOWINDEX:
			OnCheckShowIndex(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SHOWDIR:
			OnCheckShowDir(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SHOWPATH:
			OnCheckShowPath(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_ADDMODE:
			OnCheckAddMode(GTK_TOGGLE_BUTTON(widget)->active);
		break;

		// equalizer window
		case ID_BTN_EQMINUS:
			OnButtonEqMinus();
		break;
		case ID_BTN_EQPLUS:
			OnButtonEqPlus();
		break;
		case ID_BTN_EQMID:
			OnButtonEqMid();
		break;
		case ID_BTN_EQCOPY:
			OnButtonEqCopy();
		break;
		case ID_BTN_EQPASTE:
			OnButtonEqPaste();
		break;
		case ID_BTN_EQRESTORE:
			OnButtonEqRestore();
		break;
		case ID_BTN_EQSHIFTL:
			OnButtonEqShiftL();
		break;
		case ID_BTN_EQSHIFTR:
			OnButtonEqShiftR();
		break;
		case ID_BTN_EQINVERT:
			OnButtonEqInvert();
		break;

		// equalizer2 window
		case ID_BTN_EQ2MID:
			OnButtonEq2Mid();
		break;
		case ID_BTN_EQ2COPY:
			OnButtonEq2Copy();
		break;
		case ID_BTN_EQ2PASTE:
			OnButtonEq2Paste();
		break;
		case ID_BTN_EQ2RESTORE:
			OnButtonEq2Restore();
		break;

		case ID_POPUP_EQPRESET:
			OnPopupEqPreset((int)callback_data);
		break;

		case ID_CHK_EQUALIZERB:
			OnCheckEqualizerB(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQ31BANDSB:
			OnCheckEq31BandsB(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQEXTRAB:
			OnCheckEqExtraB(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SEPARATELR:
			OnCheckSeparateLR(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQZOOM:
			OnCheckEqZoom(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_EQLINK:
			OnCheckEqLink(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		
		// effects window
		case ID_CHK_EFFECTSB:
			OnCheckEffectsB(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_PITCH:
			OnCheckPitch(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_TEMPO:
			OnCheckTempo(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_SPEED:
			OnCheckSpeed(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_QUALFILTER:
			OnCheckQualFilter(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_QUALSPEED:
			OnCheckQualSpeed(GTK_TOGGLE_BUTTON(widget)->active);
		break;

		// fileout window
		case ID_BTN_FILEOUTDIR:
			OnButtonFileOutDir();
		break;
		case ID_CHK_ADTS:
			OnCheckBoxADTS(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_M4A:
			OnCheckBoxM4A(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_POPUP_BITRATE:
			OnPopupBitRate((int)callback_data);
		break;
		case ID_POPUP_QUALITY:
			OnPopupQuality((int)callback_data);
		break;
		case ID_POPUP_MODE:
			OnPopupMode((int)callback_data);
		break;
		case ID_POPUP_SAMPLERATE:
			OnPopupSampleRate((int)callback_data);
		break;
		
		// advanced settings window
		case ID_CHK_CLOSEREOPEN:
			OnCheckCloseReopen(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		case ID_CHK_HIGHPRIORITY:
			OnCheckHighPriority(GTK_TOGGLE_BUTTON(widget)->active);
		break;
		
		// audio cd
#if !defined(MANOCDA) && defined(__MAUNIX__)
		case ID_BTN_AUDIOCDSET:
			OnButtonAudioCDSet();
		break;
		case ID_BTN_AUDIOCDCLEAR:
			OnButtonAudioCDClear();
		break;
		case ID_BTN_AUDIOCDSAVE:
			OnButtonAudioCDSave();
		break;
		case ID_BTN_AUDIOCDCLOSE:
			WindowDoClose(WINDOWAUDIOCD);
		break;
		case ID_POPUP_AUDIOCD:
			OnPopupAudioCD((int)callback_data);
		break;
		case ID_CHK_CDPARANOIA:
			OnCheckCdParanoia(GTK_TOGGLE_BUTTON(widget)->active);
		break;
#endif

		// prompt number popup
		case ID_BTN_PROMPTNUMOK:
			OnButtonPromptNum(1); // Ok
		break;
		case ID_BTN_PROMPTNUMCANCEL:
			OnButtonPromptNum(0); // Cancel
		break;

		default:
#ifdef MATRACEGUIGTK
			{
			char cstr[256];
			sprintf(cstr, "CommandEventHandler callback_data=0x%x callback_action=%d widget=0x%x",
							(int)callback_data, id, (int)widget);
			maGuiLog(cstr);
			}
#endif
		return 1;
	}
	
	return 0;
	
} // CommandEventHandler


#if defined(MAKEYBOARD)
gint KeyboardEventHandler(GtkWidget *widget, GdkEventKey *event, gpointer data)
{
 #ifdef MATRACEGUIGTK
  maTrace("KeyboardEventHandler");
 #endif

	if(!g_sets.keyboard || (g_w[WINDOWEQ] && GTK_WIDGET_HAS_FOCUS(l_eqentry)))
		return(FALSE); // event not handled
		
	if(event->keyval == GDK_Return) // 0xFF0D
		maOnKey(0, MAWXK_RETURN);
	else if(event->keyval == GDK_Up) // up arrow
		return(FALSE);
	else if(event->keyval == GDK_Down) // down arrow
		return(FALSE);
	else
		maOnKey(0, event->keyval);

	return(TRUE); // event handled
}
#endif

#if defined(MAGUIGTK2)
 #if defined(MAMOUSEWHEEL)
  gint MouseWheelEventHandler(GtkWidget *widget, GdkEventScroll *event, gpointer data)
  {
   #ifdef MATRACEGUIGTK
	maTrace("MouseWheelEventHandler");
   #endif

	if(g_sets.mousewheel && event->type == GDK_SCROLL)
	{
		if(event->direction == GDK_SCROLL_UP)
			ChangeVolume(MAWHEELVOLUMEDELTA);
		else if(event->direction == GDK_SCROLL_DOWN)
			ChangeVolume(-MAWHEELVOLUMEDELTA);
	}
	
	return(TRUE); // event handled
	
  } // MouseWheelEventHandler gtk2
 #endif
#else // gtk1, also handles mouse button events from eq window, to clear preset editor focus
 #if defined(MAMOUSEWHEEL) || defined(MAKEYBOARD)
  gint MouseWheelEventHandler(GtkWidget *widget, GdkEventButton *event, gpointer data)
  {
   #ifdef MATRACEGUIGTK
	maTrace("MouseWheelEventHandler");
   #endif
   
	if(g_sets.mousewheel && event->type == GDK_BUTTON_PRESS)
	{
		if(event->button == 4) // scroll up
		{
			ChangeVolume(MAWHEELVOLUMEDELTA);
			return(TRUE);
		}
		else if(event->button == 5) // scroll down
		{
			ChangeVolume(-MAWHEELVOLUMEDELTA);
			return(TRUE);
		}
	}
	else if(g_sets.keyboard && event->type == GDK_BUTTON_RELEASE && g_w[WINDOWEQ])
	{
		if(event->button != 4 && event->button != 5) // not scroll
		{
			if(GTK_WIDGET_HAS_FOCUS(l_eqentry))
				gtk_window_set_focus(GTK_WINDOW(g_w[WINDOWEQ]), NULL);
			return(TRUE);
		}
	}
	
	return(FALSE); // event not handled

 } // MouseWheelEventHandler gtk1
 #endif
#endif


gint AppWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("AppWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;

			OnButtonQuit();
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("AppWindowEventHandler window moved");
#endif
					int x = g_sets.xpos[g_sets.winconf];
					int y = g_sets.ypos[g_sets.winconf];
					g_sets.xpos[g_sets.winconf] = event->configure.x - l_wmdiffx;
					g_sets.ypos[g_sets.winconf] = event->configure.y - l_wmdiffy;
					g_sets.xsize[g_sets.winconf] = event->configure.width;
					g_sets.ysize[g_sets.winconf] = event->configure.height;
					OnWindowMoved(WINDOWAPP, g_sets.xpos[g_sets.winconf] - x, g_sets.ypos[g_sets.winconf] - y);
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("AppWindowEventHandler window resized");
#endif
					if(g_sets.xsize[g_sets.winconf] != event->configure.width)
					{
						g_sets.xsize[g_sets.winconf] = event->configure.width;
						if(l_scale)
							gtk_widget_set_usize(GTK_WIDGET(l_scale),
								g_sets.xsize[g_sets.winconf] - HSLIDERPOSX - 4, HSLIDERHEIGHT);
					}
					g_sets.ysize[g_sets.winconf] = event->configure.height;
				}
			}
		break;

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "AppWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled

} // AppWindowEventHandler


void guiAppYield() 
{
#ifdef MATRACEGUIGTK
	maTrace("guiAppYield");
#endif
} // guiAppYield


void CheckBoxDisable(int window, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxDisable");
#endif
	int idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxDisable CheckboxIndexFromId %d failed", checkbox);
		maLog(cstr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxDisable no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_button[idx].btn), FALSE);
	
} // CheckBoxDisable


void CheckBoxEnable(int window, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxEnable");
#endif
	int idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxEnable CheckboxIndexFromId %d failed", checkbox);
		maLog(cstr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxEnable no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_button[idx].btn), TRUE);

} // CheckBoxEnable


int CheckBoxGetValue(int window, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxGetValue");
#endif
	int idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxGetValue CheckboxIndexFromId %d failed", checkbox);
		maLog(cstr);
		return 0; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxGetValue no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(cstr);
		return 0;
	}
	
	return(((GTK_TOGGLE_BUTTON(l_checkbox[idx].cb))->active) ? 1 : 0);

} // CheckBoxGetValue


void CheckBoxHide(int window, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxHide");
#endif
	int idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxHide CheckboxIndexFromId %d failed", checkbox);
		maLog(cstr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxHide no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(cstr);
		return;
	}
	
	gtk_widget_hide(l_checkbox[idx].cb);
	
	if(l_checkbox[idx].text)
		gtk_widget_hide(l_checkbox[idx].text);

} // CheckBoxHide


GtkLabel *maGtkGetFirstLabel(GtkContainer *container)
{
	GList *dlist, *free_list;
	GtkWidget *list_item;
	GtkLabel *label = NULL;
	
	free_list = dlist = gtk_container_children(container);
	while(dlist)
	{
		list_item = dlist->data;
		if(GTK_IS_LABEL(list_item))
		{
			label = GTK_LABEL(list_item);
			break;
		}
		dlist = dlist->next;
	}
	g_list_free(free_list);

	return label;
	
} // maGtkGetFirstLabel


void CheckBoxSetDescriptor(int window, int checkbox, char *desc)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxSetDescriptor");
#endif
	GtkLabel *label;
	int idx;
	char cstr[256];
	
	if(!desc)
		return;
		
	if((idx = CheckboxIndexFromId(checkbox)) < 0)
	{
		sprintf(cstr, "CheckBoxSetDescriptor CheckboxIndexFromId %d failed", checkbox);
		maLog(cstr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		sprintf(cstr, "CheckBoxSetDescriptor no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(cstr);
		return;
	}

	if(l_checkbox[idx].text)
		gtk_label_set_text(GTK_LABEL(l_checkbox[idx].text), desc);
	else
		if(desc && (label = maGtkGetFirstLabel(l_checkbox[idx].cb)))
			gtk_label_set_text(label, desc);
	
} // CheckBoxSetDescriptor


void CheckBoxSetValue(int window, int checkbox, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxSetValue");
#endif
	int idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxSetValue CheckboxIndexFromId %d failed", checkbox);
		maLog(cstr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxSetValue no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(cstr);
		return;
	}
	
	if(((GTK_TOGGLE_BUTTON(l_checkbox[idx].cb))->active && value) ||
	 (!((GTK_TOGGLE_BUTTON(l_checkbox[idx].cb))->active) && !value))
		return; // already set

	if(l_checkbox[idx].color && l_checkbox[idx].text)
		gtktextsetred(l_checkbox[idx].text, value);
	
	l_checkbox[idx].skip = 1;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(l_checkbox[idx].cb), value ? TRUE : FALSE);

} // CheckBoxSetValue


void CheckBoxShow(int window, int checkbox)
{
#ifdef MATRACEGUIGTK
	maTrace("CheckBoxShow");
#endif
	int idx = CheckboxIndexFromId(checkbox);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxShow CheckboxIndexFromId %d failed", checkbox);
		maLog(cstr);
		return; 
	}
	
	if(!l_checkbox[idx].cb)
	{
		char cstr[256];
		sprintf(cstr, "CheckBoxShow no checkbox at index %d (id=%d)", idx, checkbox);
		maLog(cstr);
		return;
	}
	
	gtk_widget_show(l_checkbox[idx].cb);
	
	if(l_checkbox[idx].text)
		gtk_widget_show(l_checkbox[idx].text);

} // CheckBoxShow


/* not used void MenuSetLabel(int item, char *label)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuSetLabel");
#endif
	char *p;
	char *q;
	char nulabel[256];
	char cstr[256];
	if(label == NULL)
	{
		maLog("MenuGetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory, item);
	if(!w)
	{
		
		sprintf(cstr, "MenuGetLabel gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(cstr);
		return;
	}
	strcpy(nulabel, gtk_item_factory_path_from_widget(w));
	q = p = nulabel;
	while(p)
	{
		q = p;
		p = strchr(p, '/');
		if(p)
			p++;
	}
	strcpy(q, label);

	// delete factory entry
	//gtk_item_factory_delete_item(GtkItemFactory *ifactory, const gchar *path);
	//...

	// add factory entry
	//gtk_item_factory_create_item(GtkItemFactory *ifactory, GtkItemFactoryEntry *entry,
	//									gpointer callback_data,  guint callback_type);
	//...
	
} // MenuSetLabel



void MenuGetLabel(int item, char *label)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuGetLabel");
#endif
	char *p;
	char *q;
	char cstr[256];
	if(label == NULL)
	{
		maLog("MenuGetLabel null label parameter");
		return;
	}
	if(l_commandid[item] == 'NULL')
		return;
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory, item);
	if(!w)
	{
		
		sprintf(cstr, "MenuGetLabel gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(cstr);
		return;
	}
	strcpy(cstr, gtk_item_factory_path_from_widget(w));
	p = cstr;
	while(p)
	{
		q = p;
		p = strchr(p, '/');
		if(p)
			p++;
	}
	strcpy(label, q);
sprintf(cstr, "MenuGetLabel item=%d label='%s'", item, label);
maTrace(cstr);
} // MenuGetLabel
*/


void maLogAPI(const char *errtxt, int window, int item)
{
	char cstr[256];
	sprintf(cstr, "%s window=%d item=%d", errtxt, window, item);
	maLog(cstr);
}


void DisplayGetSize(int *x, int *y)
{
#ifdef MATRACEGUIGTK
	maTrace("DisplayGetSize");
#endif

	if(!x)
	{
		maLog("DisplayGetSize null x parameter");
		return;
	}

	if(!y)
	{
		maLog("DisplayGetSize null y parameter");
		return;
	}

	if(!l_gtkinited)
		magtkinit();

	*x = gdk_screen_width();
	*y = gdk_screen_height();

} // DisplayGetSize


void DoTimerRunLoop(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerRunLoop");
#endif
	if(l_timerrunloop != -1)
	{
		gtk_timeout_remove(l_timerrunloop);
		l_timerrunloop = -1;
	}
	l_timerrunloop = gtk_timeout_add(delay, OnTimerRunLoop, NULL);
}


void DoTimerPlay(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerPlay");
#endif
	maSleep(delay);
	OnButtonPlay();
}


void DoTimerStop(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerStop");
#endif
	maSleep(delay);
	OnButtonStop();
}


void DoTimerPlaySonglist(int delay)
{
#ifdef MATRACEGUIGTK
	maTrace("DoTimerPlaySonglist");
#endif
	maSleep(delay);
	PlaySonglistB(g_newsonglist);
}


void EditTextSetText(int windowid, int edittext, char *text)
{
#ifdef MATRACEGUIGTK
	maTrace("EditTextSetText");
#endif
	if(!g_w[windowid])
		return;

	if(edittext == ID_EDITTEXT_EQ)
	{
		if(!l_eqentry)
		{
			maLogAPI("EditTextSetText nocb", windowid, edittext);
			return;
		}
		gtk_entry_set_text(GTK_ENTRY(l_eqentry), text);
	}
	
} // EditTextSetText


void EditTextGetText(int windowid, int edittext, char *outBuffer, int inBufferLength, long *outTextLength)
{
#ifdef MATRACEGUIGTK
	maTrace("EditTextGetText");
#endif

	if(!g_w[windowid])
		return;

	if(edittext == ID_EDITTEXT_EQ)
	{
		if(!l_eqentry)
		{
			maLogAPI("EditTextGetText ID_EDITTEXT_EQ nocb", windowid, edittext);
			return;
		}
		strcpy(outBuffer, gtk_entry_get_text(GTK_ENTRY(l_eqentry)));
		*outTextLength = strlen(outBuffer);
	}
	else if(edittext == ID_EDITTEXT_PROMPTNUM)
	{
		if(!l_promptnumentry)
		{
			maLogAPI("EditTextGetText ID_EDITTEXT_PROMPTNUM nocb", windowid, edittext);
			return;
		}
		strcpy(outBuffer, gtk_entry_get_text(GTK_ENTRY(l_promptnumentry)));
		*outTextLength = strlen(outBuffer);
	}
	else
		maLogAPI("EditTextGetText nocb", windowid, edittext);		

} // EditTextGetText


void eqentrycallback(GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
	maTrace("eqentrycallback");
#endif
	char cstr[256];
	strcpy(cstr, gtk_entry_get_text(GTK_ENTRY(l_eqentry)));
	if(!cstr[0])
		return;
		
	OnEditTextEq();
}


void EqualizerWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("EqualizerWindowMake");
#endif
	int i;
	GtkWidget *window;
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("EqualizerWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWEQ])
	{
		maLog("EqualizerWindowMake already made");
		return;
	}

	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(EqualizerWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(EqualizerWindowEventHandler), (gpointer)maGDK_CONFIGURE);

#if (defined(MAKEYBOARD) || defined(MAMOUSEWHEEL))
	int mask = 0;
 #if defined(MAKEYBOARD)
	mask = GDK_KEY_PRESS_MASK | GDK_BUTTON_RELEASE_MASK;
 #endif
 #if defined(MAMOUSEWHEEL) && defined(MAGUIGTK2)
	mask |= GDK_SCROLL_MASK;
 #endif
	gtk_widget_set_events(window, mask);
#endif

#if defined(MAKEYBOARD)
	gtk_signal_connect(GTK_OBJECT(window), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
 #if defined(MAGUIGTK2)
	gtk_signal_connect(GTK_OBJECT(window), "button_release_event",
		GTK_SIGNAL_FUNC(EqualizerWindowEventHandler), (gpointer)maMOUSEBUTTON);
 #else
	gtk_signal_connect(GTK_OBJECT(window), "button_release_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
	gtk_signal_connect(GTK_OBJECT(window), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #else
	gtk_signal_connect(GTK_OBJECT(window), "button_press_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

	g_w[WINDOWEQ] = window;

	l_eq_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_eq_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_eq_vbox);
	
	// equalizer buttons
	#define EQMENUBARH 0 // MENUBARH to line up buttons with main window buttons
	l_ButtonPos = XBASE;
	l_buttonTop = YBASE + EQMENUBARH;

	MakeButton(ID_BTN_EQMINUS, LABEL_MINUS);
	MakeButton(ID_BTN_EQPLUS, LABEL_PLUS);
	MakeButton(ID_BTN_EQMID, LABEL_MID);
	MakeButton(ID_BTN_EQCOPY, LABEL_COPY);
	MakeButton(ID_BTN_EQPASTE, LABEL_PASTE);
	MakeButton(ID_BTN_EQRESTORE, LABEL_RESET);
	MakeButton(ID_BTN_EQSHIFTL, LABEL_SHIFTL);
	MakeButton(ID_BTN_EQSHIFTR, LABEL_SHIFTR);
	MakeButton(ID_BTN_EQINVERT, LABEL_INVERT);

	#define PREX (XBASE + 450)
	#define PREY (YBASE + EQMENUBARH)
	#define PREY2 (YBASE + 40 + EQMENUBARH)

	// Equalizer checkbox
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQUALIZERB, "Equalizer", PREX, PREY - 2, CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQ31BANDSB, "Eq31Band", PREX, PREY + 14, CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQEXTRAB, "EqExtra", PREX, PREY + 30, CBXSIZ, 0);

	// Zoom checkbox
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQZOOM, "Zoom", 8, PREY2, CBXSIZ3, 0);

	// Link checkbox
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EQLINK, "Link sliders", 260, PREY2, CBXSIZ, 0);

	//Separate L/R checkbox
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_SEPARATELR, "Separate L/R", 350, PREY2, CBXSIZ, 0);

	// Offset spin
	MakeText(1, ID_TEXT_EQOFFSET, "Offset dB", 124, PREY2, 0);
	MakeText(1, ID_TEXT_EQOFFSETVAL, "000", 204, PREY2, 0);
	MakeSpinButton(ID_SPIN_EQOFFSET, 186, PREY2);
	
	// Presets popup button
	char *eqpresets[EQNUMPRESETS];
 	for(i = 0; i < EQNUMPRESETS; i++)
	{
 		if(strlen(g_sets.eqpresets[i].eqname) == 0 || g_sets.eqpresets[i].eqname[0] == ' ')
 			sprintf(g_sets.eqpresets[i].eqname, "Preset%d", i + 1);
		eqpresets[i] = g_sets.eqpresets[i].eqname;
	}  
	MakePopup(ID_POPUP_EQPRESET, EQNUMPRESETS, eqpresets, PREX + 80, PREY - 1, 88, 20);
	PopupButtonSetValue(WINDOWEQ, ID_POPUP_EQPRESET, 1);

	// Preset name editor
	MakeText(0, ID_TEXT_EQEDIT, "Preset Name",  PREX + 80, PREY + 18, 0);

	// Preset name editor keyboard input
	l_eqentry = gtk_entry_new_with_max_length(64);
	gtk_signal_connect(GTK_OBJECT(l_eqentry), "activate",
		GTK_SIGNAL_FUNC(eqentrycallback), NULL);
	gtk_fixed_put(GTK_FIXED(l_fixed), l_eqentry,  PREX + 80, PREY + 33);
	gtk_widget_set_usize(l_eqentry, 72, 23);
	gtk_widget_set_sensitive(l_eqentry, TRUE);

	// equalizer sliders
	#define SLX (XBASE)
	#define SLXDEL (VSLIDERW - 0)
	#define STXPOS (stxpos += SLXDEL)
	#define SLXPOS (slxpos += SLXDEL)
	#define TEXPOS (texpos += SLXDEL)
	#define SPXPOS (spxpos += SLXDEL)
	#define SLYPOS (YBASE + 64 + EQMENUBARH)
	#define T0YPOS (SLYPOS + 67)

	int stxpos = SLX - SLXDEL;
	int slxpos = SLX - SLXDEL;
	int texpos = SLX - SLXDEL - 1;
	//int spxpos = SLX - SLXDEL + 2;

	#define YSTAGGER 12
	int ystagger;
	int style;
	
	const char *label;
	for(i = 0; i < EQBANDS31; i++)
	{
		switch(i)
		{
			case  0 : style = 0; label = "20Hz";	break;
			case  1 : style = 0; label = "25";		break;
			case  2 : style = 1; label = "31.5";	break;
			case  3 : style = 0; label = "40";		break;
			case  4 : style = 0; label = "50";		break;
			case  5 : style = 1; label = "63";		break;
			case  6 : style = 0; label = "80";		break;
			case  7 : style = 0; label = "100";		break;
			case  8 : style = 1; label = "125";		break;
			case  9 : style = 0; label = "160";		break;
			case 10 : style = 0; label = "200";		break;
			case 11 : style = 1; label = "250";		break;
			case 12 : style = 0; label = "315";		break;
			case 13 : style = 0; label = "400";		break;
			case 14 : style = 1; label = "500";		break;
			case 15 : style = 0; label = "630";		break;
			case 16 : style = 0; label = "800";		break;
			case 17 : style = 1; label = "1kHz";	break;
			case 18 : style = 0; label = "1.25";	break;
			case 19 : style = 0; label = "1.6";		break;
			case 20 : style = 1; label = "2.0";		break;
			case 21 : style = 0; label = "2.5";		break;
			case 22 : style = 0; label = "3.15";	break;
			case 23 : style = 1; label = "4.0";		break;
			case 24 : style = 0; label = "5.0";		break;
			case 25 : style = 0; label = "6.3";		break;
			case 26 : style = 1; label = "8.0";		break;
			case 27 : style = 0; label = "10";		break;
			case 28 : style = 0; label = "12.5";	break;
			case 29 : style = 1; label = "16";		break;
			case 30 : style = 0; label = "20";		break;
			default : style = 0; label = "";		break;
		}
		
		if(i % 2)
			ystagger = YSTAGGER;
		else
			ystagger = 0;
		MakeText(0, ID_TEXT_EQBAND0 + i, (char *)label, STXPOS, SLYPOS - 6 + ystagger, style);
		MakeSlider(ID_SLIDER_EQ0 + i, DBSLIDERMIN, DBSLIDERMAX, SLXPOS, SLYPOS + 21, VSLIDERW, VSLIDERH, style);
		MakeText(1, ID_TEXT_EQ0 + i, "0000", TEXPOS, SLYPOS + 124 + SLIDERDELTAY + ystagger, style);	
	}

	gtk_box_pack_end_defaults(GTK_BOX(l_eq_vbox), l_fixed);

	if(g_sets.eqflags & MASEPARATELR)
		sprintf(cstr, "%s Equalizer Left Channel", g_prognametitle);
	else
		sprintf(cstr, "%s Equalizer", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	gtk_widget_show_all(window);

	// settings values
	CheckBoxSetValue(WINDOWEQ, ID_CHK_EQUALIZERB, g_sets.eqflags & MAEQACTIVE ? 1 : 0);
	CheckBoxSetValue(WINDOWEQ, ID_CHK_EQ31BANDSB, g_sets.eqflags & MAEQ31BANDS ? 1 : 0);
	CheckBoxSetValue(WINDOWEQ, ID_CHK_EQEXTRAB, g_sets.eqflags & MAEQEXTRA ? 1 : 0);
	CheckBoxSetValue(WINDOWEQ, ID_CHK_EQZOOM, g_sets.eqflags & MAEQZOOM ? 1 : 0);
	CheckBoxSetValue(WINDOWEQ, ID_CHK_EQLINK, g_sets.eqflags & MAEQLINK ? 1 : 0);
	CheckBoxSetValue(WINDOWEQ, ID_CHK_SEPARATELR, (g_sets.eqflags & MASEPARATELR) ? 1 : 0);

} // EqualizerWindowMake


gint EqualizerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("EqualizerWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
			OnWindowClosedEq();
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("EqualizerWindowEventHandler window moved");
#endif
					g_sets.eqxpos[g_sets.winconf] = event->configure.x - l_wmdiffx;
					g_sets.eqypos[g_sets.winconf] = event->configure.y - l_wmdiffy;
					g_sets.eqxsize[g_sets.winconf] = event->configure.width;
					g_sets.eqysize[g_sets.winconf] = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("EqualizerWindowEventHandler window resized");
#endif
					g_sets.eqxsize[g_sets.winconf] = event->configure.width;
					g_sets.eqysize[g_sets.winconf] = event->configure.height;
				}
			}
		break;

#if defined(MAKEYBOARD)
		case GDK_BUTTON_RELEASE:
			if(g_sets.keyboard && GTK_WIDGET_HAS_FOCUS(l_eqentry))
				gtk_window_set_focus(GTK_WINDOW(g_w[WINDOWEQ]), NULL);
		break;
#endif

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "EqualizerWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled

} // EqualizerWindowEventHandler


void Equalizer2WindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("Equalizer2WindowMake");
#endif
	int i;
	GtkWidget *window;
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("Equalizer2WindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWEQ2])
	{
		maLog("Equalizer2WindowMake already made");
		return;
	}

	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(Equalizer2WindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(Equalizer2WindowEventHandler), (gpointer)maGDK_CONFIGURE);

#if (defined(MAKEYBOARD) || defined(MAMOUSEWHEEL))
	int mask = 0;
 #if defined(MAKEYBOARD)
	mask = GDK_KEY_PRESS_MASK | GDK_BUTTON_RELEASE_MASK;
 #endif
 #if defined(MAMOUSEWHEEL) && defined(MAGUIGTK2)
	mask |= GDK_SCROLL_MASK;
 #endif
	gtk_widget_set_events(window, mask);
#endif

#if defined(MAKEYBOARD)
	gtk_signal_connect(GTK_OBJECT(window), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
 #if defined(MAGUIGTK2)
	gtk_signal_connect(GTK_OBJECT(window), "button_release_event",
		GTK_SIGNAL_FUNC(Equalizer2WindowEventHandler), (gpointer)maMOUSEBUTTON);
 #else
	gtk_signal_connect(GTK_OBJECT(window), "button_release_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
	gtk_signal_connect(GTK_OBJECT(window), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #else
	gtk_signal_connect(GTK_OBJECT(window), "button_press_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

	g_w[WINDOWEQ2] = window;

	l_eq_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_eq_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_eq_vbox);
	
	// equalizer buttons
	#define EQMENUBARH 0 // MENUBARH to line up buttons with main window buttons
	l_ButtonPos = XBASE + (MABUTTONW + MABUTTONSPACING) + (MABUTTONW + MABUTTONSPACING);
	l_buttonTop = YBASE + EQMENUBARH;

	MakeButton(ID_BTN_EQ2MID, LABEL_MID);
	MakeButton(ID_BTN_EQ2COPY, LABEL_COPY);
	MakeButton(ID_BTN_EQ2PASTE, LABEL_PASTE);
	MakeButton(ID_BTN_EQ2RESTORE, LABEL_RESET);
	
	// equalizer sliders
	#define SLX (XBASE)
	#define SLXDEL (VSLIDERW - 0)
	#define STXPOS (stxpos += SLXDEL)
	#define SLXPOS (slxpos += SLXDEL)
	#define TEXPOS (texpos += SLXDEL)
	#define SPXPOS (spxpos += SLXDEL)
	#define SLYPOS (YBASE + 64 + EQMENUBARH)
	#define T0YPOS (SLYPOS + 67)

	int stxpos = SLX - SLXDEL;
	int slxpos = SLX - SLXDEL;
	int texpos = SLX - SLXDEL - 1;
	//int spxpos = SLX - SLXDEL + 2;

	#define YSTAGGER 12
	int ystagger;
	int style;
	
	const char *label;
	for(i = 0; i < EQBANDS31; i++)
	{
		switch(i)
		{
			case  0 : style = 0; label = "20Hz";	break;
			case  1 : style = 0; label = "25";		break;
			case  2 : style = 1; label = "31.5";	break;
			case  3 : style = 0; label = "40";		break;
			case  4 : style = 0; label = "50";		break;
			case  5 : style = 1; label = "63";		break;
			case  6 : style = 0; label = "80";		break;
			case  7 : style = 0; label = "100";		break;
			case  8 : style = 1; label = "125";		break;
			case  9 : style = 0; label = "160";		break;
			case 10 : style = 0; label = "200";		break;
			case 11 : style = 1; label = "250";		break;
			case 12 : style = 0; label = "315";		break;
			case 13 : style = 0; label = "400";		break;
			case 14 : style = 1; label = "500";		break;
			case 15 : style = 0; label = "630";		break;
			case 16 : style = 0; label = "800";		break;
			case 17 : style = 1; label = "1kHz";	break;
			case 18 : style = 0; label = "1.25";	break;
			case 19 : style = 0; label = "1.6";		break;
			case 20 : style = 1; label = "2.0";		break;
			case 21 : style = 0; label = "2.5";		break;
			case 22 : style = 0; label = "3.15";	break;
			case 23 : style = 1; label = "4.0";		break;
			case 24 : style = 0; label = "5.0";		break;
			case 25 : style = 0; label = "6.3";		break;
			case 26 : style = 1; label = "8.0";		break;
			case 27 : style = 0; label = "10";		break;
			case 28 : style = 0; label = "12.5";	break;
			case 29 : style = 1; label = "16";		break;
			case 30 : style = 0; label = "20";		break;
			default : style = 0; label = "";		break;
		}
		
		if(i % 2)
			ystagger = YSTAGGER;
		else
			ystagger = 0;
		MakeText(0, ID_TEXT_EQ2BAND0 + i, (char *)label, STXPOS, SLYPOS - 6 + ystagger, style);
		MakeSlider(ID_SLIDER_EQ2_0 + i, DBSLIDERMIN, DBSLIDERMAX, SLXPOS, SLYPOS + 21, VSLIDERW, VSLIDERH, style);
		MakeText(1, ID_TEXT_EQ2_0 + i, "0000", TEXPOS, SLYPOS + 124 + SLIDERDELTAY + ystagger, style);	
	}

	gtk_box_pack_end_defaults(GTK_BOX(l_eq_vbox), l_fixed);

	if(g_sets.eqflags & MASEPARATELR) 
		sprintf(cstr, "%s Equalizer Right Channel", g_prognametitle);
	else
		sprintf(cstr, "%s Equalizer Right Channel (Off)", g_prognametitle); // never happens
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	gtk_widget_show_all(window);

} // Equalizer2WindowMake


gint Equalizer2WindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("Equalizer2WindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
			OnWindowClosedEq2();
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("Equalizer2WindowEventHandler window moved");
#endif
					g_sets.eq2xpos[g_sets.winconf] = event->configure.x - l_wmdiffx;
					g_sets.eq2ypos[g_sets.winconf] = event->configure.y - l_wmdiffy;
					g_sets.eq2xsize[g_sets.winconf] = event->configure.width;
					g_sets.eq2ysize[g_sets.winconf] = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("Equalizer2WindowEventHandler window resized");
#endif
					g_sets.eq2xsize[g_sets.winconf] = event->configure.width;
					g_sets.eq2ysize[g_sets.winconf] = event->configure.height;
				}
			}
		break;

#if defined(MAKEYBOARD)
		case GDK_BUTTON_RELEASE:
			if(g_sets.keyboard && GTK_WIDGET_HAS_FOCUS(l_eqentry))
				gtk_window_set_focus(GTK_WINDOW(g_w[WINDOWEQ2]), NULL);
		break;
#endif

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "Equalizer2WindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled

} // Equalizer2WindowEventHandler


gint EffectsWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("EffectsWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
				
			OnWindowClosedEffects();
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("EffectsWindowEventHandler window moved");
#endif
					g_sets.effectsxpos[g_sets.winconf] = event->configure.x - l_wmdiffx;
					g_sets.effectsypos[g_sets.winconf] = event->configure.y - l_wmdiffy;
					g_sets.effectsxsize[g_sets.winconf] = event->configure.width;
					g_sets.effectsysize[g_sets.winconf] = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("EffectsWindowEventHandler window resized");
#endif
					g_sets.effectsxsize[g_sets.winconf] = event->configure.width;
					g_sets.effectsysize[g_sets.winconf] = event->configure.height;
				}
			}
		break;

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "EffectsWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled
	
} // EffectsWindowEventHandler


void EffectsWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("EffectsWindowMake");
#endif
	
	GtkWidget *window;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("EffectsWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWEFFECTS])
	{
		maLog("EffectsWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(EffectsWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(EffectsWindowEventHandler), (gpointer)maGDK_CONFIGURE);

#if defined(MAGUIGTK2) && (defined(MAKEYBOARD) || defined(MAMOUSEWHEEL))
	int mask = 0;
#endif

#if defined(MAKEYBOARD)
 #if defined(MAGUIGTK2)
	mask = GDK_KEY_PRESS_MASK;
	gtk_widget_set_events(window, mask);
 #endif
	gtk_signal_connect(GTK_OBJECT(window), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
#endif

#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
	mask |= GDK_SCROLL_MASK;
	gtk_widget_set_events(window, GDK_SCROLL_MASK);
	gtk_signal_connect(GTK_OBJECT(window), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #else
	gtk_signal_connect(GTK_OBJECT(window), "button_press_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

	g_w[WINDOWEFFECTS] = window;

	l_effects_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_effects_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_effects_vbox);

	#define EFFX  (XBASE + 32)
	#define EFFY  (YBASE + 22)
	#define EFFY2  (EFFY + 149)
	#define EFFDELX (60)
	#define EFFCBY (EFFY + 167)

	// duplicate main effects switch
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_EFFECTSB, "Effects", EFFX + 2, EFFCBY,	CBXSIZ3 + 10, 1);

	// pitch
	MakeText(0, ID_TEXT_NOID, "Pitch", EFFX - 8, EFFY - 16, 0);
	MakeText(0, ID_TEXT_NOID, "   semitones", EFFX - 2, EFFY - 1, 0);
	MakeSlider(ID_SLIDER_PITCH, EFFECTSPITCHMIN, EFFECTSPITCHMAX, EFFX, EFFY +  21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_PITCH0, "-000", EFFX, EFFY2, 0);
	MakeText(0, ID_TEXT_NOID, "Pitch", EFFX + EFFDELX - 8, EFFY - 16, 0);
	MakeSlider(ID_SLIDER_PITCH2, EFFECTSMIN, EFFECTSMAX, EFFX + EFFDELX, EFFY + 21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_PITCH02, "-000", EFFX + EFFDELX, EFFY2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_PITCH, "Pitch", EFFX + EFFDELX + 2, EFFCBY, CBXSIZ3 + 10, 0);

	// tempo
	MakeText(0, ID_TEXT_NOID, "Tempo", EFFX + 2 * EFFDELX - 8, EFFY - 16, 0);
	MakeText(0, ID_TEXT_NOID, "  x", EFFX + 2 * EFFDELX - 2, EFFY - 1, 0);
	MakeSlider(ID_SLIDER_TEMPO, EFFECTSMIN, EFFECTSMAX, EFFX + 2 * EFFDELX, EFFY +  21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_TEMPO0, "-000", EFFX + 2 * EFFDELX, EFFY2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_TEMPO, "Tempo", EFFX + 2 * EFFDELX + 2, EFFCBY, CBXSIZ3 + 10, 0);

	// speed
	MakeText(0, ID_TEXT_NOID, "Speed", EFFX + 3 * EFFDELX - 8, EFFY - 16, 0);
	MakeText(0, ID_TEXT_NOID, "  x", EFFX + 3 * EFFDELX - 2, EFFY - 1, 0);
	MakeSlider(ID_SLIDER_SPEED, EFFECTSMIN, EFFECTSMAX, EFFX + 3 * EFFDELX, EFFY +  21, VSLIDERW, VSLIDERH, 0);
	MakeText(1, ID_TEXT_SPEED0, "-000", EFFX + 3 * EFFDELX, EFFY2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_SPEED, "Speed", EFFX + 3 * EFFDELX + 2, EFFCBY, CBXSIZ3 + 10, 0);

	// quality
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_QUALFILTER, "No AA Filter", EFFX + 2, EFFCBY + 30, CBXSIZ2, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_QUALSPEED, "Low Qual Tempo", EFFX + 2 * EFFDELX + 2, EFFCBY + 30, CBXSIZ2 + 20, 0);

	// keyboard shortcut labels
	#undef EFFX
	#define EFFX (XBASE + 54)
	#undef EFFY
	#define EFFY (YBASE + 159)

	MakeText(1, ID_TEXT_KEYEFECTS,		"", EFFX - 20,				EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYPITCHUP,		"", EFFX - 2,				EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYPITCHDOWN,   "", EFFX - 2,				EFFY - 6, 0);

	MakeText(1, ID_TEXT_KEYPITCHSET,	"", EFFX + EFFDELX - 20,	EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYPITCH2UP,	"", EFFX + EFFDELX - 2,		EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYPITCH2DOWN,  "", EFFX + EFFDELX - 2,		EFFY - 6, 0);
	MakeText(1, ID_TEXT_KEYPITCHRESET,  "", EFFX + EFFDELX - 0,		EFFY - 61, 0);

	MakeText(1, ID_TEXT_KEYTEMPOSET,	"", EFFX + 2 * EFFDELX - 20,EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYTEMPOUP,		"", EFFX + 2 * EFFDELX - 2, EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYTEMPODOWN,   "", EFFX + 2 * EFFDELX - 2,	EFFY - 6, 0);
	MakeText(1, ID_TEXT_KEYTEMPORESET,  "", EFFX + 2 * EFFDELX - 0,	EFFY - 40, 0);

	MakeText(1, ID_TEXT_KEYSPEEDSET,	"", EFFX + 3 * EFFDELX - 20,EFFY + 44, 0);
	MakeText(1, ID_TEXT_KEYSPEEDUP,		"", EFFX + 3 * EFFDELX - 2, EFFY - 13 - VSLIDERH, 0);
	MakeText(1, ID_TEXT_KEYSPEEDDOWN,   "", EFFX + 3 * EFFDELX - 2,	EFFY - 6, 0);
	MakeText(1, ID_TEXT_KEYSPEEDRESET,  "", EFFX + 3 * EFFDELX - 0,	EFFY - 40, 0);

	gtk_box_pack_end_defaults(GTK_BOX(l_effects_vbox), l_fixed);

	sprintf(cstr, "%s Effects", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	gtk_widget_set_uposition(window, g_sets.effectsxpos[g_sets.winconf], g_sets.effectsypos[g_sets.winconf]);
	gtk_widget_set_usize(window, g_sets.effectsxsize[g_sets.winconf], g_sets.effectsysize[g_sets.winconf]);

	gtk_widget_show_all(window);

} // EffectsWindowMake


#if !defined(MANOCDA) && defined(__MAUNIX__)
gint AudioCDWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("AudioCDWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
				
			OnWindowClosedAudioCD();
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("AudioCDWindowEventHandler window moved");
#endif
					g_setscdrom.winx[g_sets.winconf] = event->configure.x - l_wmdiffx;
					g_setscdrom.winy[g_sets.winconf] = event->configure.y - l_wmdiffy;
					g_setscdrom.winw[g_sets.winconf] = event->configure.width;
					g_setscdrom.winh[g_sets.winconf] = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("AudioCDWindowEventHandler window resized");
#endif
					g_setscdrom.winw[g_sets.winconf] = event->configure.width;
					g_setscdrom.winh[g_sets.winconf] = event->configure.height;
				}
			}
		break;

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "AudioCDWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled
	
} // AudioCDWindowEventHandler


void AudioCDWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("AudioCDWindowMake");
#endif
	GtkWidget *window;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("AudioCDWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWAUDIOCD])
	{
		maLog("AudioCDWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(AudioCDWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(AudioCDWindowEventHandler), (gpointer)maGDK_CONFIGURE);
		
	g_w[WINDOWAUDIOCD] = window;

	l_audiocd_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_audiocd_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_audiocd_vbox);

	// popup button, menu items are appended from maplayer
	MakePopup(ID_POPUP_AUDIOCD, 0, NULL, 130, 11, 120, 20);

	// buttons
	MakeButtonA(ID_BTN_AUDIOCDSET, "Set the drive", 5, 10, 100, 30);
	MakeButtonA(ID_BTN_AUDIOCDCLEAR, "Clear the drive", 5, 50, 100, 30);
	MakeButtonA(ID_BTN_AUDIOCDSAVE, "Save settings", 5, 90, 100, 30);
	MakeButtonA(ID_BTN_AUDIOCDCLOSE, "Close", 130, 90, 100, 30);

	// checkbox
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_CDPARANOIA, "CD Paranoia", 138, 55, 100, 1);

	gtk_box_pack_end_defaults(GTK_BOX(l_audiocd_vbox), l_fixed);

	sprintf(cstr, "%s AudioCD", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	gtk_widget_set_uposition(window, g_setscdrom.winx[g_sets.winconf],
										g_setscdrom.winy[g_sets.winconf]);
	gtk_widget_set_usize(window, g_setscdrom.winw[g_sets.winconf],
										g_setscdrom.winh[g_sets.winconf]);

	gtk_widget_show_all(window);

} // AudioCDWindowMake
#endif


gint AdvancedWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("AdvancedWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
				
			OnWindowClosedAdvanced();
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("AdvancedWindowEventHandler window moved");
#endif
					g_sets.advancedxpos = event->configure.x - l_wmdiffx;
					g_sets.advancedypos = event->configure.y - l_wmdiffy;
					g_sets.advancedxsize = event->configure.width;
					g_sets.advancedysize = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("AdvancedWindowEventHandler window resized");
#endif
					g_sets.advancedxsize = event->configure.width;
					g_sets.advancedysize = event->configure.height;
				}
			}
		break;

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "AdvancedWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled
	
} // AdvancedWindowEventHandler


void advancedbuttoncallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("advancedbuttoncallback");
#endif
	DoWindowAdvanced(0);
}


void AdvancedWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("AdvancedWindowMake");
#endif
	GtkWidget *window;
	GtkWidget *button;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("AdvancedWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWADVANCED])
	{
		maLog("AdvancedWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(AdvancedWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(AdvancedWindowEventHandler), (gpointer)maGDK_CONFIGURE);
		
	g_w[WINDOWADVANCED] = window;

	l_advanced_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_advanced_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_advanced_vbox);

	// checkbox
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_CLOSEREOPEN,
		" Close and re-open sound channel between songs (default no)", 10, 10, CBXSIZ7, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_HIGHPRIORITY,
		" HiPriority (default no)", 10, 40, CBXSIZ7, 0);
	
	// Close button
	button = gtk_button_new_with_label("Close");
	char name[64];
	sprintf(name, "mabutton%s", "Close");
	gtk_widget_set_name(button, name);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(advancedbuttoncallback), (gpointer)WINDOWADVANCED);
	gtk_fixed_put(GTK_FIXED(l_fixed), button, g_sets.advancedxsize /2 - 30, g_sets.advancedysize - 30);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);

	gtk_box_pack_end_defaults(GTK_BOX(l_advanced_vbox), l_fixed);

	sprintf(cstr, "%s Advanced Settings", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	gtk_widget_set_uposition(window, g_sets.advancedxpos, g_sets.advancedypos);
	gtk_widget_set_usize(window, g_sets.advancedxsize, g_sets.advancedysize);

	gtk_widget_show_all(window);

} // AdvancedWindowMake


char *mp3bitrate[] =
{
	"32 (lower quality, smaller files)",
	"40",
	"48",
	"56",
	"64",
	"80",
	"96",
	"112",
	"128 (default)",
	"160",
	"192",
	"224",
	"256",
	"320 (high quality, bigger files)",
};

char *mp3quality[] =
{
	"0 (high quality, slow encode)",
	"1",
	"2 (default)",
	"3",
	"4",
	"5",
	"6",
	"7",
	"8",
	"9",
	"10 (lower quality, fast encode)",
};

char *mp3mode[] =
{
	"Stereo (default)",
	"Joint Stereo",
	"Dual Stereo",
	"Mono",
};

char *mp3samplerate[] =
{
	"Auto",
	//" 8000", // crashes on OSX
	"11025",
	"12000",
	"16000",
	"22050",
	"24000",
	"32000",
	"44100 (default)",
	"48000",
	"Same as input",
};

char *oggbitrate[] =
{
	"32 (lower quality, smaller files)",
	"40",
	"48",
	"56",
	"64",
	"80",
	"96",
	"112",
	"128 (default)",
	"160",
	"192",
	"224",
	"256",
	"320 (high quality, bigger files)",
};

/*
char *oggquality[] =
{
	"0 (high quality, slow encode)",
	"1",
	"2",
	"3",
	"4",
	"5 (default)",
	"6",
	"7",
	"8",
	"9",
	"10 (lower quality, fast encode)",
};
*/

char *oggmode[] =
{
	"Stereo (default)",
	// "Joint Stereo",
	// "Dual Stereo",
	"Mono",
};


char *aacquality[] =
{
	"130 (~218 kbps)",
	"120 (~194 kbps)",
	"110 (~158 kbps)",
	"100 (~129 kbps default)",
	" 90 (~103 kbps)",
	" 80 (~79 kbps)",
	" 70 (~62 kbps)",
};

char *mp4quality[] =
{
	"130 (~218 kbps)",
	"120 (~194 kbps)",
	"110 (~158 kbps)",
	"100 (~129 kbps default)",
	" 90 (~103 kbps)",
	" 80 (~79 kbps)",
	" 70 (~62 kbps)",
};


void FileOutWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("FileOutWindowMake");
#endif

	GtkWidget *window;
	char cstr[256];

	if(!g_w[WINDOWAPP])
	{
		maLog("FileOutWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWOUTCUR])
	{
		maLog("FileOutWindowMake already made");
		return;
	}
	
	if(WINDOWOUTCUR < WINDOWOUTFIRST || WINDOWOUTCUR > WINDOWOUTLAST)
	{
		sprintf(cstr, "FileOutWindowMake error WINDOWOUTCUR=%d g_sets.output=%d", WINDOWOUTCUR, g_sets.output);
		maLog(cstr);
		return;
	}
		
	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(FileOutWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(FileOutWindowEventHandler), (gpointer)maGDK_CONFIGURE);

	g_w[WINDOWOUTCUR] = window;

	l_fileout_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_fileout_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_fileout_vbox);

	#undef POPX
	#undef POPY
	#define POPX (XBASE + 20)
	#define POPY (-24)
	#define POPW (160)
	#define POPH (20)
	#define POPXT (POPX + 1)
	#define POPYT (POPY - 13)
	#define YDEL 34

	MakeText(0, ID_TEXT_NOID, "Put new files in folder", POPXT, POPYT + 1 * YDEL + 2, 0);
	MakeText(1, ID_TEXT_FILEOUTDIR, g_sets.fileout[g_k[g_sets.output]].outdir, POPXT, POPYT + 1 * YDEL + 18, 0);
	MakeButtonA(ID_BTN_FILEOUTDIR, "Change folder", POPXT, POPYT + 2 * YDEL, POPW , POPH);
	
#if defined(ENCODEMP3) || defined(ENCODEOGG) || defined(ENCODAAC) || defined(ENCODEMP4)
	switch(g_sets.output)
	{		
 #ifdef ENCODEMP3
		case kOUTMP3 :
			MakeText(0, ID_TEXT_NOID, "Bitrate", POPXT, POPYT + 3 * YDEL, 0);
			MakePopup(ID_POPUP_BITRATE, 14, mp3bitrate, POPX, POPY + 3 * YDEL, POPW, POPH);

			MakeText(0, ID_TEXT_NOID, "Quality", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_QUALITY, 11, mp3quality, POPX, POPY + 4 * YDEL, POPW, POPH);

			MakeText(0, ID_TEXT_NOID, "Mode", POPXT, POPYT + 5 * YDEL, 0);
			MakePopup(ID_POPUP_MODE, 4, mp3mode, POPX, POPY + 5 * YDEL, POPW, POPH);

			MakeText(0, ID_TEXT_NOID, "Sample Rate", POPXT, POPYT + 6 * YDEL, 0);
			MakePopup(ID_POPUP_SAMPLERATE, 10, mp3samplerate, POPX, POPY + 6 * YDEL, POPW, POPH);
		break;
 #endif
 
 #ifdef ENCODEOGG
		case kOUTOGG :
			MakeText(0, ID_TEXT_NOID, "Bitrate", POPXT, POPYT + 3 * YDEL, 0);
			MakePopup(ID_POPUP_BITRATE, 14, oggbitrate, POPX, POPY + 3 * YDEL, POPW, POPH);

			// MakeText(0, ID_TEXT_NOID, "Quality", POPXT, POPYT + 4 * YDEL, 0);
			// MakePopup(ID_POPUP_QUALITY, 11, oggquality, POPX, POPY + 4 * YDEL, POPW, POPH);

			// MakeText(0, ID_TEXT_NOID, "Mode", POPXT, POPYT + 5 * YDEL, 0);
			// MakePopup(ID_POPUP_MODE, 4, oggmode, POPX, POPY + 5 * YDEL, POPW, POPH);
			MakeText(0, ID_TEXT_NOID, "Mode", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_MODE, 2, oggmode, POPX, POPY + 4 * YDEL, POPW, POPH);
		break;
 #endif
 
 #ifdef ENCODEAAC
		case kOUTAAC :
			MakeCheckbox(ID_TEXT_NOID, ID_CHK_ADTS, "   ADTS Headers", POPXT, POPYT + 3 * YDEL, CBXSIZ6, 0);
			MakeText(0, ID_TEXT_NOID, "Quality", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_QUALITY, 7, aacquality, POPX, POPY + 4 * YDEL, POPW + 8, POPH);
		break;
 #endif
 
 #ifdef ENCODEMP4
		case kOUTMP4 :
			MakeCheckbox(ID_TEXT_NOID, ID_CHK_M4A, "   .m4a extension", POPXT, POPYT + 3 * YDEL, CBXSIZ6, 0);
			MakeText(0, ID_TEXT_NOID, "Quality", POPXT, POPYT + 4 * YDEL, 0);
			MakePopup(ID_POPUP_QUALITY, 7, mp4quality, POPX, POPY + 4 * YDEL, POPW + 8, POPH);
		break;
 #endif
 
		default :
		break;
	} // switch
#endif

	gtk_box_pack_end_defaults(GTK_BOX(l_fileout_vbox), l_fixed);

	sprintf(cstr, "%s %s File Output", g_prognametitle, g_extstrout[g_sets.output]);
	gtk_window_set_title(GTK_WINDOW(window), cstr);
	
	gtk_widget_set_uposition(window, g_sets.fileoutxpos[g_sets.winconf],
									g_sets.fileoutypos[g_sets.winconf]);
	gtk_widget_set_usize(window, g_sets.fileoutxsize[g_sets.winconf],
									g_sets.fileoutysize[g_sets.winconf]);

	gtk_widget_show_all(window);

} // FileOutWindowMake


gint FileOutWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("FileOutWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
				
			OnWindowClosedFileOut();
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("FileOutWindowEventHandler window moved");
#endif
					g_sets.fileoutxpos[g_sets.winconf] = event->configure.x - l_wmdiffx;
					g_sets.fileoutypos[g_sets.winconf] = event->configure.y - l_wmdiffy;
					g_sets.fileoutxsize[g_sets.winconf] = event->configure.width;
					g_sets.fileoutysize[g_sets.winconf] = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("FileOutWindowEventHandler window resized");
#endif
					g_sets.fileoutxsize[g_sets.winconf] = event->configure.width;
					g_sets.fileoutysize[g_sets.winconf] = event->configure.height;
				}
			}
		break;

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "FileOutWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled
	
} // FileOutWindowEventHandler



gint PromptNumWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("PromptNumWindowEventHandler");
#endif

	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
		break;

		case GDK_CONFIGURE: // resize, move, etc
			/*
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("PromptNumWindowEventHandler window moved");
#endif
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("PromptNumWindowEventHandler window resized");
#endif
				}
			}
			*/
		break;


#if defined(MAKEYBOARD)
		case GDK_BUTTON_RELEASE:
			if(g_sets.keyboard && GTK_WIDGET_HAS_FOCUS(l_promptnumentry))
				gtk_window_set_focus(GTK_WINDOW(g_w[WINDOWPROMPTNUM]), NULL);
		break;
#endif

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "PromptNumWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled

} // PromptNumWindowEventHandler


void promptnumentrycallback(GtkWidget *widget)
{
#ifdef MATRACEGUIGTK
	maTrace("promptnumentrycallback");
#endif
	char cstr[256];
	strcpy(cstr, gtk_entry_get_text(GTK_ENTRY(l_promptnumentry)));
	if(!cstr[0])
		return;
		
	OnEditTextPromptNum();
	
} // promptnumentrycallback


#define PROMPTNUMDEFXSIZE 354 
#define PROMPTNUMDEFYSIZE 144
#define PROMPTNUMBUTTONW 60
#define PROMPTNUMBUTTONH 48
void PromptNumWindowMake()
{
 	GtkWidget *window;
	char cstr[256];
	
	if(!g_w[WINDOWAPP])
	{
		maLog("PromptNumWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWPROMPTNUM])
	{
		maLog("PromptNumWindowMake already made");
		return;
	}

	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(PromptNumWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(PromptNumWindowEventHandler), (gpointer)maGDK_CONFIGURE);

	g_w[WINDOWPROMPTNUM] = window;

	l_promptnum_vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_border_width(GTK_CONTAINER(l_promptnum_vbox), 1);
	gtk_container_add(GTK_CONTAINER(window), l_promptnum_vbox);
	
	// msg
	MakeText(1, ID_TEXT_PROMPTNUM, "Enter the index of a song to play (1 to 99999, 0 to Cancel)", 10, 10, 0);

	// keyboard input
	l_promptnumentry = gtk_entry_new_with_max_length(MAPROMPTMAX);
	gtk_signal_connect(GTK_OBJECT(l_promptnumentry), "activate",
					GTK_SIGNAL_FUNC(promptnumentrycallback), NULL);
	gtk_fixed_put(GTK_FIXED(l_fixed), l_promptnumentry,  10, 40);
	gtk_widget_set_usize(l_promptnumentry, PROMPTNUMDEFXSIZE - 20, 26);
	gtk_widget_set_sensitive(l_promptnumentry, TRUE);

	// buttons
	l_ButtonPos = PROMPTNUMDEFXSIZE - 2 * (PROMPTNUMBUTTONW + 10);
	l_buttonTop = PROMPTNUMDEFYSIZE - (PROMPTNUMBUTTONH + 10);
	MakeButton(ID_BTN_PROMPTNUMCANCEL, LABEL_CANCEL);

	l_ButtonPos = PROMPTNUMDEFXSIZE - (PROMPTNUMBUTTONW + 10);
	l_buttonTop = PROMPTNUMDEFYSIZE - (PROMPTNUMBUTTONH + 10);
	MakeButton(ID_BTN_PROMPTNUMOK, LABEL_OK);

	gtk_box_pack_end_defaults(GTK_BOX(l_promptnum_vbox), l_fixed);

	sprintf(cstr, "%s Prompt Number", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	// gtk_window_set_modal(window, 1);
														 
	gtk_widget_set_uposition(window, g_sets.xpos[g_sets.winconf] + 10, g_sets.ypos[g_sets.winconf] + 26);
	gtk_widget_set_usize(window, PROMPTNUMDEFXSIZE, PROMPTNUMDEFYSIZE);

	gtk_widget_show_all(window);
	
} // PromptNumWindowMake


void ListAppend(int window, int list, char *text)
{
#ifdef MATRACEGUIGTK
	maTrace("ListAppend");
#endif

	char *texts[1];
	texts[0] = text;
	gtk_clist_append(GTK_CLIST(l_clist), texts);
	l_linenum++;
	
} // ListAppend

 
void ListClear(int window, int list)
{
#ifdef MATRACEGUIGTK
	maTrace("ListClear");
#endif

	if(!g_w[window] || !l_clist)
		return;

	gtk_clist_clear(GTK_CLIST(l_clist));
	l_linenum = 0;

} // ListClear


int ListGetRowSelected(int window, int list)
{
#ifdef MATRACEGUIGTK
	maTrace("ListGetRowSelected");
#endif

	if(!g_w[window] || !l_clist)
		return -1;

	if(GTK_CLIST(l_clist)->selection)
		return GPOINTER_TO_INT(GTK_CLIST(l_clist)->selection->data);

	return -1;
}


void ListEnsureVisible(int window, int list, int row)
{
#ifdef MATRACEGUIGTK
	maTrace("ListEnsureVisible");
#endif

	if(!g_w[window] || !l_clist)
		return;

	if(gtk_clist_row_is_visible(GTK_CLIST(l_clist), row) != GTK_VISIBILITY_NONE)
		return;

	gtk_clist_moveto(GTK_CLIST(l_clist), row, 0, 0.0, 0.0);
}


void ListSelect(int window, int list, int row)
{
#ifdef MATRACEGUIGTK
	maTrace("ListSelect");
#endif

	if(!g_w[window] || !l_clist)
		return;

	gtk_clist_select_row(GTK_CLIST(l_clist), row, 0);
}


void ListGetText(int window, int list, int row, char *text)
{
#ifdef MATRACEGUIGTK
	maTrace("ListGetText");
#endif

	char cstr[256];
	
	if(!g_w[window] || !l_clist)
		return;

	cstr[0] = 0;
	gtk_clist_get_text(GTK_CLIST(l_clist), row, 0, (gchar **)&cstr);
	strcpy(text, cstr);

} // ListGetText


/* not used void ListSetText(int window, int list, int row, char *text)
{
#ifdef MATRACEGUIGTK
	maTrace("ListSetText");
#endif
}
*/


void ListSetHeader(int window, int list, int col, char *header)
{
#ifdef MATRACEGUIGTK
	maTrace("ListSetHeader");
#endif

	if(!g_w[window] || !l_clist)
		return;

	gtk_clist_set_column_title(GTK_CLIST(l_clist), col, header);

} // ListSetHeader


void SetColumn0Width(int width)
{
	int w;

	if(!g_w[WINDOWLIST] || !l_clist)
		return;

	if(width <= 0)
	{
		switch(g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
		{
			case LBOXINFO:
				w = g_sets.listcolxsize[g_sets.winconf][0];
			break;
			case LBOXLIST:
				w = g_sets.listcolxsize[g_sets.winconf][1];
			break;
			case LBOXLOADED:
				w = g_sets.listcolxsize[g_sets.winconf][2];
			break;
			case LBOXID3:
				w = g_sets.listcolxsize[g_sets.winconf][3];
			break;
			default:
			return;
		}
	}
	else
		w = width;
	
	gtk_clist_set_column_width(GTK_CLIST(l_clist), 0, w);
				 
	if(width > 0)
		GetColumn0Width();

} // SetColumn0Width

		
void GetColumn0Width()
{
	int width;
	
	if(!g_w[WINDOWLIST] || !l_clist)
		return;

	width = ((GtkCListColumn *)gtk_clist_get_column_widget(GTK_CLIST(l_clist), 0))->width;
	
	if(width < (g_sets.listxsize[g_sets.winconf] - SCROLLERWIDTH))
		width = g_sets.listxsize[g_sets.winconf] - SCROLLERWIDTH;

	switch(g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
	{
		case LBOXINFO:
			g_sets.listcolxsize[g_sets.winconf][0] = width;
		break;
		case LBOXLIST:
			g_sets.listcolxsize[g_sets.winconf][1] = width;
		break;
		case LBOXLOADED:
			g_sets.listcolxsize[g_sets.winconf][2] = width;
		break;
		case LBOXID3:
			g_sets.listcolxsize[g_sets.winconf][3] = width;
		break;
		default:
		break;
	}

	return;
	
} // GetColumn0Width

		
void ListSetColumnWidth()
{
#ifdef MATRACEGUIGTK
	maTrace("ListSetColumnWidth");
#endif
	
	SetColumn0Width(0);
}


gint ListWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("ListWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
			OnWindowClosedList();
			l_linenum = 0;
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("ListWindowEventHandler window moved");
#endif
					g_sets.listxpos[g_sets.winconf] = event->configure.x - l_wmdiffx;
					g_sets.listypos[g_sets.winconf] = event->configure.y - l_wmdiffy;
					g_sets.listxsize[g_sets.winconf] = event->configure.width;
					g_sets.listysize[g_sets.winconf] = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("ListWindowEventHandler window resized");
#endif
					g_sets.listxsize[g_sets.winconf] = event->configure.width;
					g_sets.listysize[g_sets.winconf] = event->configure.height;
					GetColumn0Width();
				}
			}
		break;

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "ListWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled
	
} // ListWindowEventHandler


#define MADOUBLECLICKTIME 2000 // max ms between two clicks of a list double click, big for long songlists...
int l_lastrow;
guint32 l_listclicktime;
void clist_row_selected(GtkWidget *w, gint row, gint c, GdkEventButton *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 char cstr[256];
 if(!event)
  sprintf(cstr, "clist_row_selected row=%d event=0", row);
 else
  sprintf(cstr, "clist_row_selected row=%d time=%d", row, event->time);
 maTrace(cstr);
#endif

	if(!event)
		return;
		
	if(((event->time - l_listclicktime) < MADOUBLECLICKTIME) && row == l_lastrow) // a double-click
	{
#ifdef MATRACEGUIGTK
maTrace("DoubleClick");
#endif
		l_listclicktime = 0;
		OnListWindowDoubleClick();
		return;
	}
	
	l_lastrow = row;
	l_listclicktime = event->time;
	OnListWindowSingleClick(row + 1);
	
} // clist_row_selected


void clist_row_unselected(GtkWidget *w, gint row, gint c, GdkEventButton *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 char cstr[256];
 if(!event)
  sprintf(cstr, "clist_row_unselected row=%d event=0", row);
 else
  sprintf(cstr, "clist_row_unselected row=%d time=%d", row, event->time);
 maTrace(cstr);
#endif

	if(!event)
		return;
		
	l_listclicktime = event->time;

} // clist_row_unselected


void clist_resize_column(GtkWidget *w, gint row, gint c, GdkEventButton *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 char cstr[256];
 if(!event)
  sprintf(cstr, "clist_resize_column c=%d event=0", c);
 else
  sprintf(cstr, "clist_resize_column c=%d time=%d", c, event->time);
 maTrace(cstr);
#endif

	//GetColumn0Width();
	switch(g_sets.listwindow & (LBOXINFO | LBOXLIST | LBOXLOADED | LBOXID3))
	{
		case LBOXINFO:
			g_sets.listcolxsize[g_sets.winconf][0] = c;
		break;
		case LBOXLIST:
			g_sets.listcolxsize[g_sets.winconf][1] = c;
		break;
		case LBOXLOADED:
			g_sets.listcolxsize[g_sets.winconf][2] = c;
		break;
		case LBOXID3:
			g_sets.listcolxsize[g_sets.winconf][3] = c;
		break;
		default:
		break;
	}

} // clist_resize_column


void clist_key_pressed(GtkWidget *w, GdkEventKey *event, gpointer p)
{
#ifdef MATRACEGUIGTK
 maTrace("clist_key_pressed");
#endif

	if(!event)
		return;
		
	if(event->keyval == GDK_Return) // 0xFF0D
		maOnKey(WINDOWLIST, MAWXK_RETURN);
#if GTK_MAJOR_VERSION == 2 // on arrows GTK1 scrolls without us telling it to
	else if(event->keyval == GDK_Up) // up arrow
		maOnKey(WINDOWLIST, MAWXK_UP);
	else if(event->keyval == GDK_Down) // down arrow
		maOnKey(WINDOWLIST, MAWXK_DOWN);
#endif

} // clist_key_pressed


#define LISTMENUBARH 26 // MENUBARH to line up buttons with main window buttons
void ListWindowMake()
{
#ifdef MATRACEGUIGTK
	maTrace("ListWindowMake");
#endif
	GtkWidget *window;

	if(!g_w[WINDOWAPP])
	{
		maLog("ListWindowMake no App window");
		return;
	}
	
	if(g_w[WINDOWLIST])
	{
		maLog("ListWindowMake already made");
		return;
	}
	
	l_fixed = gtk_fixed_new();
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(ListWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(ListWindowEventHandler), (gpointer)maGDK_CONFIGURE);

#if defined(MAGUIGTK2) && (defined(MAKEYBOARD) || defined(MAMOUSEWHEEL))
	int mask = 0;
#endif

#if defined(MAKEYBOARD)
 #if defined(MAGUIGTK2)
	mask = GDK_KEY_PRESS_MASK;
	gtk_widget_set_events(window, mask);
 #endif
	gtk_signal_connect(GTK_OBJECT(window), "key_press_event",
		GTK_SIGNAL_FUNC(KeyboardEventHandler), (gpointer)maENTRYKEYPRESS);
#endif

#if defined(MAMOUSEWHEEL)
 #if defined(MAGUIGTK2)
	mask |= GDK_SCROLL_MASK;
	gtk_widget_set_events(window, GDK_SCROLL_MASK);
	gtk_signal_connect(GTK_OBJECT(window), "scroll_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #else
	gtk_signal_connect(GTK_OBJECT(window), "button_press_event",
		GTK_SIGNAL_FUNC(MouseWheelEventHandler), (gpointer)maMOUSEBUTTON);
 #endif
#endif

	g_w[WINDOWLIST] = window;

	// list buttons
	l_ButtonPos = XBASE;
	l_buttonTop = YBASE + LISTMENUBARH; // line up buttons with main window buttons
	MakeButton(ID_BTN_INFO, LABEL_INFO);
	MakeButton(ID_BTN_SONGLIST, LABEL_LIST);
	MakeButton(ID_BTN_LOADED, LABEL_LOAD);
	MakeButton(ID_BTN_SONGINFO, LABEL_SONG);
	
	// list checkboxes
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_SHOWINDEX, "Show index", l_ButtonPos + 4, YBASE + LISTMENUBARH + 3 - 13, CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_SHOWDIR, "Show dir", l_ButtonPos + 4, YBASE + LISTMENUBARH + 19 - 13, CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_SHOWPATH, "Show path", l_ButtonPos + 4, YBASE + LISTMENUBARH + 35 - 13, CBXSIZ, 0);
	MakeCheckbox(ID_TEXT_NOID, ID_CHK_ADDMODE, "Add mode", l_ButtonPos + 84, YBASE + LISTMENUBARH + 3 - 13, CBXSIZ, 0);

	// list
	char *titles[] = {""};
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *scrolled_win;
	l_linenum = 0;

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), vbox);

	scrolled_win = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(scrolled_win), 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win),
								GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	l_clist = gtk_clist_new_with_titles(1, titles);
	gtk_widget_set_name(l_clist, "malist");
	gtk_clist_set_reorderable(GTK_CLIST(l_clist), FALSE);
	gtk_clist_set_auto_sort(GTK_CLIST(l_clist), FALSE);
	gtk_clist_column_titles_passive(GTK_CLIST(l_clist));
	gtk_container_add(GTK_CONTAINER(scrolled_win), l_clist);
	gtk_signal_connect(GTK_OBJECT(l_clist), "select_row",
						GTK_SIGNAL_FUNC(clist_row_selected), NULL);
	gtk_signal_connect(GTK_OBJECT(l_clist), "unselect_row",
						GTK_SIGNAL_FUNC(clist_row_unselected), NULL);
	gtk_signal_connect(GTK_OBJECT(l_clist), "resize_column",
						GTK_SIGNAL_FUNC(clist_resize_column), NULL);
	gtk_signal_connect(GTK_OBJECT(l_clist), "key_press_event",
						GTK_SIGNAL_FUNC(clist_key_pressed), NULL);

	hbox = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER (hbox), 0);
	gtk_box_pack_start (GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), l_fixed, FALSE, FALSE, 0);	  
	gtk_box_pack_start(GTK_BOX (vbox), scrolled_win, TRUE, TRUE, 0);

	SetColumn0Width(0); // from g_sets
	gtk_clist_set_column_auto_resize(GTK_CLIST(l_clist), 1, FALSE);
	gtk_clist_set_column_justification(GTK_CLIST (l_clist), 1, GTK_JUSTIFY_LEFT);
	gtk_clist_set_selection_mode(GTK_CLIST(l_clist), GTK_SELECTION_BROWSE);

	gtk_widget_set_uposition(window, g_sets.listxpos[g_sets.winconf], g_sets.listypos[g_sets.winconf]);
	gtk_widget_set_usize(window, g_sets.listxsize[g_sets.winconf], g_sets.listysize[g_sets.winconf]);
			
	gtk_widget_show_all(window);

} // ListWindowMake


void MenuEnable(int menu, int item)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuEnable");
#endif
	
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		char cstr[256];
		sprintf(cstr, "MenuEnable gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(w, TRUE);

} // MenuEnable


void MenuDisable(int menu, int item)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuDisable");
#endif
	
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		char cstr[256];
		sprintf(cstr, "MenuDisable gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(w, FALSE);

} // MenuDisable


int MenuIsChecked(int menu, int item)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuIsChecked");
#endif

	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		char cstr[256];
		sprintf(cstr, "MenuIsChecked gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(cstr);
		return 0;
	}
	
	return ((GTK_CHECK_MENU_ITEM(w))->active) ? 1 : 0;

} // MenuIsChecked


void MenuSetChecked(int menu, int item, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("MenuSetChecked");
#endif
	GtkWidget* w = gtk_item_factory_get_widget_by_action(l_item_factory, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory1, item);
  	if(!w)
		 w = gtk_item_factory_get_widget_by_action(l_subitem_factory2, item);
	if(!w)
	{
		char cstr[256];
		sprintf(cstr, "MenuSetChecked gtk_item_factory_get_widget_by_action failed item=%d", item);
		maLog(cstr);
		return;
	}
	
	if(((GTK_CHECK_MENU_ITEM(w))->active && value) || (!((GTK_CHECK_MENU_ITEM(w))->active) && !value))
		return; // already set

	// gtk_check_menu_item_set_active triggers a menu event that we want to ignore
	// so we use always_show_toggle as a flag that will be checked in MenuEventHandler()
	(GTK_CHECK_MENU_ITEM(w))->always_show_toggle = 0;

	gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(w), (value) ? TRUE : FALSE);
		
} // MenuSetChecked


void PopupButtonEnable(int window, int popup)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonEnable");
#endif
	
	if(!g_w[window])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonEnable PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		return; 
	}
	
	if(!l_popupbutton[idx].optionmenu)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonEnable no popupbutton at index %d (id=%d)", idx, popup);
		maLog(cstr);
		return;
	}

	if(l_popupbutton[idx].optionmenu)
		gtk_widget_set_sensitive(l_popupbutton[idx].optionmenu, TRUE);

} // PopupButtonEnable


void PopupButtonDisable(int window, int popup)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonDisable");
#endif

	if(!g_w[window])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonDisable PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		return; 
	}
	
	if(!l_popupbutton[idx].optionmenu)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonDisable no popupbutton at index %d (id=%d)", idx, popup);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(l_popupbutton[idx].optionmenu, FALSE);
	
} // PopupButtonDisable


void PopupButtonClear(int window, int popup)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonClear");
#endif
	GtkWidget *menu;

	if(!g_w[window])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonClear PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		return; 
	}
	
	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonClear no popupbutton at index %d (id=%d)", idx, popup);
		maLog(cstr);
		return;
	}

	l_popupbutton[idx].nitems = 0;
	gtk_option_menu_remove_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu));
	menu = gtk_menu_new();
	gtk_widget_set_name(menu, "mapopup");
	gtk_option_menu_set_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), menu);

} // PopupButtonClear


void PopupButtonAppend(int window, int popup, char *text)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonAppend");
#endif
	int i;
	GtkWidget *menu;
	GtkWidget *menuitem;
	char cstr[256];

	if(!g_w[window])
		return;

	// we have to rebuild the popup
	// i have no idea how to get the current popup item labels
	// so get them from g_sets
	if(popup != ID_POPUP_EQPRESET // these are the only ones we do
#if !defined(MANOCDA) && defined(__MAUNIX__)
	&& popup != ID_POPUP_AUDIOCD
#endif
		)
	{
		sprintf(cstr, "PopupButtonAppend popup id=%d unsupported", popup);
		maLog(cstr);
		return;
	}

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		sprintf(cstr, "PopupButtonAppend PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		return; 
	}
	
	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		sprintf(cstr, "PopupButtonAppend no popupbutton at index %d (id=%d)", idx, popup);
		maLog(cstr);
		return;
	}
	
	menu = gtk_menu_new();
	gtk_widget_set_name(menu, "mapopup");
	for(i = 0; i < l_popupbutton[idx].nitems; i++)
	{
		menuitem = NULL;
		if(popup == ID_POPUP_EQPRESET)
			menuitem = gtk_menu_item_new_with_label(g_sets.eqpresets[i].eqname);
#if !defined(MANOCDA) && defined(__MAUNIX__)
		else // (popup == ID_POPUP_AUDIOCD)
			menuitem = gtk_menu_item_new_with_label(g_setscdrom.cdaname[i + 1]);
#endif
		if(menuitem)
		{
			gtk_widget_set_name(menuitem, "mamenu");
			gtk_menu_append(GTK_MENU(menu), menuitem);
			gtk_widget_show(menuitem);
			gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
				GTK_SIGNAL_FUNC(popupcallback), (gpointer)((i << 24) + popup));
		}
	}  
	menuitem = gtk_menu_item_new_with_label(text);
	gtk_widget_set_name(menuitem, "mamenu");
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_widget_show(menuitem);
	gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
		GTK_SIGNAL_FUNC(popupcallback), (gpointer)((i << 24) + popup));

	gtk_option_menu_remove_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu));
	gtk_option_menu_set_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), menu);
	gtk_option_menu_set_history(l_popupbutton[idx].optionmenu, l_popupbutton[idx].value);
	
	l_popupbutton[idx].nitems = l_popupbutton[idx].nitems + 1;

} // PopupButtonAppend


void PopupButtonSetValue(int window, int popup, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonSetValue");
#endif
	if(!g_w[window])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonSetValue PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		return; 
	}
	
	l_popupbutton[idx].value = value;
	gtk_option_menu_set_history(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), value);

} // PopupButtonSetValue


void PopupButtonSetText(int window, int popup, int item, char *text)
{
#ifdef MATRACEGUIGTK
	maTrace("PopupButtonSetText");
#endif
	int i;
	GtkWidget *menu;
	GtkWidget *menuitem;
	char cstr[256];

	if(!g_w[window])
		return;

	// we have to rebuild the popup
	// i have no idea how to get the current popup item labels
	// so get them from g_sets
	if(popup != ID_POPUP_EQPRESET // these are the only ones we do
#if !defined(MANOCDA) && defined(__MAUNIX__)
	&& popup != ID_POPUP_AUDIOCD
#endif
	)
	{
		sprintf(cstr, "PopupButtonSetText popup id=%d unsupported", popup);
		maLog(cstr);
		return;
	}

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		sprintf(cstr, "PopupButtonSetText PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		return; 
	}
	
	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		sprintf(cstr, "PopupButtonSetText no popupbutton at index %d (id=%d)", idx, popup);
		maLog(cstr);
		return;
	}
	
	menu = gtk_menu_new();
	gtk_widget_set_name(menu, "mapopup");
	for(i = 0; i < l_popupbutton[idx].nitems; i++)
	{
		menuitem = NULL;
		if(i == popup)
			menuitem = gtk_menu_item_new_with_label(text);
		else if(popup == ID_POPUP_EQPRESET)
			menuitem = gtk_menu_item_new_with_label(g_sets.eqpresets[i].eqname);
#if !defined(MANOCDA) && defined(__MAUNIX__)
		else // if(popup == ID_POPUP_AUDIOCD)
			menuitem = gtk_menu_item_new_with_label(g_setscdrom.cdaname[i + 1]);
#endif
		if(menuitem)
		{
			gtk_widget_set_name(menuitem, "mamenu");
			gtk_menu_append(GTK_MENU(menu), menuitem);
			gtk_widget_show(menuitem);
			gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
				GTK_SIGNAL_FUNC(popupcallback), (gpointer)((i << 24) + popup));
		}
	}
	gtk_option_menu_remove_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu));
	gtk_option_menu_set_menu(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), menu);
	gtk_option_menu_set_history(l_popupbutton[idx].optionmenu, l_popupbutton[idx].value);
	
} // PopupButtonSetText


#if !defined(MANOCDA) && defined(__MAUNIX__)
void PopupButtonGetSelection(int window, int popup, int *item)
{
#ifdef MATRACEGUIGTK
	maLog("PopupButtonGetSelection");
#endif

	if(!g_w[window])
	{
		if(item)
			*item = -1;
		return;
	}
	
	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonGetSelection PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		if(item)
			*item = -1;
		return; 
	}
	
	if(item)
		*item = l_popupbutton[idx].value;

} // PopupButtonGetSelection


void PopupButtonSetSelection(int window, int popup, int item)
{
#ifdef MATRACEGUIGTK
	maLog("PopupButtonSetSelection");
#endif
	GtkWidget *menu;

	if(!g_w[window])
		return;

	int idx = PopupButtonIndexFromId(popup);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonSetSelection PopupButtonIndexFromId %d failed", popup);
		maLog(cstr);
		return; 
	}
	
	if(!l_popupbutton[idx].optionmenu)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonSetSelection no popup optionmenu at index %d", idx);
		maLog(cstr);
		return;
	}

	if(!(menu = gtk_option_menu_get_menu(l_popupbutton[idx].optionmenu)))
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonSetSelection no popupbutton at index %d (id=%d)", idx, popup);
		maLog(cstr);
		return;
	}
	
	if(item < 0 || item > l_popupbutton[idx].nitems)
	{
		char cstr[256];
		sprintf(cstr, "PopupButtonSetSelection %d out of bounds, nitems=%d popupid=%d",
													item, l_popupbutton[idx].nitems, popup);
		maLog(cstr);
		return;
	}
	l_popupbutton[idx].value = item;
	gtk_option_menu_set_history(GTK_OPTION_MENU(l_popupbutton[idx].optionmenu), item);

} // PopupButtonSetSelection
#endif


/* not used void SpinButtonEnable(int window, int spinbutton)
{
#ifdef MATRACEGUIGTK
	maTrace("SpinButtonEnable");
#endif

	int idx = SpinButtonIndexFromId(spinbutton);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "SpinButtonEnable SpinButtonIndexFromId %d failed", spinbutton);
		maLog(cstr);
		return; 
	}
	
	if(!l_spinbutton[idx].adj)
	{
		char cstr[256];
		sprintf(cstr, "SpinButtonEnable no spinbutton at index %d (id=%d)", idx, spinbutton);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_spinbutton[idx].adj), TRUE);

} // SpinButtonEnable


void SpinButtonDisable(int window, int spinbutton)
{
#ifdef MATRACEGUIGTK
	maTrace("SpinButtonDisable");
#endif

	int idx = SpinButtonIndexFromId(spinbutton);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "SpinButtonDisable SpinButtonIndexFromId %d failed", spinbutton);
		maLog(cstr);
		return; 
	}
	
	if(!l_spinbutton[idx].adj)
	{
		char cstr[256];
		sprintf(cstr, "SpinButtonDisable no spinbutton at index=%d (id=%d)", idx, spinbutton);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_spinbutton[idx].adj), FALSE);

} // SpinButtonDisable
*/


// this s.b. 'ToggleButtonPaintUp' or 'PushButtonSetValue(1)'
// but it is only called from SetPause
void PushButtonPaintUp(int window, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonPaintUp");
#endif
	int idx = ButtonIndexFromId(button);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonPaintUp ButtonIndexFromId %d failed", button);
		maLog(cstr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonPaintUp no button at index %d (id=%d)", idx, button);
		maLog(cstr);
		return;
	}
	
	if(!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(l_button[idx].btn)))
		return; // already set

	l_button[idx].skip = 1;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(l_button[idx].btn), FALSE);

} // PushButtonPaintUp


void PushButtonPaintDown(int window, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonPaintDown");
#endif
	int idx = ButtonIndexFromId(button);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonPaintDown ButtonIndexFromId %d failed", button);
		maLog(cstr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonPaintDown no button at index %d (id=%d)", idx, button);
		maLog(cstr);
		return;
	}
	
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(l_button[idx].btn)))
		return; // already set
		
	l_button[idx].skip = 1;
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(l_button[idx].btn), TRUE);

} // PushButtonPaintDown


void PushButtonEnable(int window, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonEnable");
#endif

	int idx = ButtonIndexFromId(button);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonEnable ButtonIndexFromId %d failed", button);
		maLog(cstr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonEnable no button at index %d (id=%d)", idx, button);
		maLog(cstr);
		return;
	}
	
	gtk_widget_set_sensitive(GTK_WIDGET(l_button[idx].btn), TRUE);

} // PushButtonEnable


void PushButtonDisable(int window, int button)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonDisable");
#endif

	int idx = ButtonIndexFromId(button);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonDisable ButtonIndexFromId %d failed", button);
		maLog(cstr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		char cstr[256];
		sprintf(cstr, "PushButtonDisable no button at index=%d (id=%d)", idx, button);
		maLog(cstr);
		return;
	}

	gtk_widget_set_sensitive(GTK_WIDGET(l_button[idx].btn), FALSE);


} // PushButtonDisable


void PushButtonSetDescriptor(int window, int button, char *desc)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonSetDescriptor");
#endif
	GtkLabel *label;
	int idx;
	char cstr[256];
	
	if((idx = ButtonIndexFromId(button)) < 0)
	{
		sprintf(cstr, "PushButtonSetDescriptor ButtonIndexFromId %d failed", button);
		maLog(cstr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		sprintf(cstr, "PushButtonSetDescriptor no button at index %d (id=%d)", idx, button);
		maLog(cstr);
		return;
	}

	if(desc && (label = maGtkGetFirstLabel(l_button[idx].btn)))
		gtk_label_set_text(label, desc);
	
} // PushButtonSetDescriptor


void PushButtonGetDescriptor(int window, int button, char *desc)
{
#ifdef MATRACEGUIGTK
	maTrace("PushButtonGetDescriptor");
#endif
	GtkLabel *label;
	int idx;
	char cstr[256];
	
	if((idx = ButtonIndexFromId(button)) < 0)
	{
		sprintf(cstr, "PushButtonGetDescriptor ButtonIndexFromId %d failed", button);
		maLog(cstr);
		return; 
	}
	
	if(!l_button[idx].btn)
	{
		sprintf(cstr, "PushButtonGetDescriptor no button at index %d (id=%d)", idx, button);
		maLog(cstr);
		return;
	}

	if(desc && (label = maGtkGetFirstLabel(l_button[idx].btn)))
		strcpy(desc, label->label);
	
} // PushButtonGetDescriptor


void hslidercallback(GtkWidget *widget, maslider *lslider)
{
#ifdef MATRACEGUIGTK
maTrace("hslidercallback");
#endif

	if(lslider->skip)
	{
		lslider->skip = 0;
		return;
	}
	OnSliderPosition(GTK_ADJUSTMENT(widget)->value);
}


void slidercallback(GtkWidget *widget, maslider *lslider)
{
#ifdef MATRACEGUIGTK
maTrace("slidercallback");
#endif
	int startValue;
	int idx;
	
	if(lslider->skip)
	{
		lslider->skip = 0;
		return;
	}

	startValue = GTK_ADJUSTMENT(widget)->upper - 1.0 - GTK_ADJUSTMENT(widget)->value; // lower is always 0

	if(lslider->id >= ID_SLIDER_EQ_FIRST && lslider->id <= ID_SLIDER_EQ2_LAST)
	{
		if((idx = lslider->id - ID_SLIDER_EQ_FIRST) <= EQSLIDERLAST)
			OnSliderEq(idx, startValue, 0);
		else
			OnSliderEq2(idx, startValue, 0);
		return;
	}
	
	switch(lslider->id)
	{
		case ID_SLIDER_VOLUMEL :
			OnSliderVolumeL(startValue);
		break;
		case ID_SLIDER_VOLUMER :
			OnSliderVolumeR(startValue);
		break;
		case ID_SLIDER_VOLUMESEP :
			OnSliderSeparation(startValue);
		break;
		case ID_SLIDER_PREAMP :
			OnSliderPreamp(startValue);
		break;
		case ID_SLIDER_PITCH :
			OnSliderPitch(startValue);
		break;
		case ID_SLIDER_PITCH2 :
			OnSliderPitch2(startValue);
		break;
		case ID_SLIDER_TEMPO :
			OnSliderTempo(startValue);
		break;
		case ID_SLIDER_SPEED :
			OnSliderSpeed(startValue);
		break;

		default:
			maLogAPI("slidercallback unexpected id", WINDOWAPP, lslider->id);
		break;
	}

} // slidercallback


/* not used
int SliderGetValue(int window, int slider) // also ScrollBarGetValue
{
#ifdef MATRACEGUIGTK
	maTrace("SliderGetValue");
#endif
	return 0;
}
*/


void HSliderSetValue(int window, int slider, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("HSliderSetValue");
#endif
	if(l_hslider.adj)
	{
		l_hslider.skip = 1;
		gtk_adjustment_set_value(GTK_ADJUSTMENT(l_hslider.adj), value);
	}
}


int CheckboxIndexFromId(int id)
{
	if(id >= ID_CHECKBOX_FIRST && id <= ID_CHECKBOX_LAST)
		return id - ID_CHECKBOX_FIRST;
	return -1;
}


int TextIndexFromId(int id)
{
	int i;
	for(i = 0; i < NUMTEXTS; i++)
		if(l_text[i].id == id)
			return i;
	return -1;
}


int ButtonIndexFromId(int id)
{
	if(id >= ID_BUTTON_FIRST && id <= ID_BUTTON_LAST)
		return id - ID_BUTTON_FIRST;
	return -1;
}


int PopupButtonIndexFromId(int id)
{
	if(id >= ID_POPUP_FIRST && id <= ID_POPUP_LAST)
		return id - ID_POPUP_FIRST;
	return -1;
}


int SpinButtonIndexFromId(int id)
{
	if(id >= ID_SPIN_FIRST && id <= ID_SPIN_LAST)
		return id - ID_SPIN_FIRST;
	return -1;
}


int SliderIndexFromId(int id)
{
	if(id >= ID_SLIDER_FIRST && id <= ID_SLIDER_LAST)
		return id - ID_SLIDER_FIRST;
	return -1;
}


void SliderSetValue(int window, int slider, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("SliderSetValue");
#endif
	int idx = SliderIndexFromId(slider);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "SliderSetValue SliderIndexFromId %d failed", slider);
		maLog(cstr);
		return; 
	}
	
	if(!l_slider[idx].adj)
	{
		char cstr[256];
		sprintf(cstr, "SliderSetValue no slider at index %d (id=%d)", idx, slider);
		maLog(cstr);
		return;
	}

	l_slider[idx].skip = 1;
	gtk_adjustment_set_value(GTK_ADJUSTMENT(l_slider[idx].adj), 
			GTK_ADJUSTMENT(l_slider[idx].adj)->upper - 1.0 - value); // lower is always 0

} // SliderSetValue


void SliderEnable(int window, int slider)
{
#ifdef MATRACEGUIGTK
	maTrace("SliderEnable");
#endif
	int idx = SliderIndexFromId(slider);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "SliderEnable SliderIndexFromId %d failed", slider);
		maLog(cstr);
		return; 
	}
	
	if(!l_slider[idx].adj)
	{
		char cstr[256];
		sprintf(cstr, "SliderEnable no slider at index %d (id=%d)", idx, slider);
		maLog(cstr);
		return;
	}
	
	//gtk_widget_show(GTK_WIDGET(l_slider[idx].slider));
	gtk_widget_set_sensitive(GTK_WIDGET(l_slider[idx].slider), TRUE);
	
} // SliderEnable


void SliderDisable(int window, int slider)
{
#ifdef MATRACEGUIGTK
	maTrace("SliderDisable");
#endif
	int idx = SliderIndexFromId(slider);
	if(idx < 0)
	{
		char cstr[256];
		sprintf(cstr, "SliderDisable SliderIndexFromId %d failed", slider);
		maLog(cstr);
		return; 
	}
	
	if(!l_slider[idx].slider)
	{
		char cstr[256];
		sprintf(cstr, "SliderDisable no slider at index %d (id=%d)", idx, slider);
		maLog(cstr);
		return;
	}
	
	gtk_widget_set_sensitive(GTK_WIDGET(l_slider[idx].slider), FALSE);
	//gtk_widget_hide(GTK_WIDGET(l_slider[idx].slider));
	
} // SliderDisable


void StaticTextSetValue(int window, int statictext, int value)
{
#ifdef MATRACEGUIGTK
	maTrace("StaticTextSetValue");
#endif
	int idx;
	char text[64];

	if(!g_w[window])
		return;

	if((idx = TextIndexFromId(statictext)) < 0)
	{
		char cstr[256];
		sprintf(cstr, "StaticTextSetValue TextIndexFromId %d failed", statictext);
		maLog(cstr);
		return; 
	}
	
	sprintf(text, "%d", value);
	gtk_label_set_text(GTK_LABEL(l_text[idx].text), text);
	
} // StaticTextSetValue


void WindowDoClose(int window)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowDoClose");
#endif
	GtkWidget *w;
	
	if(!(w = g_w[window]))
	{
		maLog("WindowDoClose no window");
		return;
	}

	switch(window)
	{
		case WINDOWLIST:
			OnWindowClosedList();
		break;
		case WINDOWEQ:
			OnWindowClosedEq();
		break;
		case WINDOWEQ2:
			OnWindowClosedEq2();
		break;
		case WINDOWEFFECTS:
			OnWindowClosedEffects();
		break;
#if !defined(MANOCDA) && defined(__MAUNIX__)
		case WINDOWAUDIOCD:
			OnWindowClosedAudioCD();
		break;
#endif
		case WINDOWABOUT:
		case WINDOWREADME:		
		case WINDOWCATALOG:
		case WINDOWLOG:
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
#endif
			g_w[window] = NULL;
		break;
		case WINDOWPROMPTNUM:
			OnWindowClosedPromptNum();
		break;
		case WINDOWADVANCED:
			OnWindowClosedAdvanced();
		break;
		default:
			if(window >= WINDOWOUTFIRST && window <= WINDOWOUTLAST)
			{
				OnWindowClosedFileOut();
				break;
			}
		return;
	}
	
	gtk_widget_destroy(w);

} // WindowDoClose


void WindowDoDestroy(int window)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowDoDestroy");
#endif
	if(!g_w[window])
	{
		maLog("WindowDoDestroy no window");
		return;
	}
	if(window != WINDOWAPP)
		g_w[window] = NULL;
}


/* not used	void WindowGetOrigin(int window, int *xpos, int *ypos)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowGetOrigin");
#endif
	Rect r;
	if(!g_w[window])
	{
		maLog("WindowGetOrigin no window");
		return;
	}
	if(!xpos || !ypos)
	{
		maLog("WindowGetOrigin bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[window], kWindowGlobalPortRgn, &r))
	{
		maLog("WindowGetOrigin GetWindowBounds failed");
		return;
	}
	*xpos = r.left;
	*ypos = r.top;
	
} // WindowGetOrigin


void WindowGetSize(int window, int *xsize, int *ysize)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowGetSize");
#endif
	Rect r;
	if(!g_w[window])
	{
		maLog("WindowGetSize no window");
		return;
	}
	if(!xsize || !ysize)
	{
		maLog("WindowGetSize bad pos or size parameter");
		return;
	}
	if(GetWindowBounds((WindowRef)g_w[window], kWindowGlobalPortRgn, &r))
	{
		maLog("WindowGetSize GetWindowBounds failed");
		return;
	}
	*xsize = r.right - r.left;
	*ysize = r.bottom - r.top;
	
} // WindowGetSize
*/


void WindowGetCoordinates(int window, int *xpos, int *ypos, int *xsize, int *ysize)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowGetCoordinates");
#endif
 	if(!g_w[window])
	{
		// maLog("WindowGetCoordinates no window");
		return;
	}
	
	// g_sets xpos and ypos are updated when the user moves a window (in the configure callback)
	// so they are normally always up to date and we can safely skip this:
	//gdk_window_get_position((GTK_WIDGET(g_w[window]))->window, xpos, ypos);
	//gdk_window_get_origin((GTK_WIDGET(g_w[window]))->window, xpos, ypos);
	//gdk_window_get_root_origin((GTK_WIDGET(g_w[window]))->window, xpos, ypos); // this is the one
	
	gdk_window_get_size((GTK_WIDGET(g_w[window]))->window, xsize, ysize);

} // WindowGetCoordinates


/*
void WindowItemHide(int window, int item)
{
 #ifdef MATRACEGUIGTK
	maTrace("WindowItemHide");
 #endif
	if(item == ID_EDITTEXT_KB_MAIN && l_entry)
	{
		gtk_widget_set_sensitive(l_entry, FALSE);
		gtk_widget_hide(l_entry);
	}
	else
		maLogAPI("WindowItemHide nocb", window, item);
		
} // WindowItemHide


void WindowItemShow(int window, int item)
{
 #ifdef MATRACEGUIGTK
	maTrace("WindowItemShow");
 #endif
	if(item == ID_EDITTEXT_KB_MAIN && l_entry)
	{
		gtk_widget_set_sensitive(l_entry, TRUE);
		gtk_widget_show(l_entry);
	}
	else
		maLogAPI("WindowItemShow nocb", window, item);

} // WindowItemShow
*/


int WindowIsShown(int window)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowIsShown");
#endif
	if(!g_w[window])
	{
		maLog("WindowIsShown no window");
		return 0;
	}
	return gdk_window_is_visible((GTK_WIDGET(g_w[window]))->window) ? 1 : 0;

} // WindowIsShown


void WindowMove(int window, int xpos, int ypos)
{
#ifdef MATRACEGUIGTK
//	maTrace("WindowMove");
{
char cstr[256];
sprintf(cstr, "WindowMove window=%d x=%d y=%d ", window, xpos, ypos); 
maTrace(cstr);
}
#endif

	if(!g_w[window])
		return;

	gdk_window_move((GTK_WIDGET(g_w[window]))->window, xpos, ypos);

} // WindowMove


void WindowSetSize(int window, int xsize, int ysize)
{
#ifdef MATRACEGUIGTK
//	maTrace("WindowSetSize");
{
char cstr[256];
sprintf(cstr, "WindowSetSize window=%d w=%d h=%d", window, xsize, ysize); 
maTrace(cstr);
}
#endif

	if(!g_w[window])
		return;

	gdk_window_resize((GTK_WIDGET(g_w[window]))->window, xsize, ysize);

} // WindowSetSize


/* not used
void WindowMoveAndSetSize(int window, int xpos, int ypos, int xsize, int ysize)
{
#ifdef MATRACEGUIGTK
//	maTrace("WindowMoveAndSetSize");
{
char cstr[256];
sprintf(cstr, "WindowMoveAndSetSize window=%d x=%d y=%d w=%d h=%d", window, xpos, ypos, xsize, ysize); 
maTrace(cstr);
}
#endif

	if(!g_w[window])
		return;

	// gdk_window_move_resize((GTK_WIDGET(g_w[window]))->window, xpos, ypos, xsize, ysize);
	gdk_window_move((GTK_WIDGET(g_w[window]))->window, xpos, ypos);
	gdk_window_resize((GTK_WIDGET(g_w[window]))->window, xsize, ysize);

} // WindowMoveAndSetSize


void WindowSetSize(int window, int xsize, int ysize)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowSetSize");
#endif
	gint xpos;
	gint ypos;
 	if(!g_w[window])
	{
		maLog("WindowSetSize no window");
		return;
	}
	gdk_window_get_position((GTK_WIDGET(g_w[window]))->window, &xpos, &ypos);
	WindowMoveAndSetSize(window, xpos, ypos, xsize, ysize);

} // WindowSetSize


void WindowMove(int window, int xpos, int ypos)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowMove");
#endif
	gint xsize;
	gint ysize;
	if(!g_w[window])
	{
		maLog("WindowMove no window");
		return;
	}
	//gtk_widget_set_uposition(GTK_WIDGET(g_w[window]), (gint)xpos, (gint)ypos);
	//gdk_window_move((GTK_WIDGET(g_w[window]))->window, xpos, ypos);

	gdk_window_get_size((GTK_WIDGET(g_w[window]))->window, &xsize, &ysize);
	WindowMoveAndSetSize(window, xpos, ypos, xsize, ysize);
}


void WindowsMoveAndSetSize() // in maPlayer.c
{
#ifdef MATRACEGUIGTK
	maTrace("WindowsMoveAndSetSize");
#endif

	if(g_w[WINDOWAPP])
	{
		WindowMoveAndSetSize(WINDOWAPP,
			g_sets.xpos[g_sets.winconf], g_sets.ypos[g_sets.winconf],
			g_sets.xsize[g_sets.winconf], g_sets.ysize[g_sets.winconf]);
	}
	
	if(g_w[WINDOWLIST])
	{
		WindowMoveAndSetSize(WINDOWLIST,
			g_sets.listxpos[g_sets.winconf], g_sets.listypos[g_sets.winconf],
			g_sets.listxsize[g_sets.winconf], g_sets.listysize[g_sets.winconf]);
	}
		
	if(g_w[WINDOWEQ])
	{
		WindowMoveAndSetSize(WINDOWEQ,
			g_sets.eqxpos[g_sets.winconf], g_sets.eqypos[g_sets.winconf],
			g_sets.eqxsize[g_sets.winconf], g_sets.eqysize[g_sets.winconf]);
	}
	
	if(g_w[WINDOWEQ2])
	{
		WindowMoveAndSetSize(WINDOWEQ2,
			g_sets.eq2xpos[g_sets.winconf], g_sets.eq2ypos[g_sets.winconf],
			g_sets.eq2xsize[g_sets.winconf], g_sets.eq2ysize[g_sets.winconf]);
	}
	
#if !defined(MANOCDA) && defined(__MAUNIX__)
	if(g_w[WINDOWAUDIOCD])
	{
		WindowMoveAndSetSize(WINDOWAUDIOCD,
			g_setscdrom.winx[g_sets.winconf], g_setscdrom.winy[g_sets.winconf],
			g_setscdrom.winw[g_sets.winconf], g_setscdrom.winh[g_sets.winconf]);
	}
#endif
	
	if(g_w[WINDOWEFFECTS])
	{
		WindowMoveAndSetSize(WINDOWEFFECTS,
			g_sets.effectsxpos[g_sets.winconf], g_sets.effectsypos[g_sets.winconf],
			g_sets.effectsxsize[g_sets.winconf], g_sets.effectsysize[g_sets.winconf]);
	}

	if(WINDOWOUTCUR >= WINDOWOUTFIRST && WINDOWOUTCUR <= WINDOWOUTLAST && g_w[WINDOWOUTCUR])
	{
		WindowMoveAndSetSize(WINDOWOUTCUR,
		g_sets.fileoutxpos[g_sets.winconf], g_sets.fileoutypos[g_sets.winconf],
		g_sets.fileoutxsize[g_sets.winconf], g_sets.fileoutysize[g_sets.winconf]);
	}
	
	if(g_w[WINDOWREADME])
	{
		WindowMoveAndSetSize(WINDOWREADME,
			g_sets.viewerxpos, g_sets.viewerypos, g_sets.viewerxsize, g_sets.viewerysize);
	}

	if(g_w[WINDOWCATALOG])
	{
		WindowMoveAndSetSize(WINDOWCATALOG,
			g_sets.viewerxpos, g_sets.viewerypos, g_sets.viewerxsize, g_sets.viewerysize);
	}

	if(g_w[WINDOWLOG])
	{
		WindowMoveAndSetSize(WINDOWLOG,
			g_sets.viewerxpos, g_sets.viewerypos, g_sets.viewerxsize, g_sets.viewerysize);
	}

#if defined(MAKEYBOARD)
	if(g_w[WINDOWKEYBINDINGS])
	{
		WindowMoveAndSetSize(WINDOWKEYBINDINGS,
		g_sets.keybindingsxpos, g_sets.keybindingsypos, g_sets.keybindingsxsize, g_sets.keybindingsysize);
	}
#endif

	if(g_w[WINDOWABOUT])
	{
		WindowMoveAndSetSize(WINDOWABOUT,
			g_sets.aboutxpos, g_sets.aboutypos, g_sets.aboutxsize, g_sets.aboutysize);
	}

} // WindowsMoveAndSetSize
*/


void WindowShow(int window)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowShow");
#endif
	if(!g_w[window])
	{
		maLog("WindowShow no window");
		return;
	}
	gtk_widget_show(g_w[window]);
}


void WindowSetTitle(int window, char *title)
{
#ifdef MATRACEGUIGTK
	maTrace("WindowSetTitle");
#endif
	if(!g_w[window])
	{
		char cstr[256];
		sprintf((char *)cstr, "WindowSetTitle null window %d", window);
		maLog(cstr);
		return;
	}

	gtk_window_set_title(GTK_WINDOW(g_w[window]), title);

} // WindowSetTitle


int maDirSelector(char *selectedpath, char *prompt)
{
#ifdef MATRACEGUIGTK
	maTrace("maDirSelector");
#endif

	int l;
	char *p;
	char fpath[MAX_PATH];
	
	if(selectedpath && selectedpath[0]) // default dir
		p = selectedpath;
	else
		p = NULL;

	while(1)
	{
		if(maFileDialog(fpath, WINDOWAPP, prompt, p, NULL, NULL, 0))
			return 1;
		
		if((p = strstr(fpath, "(null)")))
			*p = 0; // user accepted empty default
		
		if(maDirExists(fpath))
			break;
	}
	
	if((p = strstr(fpath, "../")))
		*p = 0; // remove trailing "../"
		
	if((p = strstr(fpath, "./")))
		*p = 0; // remove trailing "./"
	
	if((l = strlen(fpath) - 1) < 0)
		return 1;

	if(fpath[l] == FILESEP)
		fpath[l] = 0; // remove trailing '/'
		
	strcpy(selectedpath, fpath);
	
	return 0;
	
} // maDirSelector


void filesel_ok_callback(GtkWidget *w, int *selected)
{
#ifdef MATRACEGUIGTK
	maTrace("filesel_ok_callback");
#endif
  *selected = 1;
}


void filesel_cancel_callback(GtkWidget *w, int *selected)
{
#ifdef MATRACEGUIGTK
	maTrace("filesel_cancel_callback");
#endif
  *selected = 0;
}


GtkWidget *l_filesel = NULL;
int maFileDialog(char *selectedpath, int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags)
{
#ifdef MATRACEGUIGTK
	maTrace("maFileDialog");
#endif
	int selected = 0;
	char deffilepath[MAX_PATH];
	char cstr[MAX_PATH + MAX_PATH];

	if(!selectedpath)
	{
		maLog("maFileDialog null selectedpath parameter");
		return 1;
	}

	if(!l_filesel)
	{
		selected = -1;
		l_filesel = gtk_file_selection_new(prompt);
		gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(l_filesel));
		gtk_window_set_position(GTK_WINDOW(l_filesel), GTK_WIN_POS_NONE); // GTK_WIN_POS_MOUSE);
		if(defdir != NULL)
		{
			sprintf(deffilepath, "%s%c", defdir, FILESEP);
			if(deffile != NULL)
				strcat(deffilepath, deffile);
			gtk_file_selection_set_filename((GtkFileSelection *)l_filesel, deffilepath);
		}
		gtk_signal_connect(GTK_OBJECT(l_filesel), "destroy",
			GTK_SIGNAL_FUNC(gtk_widget_destroyed), &l_filesel);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(l_filesel)->ok_button), "clicked",
			GTK_SIGNAL_FUNC(filesel_ok_callback), (gpointer)&selected);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(l_filesel)->cancel_button), "clicked",
			GTK_SIGNAL_FUNC(filesel_cancel_callback), (gpointer)&selected);
	}
	
	while(1)
	{
		if(!GTK_WIDGET_VISIBLE(l_filesel))
		{
			gtk_widget_show(l_filesel);
			while(selected == -1)
				gtk_main_iteration();
		}
		else
		{
			if(l_filesel)
			{
				gtk_widget_destroy(l_filesel);
				l_filesel = NULL;
			}
			return 1;
		}
	
		if(selected == 1)
		{
			strcpy(selectedpath, gtk_file_selection_get_filename((GtkFileSelection *)l_filesel));
			if(flags & maOVERWRITE_PROMPT)
			{
				if(maFileExists(selectedpath))
				{
					sprintf(cstr, "This file already exists and will be overwritten\n\n'%s'", selectedpath);
					if(maMessageBox(cstr, (char *)"CONTINUE ?", maYES_NO | maICON_QUESTION) != maYES)
						continue;
				}
			}
	
			if(l_filesel)
			{
				gtk_widget_destroy(l_filesel);
				l_filesel = NULL;
			}

			return 0;
		}
		
		if(l_filesel)
		{
			gtk_widget_destroy(l_filesel);
			l_filesel = NULL;
		}
		
		return 1; // cancelled
		
	} // while 1
	
} // maFileDialog


void maFileDialogMFree(maArray *parray)
{
#ifdef MATRACEGUIGTK
	maTrace("maFileDialogMFree");
#endif

	int i;
	
	if(!parray)
		return;
	if(parray->pitems)
	{
		for(i = 0; i < parray->nitems; i++)
			if(parray->pitems[i])
				MAFREE(parray->pitems[i]);
		MAFREE(parray->pitems);
	}
	parray->pitems = NULL;
	parray->nitems = 0;
}


// for multiple selections (from 'Play Song Files')
// but here we only select one file or one dir ...
char l_defaultLocation[MAX_PATH] = "";
int maFileDialogM(maArray *parray, int window, char *prompt, char *defdir, char *deffile, char *wildcard, int flags)
{
#ifdef MATRACEGUIGTK
	maTrace("maFileDialogM");
#endif

	long i;
	long theCount = 0;
	int ret = 0;
	char fpath[MAX_PATH];
	
	if(!parray)
	{
		maLog("maFileDialogM null parray parameter");
		return 1;
	}
	parray->nitems = 0;
	parray->pitems = NULL;
	parray->items = NULL; // not used in guiosx

	if(defdir && defdir[0])
		strcpy(l_defaultLocation, defdir);
	else
		l_defaultLocation[0] = 0;

	if(maFileDialog(fpath, WINDOWAPP, prompt, defdir, deffile, wildcard, flags))
		goto maFileDialogMErr; // cancelled
	
	theCount = 1;
		
	parray->nitems = theCount;
	if((parray->pitems = (char **)MAMALLOC(theCount * sizeof(char *))) == NULL)
	{
		maFileDialogMFree(parray);
		maLog("maFileDialogM MAMALLOC failed");
		goto maFileDialogMErr;
	}

	for(i = 1; i <= theCount; i++)
	{
		// ... strcpy(fpath, 1-based ith item selected)
		if((parray->pitems[i - 1] = (char *)MAMALLOC(strlen(fpath) + 1)) == NULL)
		{
			maFileDialogMFree(parray);
			maLog("maFileDialogM MAMALLOC failed");
			goto maFileDialogMErr;
		}
		strcpy(parray->pitems[i - 1], fpath);
	}

	goto maFileDialogMNoErr;
		
maFileDialogMErr:
	ret = 1;
	
maFileDialogMNoErr:

	return ret;

} //maFileDialogM


GtkWidget *l_msgbox = NULL;
void msgbox_no_callback(GtkWidget *widget, int *ok)
{
	*ok = 0;
}


void msgbox_yes_callback(GtkWidget *widget, int *ok)
{
	*ok = 1;
}


int maMessageBox(char *s1, char *s2, int flags)
{
#ifdef MATRACEGUIGTK
	maTrace("maMessageBox");
#endif
	int ok = -1;
	GtkWidget *label;
	GtkWidget *button;
	char *labelyes = "Yes";
	char *labelno = "No";
	char cstr[512];
	
	sprintf(cstr, "%s\n\n%s", s2, s1);

	if(!l_gtkinited)
		magtkinit();
	
	if((flags & maOK) == maOK)
		labelyes = "Ok";

	if (!l_msgbox)
	{
		l_msgbox = gtk_dialog_new();
		gtk_signal_connect(GTK_OBJECT(l_msgbox), "destroy",
			GTK_SIGNAL_FUNC(gtk_widget_destroyed), &l_msgbox);
		gtk_window_set_title(GTK_WINDOW(l_msgbox), g_prognametitle);
		gtk_container_set_border_width(GTK_CONTAINER(l_msgbox), 0);
		gtk_widget_set_usize(l_msgbox, 400, 200);

		label = gtk_label_new(cstr);
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(l_msgbox)->vbox), label, TRUE, TRUE, 0);
		gtk_widget_show(label);

		button = gtk_button_new_with_label(labelyes);
		char name[64];
		sprintf(name, "mabutton%s", labelyes);
		gtk_widget_set_name(button, name);
		gtk_signal_connect(GTK_OBJECT(button), "clicked",
			GTK_SIGNAL_FUNC(msgbox_yes_callback), (gpointer)&ok);
		GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(l_msgbox)->action_area), button, TRUE, TRUE, 0);
		gtk_widget_show(button);

		if((flags & maYES_NO) == maYES_NO)
		{
			button = gtk_button_new_with_label(labelno);
			char name[64];
			sprintf(name, "mabutton%s", labelno);
			gtk_widget_set_name(button, name);
			gtk_signal_connect(GTK_OBJECT(button), "clicked",
				GTK_SIGNAL_FUNC(msgbox_no_callback), (gpointer)&ok);
			GTK_WIDGET_SET_FLAGS(button,GTK_CAN_DEFAULT);
			gtk_box_pack_start(GTK_BOX(GTK_DIALOG(l_msgbox)->action_area), button, TRUE, TRUE, 0);
			gtk_widget_show(button);
		}
		
		gtk_widget_grab_default(button);
	}

	if(!GTK_WIDGET_VISIBLE(l_msgbox))
	{
		gtk_widget_show(l_msgbox);
		while(ok == -1)
			gtk_main_iteration();
	}
	else
	{
		if(l_msgbox)
		{
			gtk_widget_destroy(l_msgbox);
			l_msgbox = NULL;
		}
		return 0;
	}

	if(l_msgbox)
	{
		gtk_widget_destroy(l_msgbox);
		l_msgbox = NULL;
	}
	
	return (ok == 1) ? maYES : maNO;
	
} // maMessageBox


void maViewReadme()
{
#ifdef MATRACEGUIGTK
	maTrace("maViewReadme");
#endif
	ViewerWindowMake(WINDOWREADME, "MoreAmp README");

} // maViewReadme


void maViewCatalog()
{
#ifdef MATRACEGUIGTK
	maTrace("maViewCatalog");
#endif
	ViewerWindowMake(WINDOWCATALOG, "MoreAmp CATALOG");

} // maViewCatalog


void maViewLog()
{
#ifdef MATRACEGUIGTK
	maTrace("maViewLog");
#endif
	ViewerWindowMake(WINDOWLOG, "MoreAmp LOG");

} // maViewLog


#if defined(MAKEYBOARD)
void maEditKeyBindings()
{
 #ifdef MATRACEGUIGTK
	maTrace("maEditKeyBindings");
 #endif
	ViewerWindowMake(WINDOWKEYBINDINGS, "MoreAmp Key Bindings");

} // maEditKeyBindings
#endif


#define MAFINDSTRMAX 64 // arbitrary
#define MASTRSAVE "Save"
#define MASTREDIT "Edit"
void TextShowPosition(void *text, long pos) // EnsureVisible
{
	int len;
	int lines;
	int line;
	char *p;
	char *p0;
	char *p1;
	float value;
	GtkAdjustment *adj;

	if ((len = gtk_text_get_length(GTK_TEXT(text))) <= 0)
		return;

	if(!(p0 = gtk_editable_get_chars(GTK_EDITABLE(text), 0, len)))
		return;

	line = 0;
	lines = 1;

	if((p1 = p0 + pos) > (p0 + len))
		p1 = p0 + len;
	for(p = p0; p < p0 + len; p++)
		if(*p == '\n')
		{
			lines++;
			if(p < p1)
				line++;
		}
	g_free(p0);
	
	adj = GTK_TEXT(text)->vadj;
	value = floorf(((((float)line / lines) * (adj->upper - adj->lower)) + adj->lower) /
										adj->page_increment) * adj->page_increment;
	if(value < adj->value)
		gtk_adjustment_set_value(GTK_TEXT(text)->vadj, 0);
	else if(value > adj->value)
		gtk_adjustment_set_value(GTK_TEXT(text)->vadj, value);

} // TextShowPosition


gint ViewerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("ViewerWindowEventHandler");
#endif

	int evtype = (int)data & 0xff;
	int windowid = (int)data >> 8;

	switch(evtype)
	{
		case maBUTTONFIND:
			OnButtonFind(windowid);
		break;
		
		case maBUTTONEDIT:
			OnButtonEditSave(widget, windowid);
		break;
		
		case maBUTTONCLOSE:
			WindowDoClose(windowid);
		break;
		
		case maENTRYKEYPRESS:
			if(event->type == GDK_KEY_PRESS)
				OnViewerKeyPressed(windowid, widget, ((GdkEventKey *)event)->keyval);
		break;

		case maMOUSEBUTTON:
			if(event->type == GDK_BUTTON_RELEASE)
			{
				if(((GdkEventButton *)event)->button < 4) // 4 and 5 are mouse wheel
				{
					if(((GdkEventButton *)event)->button == 1)
						OnViewerLeftClick(windowid);
					else
						OnViewerRightClick(windowid);
				}
			}
		break;

		case maGDK_DELETE:
		case maGDK_CONFIGURE: // resize, move, etc
		switch(event->type)
		{
			case GDK_DELETE:
				if(evtype != maGDK_DELETE) // spurious event ?
					return TRUE;
				g_w[windowid] = NULL;
			break;

			case GDK_CONFIGURE: // resize, move, etc
				if(evtype == maGDK_CONFIGURE)
				{
					if(event->configure.send_event) // true when moved
					{
#ifdef MATRACEGUIGTK
maTrace("ViewerWindowEventHandler window moved");
#endif
						switch(windowid)
						{
							case WINDOWREADME:
							case WINDOWCATALOG:
							case WINDOWLOG:
								g_sets.viewerxpos = event->configure.x - l_wmdiffx;
								g_sets.viewerypos = event->configure.y - l_wmdiffy;
								g_sets.viewerxsize = event->configure.width;
								g_sets.viewerysize = event->configure.height;
							break;
		
#if defined(MAKEYBOARD)
							case WINDOWKEYBINDINGS:
								g_sets.keybindingsxpos = event->configure.x - l_wmdiffx;
								g_sets.keybindingsypos = event->configure.y - l_wmdiffy;
								g_sets.keybindingsxsize = event->configure.width;
								g_sets.keybindingsysize = event->configure.height;
							break;
#endif
							default:
								maLog("ViewerWindowEventHandler bad window id");
							break;
						}
					}
					else // must be resize
					{
#ifdef MATRACEGUIGTK
maTrace("ViewerWindowEventHandler window resized");
#endif
						switch(windowid)
						{
							case WINDOWREADME:
							case WINDOWCATALOG:
							case WINDOWLOG:
								g_sets.viewerxsize = event->configure.width;
								g_sets.viewerysize = event->configure.height;
							break;
		
#if defined(MAKEYBOARD)
							case WINDOWKEYBINDINGS:
								g_sets.keybindingsxsize = event->configure.width;
								g_sets.keybindingsysize = event->configure.height;
							break;
#endif
							default:
								maLog("ViewerWindowEventHandler bad window id");
							break;
						}
					}
				}
			break;

			default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "ViewerWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
			break;
		}
		break;
	
		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "ViewerWindowEventHandler DEFAULT windowid=%d maevent=%d", windowid, evtype);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled
	
} // ViewerWindowEventHandler


typedef struct
{
	void *text;				// text widget with text to view
	void *entry;			// entry widget for text to find	
	void *found;			// static text widget for 'found' message
	long ip;				// current insertion point
	char *find;				// text to find
	int n;					// number of hits
	int busy;				// flag to ignore reentries
	char fpath[MAX_PATH];   // file to view
} maviewer;


maviewer l_viewerReadme;
maviewer l_viewerCatalog;
maviewer l_viewerLog;
#if defined(MAKEYBOARD)
 maviewer l_viewerKeyBindings;
#endif


void OnViewerKeyPressed(int windowid, void *widget, int keyval)
{
	maviewer *viewer;

	switch(windowid)
	{
		case WINDOWREADME:
			viewer = &l_viewerReadme;
		break;
		
		case WINDOWCATALOG:
			viewer = &l_viewerCatalog;
		break;
		
		case WINDOWLOG:
			viewer = &l_viewerLog;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			viewer = &l_viewerKeyBindings;
		break;
#endif

		default:
		return;
	}
	
#if GTK_MAJOR_VERSION == 1
	if(widget == viewer->text && GTK_EDITABLE(viewer->text)->editable)
		return;
#endif

	if(keyval == GDK_Return) // 0xFF0D)
		OnButtonFind(windowid);
		
} // OnViewerKeyPressed


void OnViewerLeftClick(int windowid)
{
	maviewer *viewer;

	switch(windowid)
	{
		case WINDOWREADME:
			viewer = &l_viewerReadme;
		break;
		
		case WINDOWCATALOG:
			viewer = &l_viewerCatalog;
		break;
		
		case WINDOWLOG:
			viewer = &l_viewerLog;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			viewer = &l_viewerKeyBindings;
		break;
#endif

		default:
		return;
	}

	if(viewer->busy)
		return;

#if GTK_MAJOR_VERSION == 1
	char *p0 = NULL;
	char findstr[256];
	long len;
	long from;
	long to;
	viewer->busy = 1;
	
	// left-clicking in the view text copies a selection to the find text
	if(!(GTK_EDITABLE(viewer->text))->has_selection)
	{
		viewer->busy = 0;
		return;
	}
		
	from = (GTK_EDITABLE(viewer->text))->selection_start_pos;
	to = (GTK_EDITABLE(viewer->text))->selection_end_pos;

	if(!(p0 = gtk_editable_get_chars(GTK_EDITABLE(viewer->text), from, to)))
	{
		viewer->busy = 0;
		return;
	}
	
	if((len = to - from) > 0)
	{
		if(len > MAFINDSTRMAX)
			len = MAFINDSTRMAX;
		memcpy(findstr, p0, len);
		findstr[len] = 0;
		gtk_entry_set_text(GTK_ENTRY(viewer->entry), findstr);
		gtk_label_set_text(GTK_LABEL(viewer->found), (char *)"");
	}

	g_free(p0);

	viewer->ip = to;

	viewer->busy = 0;
#endif // GTK_MAJOR_VERSION == 1
	
} // OnViewerLeftClick


void OnViewerRightClick(int windowid)
{
	maviewer *viewer;

	switch(windowid)
	{
		case WINDOWREADME:
			viewer = &l_viewerReadme;
		break;
		
		case WINDOWCATALOG:
			viewer = &l_viewerCatalog;
		break;
		
		case WINDOWLOG:
			viewer = &l_viewerLog;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			viewer = &l_viewerKeyBindings;
		break;
#endif

		default:
		return;
	}

	if(viewer->busy)
		return;
	viewer->busy = 1;
	
	// right-clicking in the viewer text starts (continues) a search.
	OnButtonFind(windowid);

	viewer->busy = 0;
	
} // OnViewerRightClick


void viewerbuttoncallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("viewerbuttoncallback");
#endif
	ViewerWindowEventHandler(widget, NULL, callback_data);
}


int maGetFileSize(FILE *file, int what, int nomem); // in maMemFile.h
int ViewerWindowMake(int windowid, char *wintitle)
{
	size_t fsize;
	FILE *fp = NULL;
	int islog = 0;
	char *p, *q;
	char *pmem = NULL;
	char *pcstr = NULL;
	char cstr[MAX_PATH + 256];
	maviewer *viewer;
	
	switch(windowid)
	{
		case WINDOWREADME:
			strcpy(l_viewerReadme.fpath, g_readmepath);
			l_viewerReadme.find = g_readmefind;
			viewer = &l_viewerReadme;
		break;
		
		case WINDOWCATALOG:
			if(FilenameFromPathname(g_songlist, cstr))
			{
				sprintf(cstr, "ViewerWindowMake FilenameFromPathname failed on '%s'", g_songlist);
				maLog(cstr);
				return 1;
			}
			if((p = strstr(cstr, g_extstr[kMAMAF])))
				*p = 0;
			sprintf(l_viewerCatalog.fpath, "%s%c%s.txt", g_madir, FILESEP, cstr);
			l_viewerCatalog.find = g_catalogfind;
			viewer = &l_viewerCatalog;
		break;
		
		case WINDOWLOG:
			islog = 1;
			strcpy(l_viewerLog.fpath, g_logpath);
			l_viewerLog.find = g_logfind;
			viewer = &l_viewerLog;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			strcpy(l_viewerKeyBindings.fpath, g_keybindingspath);
			l_viewerKeyBindings.find = g_keybindingsfind;
			viewer = &l_viewerKeyBindings;
		break;
#endif

		default:
		return 1;
	}
	
	viewer->busy = 0;
	
	if(!maFileExists(viewer->fpath))
	{
		if(islog)
			sprintf(cstr, "NO ERRORS = no log file '%s'", viewer->fpath);
		else
			sprintf(cstr, "File '%s' not found", viewer->fpath);
		pcstr = cstr;
	}
	else
	{
		if((fp = mafopen(viewer->fpath, "rb")) == NULL)
		{
			sprintf(cstr, "ViewerWindowMake mafopen failed on '%s'", viewer->fpath);
			maLog(cstr);
			pcstr = cstr;
		}
		else
		{
			fsize = maGetFileSize(fp, 0, 1);

			if((pmem = (char *)MAMALLOC(fsize + 2)) == NULL)
			{
				sprintf(cstr, "ViewerWindowMake MAMALLOC failed fsize=%d", (int)fsize);
				maLog(cstr);
				pcstr = cstr;
			}
			else
			{
				if(fread(pmem, 1, fsize, fp) != fsize)
				{
					fclose(fp);
					fp = NULL;
					MAFREE(pmem);
					pmem = NULL;
					sprintf(cstr, "ViewerWindowMake fread failed '%s'", viewer->fpath);
					maLog(cstr);
					pcstr = cstr;
				}
				else
				{
					pmem[fsize] = 0;
					p = pmem; // crlf -> spMAEOL
					cstr[0] = 0x0d;
					cstr[1] = 0x0a;
					cstr[2] = 0;
					while((q = strstr(p, cstr)))
					{
						*q++ = ' ';
						*q++ = MAEOL;
						p = q;
					}
					p = pmem; // lfcr -> spMAEOL
					cstr[0] = 0x0a;
					cstr[1] = 0x0d;
					while((q = strstr(p, cstr)))
					{
						*q++ = ' ';
						*q++ = MAEOL;
						p = q;
					}
					p = pmem;
					if(MAEOL != 0x0d)
					{
						while((q = strchr(p, 0x0d))) // cr -> MAEOL
						{
							*q++ = MAEOL;
							p = q;
						}
					}
					else // MAEOL != 0x0a
					{
						while((q = strchr(p, 0x0a))) // lf -> MAEOL
						{
							*q++ = MAEOL;
							p = q;
						}
					}
					pcstr = pmem;
				}
			}		
		}
	}
	
	if(fp)
		fclose(fp);

	viewer->ip = -1;

	static GtkWidget *window = NULL;
	GtkWidget *box1;
	GtkWidget *box2;
	GtkWidget *box3;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *separator;
	GtkWidget *scrolled_window;
	GtkWidget *text;
	GtkWidget *found;
	GtkWidget *fixed;
	GtkWidget *entry;

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(ViewerWindowEventHandler), (gpointer)((windowid << 8) + maGDK_DELETE));
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(ViewerWindowEventHandler), (gpointer)((windowid << 8) + maGDK_CONFIGURE));

	g_w[windowid] = window;

	sprintf(cstr, "%s Viewer", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	gtk_container_set_border_width(GTK_CONTAINER(window), 0);

	box1 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), box1);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 0);

	scrolled_window = gtk_scrolled_window_new(NULL, NULL);
	gtk_box_pack_start(GTK_BOX(box2), scrolled_window, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
		GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	viewer->text = text = gtk_text_new(NULL, NULL);
	gtk_text_set_word_wrap(GTK_TEXT(text), TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_window), text);
	gtk_text_set_editable(GTK_TEXT(text), TRUE);
	gtk_signal_connect(GTK_OBJECT(text), "button_release_event",
						GTK_SIGNAL_FUNC(ViewerWindowEventHandler),
						(gpointer)((windowid << 8) + maMOUSEBUTTON));
	gtk_signal_connect(GTK_OBJECT(text), "key_press_event",
						GTK_SIGNAL_FUNC(ViewerWindowEventHandler),
						(gpointer)((windowid << 8) + maENTRYKEYPRESS));
	gtk_text_set_editable(GTK_TEXT(text), FALSE);
	gtk_text_freeze(GTK_TEXT(text));
	gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, pcstr, -1);
	if(pmem)
		MAFREE(pmem);
	gtk_text_thaw(GTK_TEXT(text));
	
	hbox = gtk_hbutton_box_new();
	gtk_box_pack_start(GTK_BOX(box2), hbox, FALSE, FALSE, 0);

	separator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1), separator, FALSE, TRUE, 0);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, FALSE, TRUE, 0);

	viewer->entry = entry = gtk_entry_new_with_max_length(128);
	gtk_entry_set_text(GTK_ENTRY(entry), viewer->find);
	gtk_container_add(GTK_CONTAINER(box2), entry);
	gtk_signal_connect(GTK_OBJECT(entry), "key_press_event",
		GTK_SIGNAL_FUNC(ViewerWindowEventHandler),
		(gpointer)((windowid << 8) + maENTRYKEYPRESS));
	separator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1), separator, FALSE, TRUE, 0);

	box3 = gtk_hbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box3, FALSE, TRUE, 0);

	fixed = gtk_fixed_new();
	gtk_box_pack_start(GTK_BOX(box3), fixed, TRUE, TRUE, 0);

	button = gtk_button_new_with_label("Find");
	char name[64];
	sprintf(name, "mabutton%s", "Find");
	gtk_widget_set_name(button, name);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(viewerbuttoncallback),
		(gpointer)((windowid << 8) + maBUTTONFIND));
	gtk_fixed_put(GTK_FIXED(fixed), button, XBASE, 0);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);

	l_fixed = fixed;
	viewer->found = found = MakeText(1, ID_TEXT_VIEWERFOUND, "",  MABUTTONWDEF + 6, 5, 0);
	gtk_widget_set_name(text, "matext");
	
	fixed = gtk_fixed_new();
	gtk_box_pack_start(GTK_BOX(box3), fixed, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Edit");
	sprintf(name, "mabutton%s", "Edit");
	gtk_widget_set_name(button, name);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(viewerbuttoncallback),
		(gpointer)((windowid << 8) + maBUTTONEDIT));
	gtk_fixed_put(GTK_FIXED(fixed), button, XBASE, 0);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);

	button = gtk_button_new_with_label("Close");
	sprintf(name, "mabutton%s", "Close");
	gtk_widget_set_name(button, name);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(viewerbuttoncallback),
		(gpointer)((windowid << 8) + maBUTTONCLOSE));
	gtk_fixed_put(GTK_FIXED(fixed), button, MABUTTONWDEF + 10, 0);
	gtk_widget_set_usize(button, MABUTTONWDEF, MABUTTONHDEF);

	gtk_window_set_title(GTK_WINDOW(window), wintitle);

#if defined(MAKEYBOARD)
	if(windowid == WINDOWKEYBINDINGS)
	{
		gtk_widget_set_uposition(window, g_sets.keybindingsxpos, g_sets.keybindingsypos);
		gtk_widget_set_usize(window, g_sets.keybindingsxsize, g_sets.keybindingsysize);
	}
	else
#endif
	{
		gtk_widget_set_uposition(window, g_sets.viewerxpos, g_sets.viewerypos);
		gtk_widget_set_usize(window, g_sets.viewerxsize, g_sets.viewerysize);
	}
	
	gtk_widget_set_name(text, "matextViewer");

	gtk_widget_show_all(window);
	
	return 0;
	
} // ViewerWindowMake


gint AboutViewerWindowEventHandler(GtkWidget *widget, GdkEvent *event, gpointer data)
{
#ifdef MATRACEGUIGTK
maTrace("AboutViewerWindowEventHandler");
#endif
	switch(event->type)
	{
		case GDK_DELETE:
			if(data != (gpointer)maGDK_DELETE) // spurious event ?
				return TRUE;
				
			g_w[WINDOWABOUT] = NULL;
		break;

		case GDK_CONFIGURE: // resize, move, etc
			if(data == (gpointer)maGDK_CONFIGURE)
			{
				if(event->configure.send_event) // true when moved
				{
#ifdef MATRACEGUIGTK
maTrace("AboutViewerWindowEventHandler window moved");
#endif
					g_sets.aboutxpos = event->configure.x - l_wmdiffx;
					g_sets.aboutypos = event->configure.y - l_wmdiffy;
					g_sets.aboutxsize = event->configure.width;
					g_sets.aboutysize = event->configure.height;
				}
				else // must be resize
				{
#ifdef MATRACEGUIGTK
maTrace("AboutViewerWindowEventHandler window resized");
#endif
					g_sets.aboutxsize = event->configure.width;
					g_sets.aboutysize = event->configure.height;
				}
			}
		break;

		default:
#ifdef MATRACEGUIGTK
{
char cstr[256];
sprintf(cstr, "AboutViewerWindowEventHandler DEFAULT type=%d data=%d", event->type, (int)data);
maTrace(cstr);
}
#endif
		break;
	}
	
	return(FALSE); // event not handled
	
} // AboutViewerWindowEventHandler


void aboutviewercallback(GtkWidget *widget, gpointer callback_data)
{
#ifdef MATRACEGUIGTK
	maTrace("aboutviewercallback");
#endif

	 WindowDoClose(WINDOWABOUT);
}


int AboutViewerWindowMake(int windowid, char *wintitle)
{
	static GtkWidget *window = NULL;
	GtkWidget *box1;
	GtkWidget *box2;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *separator;
	GtkWidget *scrolled_window;
	GtkWidget *text;
	GtkWidget *entry;
	char cstr[256];	

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(AboutViewerWindowEventHandler), (gpointer)maGDK_DELETE);
	gtk_signal_connect(GTK_OBJECT(window), "configure_event",
		GTK_SIGNAL_FUNC(AboutViewerWindowEventHandler), (gpointer)maGDK_CONFIGURE);

	g_w[WINDOWABOUT] = window;

	sprintf(cstr, "About %s", g_prognametitle);
	gtk_window_set_title(GTK_WINDOW(window), cstr);

	gtk_container_set_border_width(GTK_CONTAINER(window), 0);

	box1 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), box1);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 0);

	scrolled_window = gtk_scrolled_window_new(NULL, NULL);
	gtk_box_pack_start(GTK_BOX(box2), scrolled_window, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
		GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	text = gtk_text_new(NULL, NULL);
	gtk_text_set_editable(GTK_TEXT(text), FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(text), TRUE);
	gtk_container_add(GTK_CONTAINER(scrolled_window), text);

	gtk_text_freeze(GTK_TEXT(text));
	gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, g_AboutText, -1);
	gtk_text_thaw(GTK_TEXT(text));
	
	hbox = gtk_hbutton_box_new();
	gtk_box_pack_start(GTK_BOX(box2), hbox, FALSE, FALSE, 0);

	separator = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(box1), separator, FALSE, TRUE, 0);

	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(box2), 0);
	gtk_box_pack_start(GTK_BOX(box1), box2, FALSE, TRUE, 0);

	entry = gtk_entry_new_with_max_length(128);
	gtk_entry_set_text(GTK_ENTRY(entry), MOREAMP_HOME_URL);
	gtk_container_add(GTK_CONTAINER(box2), entry);

	button = gtk_button_new_with_label("Close");
	char name[64];
	sprintf(name, "mabutton%s", "Close");
	gtk_widget_set_name(button, name);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(aboutviewercallback), (gpointer)WINDOWABOUT);
	gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 0);
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

	gtk_window_set_title(GTK_WINDOW(window), wintitle);

	gtk_widget_set_uposition(window, g_sets.aboutxpos, g_sets.aboutypos);
	gtk_widget_set_usize(window, g_sets.aboutxsize, g_sets.aboutysize);
	
	gtk_widget_set_name(text, "matextViewer");

	gtk_widget_show_all(window);
	
	return 0;
	
} // AboutViewerWindowMake


void maViewAbout()
{
#ifdef MATRACEGUIGTK
	maTrace("maViewAbout");
#endif

	if(g_w[WINDOWABOUT])
		return;
		
	AboutViewerWindowMake(WINDOWABOUT, "About MoreAmp");

} // maViewAbout


void OnButtonFind(int windowid)
{
	char *p;
	char *p0 = NULL;
	char findstr[256];
	long findlen;
	int line;
	maviewer *viewer;

	switch(windowid)
	{
		case WINDOWREADME:
			viewer = &l_viewerReadme;
		break;
		
		case WINDOWCATALOG:
			viewer = &l_viewerCatalog;
		break;
		
		case WINDOWLOG:
			viewer = &l_viewerLog;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			viewer = &l_viewerKeyBindings;
		break;
#endif

		default:
		return;
	}

	if(!(p0 = gtk_editable_get_chars(GTK_EDITABLE(viewer->text), 0, -1)))
		return;
	
	// the text in the find edit box is the target text
	findstr[0] = 0;
	findlen = strlen(gtk_entry_get_text(GTK_ENTRY(viewer->entry)));
	if(findlen < 1)
	{
		gtk_label_set_text(GTK_LABEL(viewer->found), (char *)"Nothing to find.");
		g_free(p0);
		return;
	}
	if(findlen > MAFINDSTRMAX)
	{
		findlen = MAFINDSTRMAX;
		strncpy(findstr, gtk_entry_get_text(GTK_ENTRY(viewer->entry)), findlen);
		findstr[findlen] = 0;
		gtk_entry_set_text(GTK_ENTRY(viewer->entry), findstr);
	}
	else
	{
		strncpy(findstr, gtk_entry_get_text(GTK_ENTRY(viewer->entry)), findlen);
		findstr[findlen] = 0;
	}

	// if find string has changed, recount targets
	if(viewer->n <= 0 || mastrcasecmp(findstr, viewer->find))
	{
		p = p0;
		viewer->n = 0;
		strcpy(viewer->find, findstr);
		while((p = mastrcasestr(p, viewer->find)))
		{
			viewer->n++;
			p += findlen;
		}
	}

	if(viewer->ip < 0)
		viewer->ip = 0;
	else
	{
#if GTK_MAJOR_VERSION == 1
		long from;
		long to;
		if((GTK_EDITABLE(viewer->text))->has_selection)
		{
			from = (GTK_EDITABLE(viewer->text))->selection_start_pos;
			to = (GTK_EDITABLE(viewer->text))->selection_end_pos;
			viewer->ip = to;
		}
#endif // GTK_MAJOR_VERSION == 1
		//else // no selection, find from insertion point
	}
		
	if(viewer->n <= 0)
	{
		gtk_label_set_text(GTK_LABEL(viewer->found), (char *)"0");
		g_free(p0);
		return;
	}

	// look for target string starting at viewer->ip
	p = p0 + viewer->ip;

	if((p = mastrcasestr(p, viewer->find)))
	{
		line = 1;
		char *q = p0;
		while(q < p)
			if(*q++ == '\n') // maeol
				line++;
		viewer->ip = (long)(p - p0); 
		gtk_text_set_point(GTK_TEXT(viewer->text), viewer->ip);
		TextShowPosition(GTK_TEXT(viewer->text), viewer->ip);
		gtk_editable_select_region(GTK_EDITABLE(viewer->text), viewer->ip, viewer->ip + findlen);
		sprintf(findstr, "%d (L%d)", viewer->n, line);
		gtk_label_set_text(GTK_LABEL(viewer->found), findstr);
		viewer->ip++;
	}
	else
	{
		gtk_label_set_text(GTK_LABEL(viewer->found), (char *)"At bottom.");
		viewer->ip = -1;
	}

	//m_findTextCtrl->SetFocus();
	
	g_free(p0);

} // OnButtonFind


void OnButtonEditSave(void *widget, int windowid)
{
	FILE *fp;	
	char *pbytes;
	long nbytes;
	GtkLabel *label = NULL;
	maviewer *viewer;
	char cstr[MAX_PATH + 256];
	
	if(l_txnbusy)
		return;
	l_txnbusy = 1;
	
	gtk_widget_set_sensitive(GTK_WIDGET(widget), FALSE);
	
	switch(windowid)
	{
		case WINDOWREADME:
			viewer = &l_viewerReadme;
		break;
		
		case WINDOWCATALOG:
			viewer = &l_viewerCatalog;
		break;
		
		case WINDOWLOG:
			viewer = &l_viewerLog;
		break;
		
#if defined(MAKEYBOARD)
		case WINDOWKEYBINDINGS:
			viewer = &l_viewerKeyBindings;
		break;
#endif
		default:
			gtk_widget_set_sensitive(GTK_WIDGET(widget), TRUE);
		return;
	}

	if(!(label = maGtkGetFirstLabel(widget)))
	{
		maLog("OnButtonEditSave maGtkGetFirstLabel failed");
		l_txnbusy = 0;
		gtk_widget_set_sensitive(GTK_WIDGET(widget), TRUE);
		return;
	}
	
	if(!strcmp(label->label, MASTRSAVE))
	{
		gtk_editable_set_editable(GTK_EDITABLE(viewer->text), FALSE);
		
		pbytes = gtk_editable_get_chars(GTK_EDITABLE(viewer->text), 0, -1);
		if(!pbytes || (nbytes = strlen(pbytes)) <= 0)
		{
			l_txnbusy = 0;
			gtk_widget_set_sensitive(GTK_WIDGET(widget), TRUE);return;
		}
		else
		{
			// rewrite file
			if((fp = mafopen(viewer->fpath, "wb")) == NULL)
			{
				sprintf(cstr, "OnButtonEditSave mafopen failed on '%s'", viewer->fpath);
				maLog(cstr);
			}
			else
			{
				if(fwrite(pbytes, 1, nbytes, fp) != nbytes)
				{
					sprintf(cstr, "OnButtonEditSave fwrite errno=%d '%s'", errno, viewer->fpath);
					maLog(cstr);
				}
				
				if(fclose(fp) != 0)
				{
					sprintf(cstr, "OnButtonEditSave fclose errno=%d '%s'", errno, viewer->fpath);
					maLog(cstr);
				}
			
#if defined(MAKEYBOARD)
				// reload
				if(windowid == WINDOWKEYBINDINGS) //(!strcmp(g_keybindingspath, viewer->fpath))
				{
					// int ret;
					if((/* ret = */ LoadKeyBindings(1)) == 1)
						maLog("OnButtonEditSave LoadKeyBindings failed");
					// else if(ret == 2) // fopen failed
					// else if(ret == 3) // no valid entries
					// else if(ret == 4) // duplicate entries
				}
#endif
			}
		}
		gtk_label_set_text(label, MASTREDIT);
	}
	else
	{
		gtk_label_set_text(label, MASTRSAVE);
		gtk_editable_set_editable(GTK_EDITABLE(viewer->text), TRUE);
	}
	
	gtk_widget_set_sensitive(GTK_WIDGET(widget), TRUE);
	
	l_txnbusy = 0;

} // OnButtonEditSave


void maGUIfree()
{
#ifdef MATRACEGUIGTK
	maTrace("maGUIfree");
#endif
} // maGUIfree


void maGUIQuit()
{
#ifdef MATRACEGUIGTK
	maTrace("maGUIQuit");
#endif
	gtk_main_quit();

} // maGUIQuit


int maModKeyDown() // the mouse mod1 key or shift key
{
	int x, y;
	unsigned int m;
	gdk_window_get_pointer(NULL, &x, &y, &m);

	//if(m & GDK_BUTTON3_MASK) // GDK_BUTTON1_MASK = 1 << 8, GDK_BUTTON2_MASK = 1 << 9, GDK_BUTTON3_MASK = 1 << 10,
	// if(m & (1 << 3))  // if(m & GDK_MOD1_MASK) // normally Alt key
	// if(m & (1 << 0))  // if(m & GDK_SHIFT_MASK)
	// if(m & (1 << 9))  // if(m & GDK_BUTTON2_MASK)
	// if(m & (1 << 10)) // if(m & GDK_BUTTON3_MASK)

	if((m & GDK_MOD1_MASK) || // normally the Alt key
		(m & GDK_SHIFT_MASK)) // shift key, in case MOD1 doesn't work, like on MACUNIX/GTK2
		return 1;

	return 0;
	
} // maModKeyDown

#ifdef __cplusplus
}
#endif

#endif // MAGUIGTK

// eof

