// maPlayAif.c
// and maPlayWav.c

/*
 * MoreAmp
 * Copyright (C) 2004-2008 moreforge
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

// this code contains extracts from libsndfile-1.0.5 :
/*
** Copyright (C) 1999-2004 Erik de Castro Lopo <erikd@mega-nerd.com>
*/

#include "maConfig.h" // included by all moreamp files

#ifdef __MAWIN__
 #ifdef MAUNUSEDWIN
  #pragma warning( disable : 4100 ) // unreferenced formal parameter
 #endif
 #pragma warning( disable : 4127 ) // conditional expression is constant
 #pragma warning( disable : 4201 ) // nonstandard extension used : nameless struct/union
 #pragma warning( disable : 4206 ) // nonstandard extension used : translation unit is empty
 #pragma warning (disable : 4244)
 #pragma warning( disable : 4701 ) // local variable 'wav_fmt' may be used without having been initialized
 #pragma warning( disable : 4702 ) // unreachable code (VALIDATE_SNDFILE_AND_ASSIGN_PSF)
 #pragma warning( disable : 4706 ) // assignment within conditional expression
 #pragma warning (disable : 4761)
 #pragma warning( disable : 4996 ) // The POSIX name for this item is deprecated.
 #define __RPCASYNC_H__ // rpcasync.h(45) : warning C4115: '_RPC_ASYNC_STATE' : named type definition in parentheses
#endif

#if !defined(NODECODEAIF) && !defined(NODECODEWAV)

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <stdarg.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>

#ifndef __MAWIN__
 #include <unistd.h>
#endif

#if defined(__MAOS9__) && defined(macintosh)
 #include <Files.h>
#endif

#if defined(__MAOS9__)
 #include <unix.h>
 #include <stat.h>
 #include <MacTypes.h>
#else
 #include <sys/types.h>
 #include <sys/stat.h>
#endif

#ifdef __MAOSX__
 #include <MacTypes.h>
#endif

#ifdef __MAWIN__
 #include <limits.h>
 #include <io.h>
 #include <direct.h>
#endif

#ifdef WORDS_BIGENDIAN
 #define CPU_IS_BIG_ENDIAN 1
 #define CPU_IS_LITTLE_ENDIAN 0
#else
 #define CPU_IS_BIG_ENDIAN 0
 #define CPU_IS_LITTLE_ENDIAN 1
#endif

#ifdef __MAWIN__
 #define SIZEOF_LONG 4
 #define HAVE_SNPRINTF 1
 #define HAVE_VSNPRINTF 1
 typedef long loff_t;
#endif // __MAWIN__

#ifdef __MAOS9__
 #define HAVE_SNPRINTF 1
 #define HAVE_VSNPRINTF 1
 typedef long long loff_t;
#endif // __MAOS9__

#ifdef __MAOSX__
 #define SIZEOF_LONG 4
 #define HAVE_SNPRINTF 1
 #define HAVE_VSNPRINTF 1
 typedef long long loff_t;
#endif // __MAOSX__

#ifdef __MAUNIX__ // unix/X11
 #define SIZEOF_LONG 4
 #define HAVE_SNPRINTF 1
 #define HAVE_VSNPRINTF 1
#endif // __MAUNIX__

#if defined(__MACUNIX__)
 typedef long long loff_t;
#endif // __MACUNIX__

#include "maEqualizer.h"
#include "maMemFile.h"
#include "maMemFile.h"
#include "maPlayer.h"
#include "maUtils.h"
#include "maPlayAif.h"

#ifdef __MAWIN__
 #include "maAudioWin.h"
#endif

#ifdef __MAOS9__
 #include "maAudioMac.h"
#endif

#ifdef __MAOSX__
 #include "maAudioMac.h"
#endif

#ifdef __MAUNIX__
 #include "maAudioUnix.h"
#endif

#define MAOPEN open
#define MACLOSE close
#define MAREAD read
#define MALSEEK lseek
#define MALSEEKI64 _lseeki64
#define MAFSTAT fstat
#define MAFSTATI64 _fstati64

void maPlayAif();
int AifDecodeStream();
int AifOpenFile(MASTATE *pstate);
void AifCloseFile(MASTATE *pstate);
//int AifGetPCMBlock(void *pBlock, int *pdwBlockSize);

// libsndfile:

// sndfile.h:
/*
** sndfile.h -- system-wide definitions
**
** API documentation is in the doc/ directory of the source code tarball
** and at http://www.zip.com.au/~erikd/libsndfile/api.html.
*/

#ifndef SNDFILE_H
#define SNDFILE_H

/* For the Metrowerks CodeWarrior Pro Compiler (mainly MacOS) */

/* The following file types can be read and written.
** A file type would consist of a major type (ie SF_FORMAT_WAV) bitwise
** ORed with a minor type (ie SF_FORMAT_PCM). SF_FORMAT_TYPEMASK and
** SF_FORMAT_SUBMASK can be used to separate the major and minor file
** types.
*/

enum
{	/* Major formats. */
	SF_FORMAT_WAV			= 0x010000,		/* Microsoft WAV format (little endian). */
	SF_FORMAT_AIFF			= 0x020000,		/* Apple/SGI AIFF format (big endian). */
	SF_FORMAT_AU			= 0x030000,		/* Sun/NeXT AU format (big endian). */
	SF_FORMAT_RAW			= 0x040000,		/* RAW PCM data. */
	SF_FORMAT_PAF			= 0x050000,		/* Ensoniq PARIS file format. */
	SF_FORMAT_SVX			= 0x060000,		/* Amiga IFF / SVX8 / SV16 format. */
	SF_FORMAT_NIST			= 0x070000,		/* Sphere NIST format. */
	SF_FORMAT_VOC			= 0x080000,		/* VOC files. */
	SF_FORMAT_IRCAM			= 0x0A0000,		/* Berkeley/IRCAM/CARL */
	SF_FORMAT_W64			= 0x0B0000,		/* Sonic Foundry's 64 bit RIFF/WAV */
	SF_FORMAT_MAT4			= 0x0C0000,		/* Matlab (tm) V4.2 / GNU Octave 2.0 */
	SF_FORMAT_MAT5			= 0x0D0000,		/* Matlab (tm) V5.0 / GNU Octave 2.1 */
	SF_FORMAT_PVF			= 0x0E0000,		/* Portable Voice Format */
	SF_FORMAT_XI			= 0x0F0000,		/* Fasttracker 2 Extended Instrument */
	SF_FORMAT_HTK			= 0x100000,		/* HMM Tool Kit format */
	
	/* Subtypes from here on. */

	SF_FORMAT_PCM_S8		= 0x0001,		/* Signed 8 bit data */
	SF_FORMAT_PCM_16		= 0x0002,		/* Signed 16 bit data */
	SF_FORMAT_PCM_24		= 0x0003,		/* Signed 24 bit data */
	SF_FORMAT_PCM_32		= 0x0004,		/* Signed 32 bit data */

	SF_FORMAT_PCM_U8		= 0x0005,		/* Unsigned 8 bit data (WAV and RAW only) */

	SF_FORMAT_FLOAT			= 0x0006,		/* 32 bit float data */
	SF_FORMAT_DOUBLE		= 0x0007,		/* 64 bit float data */

	SF_FORMAT_ULAW			= 0x0010,		/* U-Law encoded. */
	SF_FORMAT_ALAW			= 0x0011,		/* A-Law encoded. */
	SF_FORMAT_IMA_ADPCM		= 0x0012,		/* IMA ADPCM. */
	SF_FORMAT_MS_ADPCM		= 0x0013,		/* Microsoft ADPCM. */

	SF_FORMAT_GSM610		= 0x0020,		/* GSM 6.10 encoding. */
	SF_FORMAT_VOX_ADPCM		= 0x0021,		/* OKI / Dialogix ADPCM */

	SF_FORMAT_G721_32		= 0x0030,		/* 32kbs G721 ADPCM encoding. */
	SF_FORMAT_G723_24		= 0x0031,		/* 24kbs G723 ADPCM encoding. */
	SF_FORMAT_G723_40		= 0x0032,		/* 40kbs G723 ADPCM encoding. */

	SF_FORMAT_DWVW_12		= 0x0040, 		/* 12 bit Delta Width Variable Word encoding. */
	SF_FORMAT_DWVW_16		= 0x0041, 		/* 16 bit Delta Width Variable Word encoding. */
	SF_FORMAT_DWVW_24		= 0x0042, 		/* 24 bit Delta Width Variable Word encoding. */
	SF_FORMAT_DWVW_N		= 0x0043, 		/* N bit Delta Width Variable Word encoding. */

	SF_FORMAT_DPCM_8		= 0x0050,		/* 8 bit differential PCM (XI only) */
	SF_FORMAT_DPCM_16		= 0x0051,		/* 16 bit differential PCM (XI only) */
	

	/* Endian-ness options. */

	SF_ENDIAN_FILE			= 0x00000000,	/* Default file endian-ness. */
	SF_ENDIAN_LITTLE		= 0x10000000,	/* Force little endian-ness. */
	SF_ENDIAN_BIG			= 0x20000000,	/* Force big endian-ness. */
	SF_ENDIAN_CPU			= 0x30000000,	/* Force CPU endian-ness. */

	SF_FORMAT_SUBMASK		= 0x0000FFFF,
	SF_FORMAT_TYPEMASK		= 0x0FFF0000,
	SF_FORMAT_ENDMASK		= 0x30000000
};

/*
** The following are the valid command numbers for the sf_command()
** interface.  The use of these commands is documented in the file
** command.html in the doc directory of the source code distribution.
*/

enum
{
	SFC_GET_NORM_DOUBLE				= 0x1010,
	SFC_SET_NORM_DOUBLE				= 0x1012 //,
};


/*
** String types that can be set and read from files. Not all file types
** support this and even the file types which support one, may not support
** all string types.
*/

enum
{	SF_STR_TITLE					= 0x01,
	SF_STR_COPYRIGHT				= 0x02,
	SF_STR_SOFTWARE					= 0x03,
	SF_STR_ARTIST					= 0x04,
	SF_STR_COMMENT					= 0x05,
	SF_STR_DATE						= 0x06
};

enum
{	/* True and false */
	SF_FALSE	= 0,
	SF_TRUE		= 1,

	/* Modes for opening files. */
	SFM_READ	= 0x10
};

/* Pubic error values. These are guaranteed to remain unchanged for the duration
** of the library major version number. 
** There are also a large number of private error numbers which are internal to
** the library which can change at any time.
*/

enum
{	SF_ERR_NO_ERROR     		= 0,
	SF_ERR_UNRECOGNISED_FORMAT	= 1,
	SF_ERR_SYSTEM				= 2
};

/* A SNDFILE* pointer can be passed around much like stdio.h's FILE* pointer. */

typedef	struct SNDFILE_tag	SNDFILE;

typedef loff_t	sf_count_t;

/* A pointer to a SF_INFO structure is passed to sf_open_read () and filled in.
** On write, the SF_INFO structure is filled in by the user and passed into
** sf_open_write ().
*/

struct SF_INFO
{	sf_count_t	frames;		/* Used to be called samples.  Changed to avoid confusion. */
	int			samplerate;
	int			channels;
	int			format;
	int			sections;
	int			seekable;
};

typedef	struct SF_INFO SF_INFO;

/* The SF_FORMAT_INFO struct is used to retrieve information about the sound
** file formats libsndfile supports using the sf_command () interface.
**
** Using this interface will allow applications to support new file formats
** and encoding types when libsndfile is upgraded, without requiring
** re-compilation of the application.
**
** Please consult the libsndfile documentation (particularly the information
** on the sf_command () interface) for examples of its use.
*/

typedef struct
{	int			format;
	const char  *name;
	const char  *extension;
} SF_FORMAT_INFO;

/*
** Enums and typedefs for adding dither on read and write. 
** See the html documentation for sf_command(), SFC_SET_DITHER_ON_WRITE 
** and SFC_SET_DITHER_ON_READ.
*/

enum
{	SFD_DEFAULT_LEVEL	= 0,
	SFD_CUSTOM_LEVEL	= 0x40000000,

	SFD_NO_DITHER		= 500,
	SFD_WHITE			= 501,
	SFD_TRIANGULAR_PDF	= 502
};

/*u
typedef struct
{	int			type;
	double		level;
	const char	*name;
} SF_DITHER_INFO;
*/

/* Struct used to retrieve information about a file embedded within a
** larger file. See SF_GET_EMBED_FILE_INFO.
*/

typedef struct
{	sf_count_t	offset;
	sf_count_t	length;
} SF_EMBED_FILE_INFO;


/* Open the specified file for read, write or both. On error, this will
** return a NULL pointer. To find the error number, pass a NULL SNDFILE
** to sf_perror () or sf_error_str ().
** All calls to sf_open() should be matched with a call to sf_close().
*/

SNDFILE* 	sf_open		(MASTATE *pstate, int mode, SF_INFO *sfinfo);

/* Use the existing file descriptor to create a SNDFILE object. If close_desc
** is TRUE, the file descriptor will be closed when sf_close() is called. If
** it is FALSE, the descritor will not be closed.
** When passed a descriptor like this, the library will assume that the start
** of file header is at the current file offset. This allows sound files within
** larger container files to be read and/or written.
** On error, this will return a NULL pointer. To find the error number, pass a 
** NULL SNDFILE to sf_perror () or sf_error_str ().
** All calls to sf_open_fd() should be matched with a call to sf_close().

*/

//SNDFILE* 	sf_open_fd	(int fd, int mode, SF_INFO *sfinfo, int close_desc);

/* sf_error () returns a error number which can be translated to a text 
** string using sf_error_number().
*/

int		sf_error		(SNDFILE *sndfile);

/* sf_strerror () returns to the caller a pointer to the current error message for 
** the given SNDFILE.
*/

const char* sf_strerror (SNDFILE *sndfile);

/* sf_error_number () allows the retrieval of the error string for each internal
** error number. 
**
*/

const char*	sf_error_number	(int errnum);

/* The following three error functions are deprecated but they will remain in the
** library for the forseeable future. The function sf_strerror() should be used
** in their place.
*/

int		sf_perror		(SNDFILE *sndfile);
int		sf_error_str	(SNDFILE *sndfile, char* str, size_t len);


/* Return TRUE if fields of the SF_INFO struct are a valid combination of values. */

int		sf_command	(SNDFILE *sndfile, int command, void *data, int datasize);

/* Return TRUE if fields of the SF_INFO struct are a valid combination of values. */

int		sf_format_check	(const SF_INFO *info);

/* Seek within the waveform data chunk of the SNDFILE. sf_seek () uses
** the same values for whence (SEEK_SET, SEEK_CUR and SEEK_END) as
** stdio.h function fseek ().
** An offset of zero with whence set to SEEK_SET will position the
** read / write pointer to the first data sample.
** On success sf_seek returns the current position in (multi-channel)
** samples from the start of the file.
** Please see the libsndfile documentation for moving the read pointer
** separately from the write pointer on files open in mode SFM_RDWR.
** On error all of these functions return -1.
*/

sf_count_t	sf_seek 		(SNDFILE *sndfile, sf_count_t frames, int whence);

/* Functions for reading/writing the waveform data of a sound file.
*/

//sf_count_t	sf_read_raw		(SNDFILE *sndfile, void *ptr, sf_count_t bytes);

/* Functions for reading and writing the data chunk in terms of frames.
** The number of items actually read/written = frames * number of channels.
**     sf_xxxx_raw		read/writes the raw data bytes from/to the file
**     sf_xxxx_short	passes data in the native short format
** All of these read/write function return number of frames read/written.
*/

sf_count_t	sf_readf_short	(SNDFILE *sndfile, short *ptr, sf_count_t frames);

/* Functions for reading and writing the data chunk in terms of items.
** Otherwise similar to above.
** All of these read/write function return number of items read/written.
*/

//sf_count_t	sf_read_short	(SNDFILE *sndfile, short *ptr, sf_count_t items);

/* Close the SNDFILE and clean up all memory allocations associated with this
** file. 
** Returns 0 on success, or an error number. 
*/

int		sf_close		(SNDFILE *sndfile);

#endif	/* SNDFILE_H */

// sfendian.h:

/* 
** Many file types (ie WAV, AIFF) use sets of four consecutive bytes as a 
** marker indicating different sections of the file. 
** The following MAKE_MARKER macro allows th creation of integer constants
** for these markers.
*/

#if(CPU_IS_LITTLE_ENDIAN == 1)
	#define	MAKE_MARKER(a,b,c,d)	((a)|((b)<<8)|((c)<<16)|((d)<<24))
#elif(CPU_IS_BIG_ENDIAN == 1)
	#define	MAKE_MARKER(a,b,c,d)	(((a)<<24)|((b)<<16)|((c)<<8)|(d))
#else
	#error "Target CPU endian-ness unknown"
#endif

/* wo standard endswap macros. */

#define	ENDSWAP_SHORT(x)	((((x)>>8)&0xFF)+(((x)&0xFF)<<8))
#define	ENDSWAP_INT(x)		((((x)>>24)&0xFF)+(((x)>>8)&0xFF00)+(((x)&0xFF00)<<8)+(((x)&0xFF)<<24))
/*
** Macros to handle reading of data of a specific endian-ness into host endian
** shorts and ints. The single input is an unsigned char* pointer to the start
** of the object. There are two versions of each macro as we need to deal with
** both big and little endian CPUs.
*/

#if(CPU_IS_LITTLE_ENDIAN == 1)
	#define LES2H_SHORT(x)			(x)
	#define LEI2H_INT(x)			(x)

	#define LES2H_SHORT_PTR(x)		(((short*) x) [0])
	#define LES2H_INT_PTR(x)		((((short*) x) [0]) << 16)

	#define LET2H_SHORT_PTR(x)		((x) [1] + ((x) [2] << 8))
	#define LET2H_INT_PTR(x)		(((x) [0] << 8) + ((x) [1] << 16) + ((x) [2] << 24))

	#define	LEI2H_SHORT_PTR(x)		((((int*) x) [0]) >> 16)
	#define	LEI2H_INT_PTR(x)		(((int*) x) [0])

	#define BES2H_SHORT(x)			ENDSWAP_SHORT(x)
	#define BEI2H_INT(x)			ENDSWAP_INT(x)

	#define BES2H_SHORT_PTR(x)		(((x) [0] << 8) + (x) [1])
	#define BES2H_INT_PTR(x)		(((x) [0] << 24) + ((x) [1] << 16))

	#define BET2H_SHORT_PTR(x)		(((x) [0] << 8) + (x) [1])
	#define BET2H_INT_PTR(x)		(((x) [0] << 24) + ((x) [1] << 16) + ((x) [2] << 8))

	#define BEI2H_SHORT_PTR(x)		(((x) [0] << 8) + (x) [1])
	#define BEI2H_INT_PTR(x)		(((x) [0] << 24) + ((x) [1] << 16) + ((x) [2] << 8) + (x) [3])

#elif(CPU_IS_BIG_ENDIAN == 1)
	#define LES2H_SHORT(x)			ENDSWAP_SHORT(x)
	#define LEI2H_INT(x)			ENDSWAP_INT(x)

	#define LES2H_SHORT_PTR(x)		((x) [0] + ((x) [1] << 8))
	#define LES2H_INT_PTR(x)		(((x) [0] << 16) + ((x) [1] << 24))

	#define LET2H_SHORT_PTR(x)		((x) [1] + ((x) [2] << 8))
	#define LET2H_INT_PTR(x)		(((x) [0] << 8) + ((x) [1] << 16) + ((x) [2] << 24))

	#define	LEI2H_SHORT_PTR(x)		((x) [2] + ((x) [3] << 8))
	#define	LEI2H_INT_PTR(x)		((x) [0] + ((x) [1] << 8) + ((x) [2] << 16) + ((x) [3] << 24))

	#define BES2H_SHORT(x)			(x)
	#define BEI2H_INT(x)			(x)

	#define BES2H_SHORT_PTR(x)		(((short*) x) [0])
	#define BES2H_INT_PTR(x)		((((short*) x) [0]) << 16)

	#define BET2H_SHORT_PTR(x)		(((x) [0] << 8) + (x) [1])
	#define BET2H_INT_PTR(x)		(((x) [0] << 24) + ((x) [1] << 16) + ((x) [2] << 8))

	#define BEI2H_SHORT_PTR(x)		((((int*) x) [0]) >> 16)
	#define BEI2H_INT_PTR(x)		(((int*) x) [0])

#else
	#error "Target CPU endian-ness unknown"
#endif

/* Endian swapping routines implemented in sfendian.c. */

void	endswap_short_array	(short *ptr, int len);
void	endswap_int_array 	(int *ptr, int len);

/* Always swaps 8 byte values whether sizeof (long) == 8 or not. */
void	endswap_long_array  (long *ptr, int len); 

void	endswap_short_copy	(short *dest, short *src, int len);
void	endswap_int_copy 	(int *dest, int *src, int len);

/* Always swaps 8 byte values whether sizeof (long) == 8 or not. */
void	endswap_long_copy  (long *dest, long *src, int len); 


// common.h:

#ifndef COMMON_H_INCLUDED
#define COMMON_H_INCLUDED

#define	SF_BUFFER_LEN			(8192)
#define	SF_FILENAME_LEN			(256)
#define	SF_HEADER_LEN			(2048)
#define	SF_TEXT_LEN				(1024)
#define SF_SYSERR_LEN			(256)
#define SF_MAX_STRINGS			(16)
#define	PEAK_CHANNEL_COUNT		(16)


#define	BITWIDTH2BYTES(x)	(((x) + 7) / 8)

/*	For some reason SIGNED_SIZEOF returns an unsigned  value which causes
**	a warning when that value is added or subtracted from a signed
**	value. Use SIGNED_SIZEOF instead.
*/
#define		SIGNED_SIZEOF(x)	((int) sizeof (x))

#define		SF_COUNT_MAX_POSITIVE(x)		\
			{	x = 1;						\
				while(((x << 1) + 1) > 0)	\
					x = (x << 1) + 1;		\
				};

enum
{	/* PEAK chunk location. */
	SF_PEAK_START		= 42,
	SF_PEAK_END			= 43,

	/* PEAK chunk location. */
	SF_SCALE_MAX		= 52,
	SF_SCALE_MIN		= 53,

	/* str_flags values. */	
	SF_STR_ALLOW_START	= 0x0100,
	SF_STR_ALLOW_END	= 0x0200,

	/* Location of strings. */
	SF_STR_LOCATE_START	= 0x0400,
	SF_STR_LOCATE_END	= 0x0800,

	SFD_TYPEMASK		= 0x0FFFFFFF
};

#define		SFM_MASK 	(SFM_READ)
#define		SFM_UNMASK 	(~SFM_MASK)

/*---------------------------------------------------------------------------------------
** Formats that may be supported at some time in the future.
** When support is finalised, these values move to src/sndfile.h.
*/

enum
{	/* Work in progress. */
	SF_FORMAT_SDS			= 0x0C0000,		/* Midi Sample Sump Standard */

	/* Formats supported read only. */
	SF_FORMAT_WVE			= 0x4020000,		/* Psion ALaw Sound File */
	SF_FORMAT_TXW			= 0x4030000,		/* Yamaha TX16 sampler file */
	SF_FORMAT_DWD			= 0x4040000,		/* DiamondWare Digirized */

	/* Following are detected but not supported. */
	SF_FORMAT_OGG			= 0x4090000,

	SF_FORMAT_REX			= 0x40A0000,		/* Propellorheads Rex/Rcy */
	SF_FORMAT_SD2			= 0x40C0000,		/* Sound Designer 2 */
	SF_FORMAT_REX2			= 0x40D0000,		/* Propellorheads Rex2 */
	SF_FORMAT_KRZ			= 0x40E0000,		/* Kurzweil sampler file */
	SF_FORMAT_OCT			= 0x40F0000,		/* GNU Octave data file */
	SF_FORMAT_WMA			= 0x4100000,		/* Windows Media Audio. */
	SF_FORMAT_SHN			= 0x4110000,		/* Shorten. */
	SF_FORMAT_FLAC  		= 0x4120000,

	/* Unsupported encodings. */
	SF_FORMAT_VORBIS		= 0x1001,

	SF_FORMAT_SVX_FIB		= 0x1020, 		/* SVX Fibonacci Delta encoding. */
	SF_FORMAT_SVX_EXP		= 0x1021, 		/* SVX Exponential Delta encoding. */

	SF_FORMAT_PCM_N			= 0x1030
};

/*---------------------------------------------------------------------------------------
**	PEAK_CHUNK - This chunk type is common to both AIFF and WAVE files although their
**	endian encodings are different.
*/

typedef struct
{	float        value;    	/* signed value of peak */
	unsigned int position; 	/* the sample frame for the peak */
} PEAK_POS;

typedef struct
{	unsigned int  version;						/* version of the PEAK chunk */
	unsigned int  timestamp;					/* secs since 1/1/1970  */
	PEAK_POS      peak [PEAK_CHANNEL_COUNT];	/* the peak info */
} PEAK_CHUNK;

typedef struct
{	int		type;
	int		flags;
	char 	*str;
} STR_DATA;

/*=======================================================================================
**	SF_PRIVATE stuct - a pointer to this struct is passed back to the caller of the
**	sf_open_XXXX functions. The caller however has no knowledge of the struct's
**	contents.
*/

typedef struct sf_private_tag
{	/* Force the compiler to double align the start of buffer. */
	double			buffer		[SF_BUFFER_LEN / sizeof (double)];
	char			filename	[SF_FILENAME_LEN];

	char			syserr		[SF_SYSERR_LEN];

	/* logbuffer and logindex should only be changed within the logging functions
	** of common.c
	*/
	char			logbuffer	[SF_BUFFER_LEN];
	unsigned char	header		[SF_HEADER_LEN]; /* Must be unsigned */
	int				rwf_endian;	/* Header endian-ness flag. */
	
	/* Storage and housekeeping data for adding/reading strings from
	** sound files.
	*/
	STR_DATA		strings [SF_MAX_STRINGS];
	char			str_storage [SF_BUFFER_LEN];
	char			*str_end;
	int				str_flags;

	/* Guard value. If this changes the buffers above have overflowed. */
	int				Magick;

	/* Index variables for maintaining logbuffer and header above. */
	unsigned int	logindex;
	unsigned int	headindex, headcurrent;
	int				has_text;
	int				do_not_close_descritor;

	int 			filedes;
	int				end_of_file;
	int				error;

	int				mode;			/* Open mode : SFM_READ, SFM_WRITE or SFM_RDWR. */
	int				endian;		/* File endianness : SF_ENDIAN_LITTLE or SF_ENDIAN_BIG. */
	int				float_endswap;	/* Need to endswap float32s? */

	SF_INFO			sf;

	int				have_written;	/* Has a single write been done to the file? */
	int				has_peak;		/* Has a PEAK chunk (AIFF and WAVE) been read? */
	int				peak_loc;		/* Write a PEAK chunk at the start or end of the file? */
	PEAK_CHUNK		peak;

	sf_count_t		filelength;	/* Overall length of (embedded) file. */
	sf_count_t		fileoffset;	/* Offset in number of bytes from beginning of file. */

	sf_count_t		dataoffset;	/* Offset in number of bytes from beginning of file. */
	sf_count_t		datalength;	/* Length in bytes of the audio data. */
	sf_count_t		dataend;		/* Offset to file tailer. */

	int				blockwidth;	/* Size in bytes of one set of interleaved samples. */
	int				bytewidth;		/* Size in bytes of one sample (one channel). */

	void			*dither;
	void			*interleave;

	int				last_op;		/* Last operation; either SFM_READ or SFM_WRITE */
	sf_count_t		read_current;
	sf_count_t		write_current;

	void			*fdata;		/*	This is a pointer to dynamically allocated file format
									**	specific data.
									*/

	//u SF_DITHER_INFO	write_dither;
	//u SF_DITHER_INFO	read_dither;

	int				norm_double;
	int				norm_float;

	int				auto_header;

	int				ieee_replace;
	/* A set of file specific function pointers */

	sf_count_t		(*read_short)	(struct sf_private_tag*, short *ptr, sf_count_t len);
	sf_count_t		(*read_int)		(struct sf_private_tag*, int *ptr, sf_count_t len);
	sf_count_t		(*read_float)	(struct sf_private_tag*, float *ptr, sf_count_t len);
	sf_count_t		(*read_double)	(struct sf_private_tag*, double *ptr, sf_count_t len);

	sf_count_t		(*write_short)	(struct sf_private_tag*, short *ptr, sf_count_t len);
	sf_count_t		(*write_int)	(struct sf_private_tag*, int *ptr, sf_count_t len);
	sf_count_t		(*write_float)	(struct sf_private_tag*, float *ptr, sf_count_t len);
	sf_count_t		(*write_double)	(struct sf_private_tag*, double *ptr, sf_count_t len);

	sf_count_t		(*seek) 		(struct sf_private_tag*, int mode, sf_count_t samples_from_start);
	int				(*write_header)	(struct sf_private_tag*, int calc_length);
	int				(*command)		(struct sf_private_tag*, int command, void *data, int datasize);
	int				(*close)		(struct sf_private_tag*);
	
	MASTATE *pstate;
	
} SF_PRIVATE;

enum
{	SFE_NO_ERROR		= SF_ERR_NO_ERROR,
	SFE_BAD_OPEN_FORMAT	= SF_ERR_UNRECOGNISED_FORMAT,
	SFE_SYSTEM			= SF_ERR_SYSTEM,

	SFE_BAD_FILE,
	SFE_BAD_FILE_READ,
	SFE_OPEN_FAILED,
	SFE_BAD_SNDFILE_PTR,
	SFE_BAD_SF_INFO_PTR,
	SFE_BAD_SF_INCOMPLETE,
	SFE_BAD_FILE_PTR,
	SFE_BAD_INT_PTR,
	SFE_MALLOC_FAILED,
	SFE_UNIMPLEMENTED,
	SFE_BAD_READ_ALIGN,
	SFE_BAD_WRITE_ALIGN,
	SFE_UNKNOWN_FORMAT,
	SFE_NOT_READMODE,
	SFE_NOT_WRITEMODE,
	SFE_BAD_MODE_RW,
	SFE_BAD_SF_INFO,
	SFE_BAD_OFFSET,
	SFE_NO_EMBED_SUPPORT,
	SFE_NO_EMBEDDED_RDWR,

	SFE_INTERNAL,
	SFE_LOG_OVERRUN,
	SFE_BAD_CONTROL_CMD,
	SFE_BAD_ENDIAN,
	SFE_CHANNEL_COUNT,
	SFE_BAD_RDWR_FORMAT,

	SFE_INTERLEAVE_MODE,
	SFE_INTERLEAVE_SEEK,
	SFE_INTERLEAVE_READ,

	SFE_BAD_SEEK,
	SFE_NOT_SEEKABLE,
	SFE_AMBIGUOUS_SEEK,
	SFE_WRONG_SEEK,
	SFE_SEEK_FAILED,

	SFE_BAD_OPEN_MODE,
	SFE_OPEN_PIPE_RDWR,
	SFE_RDWR_POSITION,

	SFE_STR_NO_SUPPORT,
	SFE_STR_MAX_DATA,
	SFE_STR_MAX_COUNT,
	SFE_STR_BAD_TYPE,
	SFE_STR_NO_ADD_END,
	SFE_STR_WEIRD,

	SFE_WAV_NO_RIFF,
	SFE_WAV_NO_WAVE,
	SFE_WAV_NO_FMT,
	SFE_WAV_FMT_SHORT,
	SFE_WAV_FMT_TOO_BIG,
	SFE_WAV_BAD_FACT,
	SFE_WAV_BAD_PEAK,
	SFE_WAV_PEAK_B4_FMT,
	SFE_WAV_BAD_FORMAT,
	SFE_WAV_BAD_BLOCKALIGN,
	SFE_WAV_NO_DATA,
	SFE_WAV_ADPCM_NOT4BIT,
	SFE_WAV_ADPCM_CHANNELS,
	SFE_WAV_GSM610_FORMAT,
	SFE_WAV_UNKNOWN_CHUNK,
	SFE_WAV_WVPK_DATA,

	SFE_AIFF_NO_FORM,
	SFE_AIFF_AIFF_NO_FORM,
	SFE_AIFF_COMM_NO_FORM,
	SFE_AIFF_SSND_NO_COMM,
	SFE_AIFF_UNKNOWN_CHUNK,
	SFE_AIFF_COMM_CHUNK_SIZE,
	SFE_AIFF_BAD_COMM_CHUNK,
	SFE_AIFF_PEAK_B4_COMM,
	SFE_AIFF_BAD_PEAK,
	SFE_AIFF_NO_SSND,
	SFE_AIFF_NO_DATA,

	SFE_AU_UNKNOWN_FORMAT,
	SFE_AU_NO_DOTSND,
	SFE_AU_EMBED_BAD_LEN,

	SFE_RAW_READ_BAD_SPEC,
	SFE_RAW_BAD_BITWIDTH,
	SFE_RAW_BAD_FORMAT,

	SFE_PAF_NO_MARKER,
	SFE_PAF_VERSION,
	SFE_PAF_UNKNOWN_FORMAT,
	SFE_PAF_SHORT_HEADER,

	SFE_SVX_NO_FORM,
	SFE_SVX_NO_BODY,
	SFE_SVX_NO_DATA,
	SFE_SVX_BAD_COMP,
	SFE_SVX_BAD_NAME_LENGTH,

	SFE_NIST_BAD_HEADER,
	SFE_NIST_CRLF_CONVERISON,
	SFE_NIST_BAD_ENCODING,

	SFE_VOC_NO_CREATIVE,
	SFE_VOC_BAD_FORMAT,
	SFE_VOC_BAD_VERSION,
	SFE_VOC_BAD_MARKER,
	SFE_VOC_BAD_SECTIONS,
	SFE_VOC_MULTI_SAMPLERATE,
	SFE_VOC_MULTI_SECTION,
	SFE_VOC_MULTI_PARAM,
	SFE_VOC_SECTION_COUNT,

	SFE_IRCAM_NO_MARKER,
	SFE_IRCAM_BAD_CHANNELS,
	SFE_IRCAM_UNKNOWN_FORMAT,

	SFE_W64_64_BIT,
	SFE_W64_NO_RIFF,
	SFE_W64_NO_WAVE,
	SFE_W64_NO_FMT,
	SFE_W64_NO_DATA,
	SFE_W64_FMT_SHORT,
	SFE_W64_FMT_TOO_BIG,
	SFE_W64_ADPCM_NOT4BIT,
	SFE_W64_ADPCM_CHANNELS,
	SFE_W64_GSM610_FORMAT,

	SFE_MAT4_BAD_NAME,
	SFE_MAT4_NO_SAMPLERATE,
	SFE_MAT4_ZERO_CHANNELS,

	SFE_MAT5_BAD_ENDIAN,
	SFE_MAT5_NO_BLOCK,
	SFE_MAT5_SAMPLE_RATE,
	SFE_MAT5_ZERO_CHANNELS,

	SFE_PVF_NO_PVF1,
	SFE_PVF_BAD_HEADER,
	SFE_PVF_BAD_BITWIDTH,

	SFE_DWVW_BAD_BITWIDTH,
	SFE_G72X_NOT_MONO,

	SFE_XI_BAD_HEADER,
	SFE_XI_EXCESS_SAMPLES,
	SFE_XI_WHOOPS,

	SFE_MAX_ERROR			/* This must be last in list. */
};

int s_bitwidth_to_subformat (int bits);
int u_bitwidth_to_subformat (int bits);

/* Functions used when reading file headers. */

int psf_binheader_readf	(SF_PRIVATE *psf, char const *format, ...);

/* Functions in strings.c. */

int psf_store_string (SF_PRIVATE *psf, int str_type, const char *str);

/* Default seek function. Use for PCM and float encoded data. */
sf_count_t  psf_default_seek (SF_PRIVATE *psf, int mode, sf_count_t samples_from_start);

/*------------------------------------------------------------------------------------
**	File I/O functions which will allow access to large files (> 2 Gig) on
**	some 32 bit OSes. Implementation in file_io.c.
*/

int psf_open (SF_PRIVATE *psf, const char *pathname, int flags);

sf_count_t psf_fseek (SF_PRIVATE *psf, sf_count_t offset, int whence);
sf_count_t psf_fread (void *ptr, sf_count_t bytes, sf_count_t count, SF_PRIVATE *psf);
sf_count_t psf_fgets (char *buffer, sf_count_t bufsize, SF_PRIVATE *psf);
sf_count_t psf_ftell (SF_PRIVATE *psf);
sf_count_t psf_get_filelen (SF_PRIVATE *psf);

int psf_fclose (SF_PRIVATE *psf);

/*------------------------------------------------------------------------------------
** Functions for reading and writing different file formats.
*/

int		aiff_open	(SF_PRIVATE *psf);

/*
int		au_open		(SF_PRIVATE *psf);
int		au_nh_open	(SF_PRIVATE *psf);	// Headerless version of AU
int		htk_open	(SF_PRIVATE *psf);
int		ircam_open	(SF_PRIVATE *psf);
int		mat4_open	(SF_PRIVATE *psf);
int		mat5_open	(SF_PRIVATE *psf);
int		nist_open	(SF_PRIVATE *psf);
int		paf_open	(SF_PRIVATE *psf);
int		pvf_open	(SF_PRIVATE *psf);
int		raw_open	(SF_PRIVATE *psf);
int		svx_open	(SF_PRIVATE *psf);
int		voc_open	(SF_PRIVATE *psf);
int		w64_open	(SF_PRIVATE *psf);
*/

int		wav_open	(SF_PRIVATE *psf);

/*------------------------------------------------------------------------------------
**	Init functions for a number of common data encodings.
*/

int 	pcm_init		(SF_PRIVATE *psf);

/*------------------------------------------------------------------------------------
** Other helper functions.
*/

void	*psf_memset (void *s, int c, sf_count_t n);

/*------------------------------------------------------------------------------------
** Here's how we fix systems which don't snprintf / vsnprintf.
** Systems without these functions should use the
*/

#if(defined(WIN32) || defined(__MAWIN__))
 #define	LSF_SNPRINTF	_snprintf
#elif		(HAVE_SNPRINTF)
 #define	LSF_SNPRINTF	snprintf
#else
 int missing_snprintf (char *str, size_t n, char const *fmt, ...);
 #define	LSF_SNPRINTF	missing_snprintf
#endif

#if(defined(WIN32) || defined(__MAWIN__))
 #define	LSF_VSNPRINTF	_vsnprintf
#elif		(HAVE_VSNPRINTF)
 #define	LSF_VSNPRINTF	vsnprintf
#else
 int missing_vsnprintf (char *str, size_t n, const char *fmt, ...);
 #define	LSF_VSNPRINTF	missing_vsnprintf
#endif

#endif /* COMMON_H_INCLUDED */

/*------------------------------------------------------------------------------------
** Extra commands for sf_command(). Not for public use yet.
*/

enum
{	SFC_TEST_AIFF_ADD_INST_CHUNK	= 0x2000,
	SFC_TEST_WAV_ADD_INFO_CHUNK		= 0x2010
};

/* 
** Maybe, one day, make these functions or something like them, public.
**
** Buffer to buffer dithering. Pointer in and out are allowed to point
** to the same buffer for in-place dithering.
*/

#if 0
int sf_dither_short  (const SF_DITHER_INFO *dither, const short *in, short *out, int count);
int sf_dither_int    (const SF_DITHER_INFO *dither, const int *in, int *out, int count);
int sf_dither_float  (const SF_DITHER_INFO *dither, const float *in, float *out, int count);
int sf_dither_double (const SF_DITHER_INFO *dither, const double *in, double *out, int count);
#endif

// wav_64.h:
/* This file contains definitions commong to WAV and W64 files. */

#ifndef WAV_W64_H_INCLUDED
#define WAV_W64_H_INCLUDED

/*------------------------------------------------------------------------------
** List of known WAV format tags
*/

#ifdef __MAWIN__
 #ifdef WAVE_FORMAT_PCM
  #undef WAVE_FORMAT_PCM
 #endif
#endif

enum
{	
  /* keep sorted for wav_w64_format_str() */
	WAVE_FORMAT_UNKNOWN					= 0x0000,		/* Microsoft Corporation */
	WAVE_FORMAT_PCM	 					= 0x0001, 		/* Microsoft PCM format */
	WAVE_FORMAT_MS_ADPCM				= 0x0002,		/* Microsoft ADPCM */
	WAVE_FORMAT_IEEE_FLOAT				= 0x0003,		/* Micrososft 32 bit float format */
	WAVE_FORMAT_VSELP					= 0x0004,		/* Compaq Computer Corporation */
	WAVE_FORMAT_IBM_CVSD				= 0x0005,		/* IBM Corporation */
	WAVE_FORMAT_ALAW					= 0x0006,		/* Microsoft Corporation */
	WAVE_FORMAT_MULAW					= 0x0007,		/* Microsoft Corporation */
	WAVE_FORMAT_OKI_ADPCM				= 0x0010,		/* OKI */
	WAVE_FORMAT_IMA_ADPCM				= 0x0011,		/* Intel Corporation */
	WAVE_FORMAT_MEDIASPACE_ADPCM		= 0x0012,		/* Videologic */
	WAVE_FORMAT_SIERRA_ADPCM			= 0x0013,		/* Sierra Semiconductor Corp */
	WAVE_FORMAT_G723_ADPCM				= 0x0014,		/* Antex Electronics Corporation */
	WAVE_FORMAT_DIGISTD					= 0x0015,		/* DSP Solutions, Inc. */
	WAVE_FORMAT_DIGIFIX					= 0x0016,		/* DSP Solutions, Inc. */
	WAVE_FORMAT_DIALOGIC_OKI_ADPCM		= 0x0017,		/*  Dialogic Corporation  */
	WAVE_FORMAT_MEDIAVISION_ADPCM		= 0x0018,		/*  Media Vision, Inc. */
	WAVE_FORMAT_CU_CODEC				= 0x0019,		/* Hewlett-Packard Company */
	WAVE_FORMAT_YAMAHA_ADPCM			= 0x0020,		/* Yamaha Corporation of America */
	WAVE_FORMAT_SONARC					= 0x0021,		/* Speech Compression */
	WAVE_FORMAT_DSPGROUP_TRUESPEECH 	= 0x0022,		/* DSP Group, Inc */
	WAVE_FORMAT_ECHOSC1					= 0x0023,		/* Echo Speech Corporation */
	WAVE_FORMAT_AUDIOFILE_AF36  		= 0x0024,		/* Audiofile, Inc. */
	WAVE_FORMAT_APTX					= 0x0025,		/* Audio Processing Technology */
	WAVE_FORMAT_AUDIOFILE_AF10  		= 0x0026,		/* Audiofile, Inc. */
	WAVE_FORMAT_PROSODY_1612			= 0x0027,		/* Aculab plc */
	WAVE_FORMAT_LRC						= 0x0028,		/* Merging Technologies S.A. */
	WAVE_FORMAT_DOLBY_AC2				= 0x0030,		/* Dolby Laboratories */
	WAVE_FORMAT_GSM610					= 0x0031,		/* Microsoft Corporation */
	WAVE_FORMAT_MSNAUDIO				= 0x0032,		/* Microsoft Corporation */
	WAVE_FORMAT_ANTEX_ADPCME			= 0x0033, 		/* Antex Electronics Corporation */
	WAVE_FORMAT_CONTROL_RES_VQLPC		= 0x0034,		/* Control Resources Limited */
	WAVE_FORMAT_DIGIREAL				= 0x0035,		/* DSP Solutions, Inc. */
	WAVE_FORMAT_DIGIADPCM				= 0x0036,		/* DSP Solutions, Inc. */
	WAVE_FORMAT_CONTROL_RES_CR10		= 0x0037,		/* Control Resources Limited */
	WAVE_FORMAT_NMS_VBXADPCM			= 0x0038,		/* Natural MicroSystems */
	WAVE_FORMAT_ROLAND_RDAC				= 0x0039,		/* Roland */
	WAVE_FORMAT_ECHOSC3					= 0x003A,		/* Echo Speech Corporation */
	WAVE_FORMAT_ROCKWELL_ADPCM			= 0x003B,		/* Rockwell International */
	WAVE_FORMAT_ROCKWELL_DIGITALK		= 0x003C, 		/* Rockwell International */
	WAVE_FORMAT_XEBEC					= 0x003D,		/* Xebec Multimedia Solutions Limited */
	WAVE_FORMAT_G721_ADPCM				= 0x0040,		/* Antex Electronics Corporation */
	WAVE_FORMAT_G728_CELP				= 0x0041,		/* Antex Electronics Corporation */
	WAVE_FORMAT_MSG723					= 0x0042,		/* Microsoft Corporation */
	WAVE_FORMAT_MPEG					= 0x0050,		/* Microsoft Corporation */
	WAVE_FORMAT_RT24					= 0x0052,		/* InSoft Inc. */
	WAVE_FORMAT_PAC						= 0x0053,		/* InSoft Inc. */
	WAVE_FORMAT_MPEGLAYER3				= 0x0055,		/* MPEG 3 Layer 1 */
	WAVE_FORMAT_LUCENT_G723				= 0x0059,		/* Lucent Technologies */
	WAVE_FORMAT_CIRRUS					= 0x0060,		/* Cirrus Logic */
	WAVE_FORMAT_ESPCM					= 0x0061,		/* ESS Technology */
	WAVE_FORMAT_VOXWARE					= 0x0062,		/* Voxware Inc */
	WAVE_FORMAT_CANOPUS_ATRAC			= 0x0063,		/* Canopus, Co., Ltd. */
	WAVE_FORMAT_G726_ADPCM				= 0x0064,		/* APICOM */
	WAVE_FORMAT_G722_ADPCM				= 0x0065,		/* APICOM */
	WAVE_FORMAT_DSAT					= 0x0066,		/* Microsoft Corporation */
	WAVE_FORMAT_DSAT_DISPLAY			= 0x0067,		/* Microsoft Corporation */
	WAVE_FORMAT_VOXWARE_BYTE_ALIGNED	= 0x0069,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_AC8				= 0x0070,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_AC10			= 0x0071,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_AC16			= 0x0072,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_AC20			= 0x0073,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_RT24			= 0x0074,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_RT29			= 0x0075,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_RT29HW			= 0x0076,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_VR12			= 0x0077,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_VR18			= 0x0078,		/* Voxware Inc. */
	WAVE_FORMAT_VOXWARE_TQ40			= 0x0079,		/* Voxware Inc. */
	WAVE_FORMAT_SOFTSOUND				= 0x0080,		/* Softsound, Ltd. */
	WAVE_FORMAT_VOXARE_TQ60				= 0x0081,		/* Voxware Inc. */
	WAVE_FORMAT_MSRT24					= 0x0082,		/* Microsoft Corporation */
	WAVE_FORMAT_G729A					= 0x0083,		/* AT&T Laboratories */
	WAVE_FORMAT_MVI_MV12				= 0x0084,		/* Motion Pixels */
	WAVE_FORMAT_DF_G726					= 0x0085,		/* DataFusion Systems (Pty) (Ltd) */
	WAVE_FORMAT_DF_GSM610				= 0x0086,		/* DataFusion Systems (Pty) (Ltd) */
	/* removed because duplicate */
	/* WAVE_FORMAT_ISIAUDIO				= 0x0088, */	/* Iterated Systems, Inc. */
	WAVE_FORMAT_ONLIVE					= 0x0089,		/* OnLive! Technologies, Inc. */
	WAVE_FORMAT_SBC24					= 0x0091,		/* Siemens Business Communications Systems */
	WAVE_FORMAT_DOLBY_AC3_SPDIF			= 0x0092,		/* Sonic Foundry */
	WAVE_FORMAT_ZYXEL_ADPCM				= 0x0097,		/* ZyXEL Communications, Inc. */
	WAVE_FORMAT_PHILIPS_LPCBB			= 0x0098,		/* Philips Speech Processing */
	WAVE_FORMAT_PACKED					= 0x0099,		/* Studer Professional Audio AG */
	WAVE_FORMAT_RHETOREX_ADPCM			= 0x0100,		/* Rhetorex, Inc. */

	/* removed because of the following */
	/* WAVE_FORMAT_IRAT					= 0x0101,*/		/* BeCubed Software Inc. */

	/* these three are unofficial */
	IBM_FORMAT_MULAW					= 0x0101,		/* IBM mu-law format */
	IBM_FORMAT_ALAW						= 0x0102,		/* IBM a-law format */
	IBM_FORMAT_ADPCM					= 0x0103,		/* IBM AVC Adaptive Differential PCM format */

	WAVE_FORMAT_VIVO_G723				= 0x0111,		/* Vivo Software */
	WAVE_FORMAT_VIVO_SIREN				= 0x0112,		/* Vivo Software */
	WAVE_FORMAT_DIGITAL_G723			= 0x0123,		/* Digital Equipment Corporation */
	WAVE_FORMAT_CREATIVE_ADPCM			= 0x0200,		/* Creative Labs, Inc */
	WAVE_FORMAT_CREATIVE_FASTSPEECH8 	= 0x0202,		/* Creative Labs, Inc */
	WAVE_FORMAT_CREATIVE_FASTSPEECH10 	= 0x0203,		/* Creative Labs, Inc */
	WAVE_FORMAT_QUARTERDECK				= 0x0220,		/* Quarterdeck Corporation */
	WAVE_FORMAT_FM_TOWNS_SND			= 0x0300,		/* Fujitsu Corporation */
	WAVE_FORMAT_BZV_DIGITAL				= 0x0400,		/* Brooktree Corporation */
	WAVE_FORMAT_VME_VMPCM				= 0x0680,		/* AT&T Labs, Inc. */
	WAVE_FORMAT_OLIGSM					= 0x1000,		/* Ing C. Olivetti & C., S.p.A. */
	WAVE_FORMAT_OLIADPCM				= 0x1001,		/* Ing C. Olivetti & C., S.p.A. */
	WAVE_FORMAT_OLICELP					= 0x1002,		/* Ing C. Olivetti & C., S.p.A. */
	WAVE_FORMAT_OLISBC					= 0x1003,		/* Ing C. Olivetti & C., S.p.A. */
	WAVE_FORMAT_OLIOPR					= 0x1004,		/* Ing C. Olivetti & C., S.p.A. */
	WAVE_FORMAT_LH_CODEC				= 0x1100,		/* Lernout & Hauspie */
	WAVE_FORMAT_NORRIS					= 0x1400,		/* Norris Communications, Inc. */
	/* removed because duplicate */
	/* WAVE_FORMAT_ISIAUDIO				= 0x1401, */	/* AT&T Labs, Inc. */
	WAVE_FORMAT_SOUNDSPACE_MUSICOMPRESS	= 0x1500,		/* AT&T Labs, Inc. */
	WAVE_FORMAT_DVM						= 0x2000,		/* FAST Multimedia AG */
	WAVE_FORMAT_INTERWAV_VSC112			= 0x7150,		/* ????? */
	WAVE_FORMAT_EXTENSIBLE				= 0xFFFE
};

typedef	struct
{	unsigned short	format;
	unsigned short	channels;
	unsigned int	samplerate;
	unsigned int	bytespersec;
	unsigned short	blockalign;
	unsigned short	bitwidth;
} MIN_WAV_FMT;

typedef	struct 
{	unsigned short	format;
	unsigned short	channels;
	unsigned int	samplerate;
	unsigned int	bytespersec;
	unsigned short	blockalign;
	unsigned short	bitwidth;
	unsigned short	extrabytes;
	unsigned short	dummy;
} WAV_FMT_SIZE20;

typedef	struct
{	unsigned short	format;
	unsigned short	channels;
	unsigned int	samplerate;
	unsigned int	bytespersec;
	unsigned short	blockalign;
	unsigned short	bitwidth;
	unsigned short	extrabytes;
	unsigned short	samplesperblock;
	unsigned short	numcoeffs;
	struct
	{	short	coeff1;
		short	coeff2;
	}	coeffs [7];
} MS_ADPCM_WAV_FMT;

typedef	struct
{	unsigned short	format;
	unsigned short	channels;
	unsigned int	samplerate;
	unsigned int	bytespersec;
	unsigned short	blockalign;
	unsigned short	bitwidth;
	unsigned short	extrabytes;
	unsigned short	samplesperblock;
} IMA_ADPCM_WAV_FMT;

typedef	struct
{	unsigned short	format;
	unsigned short	channels;
	unsigned int	samplerate;
	unsigned int	bytespersec;
	unsigned short	blockalign;
	unsigned short	bitwidth;
	unsigned short	extrabytes;
	unsigned short	auxblocksize;
} G72x_ADPCM_WAV_FMT;


typedef	struct
{	unsigned short	format;
	unsigned short	channels;
	unsigned int	samplerate;
	unsigned int	bytespersec;
	unsigned short	blockalign;
	unsigned short	bitwidth;
	unsigned short	extrabytes;
	unsigned short	samplesperblock;
} GSM610_WAV_FMT;

typedef struct
{	unsigned int	esf_field1;
	unsigned short	esf_field2;
	unsigned short	esf_field3;
	char			esf_field4 [8];
} EXT_SUBFORMAT;

typedef	struct
{	unsigned short	format;
	unsigned short	channels;
	unsigned int	samplerate;
	unsigned int	bytespersec;
	unsigned short	blockalign;
	unsigned short	bitwidth;
	unsigned short	extrabytes;
	unsigned short	validbits;
	unsigned int	channelmask;
	EXT_SUBFORMAT	esf;
} EXTENSIBLE_WAV_FMT;

typedef union
{	unsigned short		format;
	MIN_WAV_FMT			min;
	IMA_ADPCM_WAV_FMT	ima;
	MS_ADPCM_WAV_FMT	msadpcm;
	G72x_ADPCM_WAV_FMT	g72x;
	EXTENSIBLE_WAV_FMT	ext;
	GSM610_WAV_FMT		gsm610;
	WAV_FMT_SIZE20		size20;
	char				padding [512];
} WAV_FMT;

typedef struct
{	int frames;
} FACT_CHUNK;

#define		WAV_W64_GSM610_BLOCKSIZE	65
#define		WAV_W64_GSM610_SAMPLES		320

/*------------------------------------------------------------------------------------ 
**	Functions defined in wav_ms_adpcm.c
*/

#define	MSADPCM_ADAPT_COEFF_COUNT	7

void	msadpcm_write_adapt_coeffs (SF_PRIVATE *psf);

/*------------------------------------------------------------------------------------ 
**	Functions defined in wav_gsm610.c
*/

int 	wav_w64_srate2blocksize (int srate_chan_product);
char const* wav_w64_format_str (int k);
int		wav_w64_read_fmt_chunk (SF_PRIVATE *psf, WAV_FMT *wav_fmt, int structsize);

#endif

// file_io.c

#define	SENSIBLE_SIZE	(0x40000000)

static void psf_log_syserr(SF_PRIVATE *psf, int error);

#if(! (defined(WIN32) || defined(__MAWIN__)))

/*------------------------------------------------------------------------------
** Win32 stuff at the bottom of the file. Unix and other sensible OSes here.
*/

int
psf_open (SF_PRIVATE *psf, const char *pathname, int open_mode)
{	int oflag, mode;

	switch (open_mode)
	{	case SFM_READ :
				oflag = O_RDONLY;
				mode = 0;
		break;

		default :
				psf->error = SFE_BAD_OPEN_MODE;
				return -1;
		break;
	};

#if defined(__CYGWIN__)
	oflag |= O_BINARY;
#endif

	if(psf->pstate->nomem)
	{
#if defined(__MAOSX__)  
		char bsdname[MAX_PATH];
		strcpy(bsdname, pathname);
		StrOSXtoStrBSD(bsdname);
		psf->filedes = MAOPEN(bsdname, oflag);
#else
		psf->filedes = MAOPEN(pathname, oflag);
#endif
	}
	else
		psf->filedes = memopen((char *)pathname, oflag);
	
	if(psf->filedes == -1)
		psf_log_syserr(psf, errno);

	return psf->filedes;
} /* psf_open */

sf_count_t
psf_fseek (SF_PRIVATE *psf, sf_count_t offset, int whence)
{	sf_count_t	new_position;

	switch (whence)
	{	case SEEK_SET :
				offset += psf->fileoffset;
		break;

		case SEEK_END :
				/* Transform it into a SEEK_SET. */
				whence = SEEK_SET;
				if(psf->pstate->nomem)
					offset = MALSEEK(psf->filedes, 0, SEEK_END) + offset;
				else
					offset = memlseek(psf->filedes, 0, SEEK_END) + offset;	
		break;

		default :
				/* No need to do anything about SEEK_CUR. */
		break;
	};

	if(psf->pstate->nomem)
		new_position = MALSEEK(psf->filedes, offset, whence);
	else
		new_position = memlseek(psf->filedes, offset, whence);
	
	if(new_position < 0)
		psf_log_syserr(psf, errno);

	new_position -= psf->fileoffset;

	return new_position;
} /* psf_fseek */

sf_count_t
psf_fread (void *ptr, sf_count_t bytes, sf_count_t items, SF_PRIVATE *psf)
{	sf_count_t total = 0;
	int /* //u ssize_t */ count;

	items *= bytes;

	/* Do this check after the multiplication above. */
	if(items <= 0)
		return 0;

	while(items > 0)
	{	/* Break the writes down to a sensible size. */
		count = (items > SENSIBLE_SIZE) ? SENSIBLE_SIZE : (size_t) items;

	if(psf->pstate->nomem)
		count = MAREAD(psf->filedes, ((char*) ptr) + total, count);
	else
		count = memread(psf->filedes, ((char*) ptr) + total, count);

		if(count == -1)
		{
			psf_log_syserr(psf, errno);
			break;
		};

		if(count == 0)
			break;

		total += count;
		items -= count;
	};

	return total / bytes;

} /* psf_fread */

sf_count_t
psf_ftell (SF_PRIVATE *psf)
{	sf_count_t pos;

	if(psf->pstate->nomem)
		pos = MALSEEK(psf->filedes, 0, SEEK_CUR);
	else
		pos = memlseek(psf->filedes, 0, SEEK_CUR);

	if(pos == ((sf_count_t) -1))
		psf_log_syserr(psf, errno);

	return pos - psf->fileoffset;
} /* psf_ftell */

int
psf_fclose (SF_PRIVATE *psf)
{
	int retval;

	if(psf->pstate->nomem)
		//uwhile ((retval = MACLOSE(psf->filedes)) == -1 && errno == EINTR)
		//	/* Do nothing. */;
		retval = MACLOSE(psf->filedes);
	else
		retval = memfclose((FILE *)psf->filedes);

	if(retval == -1)
		psf_log_syserr(psf, errno);

	psf->filedes = -1;

	return retval;
} /* psf_fclose */

sf_count_t
psf_get_filelen (SF_PRIVATE *psf)
{	struct stat statbuf;
	sf_count_t	filelen;

	if(psf->pstate->nomem)
	{
		if(MAFSTAT(psf->filedes, &statbuf) == -1)
		{
			psf_log_syserr(psf, errno);
			return (sf_count_t) -1;
		}
	}
	else
	{
		if(memfstat(psf->filedes, (struct stat *)&statbuf))
		{
			psf_log_syserr(psf, errno);
			return (sf_count_t) -1;
		}
	}

	switch (psf->mode)
	{
		case SFM_READ :
			if(psf->fileoffset > 0 && psf->filelength > 0)
				filelen = psf->filelength;
			else
				filelen = statbuf.st_size;
		break;
		default :
			filelen = 0;
	};

	return filelen;
} /* psf_get_filelen */


#else

/* Win32 ##################################################################### */

/* Win32 has a 64 file offset seek function:
**
**		__int64 _lseeki64 (int handle, __int64 offset, int origin);
**
** It also has a 64 bit fstat function:
**
**		int fstati64 (int, struct _stati64);
**
** but the fscking thing doesn't work!!!!! The file size parameter returned
** by this function is only valid up until more data is written at the end of
** the file. That makes this function completely 100% useless.
*/


/* Win32 */ int
psf_open (SF_PRIVATE *psf, const char *pathname, int open_mode)
{
	int oflag, mode;

	switch (open_mode)
	{	case SFM_READ :
				oflag = O_RDONLY | O_BINARY;
				mode = 0;
		break;
		default :
				psf->error = SFE_BAD_OPEN_MODE;
				return -1;
		break;
		};

	if(mode == 0)
	{
		if(psf->pstate->nomem)
			psf->filedes = MAOPEN(pathname, oflag);
		else
			psf->filedes = memopen((char *)pathname, oflag);
	}
	
	if(psf->filedes == -1)
		psf_log_syserr(psf, errno);

	return psf->filedes;
} /* psf_open */

/* Win32 */ sf_count_t
psf_fseek (SF_PRIVATE *psf, sf_count_t offset, int whence)
{	sf_count_t	new_position;

	switch (whence)
	{	case SEEK_SET :
				offset += psf->fileoffset;
				break;

		case SEEK_END :
				/* Transform it into a SEEK_SET. */
				whence = SEEK_SET;
				if(psf->pstate->nomem)
					offset = MALSEEKI64(psf->filedes, 0, SEEK_END) + offset;
				else
					offset = memlseek(psf->filedes, 0, SEEK_END) + offset;
		break;

		default :
				/* No need to do anything about SEEK_CUR. */
		break;
	};

	/*
	** Bypass weird Win32-ism if necessary.
	** _lseeki64() returns an "invalid parameter" error if called with the
	** offset == 0 and whence == SEEK_CUR.
	*** Use the _telli64() function instead.
	*/
	if(psf->pstate->nomem)
	{
		if(offset == 0 && whence == SEEK_CUR)
			new_position = _telli64 (psf->filedes);
		else
			new_position = MALSEEKI64(psf->filedes, offset, whence);
	}
	else
		new_position = memlseek(psf->filedes, offset, whence);
	
	if(new_position < 0)
		psf_log_syserr(psf, errno);

	new_position -= psf->fileoffset;

	return new_position;
} /* psf_fseek */

/* Win32 */ sf_count_t
psf_fread (void *ptr, sf_count_t bytes, sf_count_t items, SF_PRIVATE *psf)
{	sf_count_t total = 0;
	size_t	 count;

	items *= bytes;

	/* Do this check after the multiplication above. */
	if(items <= 0)
		return 0;

	while(items > 0)
	{	/* Break the writes down to a sensible size. */
		count = (items > SENSIBLE_SIZE) ? SENSIBLE_SIZE : (size_t) items;

	if(psf->pstate->nomem)
		count = MAREAD(psf->filedes, ((char*) ptr) + total, count);
	else
		count = memread(psf->filedes, ((char*) ptr) + total, count);

		if(count == -1)
		{	if(errno == EINTR)
				continue;

			psf_log_syserr(psf, errno);
			break;
		};

		if(count == 0)
			break;

		total += count;
		items -= count;
	};

	return total / bytes;
	
} /* psf_fread */

/* Win32 */
sf_count_t
psf_ftell (SF_PRIVATE *psf)
{	
	sf_count_t pos;

	if(psf->pstate->nomem)
	pos = _telli64 (psf->filedes);
	else
		pos = memftell((FILE *)psf->filedes);

	if(pos == ((sf_count_t) -1))
		psf_log_syserr(psf, errno);

	return pos - psf->fileoffset;
} /* psf_ftell */

/* Win32 */ int
psf_fclose (SF_PRIVATE *psf)
{	int retval;

	if(psf->pstate->nomem)
		while((retval = MACLOSE(psf->filedes)) == -1 && errno == EINTR)
			/* Do nothing. */;
	else
		retval = memfclose((FILE *)psf->filedes);

	if(retval == -1)
		psf_log_syserr(psf, errno);

	psf->filedes = -1;

	return retval;
} /* psf_fclose */

/* Win32 */
sf_count_t psf_get_filelen (SF_PRIVATE *psf)
{
#if 0
	/*
	** Windoze is SOOOOO FUCKED!!!!!!!
	** This code should work but doesn't. Why?
	** Code below does work.
	*/
	struct _stati64 statbuf;

	if(psf->pstate->nomem)
	{
		if(_fstati64(psf->filedes, &statbuf))
		{
			psf_log_syserr(psf, errno);
			return (sf_count_t) -1;
		}
	}
	else
	{
		if(memfstat(psf->filedes, (struct stat *)&statbuf)) // memfstati64 ?
		{
			psf_log_syserr(psf, errno);
			return (sf_count_t) -1;
		}
	}

	return statbuf.st_size;
#else
	sf_count_t current, filelen;

	if(psf->pstate->nomem)
	{
	if((current = _telli64 (psf->filedes)) < 0)
		{
			psf_log_syserr(psf, errno);
			return (sf_count_t) -1;
		}
	}
	else
	{
		if((current = memftell((FILE *)psf->filedes)) < 0)
		{
			psf_log_syserr(psf, errno);
			return (sf_count_t) -1;
		}
	}

	/*
	** Lets face it, windoze if FUBAR!!!
	** 
	** For some reason, I have to call _lseeki64() TWICE to get to the
	** end of the file.
	**
	** This might have been avoided if windows had implemented the POSIX
	** standard function fsync() but NO, that would have been too easy.
	**
	** I am VERY close to saying that windoze will no longer be supported
	** by libsndfile and changing the license to GPL at the same time.
	*/

	if(psf->pstate->nomem)
	{
		MALSEEKI64(psf->filedes, 0, SEEK_END);

		if((filelen = MALSEEKI64(psf->filedes, 0, SEEK_END)) < 0)
		{
			psf_log_syserr(psf, errno);
			return (sf_count_t) -1;
		}

		if(filelen > current)
			MALSEEKI64(psf->filedes, current, SEEK_SET);
	}
	else
	{
		filelen = memlseek(psf->filedes, 0, SEEK_END);
		
		if(filelen > current)
			memlseek(psf->filedes, current, SEEK_SET);
	}
	
	switch (psf->mode)
	{
		case SFM_READ :
			if(psf->fileoffset > 0 && psf->filelength > 0)
				filelen = psf->filelength;
		break;
		default :
			filelen = 0;
	};

	return filelen;
#endif
} /* psf_get_filelen */


#endif

/*==============================================================================
*/

static void
psf_log_syserr(SF_PRIVATE *psf, int error)
{
	/* Only log an error if no error has been set yet. */
	if(psf->error == 0)
	{	psf->error = SFE_SYSTEM;
		LSF_SNPRINTF (psf->syserr, sizeof (psf->syserr), "System error : %s", strerror (error));
		};

	return;
} /* psf_log_syserr */

// string.c:
int
psf_store_string (SF_PRIVATE *psf, int str_type, const char *str)
{
	int k, str_len, len_remaining, str_flags;

	if(str == NULL)
		return 0;

	str_len = strlen (str);

	/* Determine flags */
	str_flags = SF_STR_LOCATE_START;
	if(psf->have_written)
	{	if((psf->str_flags & SF_STR_ALLOW_END) == 0)
			return SFE_STR_NO_ADD_END;
		str_flags = SF_STR_LOCATE_END;
		};

	/* Find next free slot in table. */
	for(k = 0; k < SF_MAX_STRINGS; k++)
		if(psf->strings [k].type == 0)
			break;

	/* More sanity checking. */
	if(k >= SF_MAX_STRINGS)
		return SFE_STR_MAX_COUNT;

	if(k == 0 && psf->str_end != NULL)
	{
		; // psf_log_printf (psf, "SFE_STR_WEIRD : k == 0 && psf->str_end != NULL\n");
		return SFE_STR_WEIRD;
		};

	if(k != 0 && psf->str_end == NULL)
	{
		; // psf_log_printf (psf, "SFE_STR_WEIRD : k != 0 && psf->str_end == NULL\n");
		return SFE_STR_WEIRD;
		};

	/* Special case for the first string. */
	if(k == 0)
		psf->str_end = psf->str_storage;


	len_remaining = SIGNED_SIZEOF (psf->str_storage) - (psf->str_end - psf->str_storage);

	if(len_remaining < str_len + 2)
		return SFE_STR_MAX_DATA;

	switch (str_type)
	{	case SF_STR_SOFTWARE :
				/* Fall though if not write mode. */
		case SF_STR_TITLE :
		case SF_STR_COPYRIGHT :
		case SF_STR_ARTIST :
		case SF_STR_COMMENT :
		case SF_STR_DATE :
				psf->strings [k].type = str_type;
				psf->strings [k].str = psf->str_end;
				psf->strings [k].flags = str_flags;

				/* Plus one to catch string terminator. */
				memcpy (psf->str_end, str, str_len + 1);
				psf->str_end += str_len + 1;
				break;

		default :
			return SFE_STR_BAD_TYPE;
		};

	psf->str_flags |= (psf->have_written) ? SF_STR_LOCATE_END : SF_STR_LOCATE_START;

	return 0;
} /* psf_store_string */

// common.c:

int
s_bitwidth_to_subformat (int bits)
{	static int array [] =
	{	SF_FORMAT_PCM_S8, SF_FORMAT_PCM_16, SF_FORMAT_PCM_24, SF_FORMAT_PCM_32
		};

	if(bits < 8 || bits > 32)
		return 0;

	return array [((bits + 7) / 8) - 1];
} /* bitwidth_to_subformat */


int
u_bitwidth_to_subformat (int bits)
{	static int array [] =
	{	SF_FORMAT_PCM_U8, SF_FORMAT_PCM_16, SF_FORMAT_PCM_24, SF_FORMAT_PCM_32
		};

	if(bits < 8 || bits > 32)
		return 0;

	return array [((bits + 7) / 8) - 1];
} /* bitwidth_to_subformat */

/*-----------------------------------------------------------------------------------------------
**; psf_log_printf allows libsndfile internal functions to print to an internal logbuffer which
** can later be displayed.
** The format specifiers are as for printf but without the field width and other modifiers.
** Printing is performed to the logbuffer char array of the SF_PRIVATE struct.
** Printing is done in such a way as to guarantee that the log never overflows the end of the
** logbuffer array.
*/

#define LOG_PUTCHAR(a,b)									\
			if((a)->logindex < SF_BUFFER_LEN - 1)			\
			{	(a)->logbuffer [(a)->logindex++] = (b);	\
				(a)->logbuffer [(a)->logindex] = 0;		\
				}											\
			else											\
				break;

/*-----------------------------------------------------------------------------------------------
**  Binary header reading functions. Returns number of bytes read.
**
**	Format specifiers are the same as for header write function above with the following
**	additions:
**
**		p   - jump a given number of position from start of file.
**		j   - jump a given number of bytes forward in the file.
**
**	If format is NULL, psf_binheader_readf returns the current offset.
*/

#if(CPU_IS_BIG_ENDIAN == 1)
#define	GET_MARKER(ptr)	( ((ptr) [0] << 24) | ((ptr) [1] << 16) |	\
						  ((ptr) [2] <<  8) | ((ptr) [3]) )

#elif(CPU_IS_LITTLE_ENDIAN == 1)
#define	GET_MARKER(ptr)	( ((ptr) [0]      ) | ((ptr) [1] <<  8) |	\
						  ((ptr) [2] << 16) | ((ptr) [3] << 24) )

#else
#       error "Cannot determine endian-ness of processor."
#endif

#define	GET_LE_SHORT(ptr)	( ((ptr) [1] <<  8) | ((ptr) [0]) )
#define	GET_BE_SHORT(ptr)	( ((ptr) [0] <<  8) | ((ptr) [1]) )

#define	GET_LE_3BYTE(ptr)	( 	((ptr) [2] << 16) | ((ptr) [1] << 8) | ((ptr) [0]) )
#define	GET_BE_3BYTE(ptr)	( 	((ptr) [0] << 16) | ((ptr) [1] << 8) | ((ptr) [2]) )

#define	GET_LE_INT(ptr)		( 	((ptr) [3] << 24) | ((ptr) [2] << 16) |	\
								((ptr) [1] <<  8) | ((ptr) [0]) )

#define	GET_BE_INT(ptr)		( 	((ptr) [0] << 24) | ((ptr) [1] << 16) |	\
							 	((ptr) [2] <<  8) | ((ptr) [3]) )

#if(SIZEOF_LONG == 4)
#define	GET_LE_8BYTE(ptr)	( 	((ptr) [3] << 24) | ((ptr) [2] << 16) |	\
							 	((ptr) [1] <<  8) | ((ptr) [0]) )

#define	GET_BE_8BYTE(ptr)	( 	((ptr) [4] << 24) | ((ptr) [5] << 16) |	\
								((ptr) [6] <<  8) | ((ptr) [7]) )
#else
#define	GET_LE_8BYTE(ptr)	( 	((ptr) [7] << 56L) | ((ptr) [6] << 48L) |	\
							 	((ptr) [5] << 40L) | ((ptr) [4] << 32L) |	\
							 	((ptr) [3] << 24L) | ((ptr) [2] << 16L) |	\
							 	((ptr) [1] <<  8L) | ((ptr) [0] ))

#define	GET_BE_8BYTE(ptr)	( 	((ptr) [0] << 56L) | ((ptr) [1] << 48L) |	\
							 	((ptr) [2] << 40L) | ((ptr) [3] << 32L) |	\
							 	((ptr) [4] << 24L) | ((ptr) [5] << 16L) |	\
							 	((ptr) [6] <<  8L) | ((ptr) [7] ))

#endif


int
psf_binheader_readf (SF_PRIVATE *psf, char const *format, ...)
{	va_list			argptr;
	sf_count_t		*countptr, countdata, position;
	unsigned char	*ucptr, sixteen_bytes [16];
	unsigned int 	*intptr, intdata;
	unsigned short	*shortptr;
	char    		*charptr;
	size_t			size;
	char			c;
	int				count = 0;

	if(! format)
		return psf_ftell (psf);

	va_start (argptr, format);

	while((c = *format++))
	{	switch (c)
		{	case 'e' : /* All conversions are now from LE to host. */
					psf->rwf_endian = SF_ENDIAN_LITTLE;
					break;

			case 'E' : /* All conversions are now from BE to host. */
					psf->rwf_endian = SF_ENDIAN_BIG;
					break;

			case 'm' :
					intptr = va_arg (argptr, unsigned int*);
					ucptr = (unsigned char*) intptr;
					count += psf_fread (ucptr, 1, sizeof (int), psf);
					*intptr = GET_MARKER (ucptr);
					break;

			case 'h' :
					intptr = va_arg (argptr, unsigned int*);
					ucptr = (unsigned char*) intptr;
					count += psf_fread (sixteen_bytes, 1, sizeof (sixteen_bytes), psf);
					{	int k;
						intdata = 0;
						for(k = 0; k < 16; k++)
							intdata ^= sixteen_bytes [k] << k;
						}
					*intptr = intdata;
					break;

			case '1' :
					charptr = va_arg (argptr, char*);
					count += psf_fread (charptr, 1, sizeof (char), psf);
					break;

			case '2' :
					shortptr = va_arg (argptr, unsigned short*);
					ucptr = (unsigned char*) shortptr;
					count += psf_fread (ucptr, 1, sizeof (short), psf);
					if(psf->rwf_endian == SF_ENDIAN_BIG)
						*shortptr = GET_BE_SHORT (ucptr);
					else
						*shortptr = GET_LE_SHORT (ucptr);
					break;

			case '3' :
					intptr = va_arg (argptr, unsigned int*);
					count += psf_fread (sixteen_bytes, 1, 3, psf);
					if(psf->rwf_endian == SF_ENDIAN_BIG)
						*intptr = GET_BE_3BYTE (sixteen_bytes);
					else
						*intptr = GET_LE_3BYTE (sixteen_bytes);
					break;

			case '4' :
					intptr = va_arg (argptr, unsigned int*);
					ucptr = (unsigned char*) intptr;
					count += psf_fread (ucptr, 1, sizeof (int), psf);
					if(psf->rwf_endian == SF_ENDIAN_BIG)
						*intptr = GET_BE_INT (ucptr);
					else
						*intptr = GET_LE_INT (ucptr);
					break;

			case '8' :
					countptr = va_arg (argptr, sf_count_t*);
					count += psf_fread (sixteen_bytes, 1, 8, psf);
					if(psf->rwf_endian == SF_ENDIAN_BIG)
						countdata = GET_BE_8BYTE (sixteen_bytes);
					else
						countdata = GET_LE_8BYTE (sixteen_bytes);
					*countptr = countdata;
					break;

			case 's' :
					; // psf_log_printf (psf, "Format conversion 's' not implemented yet.\n");
					break;

			case 'b' :
					charptr = va_arg (argptr, char*);
					size = va_arg (argptr, int);
					if(size > 0)
					{	memset (charptr, 0, size);
						count += psf_fread (charptr, 1, size, psf);
						};
					break;

			case 'z' :
					; // psf_log_printf (psf, "Format conversion 'z' not implemented yet.\n");
					break;

			case 'p' :
					/* Get the seek position first. */
					position = va_arg (argptr, int);
					psf_fseek (psf, position, SEEK_SET);
					count = 0;
					break;

			case 'j' :
					/* Get the seek position first. */
					position = va_arg (argptr, int);
					psf_fseek (psf, position, SEEK_CUR);
					count = 0;
					break;

			default :
				; // psf_log_printf (psf, "*** Invalid format specifier `%c'\n", c);
				psf->error = SFE_INTERNAL;
				break;
			};
		};

	va_end (argptr);

	return count;
} /* psf_binheader_readf */

/*-----------------------------------------------------------------------------------------------
*/

sf_count_t
psf_default_seek (SF_PRIVATE *psf, int mode, sf_count_t samples_from_start)
{	sf_count_t position, retval;

	if(! (psf->blockwidth && psf->dataoffset >= 0))
	{	psf->error = SFE_BAD_SEEK;
		return	((sf_count_t) -1);
		};

	position = psf->dataoffset + psf->blockwidth * samples_from_start;

	if((retval = psf_fseek (psf, position, SEEK_SET)) != position)
	{	psf->error = SFE_SEEK_FAILED;
		return ((sf_count_t) -1);
		};

	mode = mode;

	return samples_from_start;
} /* psf_default_seek */

/*========================================================================================
*/

void*
psf_memset (void *s, int c, sf_count_t len)
{	char	*ptr;
	int 	setcount;

	ptr = (char *) s;

	while(len > 0)
	{	setcount = (len > 0x10000000) ? 0x10000000 : (int) len;

		memset (ptr, c, setcount);

		ptr += setcount;
		len -= setcount;
		};

	return s;
} /* psf_memset */

/*-----------------------------------------------------------------------------------------------
** Generic functions for performing endian swapping on integer arrays.
*/

void
endswap_short_array (short *ptr, int len)
{	

#if 0
	unsigned char *ucptr, temp;

	ucptr = ((unsigned char *) ptr) + 2 * len;
	while(len > 0)
	{	len --;
		ucptr -= 2;
		temp = ucptr [0];
		ucptr [0] = ucptr [1];
		ucptr [1] = temp;
		};
#else
	short	temp;
	while(len > 0)
	{	len --;
		temp = ptr [len];
		ptr [len] = ENDSWAP_SHORT (temp);
		}
#endif
} /* endswap_short_array */

void
endswap_int_array (int *ptr, int len)
{
#if 0
	unsigned char *ucptr, temp;
	
	ucptr = ((unsigned char *) ptr) + 4 * len;
	while(len > 0)
	{	len --;
		ucptr -= 4;

		temp = ucptr [0];
		ucptr [0] = ucptr [3];
		ucptr [3] = temp;

		temp = ucptr [1];
		ucptr [1] = ucptr [2];
		ucptr [2] = temp;
		};
#else
	int temp;
	
	while(len > 0)
	{	len --;
		temp = ptr [len];
		ptr [len] = ENDSWAP_INT (temp);
		};
#endif
} /* endswap_int_array */

/*	This function assumes that sizeof (long) == 8, but works correctly even 
**	is sizeof (long) == 4.
*/
void
endswap_long_array (long *ptr, int len)
{	unsigned char *ucptr, temp;
	
	ucptr = (unsigned char *) ptr + 8 * len;
	while(len > 0)
	{	len --;
		ucptr -= 8;
	
		temp = ucptr [0];
		ucptr [0] = ucptr [7];
		ucptr [7] = temp;

		temp = ucptr [1];
		ucptr [1] = ucptr [6];
		ucptr [6] = temp;
		
		temp = ucptr [2];
		ucptr [2] = ucptr [5];
		ucptr [5] = temp;
		
		temp = ucptr [3];
		ucptr [3] = ucptr [4];
		ucptr [4] = temp;
		};
} /* endswap_long_array */

/*========================================================================================
*/

void
endswap_short_copy (short *dest, short *src, int len)
{	
#if	0
	char *psrc, *pdest;

	psrc = ((char *) src) + 2 * len;
	pdest = ((char *) dest) + 2 * len;
	while(len > 0)
	{	len --;
		psrc -= 2;
		pdest -= 2;
		
		pdest [0] = psrc [1];
		pdest [1] = psrc [0];
		};
#else
	while(len > 0)
	{	len --;
		dest [len] = ENDSWAP_SHORT (src [len]);
		};
#endif
} /* endswap_short_copy */

void
endswap_int_copy (int *dest, int *src, int len)
{	
#if	0
	char *psrc, *pdest;
	
	psrc = ((char *) src) + 4 * len;
	pdest = ((char *) dest) + 4 * len;
	while(len > 0)
	{	len --;
		psrc -= 4;
		pdest -= 4;

		pdest [0] = psrc [3];
		pdest [1] = psrc [2];
		pdest [2] = psrc [1];
		pdest [3] = psrc [0];
		};
#else
	while(len > 0)
	{	len --;
		dest [len] = ENDSWAP_INT (src [len]);
		};
#endif
} /* endswap_int_copy */

/*	This function assumes that sizeof (long) == 8, but works correctly even 
**	is sizeof (long) == 4.
*/
void
endswap_long_copy (long *dest, long *src, int len)
{	char *psrc, *pdest;
	
	psrc = (char *) src + 8 * len;
	pdest = (char *) dest + 8 * len;
	while(len > 0)
	{	len --;
		psrc -= 8;
		pdest -= 8;
	
		pdest [0] = psrc [7];
		pdest [1] = psrc [6];
		pdest [2] = psrc [5];
		pdest [3] = psrc [4];
		pdest [4] = psrc [3];
		pdest [5] = psrc [2];
		pdest [6] = psrc [1];
		pdest [7] = psrc [0];
		};
} /* endswap_long_copy */

// pcm.c :
/* Need to be able to handle 3 byte (24 bit) integers. So defined a
** type and use SIZEOF_TRIBYTE instead of (tribyte).
*/

typedef	void  tribyte;

#define	SIZEOF_TRIBYTE	3

static sf_count_t	pcm_read_sc2s  (SF_PRIVATE *psf, short *ptr, sf_count_t len);
static sf_count_t	pcm_read_uc2s  (SF_PRIVATE *psf, short *ptr, sf_count_t len);
static sf_count_t	pcm_read_bes2s (SF_PRIVATE *psf, short *ptr, sf_count_t len);
static sf_count_t	pcm_read_les2s (SF_PRIVATE *psf, short *ptr, sf_count_t len);
static sf_count_t	pcm_read_bet2s (SF_PRIVATE *psf, short *ptr, sf_count_t len);
static sf_count_t	pcm_read_let2s (SF_PRIVATE *psf, short *ptr, sf_count_t len);
static sf_count_t	pcm_read_bei2s (SF_PRIVATE *psf, short *ptr, sf_count_t len);
static sf_count_t	pcm_read_lei2s (SF_PRIVATE *psf, short *ptr, sf_count_t len);

static sf_count_t	pcm_read_sc2i  (SF_PRIVATE *psf, int *ptr, sf_count_t len);
static sf_count_t	pcm_read_uc2i  (SF_PRIVATE *psf, int *ptr, sf_count_t len);
static sf_count_t	pcm_read_bes2i (SF_PRIVATE *psf, int *ptr, sf_count_t len);
static sf_count_t	pcm_read_les2i (SF_PRIVATE *psf, int *ptr, sf_count_t len);
static sf_count_t	pcm_read_bet2i (SF_PRIVATE *psf, int *ptr, sf_count_t len);
static sf_count_t	pcm_read_let2i (SF_PRIVATE *psf, int *ptr, sf_count_t len);
static sf_count_t	pcm_read_bei2i (SF_PRIVATE *psf, int *ptr, sf_count_t len);
static sf_count_t	pcm_read_lei2i (SF_PRIVATE *psf, int *ptr, sf_count_t len);

static sf_count_t	pcm_read_sc2f  (SF_PRIVATE *psf, float *ptr, sf_count_t len);
static sf_count_t	pcm_read_uc2f  (SF_PRIVATE *psf, float *ptr, sf_count_t len);
static sf_count_t	pcm_read_bes2f (SF_PRIVATE *psf, float *ptr, sf_count_t len);
static sf_count_t	pcm_read_les2f (SF_PRIVATE *psf, float *ptr, sf_count_t len);
static sf_count_t	pcm_read_bet2f (SF_PRIVATE *psf, float *ptr, sf_count_t len);
static sf_count_t	pcm_read_let2f (SF_PRIVATE *psf, float *ptr, sf_count_t len);
static sf_count_t	pcm_read_bei2f (SF_PRIVATE *psf, float *ptr, sf_count_t len);
static sf_count_t	pcm_read_lei2f (SF_PRIVATE *psf, float *ptr, sf_count_t len);

static sf_count_t	pcm_read_sc2d  (SF_PRIVATE *psf, double *ptr, sf_count_t len);
static sf_count_t	pcm_read_uc2d  (SF_PRIVATE *psf, double *ptr, sf_count_t len);
static sf_count_t	pcm_read_bes2d (SF_PRIVATE *psf, double *ptr, sf_count_t len);
static sf_count_t	pcm_read_les2d (SF_PRIVATE *psf, double *ptr, sf_count_t len);
static sf_count_t	pcm_read_bet2d (SF_PRIVATE *psf, double *ptr, sf_count_t len);
static sf_count_t	pcm_read_let2d (SF_PRIVATE *psf, double *ptr, sf_count_t len);
static sf_count_t	pcm_read_bei2d (SF_PRIVATE *psf, double *ptr, sf_count_t len);
static sf_count_t	pcm_read_lei2d (SF_PRIVATE *psf, double *ptr, sf_count_t len);

static void sc2s_array	(signed char *src, int count, short *dest);
static void uc2s_array	(unsigned char *src, int count, short *dest);

static void bet2s_array (tribyte *src, int count, short *dest);
static void let2s_array (tribyte *src, int count, short *dest);
static void bei2s_array (int *src, int count, short *dest);
static void lei2s_array (int *src, int count, short *dest);

static void sc2i_array	(signed char *src, int count, int *dest);
static void uc2i_array	(unsigned char *src, int count, int *dest);
static void bes2i_array (short *src, int count, int *dest);
static void les2i_array (short *src, int count, int *dest);
static void bet2i_array (tribyte *src, int count, int *dest);
static void let2i_array (tribyte *src, int count, int *dest);

static void sc2f_array	(signed char *src, int count, float *dest, float normfact);
static void uc2f_array	(unsigned char *src, int count, float *dest, float normfact);
static void bes2f_array (short *src, int count, float *dest, float normfact);
static void les2f_array (short *src, int count, float *dest, float normfact);
static void bet2f_array (tribyte *src, int count, float *dest, float normfact);
static void let2f_array (tribyte *src, int count, float *dest, float normfact);
static void bei2f_array (int *src, int count, float *dest, float normfact);
static void lei2f_array (int *src, int count, float *dest, float normfact);

static void sc2d_array	(signed char *src, int count, double *dest, double normfact);
static void uc2d_array	(unsigned char *src, int count, double *dest, double normfact);
static void bes2d_array (short *src, int count, double *dest, double normfact);
static void les2d_array (short *src, int count, double *dest, double normfact);
static void bet2d_array (tribyte *src, int count, double *dest, double normfact);
static void let2d_array (tribyte *src, int count, double *dest, double normfact);
static void bei2d_array (int *src, int count, double *dest, double normfact);
static void lei2d_array (int *src, int count, double *dest, double normfact);
/*-----------------------------------------------------------------------------------------------
*/

enum
{	/* Char type for 8 bit files. */
	SF_CHARS_SIGNED		= 200,
	SF_CHARS_UNSIGNED	= 201
};

/*-----------------------------------------------------------------------------------------------
*/

int
pcm_init (SF_PRIVATE *psf)
{	int chars = 0;

	if(psf->bytewidth == 0 || psf->sf.channels == 0)
		return SFE_INTERNAL;


	psf->blockwidth = psf->bytewidth * psf->sf.channels;

	if((psf->sf.format & SF_FORMAT_SUBMASK) == SF_FORMAT_PCM_S8)
		chars = SF_CHARS_SIGNED;
	else if((psf->sf.format & SF_FORMAT_SUBMASK) == SF_FORMAT_PCM_U8)
		chars = SF_CHARS_UNSIGNED;

	if(psf->mode == SFM_READ)
	{	switch (psf->bytewidth * 0x10000 + psf->endian + chars)
		{	case (0x10000 + SF_ENDIAN_BIG + SF_CHARS_SIGNED) :
			case (0x10000 + SF_ENDIAN_LITTLE + SF_CHARS_SIGNED) :
					psf->read_short  = pcm_read_sc2s;
					psf->read_int    = pcm_read_sc2i;
					psf->read_float  = pcm_read_sc2f;
					psf->read_double = pcm_read_sc2d;
					break;
			case (0x10000 + SF_ENDIAN_BIG + SF_CHARS_UNSIGNED) :
			case (0x10000 + SF_ENDIAN_LITTLE + SF_CHARS_UNSIGNED) :
					psf->read_short  = pcm_read_uc2s;
					psf->read_int    = pcm_read_uc2i;
					psf->read_float  = pcm_read_uc2f;
					psf->read_double = pcm_read_uc2d;
					break;

			case  (2 * 0x10000 + SF_ENDIAN_BIG) :
					psf->read_short  = pcm_read_bes2s;
					psf->read_int    = pcm_read_bes2i;
					psf->read_float  = pcm_read_bes2f;
					psf->read_double = pcm_read_bes2d;
					break;
			case  (3 * 0x10000 + SF_ENDIAN_BIG) :
					psf->read_short  = pcm_read_bet2s;
					psf->read_int    = pcm_read_bet2i;
					psf->read_float  = pcm_read_bet2f;
					psf->read_double = pcm_read_bet2d;
					break;
			case  (4 * 0x10000 + SF_ENDIAN_BIG) :
					psf->read_short  = pcm_read_bei2s;
					psf->read_int    = pcm_read_bei2i;
					psf->read_float  = pcm_read_bei2f;
					psf->read_double = pcm_read_bei2d;
					break;

			case  (2 * 0x10000 + SF_ENDIAN_LITTLE) :
					psf->read_short  = pcm_read_les2s;
					psf->read_int    = pcm_read_les2i;
					psf->read_float  = pcm_read_les2f;
					psf->read_double = pcm_read_les2d;
					break;
			case  (3 * 0x10000 + SF_ENDIAN_LITTLE) :
					psf->read_short  = pcm_read_let2s;
					psf->read_int    = pcm_read_let2i;
					psf->read_float  = pcm_read_let2f;
					psf->read_double = pcm_read_let2d;
					break;
			case  (4 * 0x10000 + SF_ENDIAN_LITTLE) :
					psf->read_short  = pcm_read_lei2s;
					psf->read_int    = pcm_read_lei2i;
					psf->read_float  = pcm_read_lei2f;
					psf->read_double = pcm_read_lei2d;
					break;
			default :
				// psf_log_printf (psf, "pcm.c returning SFE_UNIMPLEMENTED\n");
				maLog("maPlayAif pcm_init format not implemented");
				return SFE_UNIMPLEMENTED;
		};
	};

	if(psf->filelength > psf->dataoffset)
	{	psf->datalength = (psf->dataend > 0) ? psf->dataend - psf->dataoffset :
							psf->filelength - psf->dataoffset;
		}
	else
		psf->datalength = 0;

	psf->sf.frames  = psf->datalength / psf->blockwidth;

	return 0;
} /* pcm_init */

/*-----------------------------------------------------------------------------------------------
*/

static sf_count_t
pcm_read_sc2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (signed char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (signed char), readcount, psf);
		sc2s_array ((signed char*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_sc2s */

static sf_count_t
pcm_read_uc2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (unsigned char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (unsigned char), readcount, psf);
		uc2s_array ((unsigned char*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_uc2s */

static sf_count_t
pcm_read_bes2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int		total;

	total = psf_fread (ptr, sizeof (short), len, psf);
	if(CPU_IS_LITTLE_ENDIAN)
		endswap_short_array (ptr, len);

	return total;
} /* pcm_read_bes2s */

static sf_count_t
pcm_read_les2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int		total;

	total = psf_fread (ptr, sizeof (short), len, psf);
	if(CPU_IS_BIG_ENDIAN)
		endswap_short_array (ptr, len);

	return total;
} /* pcm_read_les2s */

static sf_count_t
pcm_read_bet2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		bet2s_array ((tribyte*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bet2s */

static sf_count_t
pcm_read_let2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		let2s_array ((tribyte*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_let2s */

static sf_count_t
pcm_read_bei2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (int);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (int), readcount, psf);
		bei2s_array ((int*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bei2s */

static sf_count_t
pcm_read_lei2s (SF_PRIVATE *psf, short *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (int);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (int), readcount, psf);
		lei2s_array ((int*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_lei2s */

/*-----------------------------------------------------------------------------------------------
*/

static sf_count_t
pcm_read_sc2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (signed char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (signed char), readcount, psf);
		sc2i_array ((signed char*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_sc2i */

static sf_count_t
pcm_read_uc2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (unsigned char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (unsigned char), readcount, psf);
		uc2i_array ((unsigned char*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_uc2i */

static sf_count_t
pcm_read_bes2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (short);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (short), readcount, psf);
		bes2i_array ((short*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bes2i */

static sf_count_t
pcm_read_les2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / sizeof (short);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (short), readcount, psf);
		les2i_array ((short*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_les2i */

static sf_count_t
pcm_read_bet2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		bet2i_array ((tribyte*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bet2i */

static sf_count_t
pcm_read_let2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		let2i_array ((tribyte*) (psf->buffer), thisread, ptr + total);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_let2i */

static sf_count_t
pcm_read_bei2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int		total;

	total = psf_fread (ptr, sizeof (int), len, psf);
	if(CPU_IS_LITTLE_ENDIAN)
		endswap_int_array	(ptr, len);

	return total;
} /* pcm_read_bei2i */

static sf_count_t
pcm_read_lei2i (SF_PRIVATE *psf, int *ptr, sf_count_t len)
{	int		total;

	total = psf_fread (ptr, sizeof (int), len, psf);
	if(CPU_IS_BIG_ENDIAN)
		endswap_int_array	(ptr, len);

	return total;
} /* pcm_read_lei2i */

/*-----------------------------------------------------------------------------------------------
*/

static sf_count_t
pcm_read_sc2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x80) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (signed char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (signed char), readcount, psf);
		sc2f_array ((signed char*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_sc2f */

static sf_count_t
pcm_read_uc2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x80) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (unsigned char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (unsigned char), readcount, psf);
		uc2f_array ((unsigned char*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_uc2f */

static sf_count_t
pcm_read_bes2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x8000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (short);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (short), readcount, psf);
		bes2f_array ((short*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bes2f */

static sf_count_t
pcm_read_les2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x8000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (short);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (short), readcount, psf);
		les2f_array ((short*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_les2f */

static sf_count_t
pcm_read_bet2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	/* Special normfactor because tribyte value is read into an int. */
	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x80000000) : 1.0 / 256.0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		bet2f_array ((tribyte*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bet2f */

static sf_count_t
pcm_read_let2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	/* Special normfactor because tribyte value is read into an int. */
	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x80000000) : 1.0 / 256.0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		let2f_array ((tribyte*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_let2f */

static sf_count_t
pcm_read_bei2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x80000000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (int);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (int), readcount, psf);
		bei2f_array ((int*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bei2f */

static sf_count_t
pcm_read_lei2f (SF_PRIVATE *psf, float *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	float	normfact;

	normfact = (psf->norm_float == SF_TRUE) ? 1.0 / ((float) 0x80000000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (int);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (int), readcount, psf);
		lei2f_array ((int*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_lei2f */

/*-----------------------------------------------------------------------------------------------
*/

static sf_count_t
pcm_read_sc2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x80) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (signed char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (signed char), readcount, psf);
		sc2d_array ((signed char*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_sc2d */

static sf_count_t
pcm_read_uc2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x80) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (unsigned char);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (unsigned char), readcount, psf);
		uc2d_array ((unsigned char*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_uc2d */

static sf_count_t
pcm_read_bes2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x8000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (short);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (short), readcount, psf);
		bes2d_array ((short*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bes2d */

static sf_count_t
pcm_read_les2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x8000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (short);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (short), readcount, psf);
		les2d_array ((short*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_les2d */

static sf_count_t
pcm_read_bet2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x80000000) : 1.0 / 256.0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		bet2d_array ((tribyte*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bet2d */

static sf_count_t
pcm_read_let2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	/* Special normfactor because tribyte value is read into an int. */
	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x80000000) : 1.0 / 256.0;

	bufferlen = sizeof (psf->buffer) / SIZEOF_TRIBYTE;

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, SIZEOF_TRIBYTE, readcount, psf);
		let2d_array ((tribyte*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_let2d */

static sf_count_t
pcm_read_bei2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x80000000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (int);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (int), readcount, psf);
		bei2d_array ((int*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_bei2d */

static sf_count_t
pcm_read_lei2d (SF_PRIVATE *psf, double *ptr, sf_count_t len)
{	int			bufferlen, readcount, thisread;
	sf_count_t	total = 0;
	double		normfact;

	normfact = (psf->norm_double == SF_TRUE) ? 1.0 / ((double) 0x80000000) : 1.0;

	bufferlen = sizeof (psf->buffer) / sizeof (int);

	while(len > 0)
	{	readcount = (len >= bufferlen) ? bufferlen : (int) len;
		thisread = psf_fread (psf->buffer, sizeof (int), readcount, psf);
		lei2d_array ((int*) (psf->buffer), thisread, ptr + total, normfact);
		total += thisread;
		len -= thisread;
		if(thisread < readcount)
			break;
		};

	return total;
} /* pcm_read_lei2d */

/*-----------------------------------------------------------------------------------------------
*/

static	void
sc2s_array	(signed char *src, int count, short *dest)
{	while(count)
	{	count --;
		dest [count] = src [count] << 8;
		};
} /* sc2s_array */

static	void
uc2s_array	(unsigned char *src, int count, short *dest)
{	while(count)
	{	count --;
		dest [count] = (((short) src [count]) - 0x80) << 8;
		};
} /* uc2s_array */

static void
let2s_array (tribyte *src, int count, short *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		dest [count] = LET2H_SHORT_PTR (ucptr);
		};
} /* let2s_array */

static void
bet2s_array (tribyte *src, int count, short *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		dest [count] = BET2H_SHORT_PTR (ucptr);
		};
} /* bet2s_array */

static void
lei2s_array (int *src, int count, short *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 4 * count;
	while(count)
	{	count --;
		ucptr -= 4;
		dest [count] = LEI2H_SHORT_PTR (ucptr);
		};
} /* lei2s_array */

static void
bei2s_array (int *src, int count, short *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 4 * count;
	while(count)
	{	count --;
		ucptr -= 4;
		dest [count] = BEI2H_SHORT_PTR (ucptr);
		};
} /* bei2s_array */

/*-----------------------------------------------------------------------------------------------
*/

static	void
sc2i_array	(signed char *src, int count, int *dest)
{	while(count)
	{	count --;
		dest [count] = ((int) src [count]) << 24;
		};
} /* sc2i_array */

static	void
uc2i_array	(unsigned char *src, int count, int *dest)
{	while(count)
	{	count --;
		dest [count] = (((int) src [count]) - 128) << 24;
		};
} /* uc2i_array */

static void
bes2i_array (short *src, int count, int *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 2 * count;
	while(count)
	{	count --;
		ucptr -= 2;
		dest [count] = BES2H_INT_PTR (ucptr);
		};
} /* bes2i_array */

static void
les2i_array (short *src, int count, int *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 2 * count;
	while(count)
	{	count --;
		ucptr -= 2;
		dest [count] = LES2H_INT_PTR (ucptr);
		};
} /* les2i_array */

static void
bet2i_array (tribyte *src, int count, int *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		dest [count] = BET2H_INT_PTR (ucptr);
		};
} /* bet2i_array */

static void
let2i_array (tribyte *src, int count, int *dest)
{	unsigned char	*ucptr;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		dest [count] = LET2H_INT_PTR (ucptr);
		};
} /* let2i_array */

/*-----------------------------------------------------------------------------------------------
*/


static	void
sc2f_array	(signed char *src, int count, float *dest, float normfact)
{	while(count)
	{	count --;
		dest [count] = ((float) src [count]) * normfact;
		};
} /* sc2f_array */

static	void
uc2f_array	(unsigned char *src, int count, float *dest, float normfact)
{	while(count)
	{	count --;
		dest [count] = (((float) src [count]) - 128.0) * normfact;
		};
} /* uc2f_array */

static void
les2f_array (short *src, int count, float *dest, float normfact)
{	short	value;

	while(count)
	{	count --;
		value = src [count];
		value = LES2H_SHORT (value);
		dest [count] = ((float) value) * normfact;
		};
} /* les2f_array */

static void
bes2f_array (short *src, int count, float *dest, float normfact)
{	short			value;

	while(count)
	{	count --;
		value = src [count];
		value = BES2H_SHORT (value);
		dest [count] = ((float) value) * normfact;
		};
} /* bes2f_array */

static void
let2f_array (tribyte *src, int count, float *dest, float normfact)
{	unsigned char	*ucptr;
	int 			value;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		value = LET2H_INT_PTR (ucptr);
		dest [count] = ((float) value) * normfact;
		};
} /* let2f_array */

static void
bet2f_array (tribyte *src, int count, float *dest, float normfact)
{	unsigned char	*ucptr;
	int 	value;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		value = BET2H_INT_PTR (ucptr);
		dest [count] = ((float) value) * normfact;
		};
} /* bet2f_array */

static void
lei2f_array (int *src, int count, float *dest, float normfact)
{	int 			value;

	while(count)
	{	count --;
		value = src [count];
		value = LEI2H_INT (value);
		dest [count] = ((float) value) * normfact;
		};
} /* lei2f_array */

static void
bei2f_array (int *src, int count, float *dest, float normfact)
{	int 			value;

	while(count)
	{	count --;
		value = src [count];
		value = BEI2H_INT (value);
		dest [count] = ((float) value) * normfact;
		};
} /* bei2f_array */

/*-----------------------------------------------------------------------------------------------
*/

static	void
sc2d_array	(signed char *src, int count, double *dest, double normfact)
{	while(count)
	{	count --;
		dest [count] = ((double) src [count]) * normfact;
		};
} /* sc2d_array */

static	void
uc2d_array	(unsigned char *src, int count, double *dest, double normfact)
{	while(count)
	{	count --;
		dest [count] = (((double) src [count]) - 128.0) * normfact;
		};
} /* uc2d_array */

static void
les2d_array (short *src, int count, double *dest, double normfact)
{	short	value;

	while(count)
	{	count --;
		value = src [count];
		value = LES2H_SHORT (value);
		dest [count] = ((double) value) * normfact;
		};
} /* les2d_array */

static void
bes2d_array (short *src, int count, double *dest, double normfact)
{	short	value;

	while(count)
	{	count --;
		value = src [count];
		value = BES2H_SHORT (value);
		dest [count] = ((double) value) * normfact;
		};
} /* bes2d_array */

static void
let2d_array (tribyte *src, int count, double *dest, double normfact)
{	unsigned char	*ucptr;
	int 	value;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		value = LET2H_INT_PTR (ucptr);
		dest [count] = ((double) value) * normfact;
		};
} /* let2d_array */

static void
bet2d_array (tribyte *src, int count, double *dest, double normfact)
{	unsigned char	*ucptr;
	int 	value;

	ucptr = ((unsigned char*) src) + 3 * count;
	while(count)
	{	count --;
		ucptr -= 3;
		value = (ucptr [0] << 24) | (ucptr [1] << 16) | (ucptr [2] << 8);
		dest [count] = ((double) value) * normfact;
		};
} /* bet2d_array */

static void
lei2d_array (int *src, int count, double *dest, double normfact)
{	int 	value;

	while(count)
	{	count --;
		value = src [count];
		value = LEI2H_INT (value);
		dest [count] = ((double) value) * normfact;
		};
} /* lei2d_array */

static void
bei2d_array (int *src, int count, double *dest, double normfact)
{	int 	value;

	while(count)
	{	count --;
		value = src [count];
		value = BEI2H_INT (value);
		dest [count] = ((double) value) * normfact;
		};
} /* bei2d_array */

/*==============================================================================
*/

// aiff.c:

/*------------------------------------------------------------------------------
 * Macros to handle big/little endian issues.
 */

#define FORM_MARKER	(MAKE_MARKER ('F', 'O', 'R', 'M'))
#define AIFF_MARKER	(MAKE_MARKER ('A', 'I', 'F', 'F'))
#define AIFC_MARKER	(MAKE_MARKER ('A', 'I', 'F', 'C'))
#define COMM_MARKER	(MAKE_MARKER ('C', 'O', 'M', 'M'))
#define SSND_MARKER	(MAKE_MARKER ('S', 'S', 'N', 'D'))
#define MARK_MARKER	(MAKE_MARKER ('M', 'A', 'R', 'K'))
#define INST_MARKER	(MAKE_MARKER ('I', 'N', 'S', 'T'))
#define APPL_MARKER	(MAKE_MARKER ('A', 'P', 'P', 'L'))

#define c_MARKER	(MAKE_MARKER ('(', 'c', ')', ' '))
#define NAME_MARKER	(MAKE_MARKER ('N', 'A', 'M', 'E'))
#define AUTH_MARKER	(MAKE_MARKER ('A', 'U', 'T', 'H'))
#define ANNO_MARKER	(MAKE_MARKER ('A', 'N', 'N', 'O'))
#define COMT_MARKER	(MAKE_MARKER ('C', 'O', 'M', 'T'))
#define FVER_MARKER	(MAKE_MARKER ('F', 'V', 'E', 'R'))
#define SFX_MARKER	(MAKE_MARKER ('S', 'F', 'X', '!'))


#define PEAK_MARKER	(MAKE_MARKER ('P', 'E', 'A', 'K'))

/* Supported AIFC encodings.*/
#define NONE_MARKER	(MAKE_MARKER ('N', 'O', 'N', 'E'))
#define sowt_MARKER	(MAKE_MARKER ('s', 'o', 'w', 't'))
#define twos_MARKER	(MAKE_MARKER ('t', 'w', 'o', 's'))
#define raw_MARKER	(MAKE_MARKER ('r', 'a', 'w', ' '))
#define in32_MARKER	(MAKE_MARKER ('i', 'n', '3', '2'))
#define ni32_MARKER	(MAKE_MARKER ('2', '3', 'n', 'i'))

#define fl32_MARKER	(MAKE_MARKER ('f', 'l', '3', '2'))
#define FL32_MARKER	(MAKE_MARKER ('F', 'L', '3', '2'))
#define fl64_MARKER	(MAKE_MARKER ('f', 'l', '6', '4'))
#define FL64_MARKER	(MAKE_MARKER ('F', 'L', '6', '4'))

#define ulaw_MARKER	(MAKE_MARKER ('u', 'l', 'a', 'w'))
#define ULAW_MARKER	(MAKE_MARKER ('U', 'L', 'A', 'W'))
#define alaw_MARKER	(MAKE_MARKER ('a', 'l', 'a', 'w'))
#define ALAW_MARKER	(MAKE_MARKER ('A', 'L', 'A', 'W'))

#define DWVW_MARKER	(MAKE_MARKER ('D', 'W', 'V', 'W'))
#define GSM_MARKER	(MAKE_MARKER ('G', 'S', 'M', ' '))

/* Unsupported AIFC encodings.*/
#define ima4_MARKER	(MAKE_MARKER ('i', 'm', 'a', '4'))

#define MAC3_MARKER	(MAKE_MARKER ('M', 'A', 'C', '3'))
#define MAC6_MARKER	(MAKE_MARKER ('M', 'A', 'C', '6'))
#define ADP4_MARKER	(MAKE_MARKER ('A', 'D', 'P', '4'))

/* Predfined chunk sizes. */
#define SIZEOF_AIFF_COMM		18
#define SIZEOF_AIFC_COMM_MIN	22
#define SIZEOF_AIFC_COMM		24
#define SIZEOF_SSND_CHUNK		8
#define SIZEOF_INST_CHUNK		20

/*------------------------------------------------------------------------------
 * Typedefs for file chunks.
 */

enum
{	HAVE_FORM	= 0x01,
	HAVE_AIFF	= 0x02,
	HAVE_COMM	= 0x04,
	HAVE_SSND	= 0x08
};

typedef struct
{	unsigned int	type;
	unsigned int	size;
	short			numChannels;
	unsigned int	numSampleFrames;
	short			sampleSize;
	unsigned char	sampleRate [10];
	unsigned int	encoding;
	char			zero_bytes [2];
} COMM_CHUNK;

typedef struct
{	unsigned int	offset;
	unsigned int	blocksize;
} SSND_CHUNK;

typedef struct
{	short			playMode;
    unsigned short	beginLoop;
	unsigned short	endLoop;
} INST_LOOP;

typedef struct
{	char		baseNote;		/* all notes are MIDI note numbers */
	char		detune;		/* cents off, only -50 to +50 are significant */
	char		lowNote;
	char		highNote;
	char		lowVelocity;	/* 1 to 127 */
	char		highVelocity;	/* 1 to 127 */
	short		gain;			/* in dB, 0 is normal */
	INST_LOOP	sustain_loop;
	INST_LOOP	release_loop;
} INST_CHUNK;

/*------------------------------------------------------------------------------
 * Private static functions.
 */


static int	aiff_close	(SF_PRIVATE *psf);
static int	tenbytefloat2int (unsigned char *bytes);

static int	aiff_read_comm_chunk (SF_PRIVATE *psf, COMM_CHUNK *comm_fmt);
static int	aiff_read_header (SF_PRIVATE *psf, COMM_CHUNK *comm_fmt);
static char *get_loop_mode_str (short mode);

/*------------------------------------------------------------------------------
** Public function.
*/

int
aiff_open	(SF_PRIVATE *psf)
{	COMM_CHUNK comm_fmt;
	int error = 0;

	if(psf->mode == SFM_READ)
	{
		if((error = aiff_read_header (psf, &comm_fmt)))
			return error;

		psf_fseek (psf, psf->dataoffset, SEEK_SET);
	};

	psf->close = aiff_close;

	psf->blockwidth = psf->sf.channels * psf->bytewidth;

	switch (psf->sf.format & SF_FORMAT_SUBMASK) // 0x0000FFFF
	{
		case SF_FORMAT_PCM_U8 :
				error = pcm_init (psf);
				break;

		case SF_FORMAT_PCM_S8 :
				error = pcm_init (psf);
				break;

		case SF_FORMAT_PCM_16 :
		case SF_FORMAT_PCM_24 :
		case SF_FORMAT_PCM_32 :
				error = pcm_init (psf);
				break;
		default : return SFE_UNIMPLEMENTED;
	};

	if(psf->mode == SFM_READ)
		psf->blockwidth = psf->sf.channels * psf->bytewidth;

	return error;
} /* aiff_open */

/*==========================================================================================
** Private functions.
*/

static int
aiff_read_header (SF_PRIVATE *psf, COMM_CHUNK *comm_fmt)
{	SSND_CHUNK	ssnd_fmt;
	int			marker, dword, bytesread, k;
	int			FORMsize, SSNDsize;
	int			filetype, found_chunk = 0, done = 0, error = 0;
	char		*cptr, byte;

	/* Set position to start of file to begin reading header. */
	psf_binheader_readf (psf, "p", 0);

	memset (comm_fmt, 0, sizeof (COMM_CHUNK));

	/* Until recently AIF* file were all BIG endian. */
	psf->endian = SF_ENDIAN_BIG;

	/* 	AIFF files can apparently have their chunks in any order. However, they
	**	must have a FORM chunk. Approach here is to read all the chunks one by
	**  one and then check for the mandatory chunks at the end.
	*/
	while(! done)
	{
		psf_binheader_readf (psf, "m", &marker);
		switch (marker)
		{
			case FORM_MARKER :
					if(found_chunk)
						return SFE_AIFF_NO_FORM;

					psf_binheader_readf (psf, "E4", &FORMsize);

					if(psf->fileoffset > 0 && psf->filelength > FORMsize + 8)
					{	/* Set file length. */
						psf->filelength = FORMsize + 8  ;
						; // psf_log_printf (psf, "FORM : %u\n", FORMsize);
						}
					else if(FORMsize != psf->filelength - 2 * SIGNED_SIZEOF (dword))
					{	dword = psf->filelength - 2 * sizeof (dword);
						; // psf_log_printf (psf, "FORM : %u (should be %u)\n", FORMsize, dword);
						FORMsize = dword;
						}
					else
						; // psf_log_printf (psf, "FORM : %u\n", FORMsize);
					found_chunk |= HAVE_FORM;
					break;

			case AIFC_MARKER :
			case AIFF_MARKER :
					if(! (found_chunk & HAVE_FORM))
						return SFE_AIFF_AIFF_NO_FORM;
					filetype = marker;
					; // psf_log_printf (psf, " %M\n", marker);
					found_chunk |= HAVE_AIFF;
					break;

			case COMM_MARKER :
					error = aiff_read_comm_chunk (psf, comm_fmt);

					psf->sf.samplerate 	= tenbytefloat2int (comm_fmt->sampleRate);
					psf->sf.frames 	= comm_fmt->numSampleFrames;
					psf->sf.channels 	= comm_fmt->numChannels;
					psf->bytewidth 		= BITWIDTH2BYTES (comm_fmt->sampleSize);

					if(error)
						return error;

					found_chunk |= HAVE_COMM;
					break;

			case PEAK_MARKER :
					/* Must have COMM chunk before PEAK chunk. */
					if((found_chunk & (HAVE_FORM | HAVE_AIFF | HAVE_COMM)) != (HAVE_FORM | HAVE_AIFF | HAVE_COMM))
						return SFE_AIFF_PEAK_B4_COMM;

					psf_binheader_readf (psf, "E4", &dword);

					; // psf_log_printf (psf, "%M : %d\n", marker, dword);
					if(dword > SIGNED_SIZEOF (psf->peak))
					{	psf_binheader_readf (psf, "j", dword);
						; // psf_log_printf (psf, "*** File PEAK chunk bigger than sizeof (PEAK_CHUNK).\n");
						return SFE_WAV_BAD_PEAK;
						};
					if(dword != SIGNED_SIZEOF (psf->peak) - SIGNED_SIZEOF (psf->peak.peak) + psf->sf.channels * SIGNED_SIZEOF (PEAK_POS))
					{	psf_binheader_readf (psf, "j", dword);
						; // psf_log_printf (psf, "*** File PEAK chunk size doesn't fit with number of channels.\n");
						return SFE_WAV_BAD_PEAK;
						};

					/* read in rest of PEAK chunk. */
					psf_binheader_readf (psf, "E44", &(psf->peak.version), &(psf->peak.timestamp));

					if(psf->peak.version != 1)
						; // psf_log_printf (psf, "  version    : %d *** (should be version 1)\n", psf->peak.version);
					else
						; // psf_log_printf (psf, "  version    : %d\n", psf->peak.version);

					; // psf_log_printf (psf, "  time stamp : %d\n", psf->peak.timestamp);
					; // psf_log_printf (psf, "    Ch   Position       Value\n");

					cptr = (char *) psf->buffer;
					for(dword = 0; dword < psf->sf.channels; dword++)
					{	psf_binheader_readf (psf, "Ef4", &(psf->peak.peak [dword].value),
														&(psf->peak.peak [dword].position));

						LSF_SNPRINTF (cptr, sizeof (psf->buffer), "    %2d   %-12d   %g\n",
								dword, psf->peak.peak [dword].position, psf->peak.peak [dword].value);
						cptr [sizeof (psf->buffer) - 1] = 0;
						; // psf_log_printf (psf, cptr);
						};

					psf->has_peak = SF_TRUE; /* Found PEAK chunk. */
					break;

			case SSND_MARKER :
					psf_binheader_readf (psf, "E444", &SSNDsize, &(ssnd_fmt.offset), &(ssnd_fmt.blocksize));

					psf->datalength = SSNDsize - sizeof (ssnd_fmt);
					psf->dataoffset = psf_ftell (psf);

					if(psf->datalength > psf->filelength - psf->dataoffset || psf->datalength < 0)
					{
		; // psf_log_printf (psf, " SSND : %u (should be %D)\n", SSNDsize, psf->filelength - psf->dataoffset + sizeof (SSND_CHUNK));
						psf->datalength = psf->filelength - psf->dataoffset;
						}
					else
					{
		; // psf_log_printf (psf, " SSND : %u\n", SSNDsize);
						psf->dataend = psf->datalength + psf->dataoffset;
						};

					; // psf_log_printf (psf, "  Offset     : %d\n", ssnd_fmt.offset);
					; // psf_log_printf (psf, "  Block Size : %d\n", ssnd_fmt.blocksize);

					found_chunk |= HAVE_SSND;

					if(! psf->sf.seekable)
						break;

					/* 	Seek to end of SSND chunk. */
					psf_fseek (psf, psf->dataoffset + psf->datalength, SEEK_SET);
					break;

			case c_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					dword += (dword & 1);
					if(dword == 0)
						break;
					if(dword > SIGNED_SIZEOF (psf->buffer))
					{
		; // psf_log_printf (psf, " %M : %d (too big)\n", marker, dword);
						return SFE_INTERNAL;
						};

					cptr = (char*) psf->buffer;
					psf_binheader_readf (psf, "b", cptr, dword);
					cptr [dword - 1] = 0;
					; // psf_log_printf (psf, " %M : %s\n", marker, cptr);
					psf_store_string (psf, SF_STR_COPYRIGHT, cptr);
					break;

			case AUTH_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					dword += (dword & 1);
					if(dword == 0)
						break;
					if(dword > SIGNED_SIZEOF (psf->buffer))
					{
		; // psf_log_printf (psf, " %M : %d (too big)\n", marker, dword);
						return SFE_INTERNAL;
						};

					cptr = (char*) psf->buffer;
					psf_binheader_readf (psf, "b", cptr, dword);
					cptr [dword - 1] = 0;
					; // psf_log_printf (psf, " %M : %s\n", marker, cptr);
					psf_store_string (psf, SF_STR_ARTIST, cptr);
					break;

			case COMT_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					dword += (dword & 1);
					if(dword == 0)
						break;
					if(dword > SIGNED_SIZEOF (psf->buffer))
					{
		; // psf_log_printf (psf, " %M : %d (too big)\n", marker, dword);
						return SFE_INTERNAL;
						};

					cptr = (char*) psf->buffer;
					psf_binheader_readf (psf, "b", cptr, dword);
					cptr [dword - 1] = 0;
					; // psf_log_printf (psf, " %M : %s\n", marker, cptr);
					psf_store_string (psf, SF_STR_COMMENT, cptr);
					break;

			case APPL_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					dword += (dword & 1);
					if(dword == 0)
						break;
					if(dword >= SIGNED_SIZEOF (psf->buffer))
					{
		; // psf_log_printf (psf, " %M : %d (too big, skipping)\n", marker, dword);
						psf_binheader_readf (psf, "j", dword);
						break;
						};

					cptr = (char*) psf->buffer;
					psf_binheader_readf (psf, "b", cptr, dword);
					cptr [dword - 1] = 0;

					for(k = 0; k < dword; k++)
						if(! isprint (cptr [k]))
						{	cptr [k] = 0;
							break;
							};

					; // psf_log_printf (psf, " %M : %s\n", marker, cptr);
					psf_store_string (psf, SF_STR_SOFTWARE, cptr);
					break;

			case NAME_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					dword += (dword & 1);
					if(dword == 0)
						break;
					if(dword > SIGNED_SIZEOF (psf->buffer))
					{
		; // psf_log_printf (psf, " %M : %d (too big)\n", marker, dword);
						return SFE_INTERNAL;
						};

					cptr = (char*) psf->buffer;
					psf_binheader_readf (psf, "b", cptr, dword);
					cptr [dword - 1] = 0;
					; // psf_log_printf (psf, " %M : %s\n", marker, cptr);
					psf_store_string (psf, SF_STR_TITLE, cptr);
					break;

			case ANNO_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					dword += (dword & 1);
					if(dword == 0)
						break;
					if(dword > SIGNED_SIZEOF (psf->buffer))
					{
		; // psf_log_printf (psf, " %M : %d (too big)\n", marker, dword);
						return SFE_INTERNAL;
						};

					cptr = (char*) psf->buffer;
					psf_binheader_readf (psf, "b", cptr, dword);
					cptr [dword - 1] = 0;
					; // psf_log_printf (psf, " %M : %s\n", marker, cptr);
					break;

			case INST_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					if(dword != SIZEOF_INST_CHUNK)
					{
		; // psf_log_printf (psf, " %M : %d (should be %d)\n", marker, dword, SIZEOF_INST_CHUNK);
						psf_binheader_readf (psf, "j", dword);
						break;
						};
					; // psf_log_printf (psf, " %M : %d\n", marker, dword);
					{	unsigned char bytes [6];
						short gain;

						psf_binheader_readf (psf, "b", bytes, 6);
						; // psf_log_printf (psf, 	"  Base Note : %u\n  Detune    : %u\n"
							// 					"  Low  Note : %u\n  High Note : %u\n"
							// 					"  Low  Vel. : %u\n  High Vel. : %u\n",
							// 	bytes [0], bytes [1], bytes [2], bytes [3], bytes [4], bytes [5]);

						psf_binheader_readf (psf, "E2", &gain);
						; // psf_log_printf (psf, 	"  Gain (dB) : %d\n", gain);

						};
					{	short	mode; /* 0 - no loop, 1 - forward looping, 2 - backward looping */
						char	*loop_mode;
						unsigned short begin, end;

						psf_binheader_readf (psf, "E222", &mode, &begin, &end);
						loop_mode = get_loop_mode_str (mode);
						; // psf_log_printf (psf, 	"  Sustain\n   mode  : %d => %s\n   begin : %u\n   end   : %u\n",
							// 	mode, loop_mode, begin, end);
						psf_binheader_readf (psf, "E222", &mode, &begin, &end);
						loop_mode = get_loop_mode_str (mode);
						; // psf_log_printf (psf, 	"  Release\n   mode  : %d => %s\n   begin : %u\n   end   : %u\n",
							// 	mode, loop_mode, begin, end);
						};
					break;

			case MARK_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					; // psf_log_printf (psf, " %M : %d\n", marker, dword);
					{	unsigned short	mark_count, mark_id;
						unsigned char	pstr_len;
						unsigned int	position;

						bytesread = psf_binheader_readf (psf, "E2", &mark_count);
						; // psf_log_printf (psf, "  Count : %d\n", mark_count);

						while(mark_count && bytesread < dword)
						{	bytesread += psf_binheader_readf (psf, "E241", &mark_id, &position, &pstr_len);
							; // psf_log_printf (psf, "   Mark ID  : %u\n   Position : %u\n", mark_id, position);

							pstr_len += (pstr_len & 1) + 1; /* fudgy, fudgy, hack, hack */

							bytesread += psf_binheader_readf (psf, "b", psf->buffer, pstr_len);
							; // psf_log_printf (psf, "   Name     : %s\n", psf->buffer);

							mark_count --;
							};
						};
					psf_binheader_readf (psf, "j", dword - bytesread);
					break;

			case FVER_MARKER :
			case SFX_MARKER :
					psf_binheader_readf (psf, "E4", &dword);
					; // psf_log_printf (psf, " %M : %d\n", marker, dword);

					psf_binheader_readf (psf, "j", dword);
					break;

			case NONE_MARKER :
					/* Fix for broken AIFC files with incorrect COMM chunk length. */
					psf_binheader_readf (psf, "1", &byte);
					dword = byte;
					psf_binheader_readf (psf, "j", dword);
					break;

			default :
					if(isprint ((marker >> 24) & 0xFF) && isprint ((marker >> 16) & 0xFF)
						&& isprint ((marker >> 8) & 0xFF) && isprint (marker & 0xFF))
					{	psf_binheader_readf (psf, "E4", &dword);
						; // psf_log_printf (psf, "%M : %d (unknown marker)\n", marker, dword);

						psf_binheader_readf (psf, "j", dword);
						break;
						};
					if((dword = psf_ftell (psf)) & 0x03)
					{
		; // psf_log_printf (psf, "  Unknown chunk marker %X at position %d. Resyncing.\n", marker, dword - 4);

						psf_binheader_readf (psf, "j", -3);
						break;
						};
					; // psf_log_printf (psf, "*** Unknown chunk marker %X at position %D. Exiting parser.\n", marker, psf_ftell (psf));
					done = 1;
					break;
			};	/* switch (marker) */

		if((! psf->sf.seekable) && (found_chunk & HAVE_SSND))
			break;

		if(psf_ftell (psf) >= (signed)(psf->filelength - (2 * sizeof (dword))))
			break;

		if(psf->logindex >= sizeof (psf->logbuffer) - 2)
			return SFE_LOG_OVERRUN;
		}; /* while(1) */

	if(! (found_chunk & HAVE_FORM))
		return SFE_AIFF_NO_FORM;

	if(! (found_chunk & HAVE_AIFF))
		return SFE_AIFF_COMM_NO_FORM;

	if(! (found_chunk & HAVE_COMM))
		return SFE_AIFF_SSND_NO_COMM;

	if(! psf->dataoffset)
		return SFE_AIFF_NO_DATA;

	return 0;
} /* aiff_read_header */

static int
aiff_close	(SF_PRIVATE *psf)
{
#ifdef MAUNUSED
 (void)psf;
#endif
	
	return 0;
} /* aiff_close */

static int
aiff_read_comm_chunk (SF_PRIVATE *psf, COMM_CHUNK *comm_fmt)
{
	int error = 0, bytesread, subformat;

	bytesread = psf_binheader_readf (psf, "E4", &(comm_fmt->size));

	/* The COMM chunk has an int aligned to an odd word boundary. Some
	** procesors are not able to deal with this (ie bus fault) so we have
	** to take special care.
	*/

	bytesread +=
	psf_binheader_readf (psf, "E242b", &(comm_fmt->numChannels), &(comm_fmt->numSampleFrames),
			&(comm_fmt->sampleSize), &(comm_fmt->sampleRate), SIGNED_SIZEOF (comm_fmt->sampleRate));

	if(comm_fmt->size == SIZEOF_AIFF_COMM)
		comm_fmt->encoding = NONE_MARKER;
	else if(comm_fmt->size == SIZEOF_AIFC_COMM_MIN)
		bytesread += psf_binheader_readf (psf, "Em", &(comm_fmt->encoding));
	else if(comm_fmt->size >= SIZEOF_AIFC_COMM)
	{	unsigned char encoding_len;

		bytesread += psf_binheader_readf (psf, "Em1", &(comm_fmt->encoding), &encoding_len);

		memset (psf->buffer, 0, comm_fmt->size);

		bytesread += psf_binheader_readf (psf, "b", psf->buffer,
							comm_fmt->size - SIZEOF_AIFC_COMM + 1);
		psf->buffer [encoding_len] = 0;
		};

	; // psf_log_printf (psf, " COMM : %d\n", comm_fmt->size);
	; // psf_log_printf (psf, "  Sample Rate : %d\n", tenbytefloat2int (comm_fmt->sampleRate));
	; // psf_log_printf (psf, "  Frames      : %d\n", comm_fmt->numSampleFrames);
	; // psf_log_printf (psf, "  Channels    : %d\n", comm_fmt->numChannels);

	/*	Found some broken 'fl32' files with comm.samplesize == 16. Fix it here. */

	if((comm_fmt->encoding == fl32_MARKER || comm_fmt->encoding == FL32_MARKER) && comm_fmt->sampleSize != 32)
	{
		; // psf_log_printf (psf, "  Sample Size : %d (should be 32)\n", comm_fmt->sampleSize);
		comm_fmt->sampleSize = 32;
		}
	else if((comm_fmt->encoding == fl64_MARKER || comm_fmt->encoding == FL64_MARKER) && comm_fmt->sampleSize != 64)
	{
		; // psf_log_printf (psf, "  Sample Size : %d (should be 64)\n", comm_fmt->sampleSize);
		comm_fmt->sampleSize = 64;
		}
	else
		; // psf_log_printf (psf, "  Sample Size : %d\n", comm_fmt->sampleSize);

	subformat = s_bitwidth_to_subformat(comm_fmt->sampleSize);

	psf->endian = SF_ENDIAN_BIG;

	switch (comm_fmt->encoding)
	{
		case NONE_MARKER :
				psf->sf.format = (SF_FORMAT_AIFF | subformat);
				break;

		case twos_MARKER :
		case in32_MARKER :
				psf->sf.format = (SF_ENDIAN_BIG | SF_FORMAT_AIFF | subformat);
				break;

		case sowt_MARKER :
		case ni32_MARKER :
				psf->endian = SF_ENDIAN_LITTLE;
				psf->sf.format = (SF_ENDIAN_LITTLE | SF_FORMAT_AIFF | subformat);
				break;

		case fl32_MARKER :
		case FL32_MARKER :
				psf->sf.format = (SF_FORMAT_AIFF | SF_FORMAT_FLOAT);
				break;

		case ulaw_MARKER :
		case ULAW_MARKER :
				psf->sf.format = (SF_FORMAT_AIFF | SF_FORMAT_ULAW);
				break;

		case alaw_MARKER :
		case ALAW_MARKER :
				psf->sf.format = (SF_FORMAT_AIFF | SF_FORMAT_ALAW);
				break;

		case fl64_MARKER :
		case FL64_MARKER :
				psf->sf.format = (SF_FORMAT_AIFF | SF_FORMAT_DOUBLE);
				break;

		case raw_MARKER :
				psf->sf.format = (SF_FORMAT_AIFF | SF_FORMAT_PCM_U8);
				break;

		case DWVW_MARKER :
				psf->sf.format = SF_FORMAT_AIFF;
				switch (comm_fmt->sampleSize)
				{	case 12 :
						psf->sf.format |= SF_FORMAT_DWVW_12;
						break;
					case 16 :
						psf->sf.format |= SF_FORMAT_DWVW_16;
						break;
					case 24 :
						psf->sf.format |= SF_FORMAT_DWVW_24;
						break;

					default :
						psf->sf.format |= SF_FORMAT_DWVW_N;
						break;
					};
				break;

		case GSM_MARKER :
				psf->sf.format = SF_FORMAT_AIFF;
				psf->sf.format = (SF_FORMAT_AIFF | SF_FORMAT_GSM610);
				break;


		/*
		case ima4_MARKER :
				psf->endian = SF_ENDIAN_BIG;
				psf->sf.format = (SF_FORMAT_AIFF | SF_FORMAT_IMA_ADPCM);
				break;
		*/

		default :
			; // psf_log_printf (psf, "AIFC : Unimplemented format : %M\n", comm_fmt->encoding);
			error = SFE_UNIMPLEMENTED;
		};

	if(! psf->buffer [0])
		; // psf_log_printf (psf, "  Encoding    : %M\n", comm_fmt->encoding);
	else
		; // psf_log_printf (psf, "  Encoding    : %M => %s\n", comm_fmt->encoding, (char*) psf->buffer);

	return error;
} /* aiff_read_comm_chunk */

static char*
get_loop_mode_str (short mode)
{	switch (mode)
	{	case 0 : return (char *)"none";
		case 1 : return (char *)"forawrd";
		case 2 : return (char *)"backward";
		};

	return (char *)"*** unknown";
} /* get_loop_mode_str */

/*==========================================================================================
**	Rough hack at converting from 80 bit IEEE float in AIFF header to an int and
**	back again. It assumes that all sample rates are between 1 and 800MHz, which
**	should be OK as other sound file formats use a 32 bit integer to store sample
**	rate.
**	There is another (probably better) version in the source code to the SoX but it
**	has a copyright which probably prevents it from being allowable as GPL/LGPL.
*/

static int
tenbytefloat2int (unsigned char *bytes)
{	int val = 3;

	if(bytes [0] & 0x80)	/* Negative number. */
		return 0;

	if(bytes [0] <= 0x3F)	/* Less than 1. */
		return 1;

	if(bytes [0] > 0x40)	/* Way too big. */
		return 0x4000000;

	if(bytes [0] == 0x40 && bytes [1] > 0x1C) /* Too big. */
		return 800000000;

	/* Ok, can handle it. */

	val = (bytes [2] << 23) | (bytes [3] << 15) | (bytes [4] << 7) | (bytes [5] >> 1);

	val >>= (29 - bytes [1]);

	return val;
} /* tenbytefloat2int */

//SF_PRIVATE *g_psf;
//SNDFILE *g_fsf;

// sndfile.c:

#define		SNDFILE_MAGICK	0x1234C0DE

typedef struct
{	int 	error;
	char	*str;
} ErrorStruct;

static
ErrorStruct SndfileErrors [] =
{
	/* Public error values and their associated strings. */
	{	SF_ERR_NO_ERROR				, (char *)"No Error." },
	{	SF_ERR_UNRECOGNISED_FORMAT	, (char *)"File opened for read. Format not recognised." },
	{	SF_ERR_SYSTEM				, (char *)"System error." /* Often replaced. */ 	},

	/* Private error values and their associated strings. */
	{	SFE_BAD_FILE			, (char *)"File does not exist or is not a regular file (possibly a pipe?)." },
	{	SFE_BAD_FILE_READ		, (char *)"File exists but no data could be read." },
	{	SFE_OPEN_FAILED			, (char *)"Could not open file." },
	{	SFE_BAD_SNDFILE_PTR		, (char *)"Not a valid SNDFILE* pointer." },
	{	SFE_BAD_SF_INFO_PTR		, (char *)"NULL SF_INFO pointer passed to libsndfile." },
	{	SFE_BAD_SF_INCOMPLETE	, (char *)"SF_PRIVATE struct incomplete and end of header parsing." },
	{	SFE_BAD_FILE_PTR		, (char *)"Bad FILE pointer." },
	{	SFE_BAD_INT_PTR			, (char *)"Internal error, Bad pointer." },
	{	SFE_MALLOC_FAILED		, (char *)"Internal SFE_MALLOC_FAILED () failed." },
	{	SFE_UNIMPLEMENTED		, (char *)"File contains data in an unimplemented format." },
	{	SFE_BAD_READ_ALIGN  	, (char *)"Attempt to read a non-integer number of channels." },
	{	SFE_BAD_WRITE_ALIGN 	, (char *)"Attempt to write a non-integer number of channels." },
	{	SFE_UNKNOWN_FORMAT		, (char *)"File contains data in an unknown format." },
	{	SFE_NOT_READMODE		, (char *)"Read attempted on file currently open for write." },
	{	SFE_NOT_WRITEMODE		, (char *)"Write attempted on file currently open for read." },
	{	SFE_BAD_MODE_RW			, (char *)"This file format does not support read/write mode." },
	{	SFE_BAD_SF_INFO			, (char *)"Internal error : SF_INFO struct incomplete." },
	{	SFE_BAD_OFFSET			, (char *)"Error : supplied offset beyond end of file." },
	{	SFE_NO_EMBED_SUPPORT	, (char *)"Error : embedding not supported for this file format." },
	{	SFE_NO_EMBEDDED_RDWR	, (char *)"Error : cannot open embedded file read/write." },
	{	SFE_BAD_RDWR_FORMAT		, (char *)"Attempted to open read only format for RDWR." },

	{	SFE_INTERLEAVE_MODE		, (char *)"Attempt to write to file with non-interleaved data." },
	{	SFE_INTERLEAVE_SEEK		, (char *)"Bad karma in seek during interleave read operation." },
	{	SFE_INTERLEAVE_READ		, (char *)"Bad karma in read during interleave read operation." },

	{	SFE_INTERNAL			, (char *)"Unspecified internal error." },
	{	SFE_LOG_OVERRUN			, (char *)"Log buffer has overrun. File probably broken." },
	{	SFE_BAD_CONTROL_CMD		, (char *)"Bad command passed to function sf_command()." },
	{	SFE_BAD_ENDIAN			, (char *)"Bad endian-ness. Try default endian-ness" },
	{	SFE_CHANNEL_COUNT		, (char *)"Too many channels specified." },

	{	SFE_BAD_SEEK			, (char *)"Internal psf_fseek() failed." },
	{	SFE_NOT_SEEKABLE		, (char *)"Seek attempted on unseekable file type." },
	{	SFE_AMBIGUOUS_SEEK		, (char *)"Error: combination of file open mode and seek command is ambiguous." },
	{	SFE_WRONG_SEEK			, (char *)"Error: invalid seek parameters." },
	{	SFE_SEEK_FAILED			, (char *)"Error: parameters OK, but psf_seek() failed." },

	{	SFE_BAD_OPEN_MODE		, (char *)"Error: bad mode parameter for file open." },
	{	SFE_OPEN_PIPE_RDWR		, (char *)"Error: attempt toopen a pipe in read/write mode." },
	{	SFE_RDWR_POSITION		, (char *)"Error on RDWR position (cryptic)." },

	{	SFE_STR_NO_SUPPORT		, (char *)"Error : File type does not support string data." },	
	{	SFE_STR_MAX_DATA		, (char *)"Error : Maximum string data storage reached." },	
	{	SFE_STR_MAX_COUNT		, (char *)"Error : Maximum string data count reached." },	
	{	SFE_STR_BAD_TYPE		, (char *)"Error : Bad string data type." },	
	{	SFE_STR_NO_ADD_END		, (char *)"Error : file type does not support strings added at end of file." },	
	{	SFE_STR_WEIRD			, (char *)"Error : Weird string error." },	

	{	SFE_WAV_NO_RIFF			, (char *)"Error in WAV file. No 'RIFF' chunk marker." },
	{	SFE_WAV_NO_WAVE			, (char *)"Error in WAV file. No 'WAVE' chunk marker." },
	{	SFE_WAV_NO_FMT			, (char *)"Error in WAV file. No 'fmt ' chunk marker." },
	{	SFE_WAV_FMT_SHORT		, (char *)"Error in WAV file. Short 'fmt ' chunk." },

	{	SFE_WAV_FMT_TOO_BIG		, (char *)"Error in WAV file. 'fmt ' chunk too large." },
	{	SFE_WAV_BAD_FACT		, (char *)"Error in WAV file. 'fact' chunk out of place." },
	{	SFE_WAV_BAD_PEAK		, (char *)"Error in WAV file. Bad 'PEAK' chunk." },
	{	SFE_WAV_PEAK_B4_FMT		, (char *)"Error in WAV file. 'PEAK' chunk found before 'fmt ' chunk." },

	{	SFE_WAV_BAD_FORMAT		, (char *)"Error in WAV file. Errors in 'fmt ' chunk." },
	{	SFE_WAV_BAD_BLOCKALIGN	, (char *)"Error in WAV file. Block alignment in 'fmt ' chunk is incorrect." },
	{	SFE_WAV_NO_DATA			, (char *)"Error in WAV file. No 'data' chunk marker." },
	{	SFE_WAV_UNKNOWN_CHUNK	, (char *)"Error in WAV file. File contains an unknown chunk marker." },
	{	SFE_WAV_WVPK_DATA		, (char *)"Error in WAV file. Data is in WAVPACK format." },

	{	SFE_WAV_ADPCM_NOT4BIT	, (char *)"Error in ADPCM WAV file. Invalid bit width." },
	{	SFE_WAV_ADPCM_CHANNELS	, (char *)"Error in ADPCM WAV file. Invalid number of channels." },
	{	SFE_WAV_GSM610_FORMAT	, (char *)"Error in GSM610 WAV file. Invalid format chunk." },

	{	SFE_AIFF_NO_FORM		, (char *)"Error in AIFF file, bad 'FORM' marker." },
	{	SFE_AIFF_AIFF_NO_FORM	, (char *)"Error in AIFF file, 'AIFF' marker without 'FORM'." },
	{	SFE_AIFF_COMM_NO_FORM	, (char *)"Error in AIFF file, 'COMM' marker without 'FORM'." },
	{	SFE_AIFF_SSND_NO_COMM	, (char *)"Error in AIFF file, 'SSND' marker without 'COMM'." },
	{	SFE_AIFF_UNKNOWN_CHUNK	, (char *)"Error in AIFF file, unknown chunk." },
	{	SFE_AIFF_COMM_CHUNK_SIZE, (char *)"Error in AIFF file, bad 'COMM' chunk size." },
	{	SFE_AIFF_BAD_COMM_CHUNK , (char *)"Error in AIFF file, bad 'COMM' chunk." },
	{	SFE_AIFF_PEAK_B4_COMM	, (char *)"Error in AIFF file. 'PEAK' chunk found before 'COMM' chunk." },
	{	SFE_AIFF_BAD_PEAK		, (char *)"Error in AIFF file. Bad 'PEAK' chunk." },
	{	SFE_AIFF_NO_SSND		, (char *)"Error in AIFF file, bad 'SSND' chunk." },
	{	SFE_AIFF_NO_DATA		, (char *)"Error in AIFF file, no sound data." },

	{	SFE_AU_UNKNOWN_FORMAT	, (char *)"Error in AU file, unknown format." },
	{	SFE_AU_NO_DOTSND		, (char *)"Error in AU file, missing '.snd' or 'dns.' marker." },
	{	SFE_AU_EMBED_BAD_LEN	, (char *)"Embedded AU file with unknown length." },

	{	SFE_RAW_READ_BAD_SPEC	, (char *)"Error while opening RAW file for read. Must specify format and channels.\n"
									"Possibly trying to open unsupported format."
									 },
	{	SFE_RAW_BAD_BITWIDTH	, (char *)"Error. RAW file bitwidth must be a multiple of 8." },
	{	SFE_RAW_BAD_FORMAT		, (char *)"Error. Bad format field in SF_INFO struct when openning a RAW file for read." },

	{	SFE_PAF_NO_MARKER		, (char *)"Error in PAF file, no marker." },
	{	SFE_PAF_VERSION			, (char *)"Error in PAF file, bad version." },
	{	SFE_PAF_UNKNOWN_FORMAT	, (char *)"Error in PAF file, unknown format." },
	{	SFE_PAF_SHORT_HEADER	, (char *)"Error in PAF file. File shorter than minimal header." },

	{	SFE_SVX_NO_FORM			, (char *)"Error in 8SVX / 16SV file, no 'FORM' marker." },
	{	SFE_SVX_NO_BODY			, (char *)"Error in 8SVX / 16SV file, no 'BODY' marker." },
	{	SFE_SVX_NO_DATA			, (char *)"Error in 8SVX / 16SV file, no sound data." },
	{	SFE_SVX_BAD_COMP		, (char *)"Error in 8SVX / 16SV file, unsupported compression format." },
	{	SFE_SVX_BAD_NAME_LENGTH	, (char *)"Error in 8SVX / 16SV file, NAME chunk too long." },

	{	SFE_NIST_BAD_HEADER		, (char *)"Error in NIST file, bad header." },
	{	SFE_NIST_CRLF_CONVERISON, (char *)"Error : NIST file damaged by Windows CR -> CRLF conversion process."	},
	{	SFE_NIST_BAD_ENCODING	, (char *)"Error in NIST file, unsupported compression format." },

	{	SFE_VOC_NO_CREATIVE		, (char *)"Error in VOC file, no 'Creative Voice File' marker." },
	{	SFE_VOC_BAD_FORMAT		, (char *)"Error in VOC file, bad format." },
	{	SFE_VOC_BAD_VERSION		, (char *)"Error in VOC file, bad version number." },
	{	SFE_VOC_BAD_MARKER		, (char *)"Error in VOC file, bad marker in file." },
	{	SFE_VOC_BAD_SECTIONS	, (char *)"Error in VOC file, incompatible VOC sections." },
	{	SFE_VOC_MULTI_SAMPLERATE, (char *)"Error in VOC file, more than one sample rate defined." },
	{	SFE_VOC_MULTI_SECTION	, (char *)"Unimplemented VOC file feature, file contains multiple sound sections." },
	{	SFE_VOC_MULTI_PARAM		, (char *)"Error in VOC file, file contains multiple bit or channel widths." },
	{	SFE_VOC_SECTION_COUNT	, (char *)"Error in VOC file, too many sections." },

	{	SFE_IRCAM_NO_MARKER		, (char *)"Error in IRCAM file, bad IRCAM marker." },
	{	SFE_IRCAM_BAD_CHANNELS	, (char *)"Error in IRCAM file, bad channel count." },
	{	SFE_IRCAM_UNKNOWN_FORMAT, (char *)"Error in IRCAM file, unknow encoding format." },

	{	SFE_W64_64_BIT			, (char *)"Error in W64 file, file contains 64 bit offset." },

	{	SFE_W64_NO_RIFF			, (char *)"Error in W64 file. No 'riff' chunk marker." },
	{	SFE_W64_NO_WAVE			, (char *)"Error in W64 file. No 'wave' chunk marker." },
	{	SFE_W64_NO_FMT			, (char *)"Error in W64 file. No 'fmt ' chunk marker." },
	{	SFE_W64_NO_DATA			, (char *)"Error in W64 file. No 'data' chunk marker." },

	{	SFE_W64_FMT_SHORT		, (char *)"Error in W64 file. Short 'fmt ' chunk." },
	{	SFE_W64_FMT_TOO_BIG		, (char *)"Error in W64 file. 'fmt ' chunk too large." },

	{	SFE_W64_ADPCM_NOT4BIT	, (char *)"Error in ADPCM W64 file. Invalid bit width." },
	{	SFE_W64_ADPCM_CHANNELS	, (char *)"Error in ADPCM W64 file. Invalid number of channels." },
	{	SFE_W64_GSM610_FORMAT	, (char *)"Error in GSM610 W64 file. Invalid format chunk." },

	{	SFE_MAT4_BAD_NAME		, (char *)"Error in MAT4 file. No variable name." },
	{	SFE_MAT4_NO_SAMPLERATE	, (char *)"Error in MAT4 file. No sample rate." },
	{	SFE_MAT4_ZERO_CHANNELS	, (char *)"Error in MAT4 file. Channel count is zero." },

	{	SFE_MAT5_BAD_ENDIAN		, (char *)"Error in MAT5 file. Not able to determine endian-ness." },
	{	SFE_MAT5_NO_BLOCK		, (char *)"Error in MAT5 file. Bad block structure." },
	{	SFE_MAT5_SAMPLE_RATE	, (char *)"Error in MAT5 file. Not able to determine sample rate." },
	{	SFE_MAT5_ZERO_CHANNELS	, (char *)"Error in MAT5 file. Channel count is zero." },

	{	SFE_PVF_NO_PVF1			, (char *)"Error in PVF file. No PVF1 marker." },
	{	SFE_PVF_BAD_HEADER		, (char *)"Error in PVF file. Bad header." },
	{	SFE_PVF_BAD_BITWIDTH	, (char *)"Error in PVF file. Bad bit width." },

	{	SFE_XI_BAD_HEADER		, (char *)"Error in XI file. Bad header." },
	{	SFE_XI_EXCESS_SAMPLES	, (char *)"Error in XI file. Excess samples in file." },
	{	SFE_XI_WHOOPS			, (char *)"Error. Whoops." },
	
	{	SFE_DWVW_BAD_BITWIDTH	, (char *)"Error : Bad bit width for DWVW encoding. Must be 12, 16 or 24." },
	{	SFE_G72X_NOT_MONO		, (char *)"Error : G72x encoding does not support more than 1 channel." },

	{	SFE_MAX_ERROR			, (char *)"Maximum error number." },
	{	SFE_MAX_ERROR + 1		, NULL }
};

/*------------------------------------------------------------------------------
*/

static int 	format_from_extension (const char *filename);
static int	guess_file_type (SF_PRIVATE *psf, const char *filename);
static int	validate_sfinfo (SF_INFO *sfinfo);
static int	validate_psf (SF_PRIVATE *psf);
static void	save_header_info (SF_PRIVATE *psf);
static void	copy_filename (SF_PRIVATE *psf, const char *path);
static int	psf_close (SF_PRIVATE  *psf);
static int	psf_open_file (SF_PRIVATE *psf, int mode, SF_INFO *sfinfo);

/*------------------------------------------------------------------------------
** Private (static) variables.
*/

static int	sf_errno = 0;
static char	sf_logbuffer [SF_BUFFER_LEN] = { 0 };
static char	sf_syserr [SF_SYSERR_LEN] = { 0 };

/*------------------------------------------------------------------------------
*/

#define	VALIDATE_SNDFILE_AND_ASSIGN_PSF(a,b,c)		\
		{	if(! (a))								\
				return SFE_BAD_SNDFILE_PTR;		\
			(b) = (SF_PRIVATE*) (a);				\
			if(((b)->filedes) < 0)					\
				return SFE_BAD_FILE_PTR;			\
			if((b)->Magick != SNDFILE_MAGICK)		\
				return	SFE_BAD_SNDFILE_PTR;		\
			if(c) (b)->error = 0;					\
			}

/*------------------------------------------------------------------------------
**	Public functions.
*/

SNDFILE*
sf_open	(MASTATE *pstate, int mode, SF_INFO *sfinfo)
{	SF_PRIVATE 	*psf;
	int			error = 0;

	if((psf = (SF_PRIVATE *)MACALLOC (1, sizeof (SF_PRIVATE))) == NULL)
	{	sf_errno = SFE_MALLOC_FAILED;
		return	NULL;
	};

	memset (psf, 0, sizeof (SF_PRIVATE));
	psf->pstate = pstate;	
	pstate->psf = psf;
	
	copy_filename (psf, pstate->inpath);

	if((psf->filedes = psf_open (psf, pstate->inpath, mode)) < 0)
		error = SFE_OPEN_FAILED;

	if(error == 0)
		error = psf_open_file (psf, mode, sfinfo);
	
	if(error)
	{	sf_errno = error;
		if(error == SFE_SYSTEM)
			LSF_SNPRINTF (sf_syserr, sizeof (sf_syserr), "%s", psf->syserr);
		LSF_SNPRINTF (sf_logbuffer, sizeof (sf_logbuffer), "%s", psf->logbuffer);
		psf_close(psf);
		pstate->psf = NULL;
		return NULL;
	};

	memcpy(sfinfo, &(psf->sf), sizeof (SF_INFO));

	return (SNDFILE*)psf;
} /* sf_open */

/*
SNDFILE*
sf_open_fd	(int fd, int mode, SF_INFO *sfinfo, int close_desc)
{	SF_PRIVATE 	*psf;
	int			error;
	
	if((psf = (SF_PRIVATE *)MACALLOC (1, sizeof (SF_PRIVATE))) == NULL)
	{	sf_errno = SFE_MALLOC_FAILED;
		return	NULL;
		};

	psf->filedes = fd;
	psf->fileoffset = psf_ftell (psf);
	
	if(! close_desc)
		psf->do_not_close_descritor = SF_TRUE;

	error = psf_open_file (psf, mode, sfinfo);
	
	if(error)
	{	sf_errno = error;
		if(error == SFE_SYSTEM)
			LSF_SNPRINTF (sf_syserr, sizeof (sf_syserr), "%s", psf->syserr);
		LSF_SNPRINTF (sf_logbuffer, sizeof (sf_logbuffer), "%s", psf->logbuffer);
		psf_close (psf);
		return NULL;
		};

	memcpy (sfinfo, &(psf->sf), sizeof (SF_INFO));

	return (SNDFILE*)psf;
} /w* sf_open_fd *w/
*/

/*------------------------------------------------------------------------------
*/

int
sf_close	(SNDFILE *sndfile)
{	SF_PRIVATE  *psf;

	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 1);

	return psf_close (psf);
} /* sf_close */

/*==============================================================================
*/

const char*
sf_error_number	(int errnum)
{	int	k;

	if(errnum < 0 || errnum >= SFE_MAX_ERROR)
		return SndfileErrors [0].str;

	for(k = 0; SndfileErrors[k].str; k++)
		if(errnum == SndfileErrors[k].error)
			return SndfileErrors[k].str;

	return "No error defined for this error number. This is a bug in libsndfile.";
} /* sf_error_number */

const char*
sf_strerror (SNDFILE *sndfile)
{	SF_PRIVATE 	*psf = NULL;
	int errnum;

	if(! sndfile)
	{	errnum = sf_errno;
	    if(errnum == SFE_SYSTEM && sf_syserr [0])
			return sf_syserr;
		}
	else
	{	psf = (SF_PRIVATE *) sndfile;

		if(psf->Magick != SNDFILE_MAGICK)
			return	"sf_strerror : Bad magic number.";

		errnum = psf->error;

	    if(errnum == SFE_SYSTEM && psf->syserr [0])
			return psf->syserr;
		};

	return sf_error_number (errnum);
} /* sf_strerror */

/*------------------------------------------------------------------------------
*/

int
sf_error (SNDFILE *sndfile)
{	SF_PRIVATE	*psf;

	if(! sndfile)
	{
		// if(sf_error != 0)
		//	return 1;
		return 0;
	}

	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 0);

	if(psf->error)
		return 1;

	return 0;
} /* sf_error */

/*------------------------------------------------------------------------------
*/

int
sf_perror (SNDFILE *sndfile)
{	SF_PRIVATE 	*psf;
	int 		errnum;

	if(! sndfile)
	{	errnum = sf_errno;
		}
	else
	{	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 0);
		errnum = psf->error;
		};

	fprintf (stderr, "%s\n", sf_error_number (errnum));
	return SFE_NO_ERROR;
} /* sf_perror */


/*------------------------------------------------------------------------------
*/

int
sf_error_str (SNDFILE *sndfile, char *str, size_t maxlen)
{	SF_PRIVATE 	*psf;
	int 		errnum;

	if(! str)
		return SFE_INTERNAL;

	if(! sndfile)
		errnum = sf_errno;
	else
	{	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 0);
		errnum = psf->error;
		};

	LSF_SNPRINTF (str, maxlen, "%s", sf_error_number (errnum));

	return SFE_NO_ERROR;
} /* sf_error_str */

/*==============================================================================
*/

int
sf_format_check	(const SF_INFO *info)
{	int	subformat, endian;

	subformat = info->format & SF_FORMAT_SUBMASK;
	endian = info->format & SF_FORMAT_SUBMASK;

	/* This is the place where each file format can check if the suppiled
	** SF_INFO struct is valid.
	** Return 0 on failure, 1 ons success.
	*/

	if(info->channels < 1 || info->channels > 256)
		return 0;

	if(info->samplerate < 0)
		return 0;

	switch (info->format & SF_FORMAT_TYPEMASK)
	{	case SF_FORMAT_WAV :
				/* WAV is strictly little endian. */
				if(endian == SF_ENDIAN_BIG || endian == SF_ENDIAN_CPU)
					return 0;
				if(subformat == SF_FORMAT_PCM_U8 || subformat == SF_FORMAT_PCM_16)
					return 1;
				if(subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if((subformat == SF_FORMAT_IMA_ADPCM || subformat == SF_FORMAT_MS_ADPCM) && info->channels <= 2)
					return 1;
				if(subformat == SF_FORMAT_GSM610 && info->channels == 1)
					return 1;
				if(subformat == SF_FORMAT_ULAW || subformat == SF_FORMAT_ALAW)
					return 1;
				if(subformat == SF_FORMAT_FLOAT || subformat == SF_FORMAT_DOUBLE)
					return 1;
				break;

		case SF_FORMAT_AIFF :
				/* AIFF does allow both endian-nesses for PCM data.*/
				if(subformat == SF_FORMAT_PCM_16 || subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				/* Other encodings. Check for endian-ness. */
				if(endian == SF_ENDIAN_LITTLE || endian == SF_ENDIAN_CPU)
					return 0;
				if(subformat == SF_FORMAT_PCM_U8 || subformat == SF_FORMAT_PCM_S8)
					return 1;
				if(subformat == SF_FORMAT_FLOAT || subformat == SF_FORMAT_DOUBLE)
					return 1;
				if(subformat == SF_FORMAT_ULAW || subformat == SF_FORMAT_ALAW)
					return 1;
				if((subformat == SF_FORMAT_DWVW_12 || subformat == SF_FORMAT_DWVW_16 ||
							subformat == SF_FORMAT_DWVW_24) && info-> channels == 1)
					return 1;
				if(subformat == SF_FORMAT_GSM610 && info->channels == 1)
					return 1;
				break;

		case SF_FORMAT_AU :
				if(subformat == SF_FORMAT_PCM_S8 || subformat == SF_FORMAT_PCM_16)
					return 1;
				if(subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if(subformat == SF_FORMAT_ULAW || subformat == SF_FORMAT_ALAW)
					return 1;
				if(subformat == SF_FORMAT_FLOAT || subformat == SF_FORMAT_DOUBLE)
					return 1;
				if(subformat == SF_FORMAT_G721_32 && info->channels == 1)
					return 1;
				if(subformat == SF_FORMAT_G723_24 && info->channels == 1)
					return 1;
				if(subformat == SF_FORMAT_G723_40 && info->channels == 1)
					return 1;
				break;

		case SF_FORMAT_RAW :
				if(subformat == SF_FORMAT_PCM_U8 || subformat == SF_FORMAT_PCM_S8 || subformat == SF_FORMAT_PCM_16)
					return 1;
				if(subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if(subformat == SF_FORMAT_FLOAT || subformat == SF_FORMAT_DOUBLE)
					return 1;
				if(subformat == SF_FORMAT_ALAW || subformat == SF_FORMAT_ULAW)
					return 1;
				if((subformat == SF_FORMAT_DWVW_12 || subformat == SF_FORMAT_DWVW_16 ||
							subformat == SF_FORMAT_DWVW_24) && info-> channels == 1)
					return 1;
				if(subformat == SF_FORMAT_GSM610 && info->channels == 1)
					return 1;
				if(subformat == SF_FORMAT_VOX_ADPCM && info->channels == 1)
					return 1;
				break;

		case SF_FORMAT_PAF :
				if(subformat == SF_FORMAT_PCM_S8 || subformat == SF_FORMAT_PCM_16)
					return 1;
				if(subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				break;

		case SF_FORMAT_SVX :
				/* SVX currently does not support more than one channel for write.
				** Read will allow more than one channel but only allow one here.
				*/
				if(info->channels != 1)
					return 0;
				/* Always big endian. */
				if(endian == SF_ENDIAN_LITTLE || endian == SF_ENDIAN_CPU)
					return 0;

				if((subformat == SF_FORMAT_PCM_S8 || subformat == SF_FORMAT_PCM_16) && info->channels == 1)
					return 1;
				break;

		case SF_FORMAT_NIST :
				if(subformat == SF_FORMAT_PCM_S8 || subformat == SF_FORMAT_PCM_16)
					return 1;
				if(subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if(subformat == SF_FORMAT_ULAW || subformat == SF_FORMAT_ALAW)
					return 1;
				break;

		case SF_FORMAT_IRCAM :
				if(subformat == SF_FORMAT_PCM_16 || subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if(subformat == SF_FORMAT_ULAW || subformat == SF_FORMAT_ALAW || subformat == SF_FORMAT_FLOAT)
					return 1;
				break;

		case SF_FORMAT_VOC :
				/* VOC is strictly little endian. */
				if(endian == SF_ENDIAN_BIG || endian == SF_ENDIAN_CPU)
					return 0;
				if(subformat == SF_FORMAT_PCM_U8 || subformat == SF_FORMAT_PCM_16)
					return 1;
				if(subformat == SF_FORMAT_ULAW || subformat == SF_FORMAT_ALAW)
					return 1;
				break;

		case SF_FORMAT_W64 :
				/* W64 is strictly little endian. */
				if(endian == SF_ENDIAN_BIG || endian == SF_ENDIAN_CPU)
					return 0;
				if(subformat == SF_FORMAT_PCM_U8 || subformat == SF_FORMAT_PCM_16)
					return 1;
				if(subformat == SF_FORMAT_PCM_24 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if((subformat == SF_FORMAT_IMA_ADPCM || subformat == SF_FORMAT_MS_ADPCM) && info->channels <= 2)
					return 1;
				if(subformat == SF_FORMAT_GSM610 && info->channels == 1)
					return 1;
				if(subformat == SF_FORMAT_ULAW || subformat == SF_FORMAT_ALAW)
					return 1;
				if(subformat == SF_FORMAT_FLOAT || subformat == SF_FORMAT_DOUBLE)
					return 1;
				break;

		case SF_FORMAT_MAT4 :
				if(subformat == SF_FORMAT_PCM_16 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if(subformat == SF_FORMAT_FLOAT || subformat == SF_FORMAT_DOUBLE)
					return 1;
				break;

		case SF_FORMAT_MAT5 :
				if(subformat == SF_FORMAT_PCM_U8 || subformat == SF_FORMAT_PCM_16 || subformat == SF_FORMAT_PCM_32)
					return 1;
				if(subformat == SF_FORMAT_FLOAT || subformat == SF_FORMAT_DOUBLE)
					return 1;
				break;

		case SF_FORMAT_PVF :
				if(subformat == SF_FORMAT_PCM_S8 || subformat == SF_FORMAT_PCM_16 || subformat == SF_FORMAT_PCM_32)
					return 1;
				break;

		case SF_FORMAT_XI :
				if(info->channels != 1)
					return 0;
				if(subformat == SF_FORMAT_DPCM_8 || subformat == SF_FORMAT_DPCM_16)
					return 1;
				break;

		case SF_FORMAT_HTK :
				if(info->channels != 1)
					return 0;
				if(subformat == SF_FORMAT_PCM_16)
					return 1;
				break;

		/*-
		case SF_FORMAT_SD2 :
				/+* SD2 is strictly big endian. *+/
				if(endian == SF_ENDIAN_LITTLE || endian == SF_ENDIAN_CPU)
					return 0;
				if(subformat == SF_FORMAT_PCM_16)
					return 1;
				break;
		-*/

		default : break;
		};

	return 0;
} /* sf_format_check */

/*------------------------------------------------------------------------------
*/

int
sf_command	(SNDFILE *sndfile, int command, void *data, int datasize)
{	SF_PRIVATE 		*psf = NULL;

	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 1);

	switch (command)
	{
		case SFC_SET_NORM_DOUBLE :
			psf->norm_double = (datasize) ? SF_TRUE : SF_FALSE;
			return psf->norm_double;

		case SFC_GET_NORM_DOUBLE :
			return psf->norm_double;

		default :
			/* Must be a file specific command. Pass it on. */
			if(psf->command)
				return psf->command (psf, command, data, datasize);

			; // psf_log_printf (psf, "*** sf_command : cmd = 0x%X\n", command);
			return (psf->error = SFE_BAD_CONTROL_CMD);
	};

	return 0;
} /* sf_command */

/*------------------------------------------------------------------------------
*/

sf_count_t
sf_seek	(SNDFILE *sndfile, sf_count_t offset, int whence)
{	SF_PRIVATE 	*psf;
	sf_count_t	seek_from_start = 0, retval;

	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 1);

	if(! psf->sf.seekable)
	{	psf->error = SFE_NOT_SEEKABLE;
		return	((sf_count_t) -1);
		};

	/* Convert all SEEK_CUR and SEEK_END into seek_from_start to be
	** used with SEEK_SET.
	*/
	switch (whence)
	{	/* The SEEK_SET behaviour is independant of mode. */
		case SEEK_SET :
		case SEEK_SET | SFM_READ :
				seek_from_start = offset;
				break;

		/* The SEEK_CUR is a little more tricky. */
		case SEEK_CUR :
				if(offset == 0)
				{	if(psf->mode == SFM_READ)
						return psf->read_current;
				};

				if(psf->mode == SFM_READ)
					seek_from_start = psf->read_current + offset;
				else
					psf->error = SFE_AMBIGUOUS_SEEK;
				break;

		case SEEK_CUR | SFM_READ :
				if(offset == 0)
					return psf->read_current;
				seek_from_start = psf->read_current + offset;
				break;
		/* The SEEK_END */
		case SEEK_END :
		case SEEK_END | SFM_READ :
				seek_from_start = psf->sf.frames + offset;
				break;

		default :
				psf->error = SFE_BAD_SEEK;
				break;
		};

	if(psf->error)
		return ((sf_count_t) -1);

	if(seek_from_start < 0 || seek_from_start > psf->sf.frames)
	{	psf->error = SFE_BAD_SEEK;
		return ((sf_count_t) -1);
		};

	if(psf->seek)
	{	int new_mode = (whence & SFM_MASK) ? (whence & SFM_MASK) : psf->mode;

		retval = psf->seek (psf, new_mode, seek_from_start);

		switch (new_mode)
		{	case SFM_READ :
					psf->read_current = retval;
					break;
			};

		psf->last_op = new_mode;

		return retval;
		};

	psf->error = SFE_AMBIGUOUS_SEEK;
	return ((sf_count_t) -1);
} /* sf_seek */

/*------------------------------------------------------------------------------
*/

/*
sf_count_t
sf_read_raw		(SNDFILE *sndfile, void *ptr, sf_count_t bytes)
{	SF_PRIVATE 	*psf;
	sf_count_t	count;

	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 1);

	if(bytes < 0 || psf->read_current >= psf->datalength)
	{	psf_memset (ptr, 0, bytes);
		return 0;
		};

	if(bytes % (psf->sf.channels * psf->bytewidth))
	{	psf->error = SFE_BAD_READ_ALIGN;
		return 0;
		};

	count = psf_fread (ptr, 1, bytes, psf);

	if(count < bytes)
		psf_memset (((char*)ptr) + count, 0, bytes - count);

	psf->read_current += count / psf->blockwidth;

	psf->last_op = SFM_READ;

	return count;
} /w* sf_read_raw *w/
*/

/*------------------------------------------------------------------------------
*/

/*
sf_count_t
sf_read_short	(SNDFILE *sndfile, short *ptr, sf_count_t len)
{	SF_PRIVATE 	*psf;
	sf_count_t	count, extra;

	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 1);

	if(len % psf->sf.channels)
	{	psf->error = SFE_BAD_READ_ALIGN;
		return 0;
		};

	if(len <= 0 || psf->read_current >= psf->sf.frames)
	{	psf_memset (ptr, 0, len * sizeof (short));
		return 0; /w* End of file. *w/
		};

	if(! psf->read_short || ! psf->seek)
	{	psf->error = SFE_UNIMPLEMENTED;
		return	0;
		};

	if(psf->last_op != SFM_READ)
		if(psf->seek (psf, SFM_READ, psf->read_current) < 0)
			return 0;

	count = psf->read_short (psf, ptr, len);

	if(psf->read_current + count / psf->sf.channels > psf->sf.frames)
	{	count = (psf->sf.frames - psf->read_current) * psf->sf.channels;
		extra = len - count;
		psf_memset (ptr + count, 0, extra * sizeof (short));
		psf->read_current = psf->sf.frames;
		};

	psf->read_current += count / psf->sf.channels;

	psf->last_op = SFM_READ;

	if(psf->read_current > psf->sf.frames)
	{	count = psf->sf.channels * (psf->read_current - psf->sf.frames);
		psf->read_current = psf->sf.frames;
		};

	return count;
} /w* sf_read_short *w/
*/

sf_count_t
sf_readf_short		(SNDFILE *sndfile, short *ptr, sf_count_t frames)
{	SF_PRIVATE 	*psf;
	sf_count_t	count, extra;

	VALIDATE_SNDFILE_AND_ASSIGN_PSF (sndfile, psf, 1);

	if(frames <= 0 || psf->read_current >= psf->sf.frames)
	{	psf_memset (ptr, 0, frames * psf->sf.channels * sizeof (short));
		return 0; /* End of file. */
		};

	if(! psf->read_short || ! psf->seek)
	{	psf->error = SFE_UNIMPLEMENTED;
		return 0;
		};

	if(psf->last_op != SFM_READ)
		if(psf->seek (psf, SFM_READ, psf->read_current) < 0)
			return 0;

	count = psf->read_short (psf, ptr, frames * psf->sf.channels);

	if(psf->read_current + count / psf->sf.channels > psf->sf.frames)
	{	count = (psf->sf.frames - psf->read_current) * psf->sf.channels;
		extra =  frames * psf->sf.channels - count;
		psf_memset (ptr + count, 0, extra * sizeof (short));
		psf->read_current = psf->sf.frames;
		};

	psf->read_current += count / psf->sf.channels;

	psf->last_op = SFM_READ;

	if(psf->read_current > psf->sf.frames)
	{	count = psf->sf.channels * (psf->read_current - psf->sf.frames);
		psf->read_current = psf->sf.frames;
		};

	return count / psf->sf.channels;
} /* sf_readf_short */

/*------------------------------------------------------------------------------
*/

/*=========================================================================
** Private functions.
*/

static int
format_from_extension (const char *filename)
{	char *cptr;
	char buffer [16];

	if(filename == NULL)
		return 0;

	if((cptr = strrchr (filename, '.')) == NULL)
		return 0;

	cptr ++;
	if(strlen (cptr) > sizeof (buffer) - 1)
		return 0;

	strncpy (buffer, cptr, sizeof (buffer));
	buffer [sizeof (buffer) - 1] = 0;

	/* Convert everything in the buffer to lower case. */
	cptr = buffer;
	while(*cptr)
	{	*cptr = tolower (*cptr);
		cptr ++;
		};

	cptr = buffer;

	if(strcmp (cptr, "au") == 0)
		return SF_FORMAT_AU | SF_FORMAT_ULAW;

	if(strcmp (cptr, "snd") == 0)
		return SF_FORMAT_AU | SF_FORMAT_ULAW;

	if(strcmp (cptr, "vox") == 0)
		return SF_FORMAT_RAW | SF_FORMAT_VOX_ADPCM;

	return 0;
} /* format_from_extension */

static int
guess_file_type (SF_PRIVATE *psf, const char *filename)
{	int 			buffer [3], format;
	unsigned char	cptr [0x40];

	if(psf_binheader_readf (psf, "b", &buffer, SIGNED_SIZEOF (buffer)) != SIGNED_SIZEOF (buffer))
	{	psf->error = SFE_BAD_FILE_READ;
		return 0;
		};

	if(buffer [0] == MAKE_MARKER ('R','I','F','F') && buffer [2] == MAKE_MARKER ('W','A','V','E'))
		return SF_FORMAT_WAV;

	if(buffer [0] == MAKE_MARKER ('F','O','R','M'))
	{	if(buffer [2] == MAKE_MARKER ('A','I','F','F') || buffer [2] == MAKE_MARKER ('A','I','F','C'))
			return SF_FORMAT_AIFF;
		if(buffer [2] == MAKE_MARKER ('8','S','V','X') || buffer [2] == MAKE_MARKER ('1','6','S','V'))
			return SF_FORMAT_SVX;
		return 0;
		};

	if(buffer [0] == MAKE_MARKER ('.','s','n','d') || buffer [0] == MAKE_MARKER ('d','n','s','.'))
		return SF_FORMAT_AU;

	if((buffer [0] == MAKE_MARKER ('f','a','p',' ') || buffer [0] == MAKE_MARKER (' ','p','a','f')))
		return SF_FORMAT_PAF;

	if(buffer [0] == MAKE_MARKER ('N','I','S','T'))
		return SF_FORMAT_NIST;

	if(buffer [0] == MAKE_MARKER ('C','r','e','a') && buffer [1] == MAKE_MARKER ('t','i','v','e'))
		return SF_FORMAT_VOC;

	if((buffer [0] & MAKE_MARKER (0xFF, 0xFF, 0xF8, 0xFF)) == MAKE_MARKER (0x64, 0xA3, 0x00, 0x00) ||
		(buffer [0] & MAKE_MARKER (0xFF, 0xF8, 0xFF, 0xFF)) == MAKE_MARKER (0x00, 0x00, 0xA3, 0x64))
		return SF_FORMAT_IRCAM;

	if(buffer [0] == MAKE_MARKER ('r', 'i', 'f', 'f'))
		return SF_FORMAT_W64;

	if(buffer [0] == MAKE_MARKER (0, 0, 0x03, 0xE8) && buffer [1] == MAKE_MARKER (0, 0, 0, 1) &&
								buffer [2] == MAKE_MARKER (0, 0, 0, 1))
		return SF_FORMAT_MAT4;

	if(buffer [0] == MAKE_MARKER (0, 0, 0, 0) && buffer [1] == MAKE_MARKER (1, 0, 0, 0) &&
								buffer [2] == MAKE_MARKER (1, 0, 0, 0))
		return SF_FORMAT_MAT4;

	if(buffer [0] == MAKE_MARKER ('M', 'A', 'T', 'L') && buffer [1] == MAKE_MARKER ('A', 'B', ' ', '5'))
		return SF_FORMAT_MAT5;

	if(buffer [0] == MAKE_MARKER ('P', 'V', 'F', '1'))
		return SF_FORMAT_PVF;

	if(buffer [0] == MAKE_MARKER ('E', 'x', 't', 'e') && buffer [1] == MAKE_MARKER ('n', 'd', 'e', 'd') &&
								buffer [2] == MAKE_MARKER (' ', 'I',  'n', 's'))
		return SF_FORMAT_XI;

	if(buffer [0] == MAKE_MARKER ('A', 'L', 'a', 'w') && buffer [1] == MAKE_MARKER ('S', 'o', 'u', 'n')
			&& buffer [2] == MAKE_MARKER ('d', 'F', 'i', 'l'))
		return SF_FORMAT_WVE;

	if(buffer [0] == MAKE_MARKER ('D', 'i', 'a', 'm') && buffer [1] == MAKE_MARKER ('o', 'n', 'd', 'W')
			&& buffer [2] == MAKE_MARKER ('a', 'r', 'e', ' '))
		return SF_FORMAT_DWD;

	if(buffer [0] == MAKE_MARKER ('L', 'M', '8', '9') || buffer [0] == MAKE_MARKER ('5', '3', 0, 0))
		return SF_FORMAT_TXW;

	if((buffer [0] & MAKE_MARKER (0xFF, 0xFF, 0x80, 0xFF)) == MAKE_MARKER (0xF0, 0x7E, 0, 0x01))
		return SF_FORMAT_SDS;

	if(buffer [0] == MAKE_MARKER ('C', 'A', 'T', ' ') && buffer [2] == MAKE_MARKER ('R', 'E', 'X', '2'))
		return SF_FORMAT_REX2;

	if(buffer [0] == MAKE_MARKER (0x30, 0x26, 0xB2, 0x75) && buffer [1] == MAKE_MARKER (0x8E, 0x66, 0xCF, 0x11))
		return 0 /*-SF_FORMAT_WMA-*/;

	/* HMM (Hidden Markov Model) Tool Kit. */
	if(2 * BEI2H_INT (buffer [0]) + 12 == psf->filelength && buffer [2] == MAKE_MARKER (0, 2, 0, 0))
		return SF_FORMAT_HTK;

	if(buffer [0] == MAKE_MARKER ('f', 'L', 'a', 'C'))
		return 0 /*-SF_FORMAT_FLAC-*/;

	/* Turtle Beach SMP 16-bit */
	if(buffer [0] == MAKE_MARKER ('S', 'O', 'U', 'N') && buffer [1] == MAKE_MARKER ('D', ' ', 'S', 'A'))
		return 0;

	if(buffer [0] == MAKE_MARKER ('S', 'Y', '8', '0') || buffer [0] == MAKE_MARKER ('S', 'Y', '8', '5'))
		return 0;

	if(buffer [0] == MAKE_MARKER ('a', 'j', 'k', 'g'))
		return 0 /*-SF_FORMAT_SHN-*/;

	/*	Detect wacky MacOS header stuff. This might be "Sound Designer II". */
	memcpy (cptr , buffer, sizeof (buffer));
	if(cptr [0] == 0 && cptr [1] > 0 && psf->sf.seekable)
	{	psf_binheader_readf (psf, "pb", 0, &cptr, SIGNED_SIZEOF (cptr));

		if(cptr [1] < (sizeof (cptr) - 3) && cptr [cptr [1] + 2] == 0 && strlen (((char*) cptr) + 2) == cptr [1])
		{
		; // psf_log_printf (psf, "Weird MacOS Header.\n");
			psf_binheader_readf (psf, "em", &buffer);
			if(buffer [0] == MAKE_MARKER (0, 'S', 'd', '2'))
				return SF_FORMAT_SD2;
			};
		};

	/* This must be the last one. */
	if((format = format_from_extension (filename)) != 0)
		return format;

	/* Default to header-less RAW PCM file type. */
	return SF_FORMAT_RAW;
} /* guess_file_type */


static int
validate_sfinfo (SF_INFO *sfinfo)
{	if(sfinfo->samplerate < 1)
		return 0;
	if(sfinfo->frames < 0)
		return 0;
	if(sfinfo->channels < 1)
		return 0;
	if((sfinfo->format & SF_FORMAT_TYPEMASK) == 0)
		return 0;

	if(sfinfo->sections < 1)
		return 0;
	return 1;
} /* validate_sfinfo */

static int
validate_psf (SF_PRIVATE *psf)
{
	if(psf->datalength < 0)
	{
		; // psf_log_printf (psf, "Invalid SF_PRIVATE field : datalength == %D.\n", psf->datalength);
		return 0;
		};
	if(psf->dataoffset < 0)
	{
		; // psf_log_printf (psf, "Invalid SF_PRIVATE field : dataoffset == %D.\n", psf->dataoffset);
		return 0;
		};
	if(psf->blockwidth && psf->blockwidth != psf->sf.channels * psf->bytewidth)
	{
		; // psf_log_printf (psf, "Invalid SF_PRIVATE field : channels * bytewidth == %d.\n",
			//					psf->sf.channels * psf->bytewidth);
		return 0;
		};
	return 1;
} /* validate_psf */

static void
save_header_info (SF_PRIVATE *psf)
{	LSF_SNPRINTF (sf_logbuffer, sizeof (sf_logbuffer), "%s", psf->logbuffer);
} /* save_header_info */

static void
copy_filename (SF_PRIVATE *psf, const char *path)
{	const char *cptr;

	if((cptr = strrchr (path, '/')) || (cptr = strrchr (path, '\\')))
		cptr ++;
	else
		cptr = path;

	memset (psf->filename, 0, SF_FILENAME_LEN);

	LSF_SNPRINTF (psf->filename, sizeof (psf->filename), "%s", cptr);

} /* copy_filename */

/*==============================================================================
*/

static int
psf_close (SF_PRIVATE  *psf)
{	int			error;

	if(psf->close)
		error = psf->close (psf);

	if(psf->do_not_close_descritor)
		psf->filedes = -1;
	else
		psf_fclose (psf);

	if(psf->fdata)
		MAFREE(psf->fdata);

	if(psf->interleave)
		MAFREE(psf->interleave);

	if(psf->dither)
		MAFREE(psf->dither);

	MAFREE(psf);
	
	return 0;
} /* psf_close */

static int
psf_open_file (SF_PRIVATE *psf, int mode, SF_INFO *sfinfo)
{	int		error;
	
	if(mode != SFM_READ && mode)
		return SFE_BAD_OPEN_MODE;

	if(! sfinfo)
		return SFE_BAD_SF_INFO_PTR;

	if(mode == SFM_READ)
	{	if((sfinfo->format & SF_FORMAT_TYPEMASK) == SF_FORMAT_RAW)
		{	if(sf_format_check (sfinfo) == 0)
				return SFE_RAW_BAD_FORMAT;
			}
		else
			memset (sfinfo, 0, sizeof (SF_INFO));
		};

	sf_errno = error = 0;
	sf_logbuffer [0] = 0;

	memcpy (&(psf->sf), sfinfo, sizeof (SF_INFO));

	psf->Magick 		= SNDFILE_MAGICK;
	psf->norm_float 	= SF_TRUE;
	psf->norm_double	= SF_TRUE;
	psf->mode 			= mode;
	psf->dataoffset		= -1;
	psf->datalength		= -1;
	psf->read_current	= -1;
	psf->write_current	= -1;
	psf->auto_header 	= SF_FALSE;
	psf->rwf_endian		= SF_ENDIAN_LITTLE;
	psf->seek			= psf_default_seek;

	/* File is open, so get the length. */
	psf->filelength = psf_get_filelen (psf);

	if(psf->fileoffset > 0)
	{	switch (psf->mode)
		{	case SFM_READ :
				if(psf->filelength < 44)
				{
		; // psf_log_printf (psf, "Short filelength: %D (fileoffset: %D)\n", psf->filelength, psf->fileoffset);
					return SFE_BAD_OFFSET;
					};
				break;
		
		};

		; // psf_log_printf (psf, "Embedded file offset : %D\n", psf->fileoffset);
	};

	psf->sf.seekable = SF_TRUE;
	psf->sf.sections = 1;

	; // psf_log_printf (psf, "Length : %D\n", psf->filelength);

	if((psf->sf.format & SF_FORMAT_TYPEMASK) != SF_FORMAT_RAW)
	{	/* If type RAW has not been specified then need to figure out file type. */
		psf->sf.format = guess_file_type (psf, psf->filename);
		};

	/* Set bytewidth if known. */
	switch (psf->sf.format & SF_FORMAT_SUBMASK)
	{	case SF_FORMAT_PCM_S8 :
		case SF_FORMAT_PCM_U8 :
		case SF_FORMAT_ULAW :
		case SF_FORMAT_ALAW :
		case SF_FORMAT_DPCM_8 :
				psf->bytewidth = 1;
				break;

		case SF_FORMAT_PCM_16 :
		case SF_FORMAT_DPCM_16 :
				psf->bytewidth = 2;
				break;

		case SF_FORMAT_PCM_24 :
				psf->bytewidth = 3;
				break;

		case SF_FORMAT_PCM_32 :
		case SF_FORMAT_FLOAT :
				psf->bytewidth = 4;
				break;

		case SF_FORMAT_DOUBLE :
				psf->bytewidth = 8;
				break;
	};

	/* Call the initialisation function for the relevant file type. */
	switch (psf->sf.format & SF_FORMAT_TYPEMASK)
	{
		case	SF_FORMAT_WAV :
				error = wav_open (psf);
				break;
				
		case	SF_FORMAT_AIFF :
				error = aiff_open (psf);
				break;
		default :
				error = SFE_UNKNOWN_FORMAT;
	};

	if(error)
		return error;

	/* For now, check whether embedding is supported. */
	if(psf->fileoffset > 0 && 
			((psf->sf.format & SF_FORMAT_TYPEMASK) != SF_FORMAT_WAV) && 
			((psf->sf.format & SF_FORMAT_TYPEMASK) != SF_FORMAT_AIFF) &&
			((psf->sf.format & SF_FORMAT_TYPEMASK) != SF_FORMAT_AU)
			)
		return SFE_NO_EMBED_SUPPORT;

	if(psf->fileoffset > 0)
		; // psf_log_printf (psf, "Embedded file length : %D\n", psf->filelength);

	if(validate_sfinfo (&(psf->sf)) == 0)
	{	
		save_header_info (psf);
		return SFE_BAD_SF_INFO;
	};

	if(validate_psf (psf) == 0)
	{	save_header_info (psf);
		return SFE_INTERNAL;
	};

	psf->read_current  = 0;
	psf->write_current = 0;

	memcpy (sfinfo, &(psf->sf), sizeof (SF_INFO));

	return 0;
} /* psf_open_file */


// wav.c:

/*------------------------------------------------------------------------------
 * Macros to handle big/little endian issues.
 */

#define RIFF_MARKER	(MAKE_MARKER ('R', 'I', 'F', 'F'))
#define WAVE_MARKER	(MAKE_MARKER ('W', 'A', 'V', 'E'))
#define fmt_MARKER	(MAKE_MARKER ('f', 'm', 't', ' '))
#define data_MARKER	(MAKE_MARKER ('d', 'a', 't', 'a'))
#define fact_MARKER	(MAKE_MARKER ('f', 'a', 'c', 't'))
#define PEAK_MARKER	(MAKE_MARKER ('P', 'E', 'A', 'K'))

#define cue_MARKER	(MAKE_MARKER ('c', 'u', 'e', ' '))
#define LIST_MARKER	(MAKE_MARKER ('L', 'I', 'S', 'T'))
#define slnt_MARKER	(MAKE_MARKER ('s', 'l', 'n', 't'))
#define wavl_MARKER	(MAKE_MARKER ('w', 'a', 'v', 'l'))
#define INFO_MARKER	(MAKE_MARKER ('I', 'N', 'F', 'O'))
#define plst_MARKER	(MAKE_MARKER ('p', 'l', 's', 't'))
#define adtl_MARKER	(MAKE_MARKER ('a', 'd', 't', 'l'))
#define labl_MARKER	(MAKE_MARKER ('l', 'a', 'b', 'l'))
#define ltxt_MARKER	(MAKE_MARKER ('l', 't', 'x', 't'))
#define note_MARKER	(MAKE_MARKER ('n', 'o', 't', 'e'))
#define smpl_MARKER	(MAKE_MARKER ('s', 'm', 'p', 'l'))
#define bext_MARKER	(MAKE_MARKER ('b', 'e', 'x', 't'))
#define MEXT_MARKER	(MAKE_MARKER ('M', 'E', 'X', 'T'))
#define DISP_MARKER	(MAKE_MARKER ('D', 'I', 'S', 'P'))
#define acid_MARKER	(MAKE_MARKER ('a', 'c', 'i', 'd'))
#define strc_MARKER	(MAKE_MARKER ('s', 't', 'r', 'c'))
#define PAD_MARKER	(MAKE_MARKER ('P', 'A', 'D', ' '))
#define afsp_MARKER	(MAKE_MARKER ('a', 'f', 's', 'p'))
#define clm_MARKER	(MAKE_MARKER ('c', 'l', 'm', ' '))

#define ISFT_MARKER	(MAKE_MARKER ('I', 'S', 'F', 'T'))
#define ICRD_MARKER	(MAKE_MARKER ('I', 'C', 'R', 'D'))
#define ICOP_MARKER	(MAKE_MARKER ('I', 'C', 'O', 'P'))
#define IARL_MARKER	(MAKE_MARKER ('I', 'A', 'R', 'L'))
#define IART_MARKER	(MAKE_MARKER ('I', 'A', 'R', 'T'))
#define INAM_MARKER	(MAKE_MARKER ('I', 'N', 'A', 'M'))
#define IENG_MARKER	(MAKE_MARKER ('I', 'E', 'N', 'G'))
#define IART_MARKER	(MAKE_MARKER ('I', 'A', 'R', 'T'))
#define ICOP_MARKER	(MAKE_MARKER ('I', 'C', 'O', 'P'))
#define IPRD_MARKER	(MAKE_MARKER ('I', 'P', 'R', 'D'))
#define ISRC_MARKER	(MAKE_MARKER ('I', 'S', 'R', 'C'))
#define ISBJ_MARKER	(MAKE_MARKER ('I', 'S', 'B', 'J'))
#define ICMT_MARKER	(MAKE_MARKER ('I', 'C', 'M', 'T'))

/* Weird WAVPACK marker which can show up at the start of the DATA section. */
#define wvpk_MARKER (MAKE_MARKER ('w', 'v', 'p', 'k'))

enum
{	HAVE_RIFF	= 0x01,
	HAVE_WAVE	= 0x02,
	HAVE_fmt	= 0x04,
	HAVE_fact	= 0x08,
	HAVE_PEAK	= 0x10,
	HAVE_data	= 0x20
};

/*------------------------------------------------------------------------------
** Private static functions.
*/

static int	wav_read_header	(SF_PRIVATE *psf, int *blockalign, int *framesperblock);
static int	wav_command (SF_PRIVATE *psf, int command, void *data, int datasize);

static int	wav_close	(SF_PRIVATE *psf);

static int 	wav_subchunk_parse	(SF_PRIVATE *psf, int chunk);
static int	wav_read_smpl_chunk (SF_PRIVATE *psf, unsigned int chunklen);
static int	wav_read_acid_chunk (SF_PRIVATE *psf, unsigned int chunklen);

/*------------------------------------------------------------------------------
** Public function.
*/

int
wav_open	(SF_PRIVATE *psf)
{	
	int error = 0;
	int	subformat, blockalign = 0, framesperblock = 0;

	if(psf->mode == SFM_READ)
	{	if((error = wav_read_header (psf, &blockalign, &framesperblock)))
			return error;
		};

	subformat = psf->sf.format & SF_FORMAT_SUBMASK; // 0x0000FFFF

	psf->close = wav_close;
	psf->command = wav_command;

	switch (subformat)
	{	case SF_FORMAT_PCM_U8 :
		case SF_FORMAT_PCM_16 :
		case SF_FORMAT_PCM_24 :
		case SF_FORMAT_PCM_32 :
					error = pcm_init (psf);
					break;
		default : 	return SFE_UNIMPLEMENTED;
	};

	return error;
} /* wav_open */

/*=========================================================================
** Private functions.
*/

static int
wav_read_header	(SF_PRIVATE *psf, int *blockalign, int *framesperblock)
{
#ifdef MAUNUSED
 (void)blockalign; (void)framesperblock;
#endif

	WAV_FMT		wav_fmt;
	FACT_CHUNK	fact_chunk;
	int			dword = 0, marker, RIFFsize, done = 0;
	int			parsestage = 0, error, format = 0;
	char		*cptr;

	/* Set position to start of file to begin reading header. */
	psf_binheader_readf (psf, "p", 0);

	while(! done)
	{	psf_binheader_readf (psf, "m", &marker);

		switch (marker)
		{	case RIFF_MARKER :
					if(parsestage)
						return SFE_WAV_NO_RIFF;

					psf_binheader_readf (psf, "e4", &RIFFsize);

					if(psf->fileoffset > 0 && psf->filelength > RIFFsize + 8)
					{	/* Set file length. */
						psf->filelength = RIFFsize + 8  ;
						; // psf_log_printf (psf, "RIFF : %u\n", RIFFsize);
						}
					else if(psf->filelength < RIFFsize + 2 * SIGNED_SIZEOF (dword))
					{
		; // psf_log_printf (psf, "RIFF : %u (should be %D)\n", (sf_count_t) RIFFsize, psf->filelength - 2 * SIGNED_SIZEOF (dword));
						RIFFsize = dword;
						}
					else
						; // psf_log_printf (psf, "RIFF : %u\n", RIFFsize);

					parsestage |= HAVE_RIFF;
					break;

			case WAVE_MARKER :
					if((parsestage & HAVE_RIFF) != HAVE_RIFF)
						return SFE_WAV_NO_WAVE;
					; // psf_log_printf (psf, "WAVE\n");
					parsestage |= HAVE_WAVE;
					break;

			case fmt_MARKER :
					if((parsestage & (HAVE_RIFF | HAVE_WAVE)) != (HAVE_RIFF | HAVE_WAVE))
						return SFE_WAV_NO_FMT;

					/* If this file has a SECOND fmt chunk, I don't want to know about it. */
					if(parsestage & HAVE_fmt)
						break;

					psf_binheader_readf (psf, "e4", &dword);
					; // psf_log_printf (psf, "fmt  : %d\n", dword);

					if((error = wav_w64_read_fmt_chunk (psf, &wav_fmt, dword)))
						return error;

					format = wav_fmt.format;
					parsestage |= HAVE_fmt;
					break;

			case data_MARKER :
					if((parsestage & (HAVE_RIFF | HAVE_WAVE | HAVE_fmt)) != (HAVE_RIFF | HAVE_WAVE | HAVE_fmt))
						return SFE_WAV_NO_DATA;

					psf_binheader_readf (psf, "e4", &dword);

					psf->datalength = dword;
					psf->dataoffset = psf_ftell (psf);

					if(psf->datalength > psf->filelength - psf->dataoffset)
					{
		; // psf_log_printf (psf, "data : %D (should be %D)\n", psf->datalength, psf->filelength - psf->dataoffset);
						psf->datalength = psf->filelength - psf->dataoffset;
						}
					else
					{
		; // psf_log_printf (psf, "data : %D\n", psf->datalength);
						psf->dataend = psf->datalength + psf->dataoffset;
						};

					if(format == WAVE_FORMAT_MS_ADPCM && psf->datalength % 2)
					{	psf->datalength ++;
						; // psf_log_printf (psf, "*** Data length odd. Increasing it by 1.\n");
						};

					parsestage |= HAVE_data;

					if(! psf->sf.seekable)
						break;

					/* Seek past data and continue reading header. */
					psf_fseek (psf, psf->datalength, SEEK_CUR);

					dword = psf_ftell (psf);
					if(dword != (sf_count_t) (psf->dataoffset + psf->datalength))
						; // psf_log_printf (psf, "*** psf_fseek past end error ***\n", dword, psf->dataoffset + psf->datalength);
					break;

			case fact_MARKER :
					if((parsestage & (HAVE_RIFF | HAVE_WAVE)) != (HAVE_RIFF | HAVE_WAVE))
						return SFE_WAV_BAD_FACT;

					if((parsestage & HAVE_fmt) != HAVE_fmt)
						; // psf_log_printf (psf, "*** Should have 'fmt ' chunk before 'fact'\n");

					psf_binheader_readf (psf, "e44", &dword, &(fact_chunk.frames));

					if(dword > SIGNED_SIZEOF (fact_chunk))
						psf_binheader_readf (psf, "j", (int) (dword - SIGNED_SIZEOF (fact_chunk)));

					if(dword)
						; // psf_log_printf (psf, "%M : %d\n", marker, dword);
					else
						; // psf_log_printf (psf, "%M : %d (should not be zero)\n", marker, dword);

					; // psf_log_printf (psf, "  frames  : %d\n", fact_chunk.frames);
					parsestage |= HAVE_fact;
					break;

			case PEAK_MARKER :
					if((parsestage & (HAVE_RIFF | HAVE_WAVE | HAVE_fmt)) != (HAVE_RIFF | HAVE_WAVE | HAVE_fmt))
						return SFE_WAV_PEAK_B4_FMT;

					psf_binheader_readf (psf, "e4", &dword);

					; // psf_log_printf (psf, "%M : %d\n", marker, dword);
					if(dword > SIGNED_SIZEOF (psf->peak))
					{	psf_binheader_readf (psf, "j", dword);
						; // psf_log_printf (psf, "*** File PEAK chunk bigger than sizeof (PEAK_CHUNK).\n");
						return SFE_WAV_BAD_PEAK;
						};
					if(dword != SIGNED_SIZEOF (psf->peak) - SIGNED_SIZEOF (psf->peak.peak) + psf->sf.channels * SIGNED_SIZEOF (PEAK_POS))
					{	psf_binheader_readf (psf, "j", dword);
						; // psf_log_printf (psf, "*** File PEAK chunk size doesn't fit with number of channels.\n");
						return SFE_WAV_BAD_PEAK;
						};

					psf_binheader_readf (psf, "e44", &(psf->peak.version), &(psf->peak.timestamp));

					if(psf->peak.version != 1)
						; // psf_log_printf (psf, "  version    : %d *** (should be version 1)\n", psf->peak.version);
					else
						; // psf_log_printf (psf, "  version    : %d\n", psf->peak.version);

					; // psf_log_printf (psf, "  time stamp : %d\n", psf->peak.timestamp);
					; // psf_log_printf (psf, "    Ch   Position       Value\n");

					cptr = (char *) psf->buffer;
					for(dword = 0; dword < psf->sf.channels; dword++)
					{	psf_binheader_readf (psf, "ef4", &(psf->peak.peak [dword].value),
														&(psf->peak.peak [dword].position));

						LSF_SNPRINTF (cptr, sizeof (psf->buffer), "    %2d   %-12d   %g\n",
								dword, psf->peak.peak [dword].position, psf->peak.peak [dword].value);
						cptr [sizeof (psf->buffer) - 1] = 0;
						; // psf_log_printf (psf, cptr);
						};

					psf->has_peak = SF_TRUE; /* Found PEAK chunk. */
					break;

			case cue_MARKER :
					{	int bytesread, cue_count;
						int id, position, chunk_id, chunk_start, block_start, offset;

						bytesread = psf_binheader_readf (psf, "e44", &dword, &cue_count);
						bytesread -= 4; /* Remove bytes for first dword. */
						; // psf_log_printf (psf, "%M : %u\n  Count : %d\n", marker, dword, cue_count);

						while(cue_count)
						{	bytesread += psf_binheader_readf (psf, "e444444", &id, &position,
									&chunk_id, &chunk_start, &block_start, &offset);
							; // psf_log_printf (psf, "   Cue ID : %2d"
								//				 "  Pos : %5u  Chunk : %M"
								//				 "  Chk Start : %d  Blk Start : %d"
								//				 "  Offset : %5d\n",
								//	id, position, chunk_id, chunk_start, block_start, offset);
							cue_count --;
							};

						if(bytesread != dword)
						{
		; // psf_log_printf (psf, "**** Chunk size weirdness (%d != %d)\n", dword, bytesread);
							psf_binheader_readf (psf, "j", dword - bytesread);
							};
						};
					break;

			case smpl_MARKER :
					psf_binheader_readf (psf, "e4", &dword);
					; // psf_log_printf (psf, "smpl : %u\n", dword);

					if((error = wav_read_smpl_chunk (psf, dword)))
						return error;
					break;

			case acid_MARKER :
					psf_binheader_readf (psf, "e4", &dword);
					; // psf_log_printf (psf, "acid : %u\n", dword);

					if((error = wav_read_acid_chunk (psf, dword)))
						return error;
					break;

			case INFO_MARKER :
			case LIST_MARKER :
					if((error = wav_subchunk_parse (psf, marker)))
						return error;
					break;

			case strc_MARKER : /* Multiple of 32 bytes. */

			case afsp_MARKER :
			case bext_MARKER :
			case clm_MARKER :
			case plst_MARKER :
			case DISP_MARKER :
			case MEXT_MARKER :
			case PAD_MARKER :
					psf_binheader_readf (psf, "e4", &dword);
					; // psf_log_printf (psf, "%M : %d\n", marker, dword);
					dword += (dword & 1);
					psf_binheader_readf (psf, "j", dword);
					break;

			default :
					if(isprint ((marker >> 24) & 0xFF) && isprint ((marker >> 16) & 0xFF)
						&& isprint ((marker >> 8) & 0xFF) && isprint (marker & 0xFF))
					{	psf_binheader_readf (psf, "e4", &dword);
						; // psf_log_printf (psf, "*** %M : %d (unknown marker)\n", marker, dword);
						psf_binheader_readf (psf, "j", dword);
						break;
						};
					if(psf_ftell (psf) & 0x03)
					{
		; // psf_log_printf (psf, "  Unknown chunk marker at position %d. Resynching.\n", dword - 4);
						psf_binheader_readf (psf, "j", -3);
						break;
						};
					; // psf_log_printf (psf, "*** Unknown chunk marker : %X. Exiting parser.\n", marker);
					done = SF_TRUE;
					break;
			};	/* switch (dword) */

		if(! psf->sf.seekable && (parsestage & HAVE_data))
			break;

		if(psf_ftell (psf) >= (signed)(psf->filelength - sizeof (dword)))
		{
		; // psf_log_printf (psf, "End\n");
			break;
			};

		if(psf->logindex >= sizeof (psf->logbuffer) - 2)
			return SFE_LOG_OVERRUN;
		}; /* while(1) */

	if(! psf->dataoffset)
		return SFE_WAV_NO_DATA;

	psf->endian = SF_ENDIAN_LITTLE;		/* All WAV files are little endian. */

	psf_fseek (psf, psf->dataoffset, SEEK_SET);

	/*
	** Check for 'wvpk' at the start of the DATA section. Not able to
	** handle this.
	*/
	psf_binheader_readf (psf, "e4", &marker);
	if(marker == wvpk_MARKER)
		return SFE_WAV_WVPK_DATA;

	/* Seek to start of DATA section. */
	psf_fseek (psf, psf->dataoffset, SEEK_SET);

	psf->close = wav_close;

	if(psf->blockwidth)
	{	if(psf->filelength - psf->dataoffset < psf->datalength)
			psf->sf.frames = (psf->filelength - psf->dataoffset) / psf->blockwidth;
		else
			psf->sf.frames = psf->datalength / psf->blockwidth;
		};

	switch (format)
	{
		case WAVE_FORMAT_PCM :
					psf->sf.format = SF_FORMAT_WAV | SF_FORMAT_PCM_16; // psf->sf.format = SF_FORMAT_WAV;
					break;

		case WAVE_FORMAT_EXTENSIBLE :
					psf->sf.format = SF_FORMAT_WAV | u_bitwidth_to_subformat (psf->bytewidth * 8);
					break;

		case WAVE_FORMAT_MULAW :
		case IBM_FORMAT_MULAW :
					psf->sf.format = (SF_FORMAT_WAV | SF_FORMAT_ULAW);
					break;

		case WAVE_FORMAT_ALAW :
		case IBM_FORMAT_ALAW :
					psf->sf.format = (SF_FORMAT_WAV | SF_FORMAT_ALAW);
					break;

		case WAVE_FORMAT_MS_ADPCM :
					psf->sf.format = (SF_FORMAT_WAV | SF_FORMAT_MS_ADPCM);
					*blockalign = wav_fmt.msadpcm.blockalign;
					*framesperblock = wav_fmt.msadpcm.samplesperblock;
					break;

		case WAVE_FORMAT_IMA_ADPCM :
					psf->sf.format = (SF_FORMAT_WAV | SF_FORMAT_IMA_ADPCM);
					*blockalign = wav_fmt.ima.blockalign;
					*framesperblock = wav_fmt.ima.samplesperblock;
					break;

		case WAVE_FORMAT_GSM610 :
					psf->sf.format = (SF_FORMAT_WAV | SF_FORMAT_GSM610);
					break;

		case WAVE_FORMAT_IEEE_FLOAT :
					psf->sf.format = SF_FORMAT_WAV;
					psf->sf.format |= (psf->bytewidth == 8) ? SF_FORMAT_DOUBLE : SF_FORMAT_FLOAT;
					break;

		default : return SFE_UNIMPLEMENTED;
		};

	return 0;
} /* wav_read_header */

static int
wav_close (SF_PRIVATE *psf)
{
#ifdef MAUNUSED
 (void)psf;
#endif

	return 0;
} /* wav_close */

static int
wav_command (SF_PRIVATE *psf, int command, void *data, int datasize)
{
	/* Avoid compiler warnings. */
	psf = psf;
	data = data;
	datasize = datasize;

	switch (command)
	{	default : break;
		};

	return 0;
} /* wav_command */

static int
wav_subchunk_parse (SF_PRIVATE *psf, int chunk)
{	sf_count_t	current_pos;
	char		*cptr;
	int 		dword, bytesread, length;

	current_pos = psf_fseek (psf, 0, SEEK_CUR);

	bytesread = psf_binheader_readf (psf, "e4", &length);

	if(current_pos + length > psf->filelength)
	{
		; // psf_log_printf (psf, "%M : %d (should be %d)\n", chunk, length, (int) (psf->filelength - current_pos));
		length = psf->filelength - current_pos;
		}
	else
		; // psf_log_printf (psf, "%M : %d\n", chunk, length);


	while(bytesread < length)
	{	bytesread += psf_binheader_readf (psf, "m", &chunk);

		switch (chunk)
		{	case adtl_MARKER :
			case INFO_MARKER :
					/* These markers don't contain anything. */
					; // psf_log_printf (psf, "  %M\n", chunk);
					break;

			case data_MARKER:
					; // psf_log_printf (psf, "  %M inside a LIST block??? Backing out.\n", chunk);
					/* Jump back four bytes and return to caller. */
					psf_binheader_readf (psf, "j", -4);
					return 0;

			case ISFT_MARKER :
			case ICOP_MARKER :
			case IARL_MARKER :
			case IART_MARKER :
			case ICMT_MARKER :
			case ICRD_MARKER :
			case IENG_MARKER :

			case INAM_MARKER :
			case IPRD_MARKER :
			case ISBJ_MARKER :
			case ISRC_MARKER :
					bytesread += psf_binheader_readf (psf, "e4", &dword);
					dword += (dword & 1);
					if(dword > SIGNED_SIZEOF (psf->buffer))
					{
		; // psf_log_printf (psf, "  *** %M : %d (too big)\n", chunk, dword);
						return SFE_INTERNAL;
						};

					cptr = (char*) psf->buffer;
					psf_binheader_readf (psf, "b", cptr, dword);
					bytesread += dword;
					cptr [dword - 1] = 0;
					; // psf_log_printf (psf, "    %M : %s\n", chunk, cptr);
					break;

			case labl_MARKER :
					{	int mark_id;

						bytesread += psf_binheader_readf (psf, "e44", &dword, &mark_id);
						dword -= 4;
						dword += (dword & 1);
						if(dword > SIGNED_SIZEOF (psf->buffer))
						{
		; // psf_log_printf (psf, "  *** %M : %d (too big)\n", chunk, dword);
							return SFE_INTERNAL;
							};

						cptr = (char*) psf->buffer;
						psf_binheader_readf (psf, "b", cptr, dword);
						bytesread += dword;
						cptr [dword - 1] = 0;
						; // psf_log_printf (psf, "    %M : %d : %s\n", chunk, mark_id, cptr);
						};
					break;


			case DISP_MARKER :
			case ltxt_MARKER :
			case note_MARKER :
					bytesread += psf_binheader_readf (psf, "e4", &dword);
					dword += (dword & 1);
					psf_binheader_readf (psf, "j", dword);
					bytesread += dword;
					; // psf_log_printf (psf, "    %M : %d\n", chunk, dword);
					break;

			default :
					psf_binheader_readf (psf, "e4", &dword);
					bytesread += sizeof (dword);
					dword += (dword & 1);
					psf_binheader_readf (psf, "j", dword);
					bytesread += dword;
					; // psf_log_printf (psf, "    *** %M : %d\n", chunk, dword);
					if(dword > length)
						return 0;
					break;
			};

		switch (chunk)
		{	case ISFT_MARKER :
					psf_store_string (psf, SF_STR_SOFTWARE, (char*) psf->buffer);
					break;
			case ICOP_MARKER :
					psf_store_string (psf, SF_STR_COPYRIGHT, (char*) psf->buffer);
					break;
			case INAM_MARKER :
					psf_store_string (psf, SF_STR_TITLE, (char*) psf->buffer);
					break;
			case IART_MARKER :
					psf_store_string (psf, SF_STR_ARTIST, (char*) psf->buffer);
					break;
			case ICMT_MARKER :
					psf_store_string (psf, SF_STR_COMMENT, (char*) psf->buffer);
					break;
			case ICRD_MARKER :
					psf_store_string (psf, SF_STR_DATE, (char*) psf->buffer);
					break;
			};

		if(psf->logindex >= sizeof (psf->logbuffer) - 2)
			return SFE_LOG_OVERRUN;
		};

	current_pos = psf_fseek (psf, 0, SEEK_CUR) - current_pos;

	if(current_pos - 4 != length)
		; // psf_log_printf (psf, "**** Bad chunk length %d sbould be %D\n", length, current_pos - 4);

	return 0;
} /* wav_subchunk_parse */

static int
wav_read_smpl_chunk (SF_PRIVATE *psf, unsigned int chunklen)
{	unsigned int bytesread = 0, dword, sampler_data, loop_count;
	int k;

	chunklen += (chunklen & 1);

	bytesread += psf_binheader_readf (psf, "e4", &dword);
	; // psf_log_printf (psf, "  Manufacturer : %X\n", dword);

	bytesread += psf_binheader_readf (psf, "e4", &dword);
	; // psf_log_printf (psf, "  Product      : %u\n", dword);

	bytesread += psf_binheader_readf (psf, "e4", &dword);
	; // psf_log_printf (psf, "  Period       : %u nsec\n", dword);

	bytesread += psf_binheader_readf (psf, "e4", &dword);
	; // psf_log_printf (psf, "  Midi Note    : %u\n", dword);

	bytesread += psf_binheader_readf (psf, "e4", &dword);
	if(dword != 0)
	{	LSF_SNPRINTF ((char*) psf->buffer, sizeof (psf->buffer), "%f",
				(1.0 * 0x80000000) / ((unsigned int) dword));
		; // psf_log_printf (psf, "  Pitch Fract. : %s\n", (char*) psf->buffer);
		}
	else
		; // psf_log_printf (psf, "  Pitch Fract. : 0\n");

	bytesread += psf_binheader_readf (psf, "e4", &dword);
	; // psf_log_printf (psf, "  SMPTE Format : %u\n", dword);

	bytesread += psf_binheader_readf (psf, "e4", &dword);
	LSF_SNPRINTF ((char*) psf->buffer, sizeof (psf->buffer), "%02d:%02d:%02d %02d",
		(dword >> 24) & 0x7F, (dword >> 16) & 0x7F, (dword >> 8) & 0x7F, dword & 0x7F);
	; // psf_log_printf (psf, "  SMPTE Offset : %s\n", psf->buffer);

	bytesread += psf_binheader_readf (psf, "e4", &loop_count);
	; // psf_log_printf (psf, "  Loop Count   : %u\n", loop_count);

	/* Sampler Data holds the number of data bytes after the CUE chunks which
	** is not actually CUE data. Display value after CUE data.
	*/
	bytesread += psf_binheader_readf (psf, "e4", &sampler_data);

	while(loop_count > 0 && chunklen - bytesread >= 24)
	{
		bytesread += psf_binheader_readf (psf, "e4", &dword);
		; // psf_log_printf (psf, "    Cue ID : %2u", dword);

		bytesread += psf_binheader_readf (psf, "e4", &dword);
		; // psf_log_printf (psf, "  Type : %2u", dword);

		bytesread += psf_binheader_readf (psf, "e4", &dword);
		; // psf_log_printf (psf, "  Start : %5u", dword);

		bytesread += psf_binheader_readf (psf, "e4", &dword);
		; // psf_log_printf (psf, "  End : %5u", dword);

		bytesread += psf_binheader_readf (psf, "e4", &dword);
		; // psf_log_printf (psf, "  Fraction : %5u", dword);

		bytesread += psf_binheader_readf (psf, "e4", &dword);
		; // psf_log_printf (psf, "  Count : %5u\n", dword);

		loop_count --;
		};

	if(chunklen - bytesread == 0)
	{	if(sampler_data != 0)
			; // psf_log_printf (psf, "  Sampler Data : %u (should be 0)\n", sampler_data);
		else
			; // psf_log_printf (psf, "  Sampler Data : %u\n", sampler_data);
		}
	else
	{	if(sampler_data != chunklen - bytesread)
		{
		; // psf_log_printf (psf, "  Sampler Data : %u (should have been %u)\n", sampler_data, chunklen - bytesread);
			sampler_data = chunklen - bytesread;
			}
		else
			; // psf_log_printf (psf, "  Sampler Data : %u\n", sampler_data);

		; // psf_log_printf (psf, "      ");
		for(k = 0; k < (int) sampler_data; k++)
		{	char ch;

			if(k > 0 && (k % 20) == 0)
				; // psf_log_printf (psf, "\n      ");

			bytesread += psf_binheader_readf (psf, "1", &ch);
			; // psf_log_printf (psf, "%02X ", ch & 0xFF);
			};

		; // psf_log_printf (psf, "\n");
		};

	return 0;
} /* wav_read_smpl_chunk */

/*
** The acid chunk goes a little something like this:
**
** 4 bytes          'acid'
** 4 bytes (int)     length of chunk
** 4 bytes (int)     ???
** 2 bytes (short)      root note
** 2 bytes (short)      ???
** 4 bytes (float)      ???
** 4 bytes (int)     number of beats
** 2 bytes (short)      meter denominator
** 2 bytes (short)      meter numerator
** 4 bytes (float)      tempo
**
*/

static int
wav_read_acid_chunk (SF_PRIVATE *psf, unsigned int chunklen)
{	unsigned int bytesread = 0;
	int	beats;
	short rootnote, q1, meter_denom, meter_numer;
	float q2, q3, tempo;

	chunklen += (chunklen & 1);

	bytesread += psf_binheader_readf (psf, "e224f", &rootnote, &q1, &q2, &q3);
	LSF_SNPRINTF ((char*) psf->buffer, sizeof (psf->buffer), "%f", q2);
	; // psf_log_printf (psf, "  Root note : %d\n  ????      : %d\n  ????      : %s\n  ????      : %d\n",
		//		rootnote, q1, psf->buffer, q3);

	bytesread += psf_binheader_readf (psf, "e422f", &beats, &meter_denom, &meter_numer, &tempo);
	LSF_SNPRINTF ((char*) psf->buffer, sizeof (psf->buffer), "%f", tempo);
	; // psf_log_printf (psf, "  Beats     : %d\n  Meter     : %d/%d\n  Tempo     : %s\n",
		//		beats, meter_denom, meter_numer, psf->buffer);

	psf_binheader_readf (psf, "j", chunklen - bytesread);

	return 0;
} /* wav_read_acid_chunk */

// wav64.c:

/*------------------------------------------------------------------------------
 * Private static functions.
 */

int
wav_w64_read_fmt_chunk (SF_PRIVATE *psf, WAV_FMT *wav_fmt, int structsize)
{	int	bytesread, k, bytespersec = 0  ;

	memset (wav_fmt, 0, sizeof (WAV_FMT));

	if(structsize < 16)
		return SFE_WAV_FMT_SHORT;
	if(structsize > SIGNED_SIZEOF (WAV_FMT))
		return SFE_WAV_FMT_TOO_BIG;

	/* Read the minimal WAV file header here. */
	bytesread =
	psf_binheader_readf (psf, "e224422", &(wav_fmt->format), &(wav_fmt->min.channels),
			&(wav_fmt->min.samplerate), &(wav_fmt->min.bytespersec),
			&(wav_fmt->min.blockalign), &(wav_fmt->min.bitwidth))  ;

	; // psf_log_printf (psf, "  Format        : 0x%X => %s\n", wav_fmt->format, wav_w64_format_str (wav_fmt->format));
	; // psf_log_printf (psf, "  Channels      : %d\n", wav_fmt->min.channels);
	; // psf_log_printf (psf, "  Sample Rate   : %d\n", wav_fmt->min.samplerate);
	; // psf_log_printf (psf, "  Block Align   : %d\n", wav_fmt->min.blockalign);

	if(wav_fmt->format == WAVE_FORMAT_PCM && wav_fmt->min.bitwidth == 24 &&
			wav_fmt->min.blockalign == 4 * wav_fmt->min.channels)
	{
		; // psf_log_printf (psf, "\nInvalid file generated by Syntrillium's Cooledit!\n"
			//	"Treating as WAVE_FORMAT_IEEE_FLOAT 32 bit floating point file.\n\n");
		; // psf_log_printf (psf, "  Bit Width     : 24 (should be 32)\n");
		wav_fmt->min.bitwidth = 32;
		wav_fmt->format = WAVE_FORMAT_IEEE_FLOAT;
		}
	else if(wav_fmt->format == WAVE_FORMAT_GSM610 && wav_fmt->min.bitwidth != 0)
		; // psf_log_printf (psf, "  Bit Width     : %d (should be 0)\n", wav_fmt->min.bitwidth);
	else
		; // psf_log_printf (psf, "  Bit Width     : %d\n", wav_fmt->min.bitwidth);


	psf->sf.samplerate	= wav_fmt->min.samplerate;
	psf->sf.frames 		= 0;					/* Correct this when reading data chunk. */
	psf->sf.channels	= wav_fmt->min.channels;

	switch (wav_fmt->format)
	{	case WAVE_FORMAT_PCM :
		case WAVE_FORMAT_IEEE_FLOAT :
				bytespersec = wav_fmt->min.samplerate * wav_fmt->min.blockalign;
				if(wav_fmt->min.bytespersec != (unsigned) bytespersec)
					; // psf_log_printf (psf, "  Bytes/sec     : %d (should be %d)\n", wav_fmt->min.bytespersec, bytespersec);
				else
					; // psf_log_printf (psf, "  Bytes/sec     : %d\n", wav_fmt->min.bytespersec);

				psf->bytewidth = BITWIDTH2BYTES (wav_fmt->min.bitwidth);
				break;

		case WAVE_FORMAT_ALAW :
		case WAVE_FORMAT_MULAW :
				if(wav_fmt->min.bytespersec / wav_fmt->min.blockalign != wav_fmt->min.samplerate)
					; // psf_log_printf (psf, "  Bytes/sec     : %d (should be %d)\n", wav_fmt->min.bytespersec, wav_fmt->min.samplerate * wav_fmt->min.blockalign);
				else
					; // psf_log_printf (psf, "  Bytes/sec     : %d\n", wav_fmt->min.bytespersec);

				psf->bytewidth = 1;
				if(structsize >= 18)
				{	bytesread += psf_binheader_readf (psf, "e2", &(wav_fmt->size20.extrabytes));
					; // psf_log_printf (psf, "  Extra Bytes   : %d\n", wav_fmt->size20.extrabytes);
					};
				break;

		case WAVE_FORMAT_IMA_ADPCM :
				if(wav_fmt->min.bitwidth != 4)
					return SFE_WAV_ADPCM_NOT4BIT;
				if(wav_fmt->min.channels < 1 || wav_fmt->min.channels > 2)
					return SFE_WAV_ADPCM_CHANNELS;

				bytesread +=
				psf_binheader_readf (psf, "e22", &(wav_fmt->ima.extrabytes), &(wav_fmt->ima.samplesperblock));

				bytespersec = (wav_fmt->ima.samplerate * wav_fmt->ima.blockalign) / wav_fmt->ima.samplesperblock;
				if(wav_fmt->ima.bytespersec != (unsigned) bytespersec)
					; // psf_log_printf (psf, "  Bytes/sec     : %d (should be %d)\n", wav_fmt->ima.bytespersec, bytespersec);
				else
					; // psf_log_printf (psf, "  Bytes/sec     : %d\n", wav_fmt->ima.bytespersec);

				psf->bytewidth = 2;
				; // psf_log_printf (psf, "  Extra Bytes   : %d\n", wav_fmt->ima.extrabytes);
				; // psf_log_printf (psf, "  Samples/Block : %d\n", wav_fmt->ima.samplesperblock);
				break;

		case WAVE_FORMAT_MS_ADPCM :
				if(wav_fmt->msadpcm.bitwidth != 4)
					return SFE_WAV_ADPCM_NOT4BIT;
				if(wav_fmt->msadpcm.channels < 1 || wav_fmt->msadpcm.channels > 2)
					return SFE_WAV_ADPCM_CHANNELS;

				bytesread +=
				psf_binheader_readf (psf, "e222", &(wav_fmt->msadpcm.extrabytes),
						&(wav_fmt->msadpcm.samplesperblock), &(wav_fmt->msadpcm.numcoeffs));

				bytespersec = (wav_fmt->min.samplerate * wav_fmt->min.blockalign) / wav_fmt->msadpcm.samplesperblock;
				if(wav_fmt->min.bytespersec == (unsigned) bytespersec)
					; // psf_log_printf (psf, "  Bytes/sec     : %d\n", wav_fmt->min.bytespersec);
				else if(wav_fmt->min.bytespersec == (wav_fmt->min.samplerate / wav_fmt->msadpcm.samplesperblock) * wav_fmt->min.blockalign)
					; // psf_log_printf (psf, "  Bytes/sec     : %d (should be %d (MS BUG!))\n", wav_fmt->min.bytespersec, bytespersec);
				else
					; // psf_log_printf (psf, "  Bytes/sec     : %d (should be %d)\n", wav_fmt->min.bytespersec, bytespersec);


				psf->bytewidth = 2;
				; // psf_log_printf (psf, "  Extra Bytes   : %d\n", wav_fmt->msadpcm.extrabytes);
				; // psf_log_printf (psf, "  Samples/Block : %d\n", wav_fmt->msadpcm.samplesperblock);
				if(wav_fmt->msadpcm.numcoeffs > SIGNED_SIZEOF (MS_ADPCM_WAV_FMT) / SIGNED_SIZEOF (int))
				{
		; // psf_log_printf (psf, "  No. of Coeffs : %d ****\n", wav_fmt->msadpcm.numcoeffs);
					wav_fmt->msadpcm.numcoeffs = SIGNED_SIZEOF (MS_ADPCM_WAV_FMT) / SIGNED_SIZEOF (int);
					}
				else
					; // psf_log_printf (psf, "  No. of Coeffs : %d\n", wav_fmt->msadpcm.numcoeffs);

				; // psf_log_printf (psf, "    Index   Coeffs1   Coeffs2\n");
				for(k = 0; k < wav_fmt->msadpcm.numcoeffs; k++)
				{	bytesread +=
					psf_binheader_readf (psf, "e22", &(wav_fmt->msadpcm.coeffs [k].coeff1), &(wav_fmt->msadpcm.coeffs [k].coeff2));
					LSF_SNPRINTF ((char*) psf->buffer, sizeof (psf->buffer), "     %2d     %7d   %7d\n", k, wav_fmt->msadpcm.coeffs [k].coeff1, wav_fmt->msadpcm.coeffs [k].coeff2);
					; // psf_log_printf (psf, (char*) psf->buffer);
					};
				break;

		case WAVE_FORMAT_GSM610 :
				if(wav_fmt->gsm610.channels != 1 || wav_fmt->gsm610.blockalign != 65)
					return SFE_WAV_GSM610_FORMAT;

				bytesread +=
				psf_binheader_readf (psf, "e22", &(wav_fmt->gsm610.extrabytes), &(wav_fmt->gsm610.samplesperblock));

				if(wav_fmt->gsm610.samplesperblock != 320)
					return SFE_WAV_GSM610_FORMAT;

				bytespersec = (wav_fmt->gsm610.samplerate * wav_fmt->gsm610.blockalign) / wav_fmt->gsm610.samplesperblock;
				if(wav_fmt->gsm610.bytespersec != (unsigned) bytespersec)
					; // psf_log_printf (psf, "  Bytes/sec     : %d (should be %d)\n", wav_fmt->gsm610.bytespersec, bytespersec);
				else
					; // psf_log_printf (psf, "  Bytes/sec     : %d\n", wav_fmt->gsm610.bytespersec);

				psf->bytewidth = 2;
				; // psf_log_printf (psf, "  Extra Bytes   : %d\n", wav_fmt->gsm610.extrabytes);
				; // psf_log_printf (psf, "  Samples/Block : %d\n", wav_fmt->gsm610.samplesperblock);
				break;

		case WAVE_FORMAT_EXTENSIBLE :
				if(wav_fmt->ext.bytespersec / wav_fmt->ext.blockalign != wav_fmt->ext.samplerate)
					; // psf_log_printf (psf, "  Bytes/sec     : %d (should be %d)\n", wav_fmt->ext.bytespersec, wav_fmt->ext.samplerate * wav_fmt->ext.blockalign);
				else
					; // psf_log_printf (psf, "  Bytes/sec     : %d\n", wav_fmt->ext.bytespersec);

				bytesread +=
				psf_binheader_readf (psf, "e224", &(wav_fmt->ext.extrabytes), &(wav_fmt->ext.validbits),
						&(wav_fmt->ext.channelmask));

				; // psf_log_printf (psf, "  Valid Bits    : %d\n", wav_fmt->ext.validbits);
				; // psf_log_printf (psf, "  Channel Mask  : 0x%X\n", wav_fmt->ext.channelmask);

				bytesread +=
				psf_binheader_readf (psf, "e422", &(wav_fmt->ext.esf.esf_field1), &(wav_fmt->ext.esf.esf_field2),
						&(wav_fmt->ext.esf.esf_field3));

				; // psf_log_printf (psf, "  Subformat\n");
				; // psf_log_printf (psf, "    esf_field1 : 0x%X\n", wav_fmt->ext.esf.esf_field1);
				; // psf_log_printf (psf, "    esf_field2 : 0x%X\n", wav_fmt->ext.esf.esf_field2);
				; // psf_log_printf (psf, "    esf_field3 : 0x%X\n", wav_fmt->ext.esf.esf_field3);
				; // psf_log_printf (psf, "    esf_field4 : ");
				for(k = 0; k < 8; k++)
				{	bytesread += psf_binheader_readf (psf, "1", &(wav_fmt->ext.esf.esf_field4 [k]));
					; // psf_log_printf (psf, "0x%X ", wav_fmt->ext.esf.esf_field4 [k] & 0xFF);
					};
				; // psf_log_printf (psf, "\n");
				psf->bytewidth = BITWIDTH2BYTES (wav_fmt->ext.bitwidth);
				break;

		default : break;
		};

	if(bytesread > structsize)
	{
		; // psf_log_printf (psf, "*** wav_w64_read_fmt_chunk (bytesread > structsize)\n");
		return SFE_W64_FMT_SHORT;
		}
	else
		psf_binheader_readf (psf, "j", structsize - bytesread);

	psf->blockwidth = wav_fmt->min.channels * psf->bytewidth;

	return 0;
} /* wav_w64_read_fmt_chunk */

/*==============================================================================
*/

typedef struct
{	int		ID;
	const char	*name;
} WAV_FORMAT_DESC;

#define STR(x)			#x
#define FORMAT_TYPE(x)	{ x, STR (x) }

static WAV_FORMAT_DESC wave_descs [] = 
{	FORMAT_TYPE	(WAVE_FORMAT_PCM),
	FORMAT_TYPE (WAVE_FORMAT_MS_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_IEEE_FLOAT),
	FORMAT_TYPE (WAVE_FORMAT_VSELP),
	FORMAT_TYPE (WAVE_FORMAT_IBM_CVSD),
	FORMAT_TYPE (WAVE_FORMAT_ALAW),
	FORMAT_TYPE (WAVE_FORMAT_MULAW),
	FORMAT_TYPE (WAVE_FORMAT_OKI_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_IMA_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_MEDIASPACE_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_SIERRA_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_G723_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_DIGISTD),
	FORMAT_TYPE (WAVE_FORMAT_DIGIFIX),
	FORMAT_TYPE (WAVE_FORMAT_DIALOGIC_OKI_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_MEDIAVISION_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_CU_CODEC),
	FORMAT_TYPE (WAVE_FORMAT_YAMAHA_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_SONARC),
	FORMAT_TYPE (WAVE_FORMAT_DSPGROUP_TRUESPEECH),
	FORMAT_TYPE (WAVE_FORMAT_ECHOSC1),
	FORMAT_TYPE (WAVE_FORMAT_AUDIOFILE_AF36),
	FORMAT_TYPE (WAVE_FORMAT_APTX),
	FORMAT_TYPE (WAVE_FORMAT_AUDIOFILE_AF10),
	FORMAT_TYPE (WAVE_FORMAT_PROSODY_1612),
	FORMAT_TYPE (WAVE_FORMAT_LRC),
	FORMAT_TYPE (WAVE_FORMAT_DOLBY_AC2),
	FORMAT_TYPE (WAVE_FORMAT_GSM610),
	FORMAT_TYPE (WAVE_FORMAT_MSNAUDIO),
	FORMAT_TYPE (WAVE_FORMAT_ANTEX_ADPCME),
	FORMAT_TYPE (WAVE_FORMAT_CONTROL_RES_VQLPC),
	FORMAT_TYPE (WAVE_FORMAT_DIGIREAL),
	FORMAT_TYPE (WAVE_FORMAT_DIGIADPCM),
	FORMAT_TYPE (WAVE_FORMAT_CONTROL_RES_CR10),
	FORMAT_TYPE (WAVE_FORMAT_NMS_VBXADPCM),
	FORMAT_TYPE (WAVE_FORMAT_ROLAND_RDAC),
	FORMAT_TYPE (WAVE_FORMAT_ECHOSC3),
	FORMAT_TYPE (WAVE_FORMAT_ROCKWELL_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_ROCKWELL_DIGITALK),
	FORMAT_TYPE (WAVE_FORMAT_XEBEC),
	FORMAT_TYPE (WAVE_FORMAT_G721_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_G728_CELP),
	FORMAT_TYPE (WAVE_FORMAT_MSG723),
	FORMAT_TYPE (WAVE_FORMAT_MPEG),
	FORMAT_TYPE (WAVE_FORMAT_RT24),
	FORMAT_TYPE (WAVE_FORMAT_PAC),
	FORMAT_TYPE (WAVE_FORMAT_MPEGLAYER3),
	FORMAT_TYPE (WAVE_FORMAT_LUCENT_G723),
	FORMAT_TYPE (WAVE_FORMAT_CIRRUS),
	FORMAT_TYPE (WAVE_FORMAT_ESPCM),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE),
	FORMAT_TYPE (WAVE_FORMAT_CANOPUS_ATRAC),
	FORMAT_TYPE (WAVE_FORMAT_G726_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_G722_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_DSAT),
	FORMAT_TYPE (WAVE_FORMAT_DSAT_DISPLAY),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_BYTE_ALIGNED),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_AC8),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_AC10),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_AC16),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_AC20),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_RT24),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_RT29),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_RT29HW),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_VR12),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_VR18),
	FORMAT_TYPE (WAVE_FORMAT_VOXWARE_TQ40),
	FORMAT_TYPE (WAVE_FORMAT_SOFTSOUND),
	FORMAT_TYPE (WAVE_FORMAT_VOXARE_TQ60),
	FORMAT_TYPE (WAVE_FORMAT_MSRT24),
	FORMAT_TYPE (WAVE_FORMAT_G729A),
	FORMAT_TYPE (WAVE_FORMAT_MVI_MV12),
	FORMAT_TYPE (WAVE_FORMAT_DF_G726),
	FORMAT_TYPE (WAVE_FORMAT_DF_GSM610),
	FORMAT_TYPE (WAVE_FORMAT_ONLIVE),
	FORMAT_TYPE (WAVE_FORMAT_SBC24),
	FORMAT_TYPE (WAVE_FORMAT_DOLBY_AC3_SPDIF),
	FORMAT_TYPE (WAVE_FORMAT_ZYXEL_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_PHILIPS_LPCBB),  
	FORMAT_TYPE (WAVE_FORMAT_PACKED),
	FORMAT_TYPE (WAVE_FORMAT_RHETOREX_ADPCM),
	FORMAT_TYPE (IBM_FORMAT_MULAW),
	FORMAT_TYPE (IBM_FORMAT_ALAW),
	FORMAT_TYPE (IBM_FORMAT_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_VIVO_G723),
	FORMAT_TYPE (WAVE_FORMAT_VIVO_SIREN),
	FORMAT_TYPE (WAVE_FORMAT_DIGITAL_G723),
	FORMAT_TYPE (WAVE_FORMAT_CREATIVE_ADPCM),
	FORMAT_TYPE (WAVE_FORMAT_CREATIVE_FASTSPEECH8),
	FORMAT_TYPE (WAVE_FORMAT_CREATIVE_FASTSPEECH10),
	FORMAT_TYPE (WAVE_FORMAT_QUARTERDECK),
	FORMAT_TYPE (WAVE_FORMAT_FM_TOWNS_SND),
	FORMAT_TYPE (WAVE_FORMAT_BZV_DIGITAL),
	FORMAT_TYPE (WAVE_FORMAT_VME_VMPCM),
	FORMAT_TYPE (WAVE_FORMAT_OLIGSM),
	FORMAT_TYPE (WAVE_FORMAT_OLIADPCM),
	FORMAT_TYPE (WAVE_FORMAT_OLICELP),
	FORMAT_TYPE (WAVE_FORMAT_OLISBC),
	FORMAT_TYPE (WAVE_FORMAT_OLIOPR),
	FORMAT_TYPE (WAVE_FORMAT_LH_CODEC),
	FORMAT_TYPE (WAVE_FORMAT_NORRIS),
	FORMAT_TYPE (WAVE_FORMAT_SOUNDSPACE_MUSICOMPRESS),
	FORMAT_TYPE (WAVE_FORMAT_DVM),
};

char const*
wav_w64_format_str (int k)
{	int lower, upper, mid;

	lower = -1;
	upper = sizeof (wave_descs) / sizeof (WAV_FORMAT_DESC);

	/* binary search */
	if((wave_descs [0].ID <= k) & (k <= wave_descs [upper - 1].ID))
	{
		while(lower + 1 < upper)
		{	mid = (upper + lower) / 2;

			if(k == wave_descs [mid].ID)
				return wave_descs [mid].name;
			if(k < wave_descs [mid].ID)
				upper = mid;
			else
				lower = mid;
			};
		};

	return "Unknown format";
} /* wav_w64_format_str */

int
wav_w64_srate2blocksize (int srate_chan_product)
{	if(srate_chan_product < 12000)
		return 256;
	if(srate_chan_product < 23000)
		return 512;
	if(srate_chan_product < 44000)
		return 1024;
	return 2048;
} /* srate2blocksize */


///////////////////////

int l_aifseek = -1;

void aifseek(int pos)
{
	if(!g_state.fsf || l_aifseek >= 0 || pos < 0)
		return;
	
	l_aifseek = pos;	

} // aifseek


void maPlayAif() // also maPlayWav
{
	char cstr[256];

	if(!g_state.inpath)
	{
		maLog("maPlayAif error null filename");
		return;
	}

	// format of this decoder output
#ifdef WORDS_BIGENDIAN
	g_state.inwordsbigendian = 1;
#else
	g_state.inwordsbigendian = 0;
#endif
	g_state.ininterleaved = 1;
	
	// open input
	if(AifOpenFile(&g_state))
	{
		sprintf(cstr, "maPlayAif AifOpenFile failed on '%s'", g_state.inpath);
		maLog(cstr);
		return;
	}
	
 	if(maOutputOpen() < 0)
	{
		AifCloseFile(&g_state);
		maLog("maPlayAif maOutputOpen failed");
		return;
	}

	if(!g_posendon)
		g_posend = g_state.duration;

	g_state.inchannels = ((SF_PRIVATE *)g_state.psf)->sf.channels; 
		
	// wav, aif decode loop
	while(1)
	{	
		ThreadYield();
		
		if(g_state.stop)
			break;
				
		if(l_aifseek >= 0) // in ms from beginning of song
		{
			sf_seek((SNDFILE *)g_state.fsf, (sf_count_t)(((double)l_aifseek *
				(double)((SF_PRIVATE *)g_state.psf)->sf.frames) / g_state.duration), SEEK_SET);
				
			l_aifseek = -1;
		}

		if(AifDecodeStream())
			break;

		g_state.position = LROUND(((double)((SF_PRIVATE *)g_state.psf)->read_current *
							(double)g_state.duration) / ((SF_PRIVATE *)g_state.psf)->sf.frames);

	} // while 1

	// finish

	FlushFifo();

	AifCloseFile(&g_state);
	
	g_state.position = 0;
	l_aifseek = -1;
	
} // maPlayAif


// read PCMBLOCKSIZE bytes, output audio (block-wait if needed), return : 1 if song is finished, else 0
#define PCMBLOCKSIZE FIFOSIZE
int AifDecodeStream()
{
	char pcmbuffer[PCMBLOCKSIZE];
	sf_count_t frames;
	int bytesread;
	int itemsread;
	char cstr[256];

	// Get pcm block
	frames = (((SF_PRIVATE *)g_state.psf)->sf.channels == 1) ?
			(PCMBLOCKSIZE / 2) / ((SF_PRIVATE *)g_state.psf)->blockwidth :
				  PCMBLOCKSIZE / ((SF_PRIVATE *)g_state.psf)->blockwidth;
	
	if((itemsread = sf_readf_short((SNDFILE *)g_state.fsf, (short *)pcmbuffer, frames)) > 0)
	{
		bytesread = itemsread * ((SF_PRIVATE *)g_state.psf)->blockwidth;

		// Write to fifo
		if(maOutputWrite((char *)pcmbuffer, bytesread, &g_state) != 0)
		{
			sprintf(cstr, "AifDecodeStream maOutputWrite failed : len=%d g_state.stop=x%x g_fifoready=%d",
														bytesread, g_state.stop, g_fifoready);
			maLog(cstr);
			return 1;
		}
	
	} //if(framesread > 0)
	else
		bytesread = 0;
	
	if(bytesread > 0)
		return 0; // song not finished

	// song is finished :
	
	if(g_reptsong) // seek to beginning and continue
	{
		l_aifseek = g_posbeg;
		return 0;
	}

	return 1; // song is finished
	
} // AifDecodeStream


int AifOpenFile(MASTATE *pstate) //also WavOpenFile
{
	SF_INFO isf;
	char cstr[256];
	
	memset(&isf, 0, sizeof(SF_INFO));
	pstate->psf = NULL;

	if((pstate->fsf = sf_open(pstate, SFM_READ, &isf)) == NULL)
	{
		sprintf(cstr, "AifOpenFile sf_open failed on '%s'", pstate->inpath);
		maLog(cstr);
		return 1;
	}
	
	pstate->insamplerate = isf.samplerate;
	pstate->position = 0;
	pstate->duration = LROUND(((double)((SF_PRIVATE *)pstate->psf)->datalength * 500.0) /
		((double)isf.samplerate * ((SF_PRIVATE *)pstate->psf)->sf.channels)); // ms, 2 channels * 44100
		
	return 0;
	
} // AifOpenFile


void AifCloseFile(MASTATE *pstate) // also WavCloseFile
{
	if(pstate && pstate->fsf)
	{
		sf_close((SNDFILE *)pstate->fsf);
		pstate->fsf = NULL;
	}
		
} // AifCloseFile


/*
int AifGetPCMBlock(void *pBlock, int *pBlockSize)
{
	return sf_read_raw((SNDFILE *)pstate->fsf, pBlock, *pBlockSize);

} // AifGetPCMBlock
*/

signed long ThreadPlayAif(void *parameter)
{
#ifdef MAUNUSED
 (void)parameter;
#endif

	g_waitaudiodone = 1;
	
	maPlayAif();

	g_state.stop |= STOP_PLAYDECODE;
	
	// wait for output owned by this thread to finish
	while(!g_stopB && g_waitaudiodone)
		maSleep(100);

	return 0;

} // ThreadPlayAif


int DumpInfoAif(MASTATE *pstate, FILE *dumpfp)
{
	char tstr[32];
	char cstrx[512];

	if(AifOpenFile(pstate))
	{
		sprintf(cstrx, "DumpInfoAif AifOpenFile failed on '%s'", pstate->inpath);
		maLog(cstrx);
		return 1;
	}

	sprintf(cstrx, "Channels : %d", (pstate->inchannels == 1) ? 1 : 2);
	DumpString(dumpfp, cstrx);
	sprintf(cstrx, "SampleRate : %d", pstate->insamplerate);
	DumpString(dumpfp, cstrx);
	// sprintf(cstrx, "BitRate : %d", pstate->bitrate);
	// DumpString(dumpfp, cstrx);
	sprintf(cstrx, "Duration : %s", SecondsToStrHMS(tstr, pstate->duration / MSPERSEC));
	DumpString(dumpfp, cstrx);
	AifCloseFile(pstate);
	
	return 0;
	
} // DumpInfoAif


int DumpInfoWav(MASTATE *pstate, FILE *dumpfp)
{
	char tstr[32];
	char cstrx[512];

	if(AifOpenFile(pstate))
	{
		sprintf(cstrx, "DumpInfoWav AifOpenFile failed on '%s'", pstate->inpath);
		maLog(cstrx);
		return 1;
	}
		
	sprintf(cstrx, "Channels : %d", (pstate->inchannels == 1) ? 1 : 2);
	DumpString(dumpfp, cstrx);
	sprintf(cstrx, "SampleRate : %d", pstate->insamplerate);
	DumpString(dumpfp, cstrx);
	// sprintf(cstrx, "BitRate : %d", pstate->bitrate);
	// DumpString(dumpfp, cstrx);
	sprintf(cstrx, "Duration : %s", SecondsToStrHMS(tstr, pstate->duration / MSPERSEC));
	DumpString(dumpfp, cstrx);
	AifCloseFile(pstate);
	
	return 0;
	
} // DumpInfoWav

#ifdef __cplusplus
}
#endif

#endif // !NODECODEAIF && !NODECODEWAV

// eof
